/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/path","vs/base/common/types","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/network","vs/platform/log/common/log","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],we=function(ie){for(var e=[],E=0,k=ie.length;E<k;E++)e[E]=be[ie[E]];return e};define(be[42],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function E(k,A){if(!k)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=E}),define(be[50],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const E=Object.prototype.hasOwnProperty;function k(R){const C=[];for(let v in R)E.call(R,v)&&C.push(R[v]);return C}e.values=k;function A(R,C){for(let v in R)if(E.call(R,v)&&C({key:v,value:R[v]},function(){delete R[v]})===!1)return}e.forEach=A;function T(R,C){const v=Object.create(null);for(const m of R){const i=C(m);let s=v[i];s||(s=v[i]=[]),s.push(m)}return v}e.groupBy=T;function S(R){const C=Object.create(null);return R&&R.forEach((v,m)=>{C[m]=v}),C}e.fromMap=S;function I(R,C){const v=[],m=[];for(let i of R)C.has(i)||v.push(i);for(let i of C)R.has(i)||m.push(i);return{removed:v,added:m}}e.diffSets=I;function y(R,C){const v=[],m=[];for(let[i,s]of R)C.has(i)||v.push(s);for(let[i,s]of C)R.has(i)||m.push(s);return{removed:v,added:m}}e.diffMaps=y;class n{constructor(){this.map=new Map}add(C,v){let m=this.map.get(C);m||(m=new Set,this.map.set(C,m)),m.add(v)}delete(C,v){const m=this.map.get(C);!m||(m.delete(v),m.size===0&&this.map.delete(C))}forEach(C,v){const m=this.map.get(C);!m||m.forEach(v)}}e.SetMap=n}),define(be[51],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function E(y){return(n,R,C)=>{let v=null,m=null;if(typeof C.value=="function"?(v="value",m=C.value):typeof C.get=="function"&&(v="get",m=C.get),!m)throw new Error("not supported");C[v]=y(m,R)}}e.createDecorator=E;let k=0;function A(){const y=`$memoize${k++}`;let n;const R=function(v,m,i){let s=null,p=null;if(typeof i.value=="function"?(s="value",p=i.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof i.get=="function"&&(s="get",p=i.get),!p)throw new Error("not supported");const h=`${y}:${m}`;i[s]=function(...w){return n=this,this.hasOwnProperty(h)||Object.defineProperty(this,h,{configurable:!0,enumerable:!1,writable:!0,value:p.apply(this,w)}),this[h]}};return R.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(C=>{C.indexOf(y)===0&&delete n[C]})},R}e.createMemoizer=A;function T(y,n,R){return A()(y,n,R)}e.memoize=T;function S(y,n,R){return E((C,v)=>{const m=`$debounce$${v}`,i=`$debounce$result$${v}`;return function(...s){this[i]||(this[i]=R?R():void 0),clearTimeout(this[m]),n&&(this[i]=n(this[i],...s),s=[this[i]]),this[m]=setTimeout(()=>{C.apply(this,s),this[i]=R?R():void 0},y)}})}e.debounce=S;function I(y,n,R){return E((C,v)=>{const m=`$throttle$timer$${v}`,i=`$throttle$result$${v}`,s=`$throttle$lastRun$${v}`,p=`$throttle$pending$${v}`;return function(...h){if(this[i]||(this[i]=R?R():void 0),(this[s]===null||this[s]===void 0)&&(this[s]=-Number.MAX_VALUE),n&&(this[i]=n(this[i],...h)),!this[p]){const w=this[s]+y;w<=Date.now()?(this[s]=Date.now(),C.apply(this,[this[i]]),this[i]=R?R():void 0):(this[p]=!0,this[m]=setTimeout(()=>{this[p]=!1,this[s]=Date.now(),C.apply(this,[this[i]]),this[i]=R?R():void 0},w-Date.now()))}}})}e.throttle=I}),define(be[10],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=E,e.errorHandler=new E;function k(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=k;function A(l){y(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=A;function T(l){y(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=T;function S(l){if(l instanceof Error){let{name:t,message:r}=l;const u=l.stacktrace||l.stack;return{$isError:!0,name:t,message:r,stack:u}}return l}e.transformErrorForSerialization=S;const I="Canceled";function y(l){return l instanceof Error&&l.name===I&&l.message===I}e.isPromiseCanceledError=y;class n extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=n;function R(){const l=new Error(I);return l.name=l.message,l}e.canceled=R;function C(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=C;function v(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=v;function m(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function i(l){const t=new Error(`${l} has been disposed`);return t.name="DISPOSED",t}e.disposed=i;function s(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=s;class p extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=p;class h extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=h;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function _(l){const t=l;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=_;function c(l,t=Object.create(null)){const r=new Error(l);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=c}),define(be[15],we([0,1,10]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k(L,U=0){return L[L.length-(1+U)]}e.tail=k;function A(L){if(L.length===0)throw new Error("Invalid tail call");return[L.slice(0,L.length-1),L[L.length-1]]}e.tail2=A;function T(L,U,x=(Q,$)=>Q===$){if(L===U)return!0;if(!L||!U||L.length!==U.length)return!1;for(let Q=0,$=L.length;Q<$;Q++)if(!x(L[Q],U[Q]))return!1;return!0}e.equals=T;function S(L,U,x){let Q=0,$=L.length-1;for(;Q<=$;){const ee=(Q+$)/2|0,re=x(L[ee],U);if(re<0)Q=ee+1;else if(re>0)$=ee-1;else return ee}return-(Q+1)}e.binarySearch=S;function I(L,U){let x=0,Q=L.length;if(Q===0)return 0;for(;x<Q;){const $=Math.floor((x+Q)/2);U(L[$])?Q=$:x=$+1}return x}e.findFirstInSorted=I;function y(L,U,x){if(L=L|0,L>=U.length)throw new TypeError("invalid index");let Q=U[Math.floor(U.length*Math.random())],$=[],ee=[],re=[];for(let se of U){const ye=x(se,Q);ye<0?$.push(se):ye>0?ee.push(se):re.push(se)}return L<$.length?y(L,$,x):L<$.length+re.length?re[0]:y(L-($.length+re.length),ee,x)}e.quickSelect=y;function n(L,U){const x=[];let Q;for(const $ of L.slice(0).sort(U))!Q||U(Q[0],$)!==0?(Q=[$],x.push(Q)):Q.push($);return x}e.groupBy=n;function R(L,U,x){const Q=[];function $(se,ye,Ie){if(!(ye===0&&Ie.length===0)){const xe=Q[Q.length-1];xe&&xe.start+xe.deleteCount===se?(xe.deleteCount+=ye,xe.toInsert.push(...Ie)):Q.push({start:se,deleteCount:ye,toInsert:Ie})}}let ee=0,re=0;for(;;){if(ee===L.length){$(ee,0,U.slice(re));break}if(re===U.length){$(ee,L.length-ee,[]);break}const se=L[ee],ye=U[re],Ie=x(se,ye);Ie===0?(ee+=1,re+=1):Ie<0?($(ee,1,[]),ee+=1):Ie>0&&($(ee,0,[ye]),re+=1)}return Q}e.sortedDiff=R;function C(L,U,x){const Q=R(L,U,x),$=[],ee=[];for(const re of Q)$.push(...L.slice(re.start,re.start+re.deleteCount)),ee.push(...re.toInsert);return{removed:$,added:ee}}e.delta=C;function v(L,U,x){if(x===0)return[];const Q=L.slice(0,x).sort(U);return i(L,U,Q,x,L.length),Q}e.top=v;function m(L,U,x,Q,$){return x===0?Promise.resolve([]):new Promise((ee,re)=>{(async()=>{const se=L.length,ye=L.slice(0,x).sort(U);for(let Ie=x,xe=Math.min(x+Q,se);Ie<se;Ie=xe,xe=Math.min(xe+Q,se)){if(Ie>x&&await new Promise(Fe=>setTimeout(Fe)),$&&$.isCancellationRequested)throw(0,E.canceled)();i(L,U,ye,Ie,xe)}return ye})().then(ee,re)})}e.topAsync=m;function i(L,U,x,Q,$){for(const ee=x.length;Q<$;Q++){const re=L[Q];if(U(re,x[ee-1])<0){x.pop();const se=I(x,ye=>U(re,ye)<0);x.splice(se,0,re)}}}function s(L){return L.filter(U=>!!U)}e.coalesce=s;function p(L){let U=0;for(let x=0;x<L.length;x++)L[x]&&(L[U]=L[x],U+=1);L.length=U}e.coalesceInPlace=p;function h(L,U,x){L.splice(x,0,L.splice(U,1)[0])}e.move=h;function w(L){return!Array.isArray(L)||L.length===0}e.isFalsyOrEmpty=w;function _(L){return Array.isArray(L)&&L.length>0}e.isNonEmptyArray=_;function c(L,U){if(!U)return L.filter((Q,$)=>L.indexOf(Q)===$);const x=Object.create(null);return L.filter(Q=>{const $=U(Q);return x[$]?!1:(x[$]=!0,!0)})}e.distinct=c;function l(L){const U=new Set;return L.filter(x=>U.has(x)?!1:(U.add(x),!0))}e.distinctES6=l;function t(L){const U=Object.create(null);return x=>{const Q=L(x);return U[Q]?!1:(U[Q]=!0,!0)}}e.uniqueFilter=t;function r(L,U){for(let x=L.length-1;x>=0;x--){const Q=L[x];if(U(Q))return x}return-1}e.lastIndex=r;function u(L,U){return L.length>0?L[0]:U}e.firstOrDefault=u;function o(L,U,x=(Q,$)=>Q===$){let Q=0;for(let $=0,ee=Math.min(L.length,U.length);$<ee&&x(L[$],U[$]);$++)Q++;return Q}e.commonPrefixLength=o;function a(L){return[].concat(...L)}e.flatten=a;function f(L,U){let x=typeof U=="number"?L:0;typeof U=="number"?x=L:(x=0,U=L);const Q=[];if(x<=U)for(let $=x;$<U;$++)Q.push($);else for(let $=x;$>U;$--)Q.push($);return Q}e.range=f;function b(L,U,x){return L.reduce((Q,$)=>(Q[U($)]=x?x($):$,Q),Object.create(null))}e.index=b;function D(L,U){return L.push(U),()=>d(L,U)}e.insert=D;function d(L,U){const x=L.indexOf(U);if(x>-1)return L.splice(x,1),U}e.remove=d;function g(L,U,x){const Q=L.slice(0,U),$=L.slice(U);return Q.concat(x,$)}e.arrayInsert=g;function P(L,U){let x;if(typeof U=="number"){let Q=U;x=()=>{const $=Math.sin(Q++)*179426549;return $-Math.floor($)}}else x=Math.random;for(let Q=L.length-1;Q>0;Q-=1){const $=Math.floor(x()*(Q+1)),ee=L[Q];L[Q]=L[$],L[$]=ee}}e.shuffle=P;function F(L,U){const x=L.indexOf(U);x>-1&&(L.splice(x,1),L.unshift(U))}e.pushToStart=F;function z(L,U){const x=L.indexOf(U);x>-1&&(L.splice(x,1),L.push(U))}e.pushToEnd=z;function de(L,U){return Array.isArray(L)?L.map(U):U(L)}e.mapArrayOrNot=de;function W(L){return Array.isArray(L)?L:[L]}e.asArray=W;function B(L){return L[Math.floor(Math.random()*L.length)]}e.getRandomElement=B;function K(L,U){for(const x of L){const Q=U(x);if(Q!==void 0)return Q}}e.mapFind=K}),define(be[52],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(k){const A=this;let T=!1,S;return function(){return T||(T=!0,S=k.apply(A,arguments)),S}}e.once=E}),define(be[53],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class E{constructor(A){this._prefix=A,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=E,e.defaultGenerator=new E("id#")}),define(be[54],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(k){function A(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}k.is=A;const T=Object.freeze([]);function S(){return T}k.empty=S;function*I(l){yield l}k.single=I;function y(l){return l||T}k.from=y;function n(l){return!l||l[Symbol.iterator]().next().done===!0}k.isEmpty=n;function R(l){return l[Symbol.iterator]().next().value}k.first=R;function C(l,t){for(const r of l)if(t(r))return!0;return!1}k.some=C;function v(l,t){for(const r of l)if(t(r))return r}k.find=v;function*m(l,t){for(const r of l)t(r)&&(yield r)}k.filter=m;function*i(l,t){for(const r of l)yield t(r)}k.map=i;function*s(...l){for(const t of l)for(const r of t)yield r}k.concat=s;function*p(l){for(const t of l)for(const r of t)yield r}k.concatNested=p;function h(l,t,r){let u=r;for(const o of l)u=t(u,o);return u}k.reduce=h;function*w(l,t,r=l.length){for(t<0&&(t+=l.length),r<0?r+=l.length:r>l.length&&(r=l.length);t<r;t++)yield l[t]}k.slice=w;function _(l,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,l];const u=l[Symbol.iterator]();for(let o=0;o<t;o++){const a=u.next();if(a.done)return[r,k.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return u}}]}k.consume=_;function c(l,t,r=(u,o)=>u===o){const u=l[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const a=u.next(),f=o.next();if(a.done!==f.done)return!1;if(a.done)return!0;if(!r(a.value,f.value))return!1}}k.equals=c})(E=e.Iterable||(e.Iterable={}))}),define(be[43],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function S(t,r=!1){let u=0,o=t.length,a="",f=0,b=16,D=0;function d(B){let K=0,L=0;for(;K<B;){const U=t.charCodeAt(u);if(U>=48&&U<=57)L=L*16+U-48;else if(U>=65&&U<=70)L=L*16+U-65+10;else if(U>=97&&U<=102)L=L*16+U-97+10;else break;u++,K++}return K<B&&(L=-1),L}function g(B){u=B,a="",f=0,b=16,D=0}function P(){const B=u;if(t.charCodeAt(u)===48)u++;else for(u++;u<t.length&&n(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===46)if(u++,u<t.length&&n(t.charCodeAt(u)))for(u++;u<t.length&&n(t.charCodeAt(u));)u++;else return D=3,t.substring(B,u);let K=u;if(u<t.length&&(t.charCodeAt(u)===69||t.charCodeAt(u)===101))if(u++,(u<t.length&&t.charCodeAt(u)===43||t.charCodeAt(u)===45)&&u++,u<t.length&&n(t.charCodeAt(u))){for(u++;u<t.length&&n(t.charCodeAt(u));)u++;K=u}else D=3;return t.substring(B,K)}function F(){let B="",K=u;for(;;){if(u>=o){B+=t.substring(K,u),D=2;break}const L=t.charCodeAt(u);if(L===34){B+=t.substring(K,u),u++;break}if(L===92){if(B+=t.substring(K,u),u++,u>=o){D=2;break}switch(t.charCodeAt(u++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const x=d(4);x>=0?B+=String.fromCharCode(x):D=4;break;default:D=5}K=u;continue}if(L>=0&&L<=31)if(y(L)){B+=t.substring(K,u),D=2;break}else D=6;u++}return B}function z(){if(a="",D=0,f=u,u>=o)return f=o,b=17;let B=t.charCodeAt(u);if(I(B)){do u++,a+=String.fromCharCode(B),B=t.charCodeAt(u);while(I(B));return b=15}if(y(B))return u++,a+=String.fromCharCode(B),B===13&&t.charCodeAt(u)===10&&(u++,a+=`
`),b=14;switch(B){case 123:return u++,b=1;case 125:return u++,b=2;case 91:return u++,b=3;case 93:return u++,b=4;case 58:return u++,b=6;case 44:return u++,b=5;case 34:return u++,a=F(),b=10;case 47:const K=u-1;if(t.charCodeAt(u+1)===47){for(u+=2;u<o&&!y(t.charCodeAt(u));)u++;return a=t.substring(K,u),b=12}if(t.charCodeAt(u+1)===42){u+=2;const L=o-1;let U=!1;for(;u<L;){if(t.charCodeAt(u)===42&&t.charCodeAt(u+1)===47){u+=2,U=!0;break}u++}return U||(u++,D=1),a=t.substring(K,u),b=13}return a+=String.fromCharCode(B),u++,b=16;case 45:if(a+=String.fromCharCode(B),u++,u===o||!n(t.charCodeAt(u)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=P(),b=11;default:for(;u<o&&de(B);)u++,B=t.charCodeAt(u);if(f!==u){switch(a=t.substring(f,u),a){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return a+=String.fromCharCode(B),u++,b=16}}function de(B){if(I(B)||y(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let B;do B=z();while(B>=12&&B<=15);return B}return{setPosition:g,getPosition:()=>u,scan:r?W:z,getToken:()=>b,getTokenValue:()=>a,getTokenOffset:()=>f,getTokenLength:()=>u-f,getTokenError:()=>D}}e.createScanner=S;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function C(t,r){const u=[],o=new Object;let a;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function D(d,g,P,F){f.value=d,f.offset=g,f.length=P,f.type=F,f.colonOffset=void 0,a=f}try{_(t,{onObjectBegin:(d,g)=>{if(r<=d)throw o;a=void 0,b=r>d,u.push("")},onObjectProperty:(d,g,P)=>{if(r<g||(D(d,g,P,"property"),u[u.length-1]=d,r<=g+P))throw o},onObjectEnd:(d,g)=>{if(r<=d)throw o;a=void 0,u.pop()},onArrayBegin:(d,g)=>{if(r<=d)throw o;a=void 0,u.push(0)},onArrayEnd:(d,g)=>{if(r<=d)throw o;a=void 0,u.pop()},onLiteralValue:(d,g,P)=>{if(r<g||(D(d,g,P,l(d)),r<=g+P))throw o},onSeparator:(d,g,P)=>{if(r<=g)throw o;if(d===":"&&a&&a.type==="property")a.colonOffset=g,b=!1,a=void 0;else if(d===","){const F=u[u.length-1];typeof F=="number"?u[u.length-1]=F+1:(b=!0,u[u.length-1]=""),a=void 0}}})}catch(d){if(d!==o)throw d}return{path:u,previousNode:a,isAtPropertyKey:b,matches:d=>{let g=0;for(let P=0;g<d.length&&P<u.length;P++)if(d[g]===u[P]||d[g]==="*")g++;else if(d[g]!=="**")return!1;return g===d.length}}}e.getLocation=C;function v(t,r=[],u=T.DEFAULT){let o=null,a=[];const f=[];function b(d){Array.isArray(a)?a.push(d):o!==null&&(a[o]=d)}return _(t,{onObjectBegin:()=>{const d={};b(d),f.push(a),a=d,o=null},onObjectProperty:d=>{o=d},onObjectEnd:()=>{a=f.pop()},onArrayBegin:()=>{const d=[];b(d),f.push(a),a=d,o=null},onArrayEnd:()=>{a=f.pop()},onLiteralValue:b,onError:(d,g,P)=>{r.push({error:d,offset:g,length:P})}},u),a[0]}e.parse=v;function m(t,r=[],u=T.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(d){o.type==="property"&&(o.length=d-o.offset,o=o.parent)}function f(d){return o.children.push(d),d}_(t,{onObjectBegin:d=>{o=f({type:"object",offset:d,length:-1,parent:o,children:[]})},onObjectProperty:(d,g,P)=>{o=f({type:"property",offset:g,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:d,offset:g,length:P,parent:o})},onObjectEnd:(d,g)=>{o.length=d+g-o.offset,o=o.parent,a(d+g)},onArrayBegin:(d,g)=>{o=f({type:"array",offset:d,length:-1,parent:o,children:[]})},onArrayEnd:(d,g)=>{o.length=d+g-o.offset,o=o.parent,a(d+g)},onLiteralValue:(d,g,P)=>{f({type:l(d),offset:g,length:P,parent:o,value:d}),a(g+P)},onSeparator:(d,g,P)=>{o.type==="property"&&(d===":"?o.colonOffset=g:d===","&&a(g))},onError:(d,g,P)=>{r.push({error:d,offset:g,length:P})}},u);const D=o.children[0];return D&&delete D.parent,D}e.parseTree=m;function i(t,r){if(!!t){let u=t;for(let o of r)if(typeof o=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let a=!1;for(const f of u.children)if(Array.isArray(f.children)&&f.children[0].value===o){u=f.children[1],a=!0;break}if(!a)return}else{const a=o;if(u.type!=="array"||a<0||!Array.isArray(u.children)||a>=u.children.length)return;u=u.children[a]}return u}}e.findNodeAtLocation=i;function s(t){if(!t.parent||!t.parent.children)return[];const r=s(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;r.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&r.push(u)}return r}e.getNodePath=s;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":const r=Object.create(null);for(let u of t.children){const o=u.children[1];o&&(r[u.children[0].value]=p(o))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=p;function h(t,r,u=!1){return r>=t.offset&&r<t.offset+t.length||u&&r===t.offset+t.length}e.contains=h;function w(t,r,u=!1){if(h(t,r,u)){const o=t.children;if(Array.isArray(o))for(let a=0;a<o.length&&o[a].offset<=r;a++){const f=w(o[a],r,u);if(f)return f}return t}}e.findNodeAtOffset=w;function _(t,r,u=T.DEFAULT){const o=S(t,!1);function a(ye){return ye?()=>ye(o.getTokenOffset(),o.getTokenLength()):()=>!0}function f(ye){return ye?Ie=>ye(Ie,o.getTokenOffset(),o.getTokenLength()):()=>!0}const b=a(r.onObjectBegin),D=f(r.onObjectProperty),d=a(r.onObjectEnd),g=a(r.onArrayBegin),P=a(r.onArrayEnd),F=f(r.onLiteralValue),z=f(r.onSeparator),de=a(r.onComment),W=f(r.onError),B=u&&u.disallowComments,K=u&&u.allowTrailingComma;function L(){for(;;){const ye=o.scan();switch(o.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:B||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(ye){case 12:case 13:B?U(10):de();break;case 16:U(1);break;case 15:case 14:break;default:return ye}}}function U(ye,Ie=[],xe=[]){if(W(ye),Ie.length+xe.length>0){let Fe=o.getToken();for(;Fe!==17;){if(Ie.indexOf(Fe)!==-1){L();break}else if(xe.indexOf(Fe)!==-1)break;Fe=L()}}}function x(ye){const Ie=o.getTokenValue();return ye?F(Ie):D(Ie),L(),!0}function Q(){switch(o.getToken()){case 11:let ye=0;try{ye=JSON.parse(o.getTokenValue()),typeof ye!="number"&&(U(2),ye=0)}catch(Ie){U(2)}F(ye);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return L(),!0}function $(){return o.getToken()!==10?(U(3,[],[2,5]),!1):(x(!1),o.getToken()===6?(z(":"),L(),se()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function ee(){b(),L();let ye=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ye||U(4,[],[]),z(","),L(),o.getToken()===2&&K)break}else ye&&U(6,[],[]);$()||U(4,[],[2,5]),ye=!0}return d(),o.getToken()!==2?U(7,[2],[]):L(),!0}function re(){g(),L();let ye=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ye||U(4,[],[]),z(","),L(),o.getToken()===4&&K)break}else ye&&U(6,[],[]);se()||U(4,[],[4,5]),ye=!0}return P(),o.getToken()!==4?U(8,[4],[]):L(),!0}function se(){switch(o.getToken()){case 3:return re();case 1:return ee();case 10:return x(!0);default:return Q()}}return L(),o.getToken()===17?u.allowEmptyContent?!0:(U(4,[],[]),!1):se()?(o.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=_;function c(t,r){let u=S(t),o=[],a,f=0,b;do switch(b=u.getPosition(),a=u.scan(),a){case 12:case 13:case 17:f!==b&&o.push(t.substring(f,b)),r!==void 0&&o.push(u.getTokenValue().replace(/[^\r\n]/g,r)),f=u.getPosition();break}while(a!==17);return o.join("")}e.stripComments=c;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(be[104],we([0,1,43]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(y,n,R){let C,v,m,i,s;if(n){for(i=n.offset,s=i+n.length,m=i;m>0&&!I(y,m-1);)m--;let f=s;for(;f<y.length&&!I(y,f);)f++;v=y.substring(m,f),C=T(v,R)}else v=y,C=0,m=0,i=0,s=y.length;const p=S(R,y);let h=!1,w=0,_;R.insertSpaces?_=A(" ",R.tabSize||4):_="	";const c=(0,E.createScanner)(v,!1);let l=!1;function t(){return p+A(_,C+w)}function r(){let f=c.scan();for(h=!1;f===15||f===14;)h=h||f===14,f=c.scan();return l=f===16||c.getTokenError()!==0,f}const u=[];function o(f,b,D){!l&&b<s&&D>i&&y.substring(b,D)!==f&&u.push({offset:b,length:D-b,content:f})}let a=r();if(a!==17){const f=c.getTokenOffset()+m,b=A(_,C);o(b,m,f)}for(;a!==17;){let f=c.getTokenOffset()+c.getTokenLength()+m,b=r(),D="";for(;!h&&(b===12||b===13);){const g=c.getTokenOffset()+m;o(" ",f,g),f=c.getTokenOffset()+c.getTokenLength()+m,D=b===12?t():"",b=r()}if(b===2)a!==1&&(w--,D=t());else if(b===4)a!==3&&(w--,D=t());else{switch(a){case 3:case 1:w++,D=t();break;case 5:case 12:D=t();break;case 13:h?D=t():D=" ";break;case 6:D=" ";break;case 10:if(b===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?D=" ":b!==5&&b!==17&&(l=!0);break;case 16:l=!0;break}h&&(b===12||b===13)&&(D=t())}const d=c.getTokenOffset()+m;o(D,f,d),a=b}return u}e.format=k;function A(y,n){let R="";for(let C=0;C<n;C++)R+=y;return R}function T(y,n){let R=0,C=0;const v=n.tabSize||4;for(;R<y.length;){const m=y.charAt(R);if(m===" ")C++;else if(m==="	")C+=v;else break;R++}return Math.floor(C/v)}function S(y,n){for(let R=0;R<n.length;R++){const C=n.charAt(R);if(C==="\r")return R+1<n.length&&n.charAt(R+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=S;function I(y,n){return`\r
`.indexOf(y.charAt(n))!==-1}e.isEOL=I}),define(be[105],we([0,1,43,104]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(n,R,C){return T(n,R,void 0,C)}e.removeProperty=A;function T(n,R,C,v,m){const i=R.slice(),s=[],p=(0,E.parseTree)(n,s);let h,w;for(;i.length>0&&(w=i.pop(),h=(0,E.findNodeAtLocation)(p,i),h===void 0&&C!==void 0);)typeof w=="string"?C={[w]:C}:C=[C];if(h)if(h.type==="object"&&typeof w=="string"&&Array.isArray(h.children)){const _=(0,E.findNodeAtLocation)(h,[w]);if(_!==void 0)if(C===void 0){if(!_.parent)throw new Error("Malformed AST");const c=h.children.indexOf(_.parent);let l,t=_.parent.offset+_.parent.length;if(c>0){const r=h.children[c-1];l=r.offset+r.length}else l=h.offset+1,h.children.length>1&&(t=h.children[1].offset);return S(n,{offset:l,length:t-l,content:""},v)}else return S(n,{offset:_.offset,length:_.length,content:JSON.stringify(C)},v);else{if(C===void 0)return[];const c=`${JSON.stringify(w)}: ${JSON.stringify(C)}`,l=m?m(h.children.map(r=>r.children[0].value)):h.children.length;let t;if(l>0){const r=h.children[l-1];t={offset:r.offset+r.length,length:0,content:","+c}}else h.children.length===0?t={offset:h.offset+1,length:0,content:c}:t={offset:h.offset+1,length:0,content:c+","};return S(n,t,v)}}else if(h.type==="array"&&typeof w=="number"&&Array.isArray(h.children))if(C!==void 0){const _=`${JSON.stringify(C)}`;let c;if(h.children.length===0||w===0)c={offset:h.offset+1,length:0,content:h.children.length===0?_:_+","};else{const l=w===-1||w>h.children.length?h.children.length:w,t=h.children[l-1];c={offset:t.offset+t.length,length:0,content:","+_}}return S(n,c,v)}else{const _=w,c=h.children[_];let l;if(h.children.length===1)l={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===_){const t=h.children[_-1],r=t.offset+t.length,u=h.offset+h.length;l={offset:r,length:u-2-r,content:""}}else l={offset:c.offset,length:h.children[_+1].offset-c.offset,content:""};return S(n,l,v)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${h.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return S(n,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(C)},v)}}e.setProperty=T;function S(n,R,C){let v=I(n,R),m=R.offset,i=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;m>0&&!(0,k.isEOL)(v,m-1);)m--;for(;i<v.length&&!(0,k.isEOL)(v,i);)i++}const s=(0,k.format)(v,{offset:m,length:i-m},C);for(let h=s.length-1;h>=0;h--){const w=s[h];v=I(v,w),m=Math.min(m,w.offset),i=Math.max(i,w.offset+w.length),i+=w.content.length-w.length}const p=n.length-(v.length-i)-m;return[{offset:m,length:p,content:v.substring(m,i)}]}e.withFormatting=S;function I(n,R){return n.substring(0,R.offset)+R.content+n.substring(R.offset+R.length)}e.applyEdit=I;function y(n,R){let C=R.slice(0).sort((m,i)=>{const s=m.offset-i.offset;return s===0?m.length-i.length:s}),v=n.length;for(let m=C.length-1;m>=0;m--){let i=C[m];if(i.offset+i.length<=v)n=I(n,i);else throw new Error("Overlapping edit");v=i.offset}return n}e.applyEdits=y}),define(be[106],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(A){this.executor=A,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(A){return new E(()=>A(this.getValue()))}}e.Lazy=E}),define(be[6],we([0,1,52,54]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let T=null;function S(_){T=_}if(e.setDisposableTracker=S,A){const _="__is_disposable_tracked__";T=new class{trackDisposable(c){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[_]||console.log(l)},3e3)}markTracked(c){if(c&&c!==s.None)try{c[_]=!0}catch(l){}}}}function I(_){!T||T.markTracked(_)}function y(_){return T&&T.trackDisposable(_),_}e.trackDisposable=y;class n extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=n;function R(_){return typeof _.dispose=="function"&&_.dispose.length===0}e.isDisposable=R;function C(_){if(k.Iterable.is(_)){let c=[];for(const l of _)if(l){I(l);try{l.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new n(c);return Array.isArray(_)?[]:_}else if(_)return I(_),_.dispose(),_}e.dispose=C;function v(..._){return _.forEach(I),m(()=>C(_))}e.combinedDisposable=v;function m(_){const c=y({dispose:()=>{I(c),_()}});return c}e.toDisposable=m;class i{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(I(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return I(c),this._isDisposed?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=i,i.DISABLE_DISPOSED_WARNING=!1;class s{constructor(){this._store=new i,y(this)}dispose(){I(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=s,s.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var l;this._isDisposed||c===this._value||((l=this._value)===null||l===void 0||l.dispose(),c&&I(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,I(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=p;class h{constructor(){this.references=new Map}acquire(c,...l){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...l)},this.references.set(c,t));const{object:r}=t,u=(0,E.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:r,dispose:u}}}e.ReferenceCollection=h;class w{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=w}),define(be[44],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(T){this.element=T,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class k{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,S){const I=new E(T);if(this._first===E.Undefined)this._first=I,this._last=I;else if(S){const n=this._last;this._last=I,I.prev=n,n.next=I}else{const n=this._first;this._first=I,I.next=n,n.prev=I}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(I))}}shift(){if(this._first!==E.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==E.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==E.Undefined&&T.next!==E.Undefined){const S=T.prev;S.next=T.next,T.next.prev=S}else T.prev===E.Undefined&&T.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):T.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):T.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==E.Undefined;)yield T.element,T=T.next}}e.LinkedList=k}),function(ie,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ie=typeof globalThis!="undefined"?globalThis:ie||self,ie.marked=e())}(this,function(){"use strict";function ie(H,ne){for(var he=0;he<ne.length;he++){var q=ne[he];q.enumerable=q.enumerable||!1,q.configurable=!0,"value"in q&&(q.writable=!0),Object.defineProperty(H,q.key,q)}}function e(H,ne,he){return ne&&ie(H.prototype,ne),he&&ie(H,he),H}function E(H,ne){if(!!H){if(typeof H=="string")return k(H,ne);var he=Object.prototype.toString.call(H).slice(8,-1);if(he==="Object"&&H.constructor&&(he=H.constructor.name),he==="Map"||he==="Set")return Array.from(H);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return k(H,ne)}}function k(H,ne){(ne==null||ne>H.length)&&(ne=H.length);for(var he=0,q=new Array(ne);he<ne;he++)q[he]=H[he];return q}function A(H,ne){var he;if(typeof Symbol=="undefined"||H[Symbol.iterator]==null){if(Array.isArray(H)||(he=E(H))||ne&&H&&typeof H.length=="number"){he&&(H=he);var q=0;return function(){return q>=H.length?{done:!0}:{done:!1,value:H[q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return he=H[Symbol.iterator](),he.next.bind(he)}function T(H){var ne={exports:{}};return H(ne,ne.exports),ne.exports}var S=T(function(H){function ne(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function he(q){H.exports.defaults=q}H.exports={defaults:ne(),getDefaults:ne,changeDefaults:he}}),I=/[&<>"']/,y=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(ne){return C[ne]};function m(H,ne){if(ne){if(I.test(H))return H.replace(y,v)}else if(n.test(H))return H.replace(R,v);return H}var i=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(H){return H.replace(i,function(ne,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var p=/(^|[^\[])\^/g;function h(H,ne){H=H.source||H,ne=ne||"";var he={replace:function(J,oe){return oe=oe.source||oe,oe=oe.replace(p,"$1"),H=H.replace(J,oe),he},getRegex:function(){return new RegExp(H,ne)}};return he}var w=/[^\w:]/g,_=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(H,ne,he){if(H){var q;try{q=decodeURIComponent(s(he)).replace(w,"").toLowerCase()}catch(J){return null}if(q.indexOf("javascript:")===0||q.indexOf("vbscript:")===0||q.indexOf("data:")===0)return null}ne&&!_.test(he)&&(he=o(ne,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch(J){return null}return he}var l={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(H,ne){l[" "+H]||(t.test(H)?l[" "+H]=H+"/":l[" "+H]=D(H,"/",!0)),H=l[" "+H];var he=H.indexOf(":")===-1;return ne.substring(0,2)==="//"?he?ne:H.replace(r,"$1")+ne:ne.charAt(0)==="/"?he?ne:H.replace(u,"$1")+ne:H+ne}var a={exec:function(){}};function f(H){for(var ne=1,he,q;ne<arguments.length;ne++){he=arguments[ne];for(q in he)Object.prototype.hasOwnProperty.call(he,q)&&(H[q]=he[q])}return H}function b(H,ne){var he=H.replace(/\|/g,function(oe,fe,pe){for(var We=!1,Ne=fe;--Ne>=0&&pe[Ne]==="\\";)We=!We;return We?"|":" |"}),q=he.split(/ \|/),J=0;if(q.length>ne)q.splice(ne);else for(;q.length<ne;)q.push("");for(;J<q.length;J++)q[J]=q[J].trim().replace(/\\\|/g,"|");return q}function D(H,ne,he){var q=H.length;if(q===0)return"";for(var J=0;J<q;){var oe=H.charAt(q-J-1);if(oe===ne&&!he)J++;else if(oe!==ne&&he)J++;else break}return H.substr(0,q-J)}function d(H,ne){if(H.indexOf(ne[1])===-1)return-1;for(var he=H.length,q=0,J=0;J<he;J++)if(H[J]==="\\")J++;else if(H[J]===ne[0])q++;else if(H[J]===ne[1]&&(q--,q<0))return J;return-1}function g(H){H&&H.sanitize&&!H.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(H,ne){if(ne<1)return"";for(var he="";ne>1;)ne&1&&(he+=H),ne>>=1,H+=H;return he+H}var F={escape:m,unescape:s,edit:h,cleanUrl:c,resolveUrl:o,noopTest:a,merge:f,splitCells:b,rtrim:D,findClosingBracket:d,checkSanitizeDeprecation:g,repeatString:P},z=S.defaults,de=F.rtrim,W=F.splitCells,B=F.escape,K=F.findClosingBracket;function L(H,ne,he){var q=ne.href,J=ne.title?B(ne.title):null,oe=H[1].replace(/\\([\[\]])/g,"$1");return H[0].charAt(0)!=="!"?{type:"link",raw:he,href:q,title:J,text:oe}:{type:"image",raw:he,href:q,title:J,text:B(oe)}}function U(H,ne){var he=H.match(/^(\s+)(?:```)/);if(he===null)return ne;var q=he[1];return ne.split(`
`).map(function(J){var oe=J.match(/^\s+/);if(oe===null)return J;var fe=oe[0];return fe.length>=q.length?J.slice(q.length):J}).join(`
`)}var x=function(){function H(he){this.options=he||z}var ne=H.prototype;return ne.space=function(q){var J=this.rules.block.newline.exec(q);if(J)return J[0].length>1?{type:"space",raw:J[0]}:{raw:`
`}},ne.code=function(q){var J=this.rules.block.code.exec(q);if(J){var oe=J[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:J[0],codeBlockStyle:"indented",text:this.options.pedantic?oe:de(oe,`
`)}}},ne.fences=function(q){var J=this.rules.block.fences.exec(q);if(J){var oe=J[0],fe=U(oe,J[3]||"");return{type:"code",raw:oe,lang:J[2]?J[2].trim():J[2],text:fe}}},ne.heading=function(q){var J=this.rules.block.heading.exec(q);if(J){var oe=J[2].trim();if(/#$/.test(oe)){var fe=de(oe,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(oe=fe.trim())}return{type:"heading",raw:J[0],depth:J[1].length,text:oe}}},ne.nptable=function(q){var J=this.rules.block.nptable.exec(q);if(J){var oe={type:"table",header:W(J[1].replace(/^ *| *\| *$/g,"")),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:J[3]?J[3].replace(/\n$/,"").split(`
`):[],raw:J[0]};if(oe.header.length===oe.align.length){var fe=oe.align.length,pe;for(pe=0;pe<fe;pe++)/^ *-+: *$/.test(oe.align[pe])?oe.align[pe]="right":/^ *:-+: *$/.test(oe.align[pe])?oe.align[pe]="center":/^ *:-+ *$/.test(oe.align[pe])?oe.align[pe]="left":oe.align[pe]=null;for(fe=oe.cells.length,pe=0;pe<fe;pe++)oe.cells[pe]=W(oe.cells[pe],oe.header.length);return oe}}},ne.hr=function(q){var J=this.rules.block.hr.exec(q);if(J)return{type:"hr",raw:J[0]}},ne.blockquote=function(q){var J=this.rules.block.blockquote.exec(q);if(J){var oe=J[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:J[0],text:oe}}},ne.list=function(q){var J=this.rules.block.list.exec(q);if(J){var oe=J[0],fe=J[2],pe=fe.length>1,We={type:"list",raw:oe,ordered:pe,start:pe?+fe.slice(0,-1):"",loose:!1,items:[]},Ne=J[0].match(this.rules.block.item),Ve=!1,Xe,Ze,ct,ot,nt,ue,De,le,j=Ne.length;ct=this.rules.block.listItemStart.exec(Ne[0]);for(var Ae=0;Ae<j;Ae++){if(Xe=Ne[Ae],oe=Xe,Ae!==j-1){if(ot=this.rules.block.listItemStart.exec(Ne[Ae+1]),this.options.pedantic?ot[1].length>ct[1].length:ot[1].length>ct[0].length||ot[1].length>3){Ne.splice(Ae,2,Ne[Ae]+`
`+Ne[Ae+1]),Ae--,j--;continue}else(!this.options.pedantic||this.options.smartLists?ot[2][ot[2].length-1]!==fe[fe.length-1]:pe===(ot[2].length===1))&&(nt=Ne.slice(Ae+1).join(`
`),We.raw=We.raw.substring(0,We.raw.length-nt.length),Ae=j-1);ct=ot}Ze=Xe.length,Xe=Xe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Xe.indexOf(`
 `)&&(Ze-=Xe.length,Xe=this.options.pedantic?Xe.replace(/^ {1,4}/gm,""):Xe.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),ue=Ve||/\n\n(?!\s*$)/.test(Xe),Ae!==j-1&&(Ve=Xe.charAt(Xe.length-1)===`
`,ue||(ue=Ve)),ue&&(We.loose=!0),this.options.gfm&&(De=/^\[[ xX]\] /.test(Xe),le=void 0,De&&(le=Xe[1]!==" ",Xe=Xe.replace(/^\[[ xX]\] +/,""))),We.items.push({type:"list_item",raw:oe,task:De,checked:le,loose:ue,text:Xe})}return We}},ne.html=function(q){var J=this.rules.block.html.exec(q);if(J)return{type:this.options.sanitize?"paragraph":"html",raw:J[0],pre:!this.options.sanitizer&&(J[1]==="pre"||J[1]==="script"||J[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):B(J[0]):J[0]}},ne.def=function(q){var J=this.rules.block.def.exec(q);if(J){J[3]&&(J[3]=J[3].substring(1,J[3].length-1));var oe=J[1].toLowerCase().replace(/\s+/g," ");return{tag:oe,raw:J[0],href:J[2],title:J[3]}}},ne.table=function(q){var J=this.rules.block.table.exec(q);if(J){var oe={type:"table",header:W(J[1].replace(/^ *| *\| *$/g,"")),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:J[3]?J[3].replace(/\n$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=J[0];var fe=oe.align.length,pe;for(pe=0;pe<fe;pe++)/^ *-+: *$/.test(oe.align[pe])?oe.align[pe]="right":/^ *:-+: *$/.test(oe.align[pe])?oe.align[pe]="center":/^ *:-+ *$/.test(oe.align[pe])?oe.align[pe]="left":oe.align[pe]=null;for(fe=oe.cells.length,pe=0;pe<fe;pe++)oe.cells[pe]=W(oe.cells[pe].replace(/^ *\| *| *\| *$/g,""),oe.header.length);return oe}}},ne.lheading=function(q){var J=this.rules.block.lheading.exec(q);if(J)return{type:"heading",raw:J[0],depth:J[2].charAt(0)==="="?1:2,text:J[1]}},ne.paragraph=function(q){var J=this.rules.block.paragraph.exec(q);if(J)return{type:"paragraph",raw:J[0],text:J[1].charAt(J[1].length-1)===`
`?J[1].slice(0,-1):J[1]}},ne.text=function(q){var J=this.rules.block.text.exec(q);if(J)return{type:"text",raw:J[0],text:J[0]}},ne.escape=function(q){var J=this.rules.inline.escape.exec(q);if(J)return{type:"escape",raw:J[0],text:B(J[1])}},ne.tag=function(q,J,oe){var fe=this.rules.inline.tag.exec(q);if(fe)return!J&&/^<a /i.test(fe[0])?J=!0:J&&/^<\/a>/i.test(fe[0])&&(J=!1),!oe&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?oe=!0:oe&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(oe=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:J,inRawBlock:oe,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):B(fe[0]):fe[0]}},ne.link=function(q){var J=this.rules.inline.link.exec(q);if(J){var oe=J[2].trim();if(!this.options.pedantic&&/^</.test(oe)){if(!/>$/.test(oe))return;var fe=de(oe.slice(0,-1),"\\");if((oe.length-fe.length)%2==0)return}else{var pe=K(J[2],"()");if(pe>-1){var We=J[0].indexOf("!")===0?5:4,Ne=We+J[1].length+pe;J[2]=J[2].substring(0,pe),J[0]=J[0].substring(0,Ne).trim(),J[3]=""}}var Ve=J[2],Xe="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ve);Ze&&(Ve=Ze[1],Xe=Ze[3])}else Xe=J[3]?J[3].slice(1,-1):"";return Ve=Ve.trim(),/^</.test(Ve)&&(this.options.pedantic&&!/>$/.test(oe)?Ve=Ve.slice(1):Ve=Ve.slice(1,-1)),L(J,{href:Ve&&Ve.replace(this.rules.inline._escapes,"$1"),title:Xe&&Xe.replace(this.rules.inline._escapes,"$1")},J[0])}},ne.reflink=function(q,J){var oe;if((oe=this.rules.inline.reflink.exec(q))||(oe=this.rules.inline.nolink.exec(q))){var fe=(oe[2]||oe[1]).replace(/\s+/g," ");if(fe=J[fe.toLowerCase()],!fe||!fe.href){var pe=oe[0].charAt(0);return{type:"text",raw:pe,text:pe}}return L(oe,fe,oe[0])}},ne.emStrong=function(q,J,oe){oe===void 0&&(oe="");var fe=this.rules.inline.emStrong.lDelim.exec(q);if(!!fe&&!(fe[3]&&oe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var pe=fe[1]||fe[2]||"";if(!pe||pe&&(oe===""||this.rules.inline.punctuation.exec(oe))){var We=fe[0].length-1,Ne,Ve,Xe=We,Ze=0,ct=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ct.lastIndex=0,J=J.slice(-1*q.length+We);(fe=ct.exec(J))!=null;)if(Ne=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Ne){if(Ve=Ne.length,fe[3]||fe[4]){Xe+=Ve;continue}else if((fe[5]||fe[6])&&We%3&&!((We+Ve)%3)){Ze+=Ve;continue}if(Xe-=Ve,!(Xe>0)){if(Xe+Ze-Ve<=0&&!J.slice(ct.lastIndex).match(ct)&&(Ve=Math.min(Ve,Ve+Xe+Ze)),Math.min(We,Ve)%2)return{type:"em",raw:q.slice(0,We+fe.index+Ve+1),text:q.slice(1,We+fe.index+Ve)};if(Math.min(We,Ve)%2==0)return{type:"strong",raw:q.slice(0,We+fe.index+Ve+1),text:q.slice(2,We+fe.index+Ve-1)}}}}}},ne.codespan=function(q){var J=this.rules.inline.code.exec(q);if(J){var oe=J[2].replace(/\n/g," "),fe=/[^ ]/.test(oe),pe=/^ /.test(oe)&&/ $/.test(oe);return fe&&pe&&(oe=oe.substring(1,oe.length-1)),oe=B(oe,!0),{type:"codespan",raw:J[0],text:oe}}},ne.br=function(q){var J=this.rules.inline.br.exec(q);if(J)return{type:"br",raw:J[0]}},ne.del=function(q){var J=this.rules.inline.del.exec(q);if(J)return{type:"del",raw:J[0],text:J[2]}},ne.autolink=function(q,J){var oe=this.rules.inline.autolink.exec(q);if(oe){var fe,pe;return oe[2]==="@"?(fe=B(this.options.mangle?J(oe[1]):oe[1]),pe="mailto:"+fe):(fe=B(oe[1]),pe=fe),{type:"link",raw:oe[0],text:fe,href:pe,tokens:[{type:"text",raw:fe,text:fe}]}}},ne.url=function(q,J){var oe;if(oe=this.rules.inline.url.exec(q)){var fe,pe;if(oe[2]==="@")fe=B(this.options.mangle?J(oe[0]):oe[0]),pe="mailto:"+fe;else{var We;do We=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while(We!==oe[0]);fe=B(oe[0]),oe[1]==="www."?pe="http://"+fe:pe=fe}return{type:"link",raw:oe[0],text:fe,href:pe,tokens:[{type:"text",raw:fe,text:fe}]}}},ne.inlineText=function(q,J,oe){var fe=this.rules.inline.text.exec(q);if(fe){var pe;return J?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):B(fe[0]):fe[0]:pe=B(this.options.smartypants?oe(fe[0]):fe[0]),{type:"text",raw:fe[0],text:pe}}},H}(),Q=F.noopTest,$=F.edit,ee=F.merge,re={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:Q,table:Q,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};re._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,re._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,re.def=$(re.def).replace("label",re._label).replace("title",re._title).getRegex(),re.bullet=/(?:[*+-]|\d{1,9}[.)])/,re.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,re.item=$(re.item,"gm").replace(/bull/g,re.bullet).getRegex(),re.listItemStart=$(/^( *)(bull)/).replace("bull",re.bullet).getRegex(),re.list=$(re.list).replace(/bull/g,re.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+re.def.source+")").getRegex(),re._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",re._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,re.html=$(re.html,"i").replace("comment",re._comment).replace("tag",re._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),re.paragraph=$(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",re._tag).getRegex(),re.blockquote=$(re.blockquote).replace("paragraph",re.paragraph).getRegex(),re.normal=ee({},re),re.gfm=ee({},re.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),re.gfm.nptable=$(re.gfm.nptable).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",re._tag).getRegex(),re.gfm.table=$(re.gfm.table).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",re._tag).getRegex(),re.pedantic=ee({},re.normal,{html:$(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",re._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:Q,paragraph:$(re.normal._paragraph).replace("hr",re.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",re.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Q,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Q,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=$(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=$(re._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=$(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=$(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=$(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=$(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=$(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=$(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=$(se.reflink).replace("label",se._label).getRegex(),se.reflinkSearch=$(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=ee({},se),se.pedantic=ee({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:$(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:$(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=ee({},se.normal,{escape:$(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),se.gfm.url=$(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=ee({},se.gfm,{br:$(se.br).replace("{2,}","*").getRegex(),text:$(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ye={block:re,inline:se},Ie=S.defaults,xe=ye.block,Fe=ye.inline,ze=F.repeatString;function N(H){return H.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(H){var ne="",he,q,J=H.length;for(he=0;he<J;he++)q=H.charCodeAt(he),Math.random()>.5&&(q="x"+q.toString(16)),ne+="&#"+q+";";return ne}var te=function(){function H(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||Ie,this.options.tokenizer=this.options.tokenizer||new x,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var q={block:xe.normal,inline:Fe.normal};this.options.pedantic?(q.block=xe.pedantic,q.inline=Fe.pedantic):this.options.gfm&&(q.block=xe.gfm,this.options.breaks?q.inline=Fe.breaks:q.inline=Fe.gfm),this.tokenizer.rules=q}H.lex=function(q,J){var oe=new H(J);return oe.lex(q)},H.lexInline=function(q,J){var oe=new H(J);return oe.inlineTokens(q)};var ne=H.prototype;return ne.lex=function(q){return q=q.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(q,this.tokens,!0),this.inline(this.tokens),this.tokens},ne.blockTokens=function(q,J,oe){J===void 0&&(J=[]),oe===void 0&&(oe=!0),this.options.pedantic&&(q=q.replace(/^ +$/gm,""));for(var fe,pe,We,Ne;q;){if(fe=this.tokenizer.space(q)){q=q.substring(fe.raw.length),fe.type&&J.push(fe);continue}if(fe=this.tokenizer.code(q)){q=q.substring(fe.raw.length),Ne=J[J.length-1],Ne&&Ne.type==="paragraph"?(Ne.raw+=`
`+fe.raw,Ne.text+=`
`+fe.text):J.push(fe);continue}if(fe=this.tokenizer.fences(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(fe=this.tokenizer.heading(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(fe=this.tokenizer.nptable(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(fe=this.tokenizer.hr(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(fe=this.tokenizer.blockquote(q)){q=q.substring(fe.raw.length),fe.tokens=this.blockTokens(fe.text,[],oe),J.push(fe);continue}if(fe=this.tokenizer.list(q)){for(q=q.substring(fe.raw.length),We=fe.items.length,pe=0;pe<We;pe++)fe.items[pe].tokens=this.blockTokens(fe.items[pe].text,[],!1);J.push(fe);continue}if(fe=this.tokenizer.html(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(oe&&(fe=this.tokenizer.def(q))){q=q.substring(fe.raw.length),this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(fe=this.tokenizer.lheading(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(oe&&(fe=this.tokenizer.paragraph(q))){q=q.substring(fe.raw.length),J.push(fe);continue}if(fe=this.tokenizer.text(q)){q=q.substring(fe.raw.length),Ne=J[J.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+fe.raw,Ne.text+=`
`+fe.text):J.push(fe);continue}if(q){var Ve="Infinite loop on byte: "+q.charCodeAt(0);if(this.options.silent){console.error(Ve);break}else throw new Error(Ve)}}return J},ne.inline=function(q){var J,oe,fe,pe,We,Ne,Ve=q.length;for(J=0;J<Ve;J++)switch(Ne=q[J],Ne.type){case"paragraph":case"text":case"heading":{Ne.tokens=[],this.inlineTokens(Ne.text,Ne.tokens);break}case"table":{for(Ne.tokens={header:[],cells:[]},pe=Ne.header.length,oe=0;oe<pe;oe++)Ne.tokens.header[oe]=[],this.inlineTokens(Ne.header[oe],Ne.tokens.header[oe]);for(pe=Ne.cells.length,oe=0;oe<pe;oe++)for(We=Ne.cells[oe],Ne.tokens.cells[oe]=[],fe=0;fe<We.length;fe++)Ne.tokens.cells[oe][fe]=[],this.inlineTokens(We[fe],Ne.tokens.cells[oe][fe]);break}case"blockquote":{this.inline(Ne.tokens);break}case"list":{for(pe=Ne.items.length,oe=0;oe<pe;oe++)this.inline(Ne.items[oe].tokens);break}}return q},ne.inlineTokens=function(q,J,oe,fe){J===void 0&&(J=[]),oe===void 0&&(oe=!1),fe===void 0&&(fe=!1);var pe,We,Ne=q,Ve,Xe,Ze;if(this.tokens.links){var ct=Object.keys(this.tokens.links);if(ct.length>0)for(;(Ve=this.tokenizer.rules.inline.reflinkSearch.exec(Ne))!=null;)ct.includes(Ve[0].slice(Ve[0].lastIndexOf("[")+1,-1))&&(Ne=Ne.slice(0,Ve.index)+"["+ze("a",Ve[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ve=this.tokenizer.rules.inline.blockSkip.exec(Ne))!=null;)Ne=Ne.slice(0,Ve.index)+"["+ze("a",Ve[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ve=this.tokenizer.rules.inline.escapedEmSt.exec(Ne))!=null;)Ne=Ne.slice(0,Ve.index)+"++"+Ne.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;q;){if(Xe||(Ze=""),Xe=!1,pe=this.tokenizer.escape(q)){q=q.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.tag(q,oe,fe)){q=q.substring(pe.raw.length),oe=pe.inLink,fe=pe.inRawBlock;var ot=J[J.length-1];ot&&pe.type==="text"&&ot.type==="text"?(ot.raw+=pe.raw,ot.text+=pe.text):J.push(pe);continue}if(pe=this.tokenizer.link(q)){q=q.substring(pe.raw.length),pe.type==="link"&&(pe.tokens=this.inlineTokens(pe.text,[],!0,fe)),J.push(pe);continue}if(pe=this.tokenizer.reflink(q,this.tokens.links)){q=q.substring(pe.raw.length);var nt=J[J.length-1];pe.type==="link"?(pe.tokens=this.inlineTokens(pe.text,[],!0,fe),J.push(pe)):nt&&pe.type==="text"&&nt.type==="text"?(nt.raw+=pe.raw,nt.text+=pe.text):J.push(pe);continue}if(pe=this.tokenizer.emStrong(q,Ne,Ze)){q=q.substring(pe.raw.length),pe.tokens=this.inlineTokens(pe.text,[],oe,fe),J.push(pe);continue}if(pe=this.tokenizer.codespan(q)){q=q.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.br(q)){q=q.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.del(q)){q=q.substring(pe.raw.length),pe.tokens=this.inlineTokens(pe.text,[],oe,fe),J.push(pe);continue}if(pe=this.tokenizer.autolink(q,G)){q=q.substring(pe.raw.length),J.push(pe);continue}if(!oe&&(pe=this.tokenizer.url(q,G))){q=q.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.inlineText(q,fe,N)){q=q.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(Ze=pe.raw.slice(-1)),Xe=!0,We=J[J.length-1],We&&We.type==="text"?(We.raw+=pe.raw,We.text+=pe.text):J.push(pe);continue}if(q){var ue="Infinite loop on byte: "+q.charCodeAt(0);if(this.options.silent){console.error(ue);break}else throw new Error(ue)}}return J},e(H,null,[{key:"rules",get:function(){return{block:xe,inline:Fe}}}]),H}(),ae=S.defaults,me=F.cleanUrl,Se=F.escape,Me=function(){function H(he){this.options=he||ae}var ne=H.prototype;return ne.code=function(q,J,oe){var fe=(J||"").match(/\S*/)[0];if(this.options.highlight){var pe=this.options.highlight(q,fe);pe!=null&&pe!==q&&(oe=!0,q=pe)}return q=q.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+Se(fe,!0)+'">'+(oe?q:Se(q,!0))+`</code></pre>
`:"<pre><code>"+(oe?q:Se(q,!0))+`</code></pre>
`},ne.blockquote=function(q){return`<blockquote>
`+q+`</blockquote>
`},ne.html=function(q){return q},ne.heading=function(q,J,oe,fe){return this.options.headerIds?"<h"+J+' id="'+this.options.headerPrefix+fe.slug(oe)+'">'+q+"</h"+J+`>
`:"<h"+J+">"+q+"</h"+J+`>
`},ne.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ne.list=function(q,J,oe){var fe=J?"ol":"ul",pe=J&&oe!==1?' start="'+oe+'"':"";return"<"+fe+pe+`>
`+q+"</"+fe+`>
`},ne.listitem=function(q){return"<li>"+q+`</li>
`},ne.checkbox=function(q){return"<input "+(q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ne.paragraph=function(q){return"<p>"+q+`</p>
`},ne.table=function(q,J){return J&&(J="<tbody>"+J+"</tbody>"),`<table>
<thead>
`+q+`</thead>
`+J+`</table>
`},ne.tablerow=function(q){return`<tr>
`+q+`</tr>
`},ne.tablecell=function(q,J){var oe=J.header?"th":"td",fe=J.align?"<"+oe+' align="'+J.align+'">':"<"+oe+">";return fe+q+"</"+oe+`>
`},ne.strong=function(q){return"<strong>"+q+"</strong>"},ne.em=function(q){return"<em>"+q+"</em>"},ne.codespan=function(q){return"<code>"+q+"</code>"},ne.br=function(){return this.options.xhtml?"<br/>":"<br>"},ne.del=function(q){return"<del>"+q+"</del>"},ne.link=function(q,J,oe){if(q=me(this.options.sanitize,this.options.baseUrl,q),q===null)return oe;var fe='<a href="'+Se(q)+'"';return J&&(fe+=' title="'+J+'"'),fe+=">"+oe+"</a>",fe},ne.image=function(q,J,oe){if(q=me(this.options.sanitize,this.options.baseUrl,q),q===null)return oe;var fe='<img src="'+q+'" alt="'+oe+'"';return J&&(fe+=' title="'+J+'"'),fe+=this.options.xhtml?"/>":">",fe},ne.text=function(q){return q},H}(),ge=function(){function H(){}var ne=H.prototype;return ne.strong=function(q){return q},ne.em=function(q){return q},ne.codespan=function(q){return q},ne.del=function(q){return q},ne.html=function(q){return q},ne.text=function(q){return q},ne.link=function(q,J,oe){return""+oe},ne.image=function(q,J,oe){return""+oe},ne.br=function(){return""},H}(),Ce=function(){function H(){this.seen={}}var ne=H.prototype;return ne.serialize=function(q){return q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ne.getNextSafeSlug=function(q,J){var oe=q,fe=0;if(this.seen.hasOwnProperty(oe)){fe=this.seen[q];do fe++,oe=q+"-"+fe;while(this.seen.hasOwnProperty(oe))}return J||(this.seen[q]=fe,this.seen[oe]=0),oe},ne.slug=function(q,J){J===void 0&&(J={});var oe=this.serialize(q);return this.getNextSafeSlug(oe,J.dryrun)},H}(),Pe=S.defaults,$e=F.unescape,_e=function(){function H(he){this.options=he||Pe,this.options.renderer=this.options.renderer||new Me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ge,this.slugger=new Ce}H.parse=function(q,J){var oe=new H(J);return oe.parse(q)},H.parseInline=function(q,J){var oe=new H(J);return oe.parseInline(q)};var ne=H.prototype;return ne.parse=function(q,J){J===void 0&&(J=!0);var oe="",fe,pe,We,Ne,Ve,Xe,Ze,ct,ot,nt,ue,De,le,j,Ae,Te,Ye,Ge,rt=q.length;for(fe=0;fe<rt;fe++)switch(nt=q[fe],nt.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(nt.tokens),nt.depth,$e(this.parseInline(nt.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(nt.text,nt.lang,nt.escaped);continue}case"table":{for(ct="",Ze="",Ne=nt.header.length,pe=0;pe<Ne;pe++)Ze+=this.renderer.tablecell(this.parseInline(nt.tokens.header[pe]),{header:!0,align:nt.align[pe]});for(ct+=this.renderer.tablerow(Ze),ot="",Ne=nt.cells.length,pe=0;pe<Ne;pe++){for(Xe=nt.tokens.cells[pe],Ze="",Ve=Xe.length,We=0;We<Ve;We++)Ze+=this.renderer.tablecell(this.parseInline(Xe[We]),{header:!1,align:nt.align[We]});ot+=this.renderer.tablerow(Ze)}oe+=this.renderer.table(ct,ot);continue}case"blockquote":{ot=this.parse(nt.tokens),oe+=this.renderer.blockquote(ot);continue}case"list":{for(ue=nt.ordered,De=nt.start,le=nt.loose,Ne=nt.items.length,ot="",pe=0;pe<Ne;pe++)Ae=nt.items[pe],Te=Ae.checked,Ye=Ae.task,j="",Ae.task&&(Ge=this.renderer.checkbox(Te),le?Ae.tokens.length>0&&Ae.tokens[0].type==="text"?(Ae.tokens[0].text=Ge+" "+Ae.tokens[0].text,Ae.tokens[0].tokens&&Ae.tokens[0].tokens.length>0&&Ae.tokens[0].tokens[0].type==="text"&&(Ae.tokens[0].tokens[0].text=Ge+" "+Ae.tokens[0].tokens[0].text)):Ae.tokens.unshift({type:"text",text:Ge}):j+=Ge),j+=this.parse(Ae.tokens,le),ot+=this.renderer.listitem(j,Ye,Te);oe+=this.renderer.list(ot,ue,De);continue}case"html":{oe+=this.renderer.html(nt.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(nt.tokens));continue}case"text":{for(ot=nt.tokens?this.parseInline(nt.tokens):nt.text;fe+1<rt&&q[fe+1].type==="text";)nt=q[++fe],ot+=`
`+(nt.tokens?this.parseInline(nt.tokens):nt.text);oe+=J?this.renderer.paragraph(ot):ot;continue}default:{var at='Token with "'+nt.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}return oe},ne.parseInline=function(q,J){J=J||this.renderer;var oe="",fe,pe,We=q.length;for(fe=0;fe<We;fe++)switch(pe=q[fe],pe.type){case"escape":{oe+=J.text(pe.text);break}case"html":{oe+=J.html(pe.text);break}case"link":{oe+=J.link(pe.href,pe.title,this.parseInline(pe.tokens,J));break}case"image":{oe+=J.image(pe.href,pe.title,pe.text);break}case"strong":{oe+=J.strong(this.parseInline(pe.tokens,J));break}case"em":{oe+=J.em(this.parseInline(pe.tokens,J));break}case"codespan":{oe+=J.codespan(pe.text);break}case"br":{oe+=J.br();break}case"del":{oe+=J.del(this.parseInline(pe.tokens,J));break}case"text":{oe+=J.text(pe.text);break}default:{var Ne='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}return oe},H}(),qe=F.merge,V=F.checkSanitizeDeprecation,X=F.escape,ve=S.getDefaults,Le=S.changeDefaults,He=S.defaults;function Oe(H,ne,he){if(typeof H=="undefined"||H===null)throw new Error("marked(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");if(typeof ne=="function"&&(he=ne,ne=null),ne=qe({},Oe.defaults,ne||{}),V(ne),he){var q=ne.highlight,J;try{J=te.lex(H,ne)}catch(We){return he(We)}var oe=function(Ne){var Ve;if(!Ne)try{Ve=_e.parse(J,ne)}catch(Xe){Ne=Xe}return ne.highlight=q,Ne?he(Ne):he(null,Ve)};if(!q||q.length<3||(delete ne.highlight,!J.length))return oe();var fe=0;Oe.walkTokens(J,function(We){We.type==="code"&&(fe++,setTimeout(function(){q(We.text,We.lang,function(Ne,Ve){if(Ne)return oe(Ne);Ve!=null&&Ve!==We.text&&(We.text=Ve,We.escaped=!0),fe--,fe===0&&oe()})},0))}),fe===0&&oe();return}try{var pe=te.lex(H,ne);return ne.walkTokens&&Oe.walkTokens(pe,ne.walkTokens),_e.parse(pe,ne)}catch(We){if(We.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+X(We.message+"",!0)+"</pre>";throw We}}Oe.options=Oe.setOptions=function(H){return qe(Oe.defaults,H),Le(Oe.defaults),Oe},Oe.getDefaults=ve,Oe.defaults=He,Oe.use=function(H){var ne=qe({},H);if(H.renderer&&function(){var q=Oe.defaults.renderer||new Me,J=function(pe){var We=q[pe];q[pe]=function(){for(var Ne=arguments.length,Ve=new Array(Ne),Xe=0;Xe<Ne;Xe++)Ve[Xe]=arguments[Xe];var Ze=H.renderer[pe].apply(q,Ve);return Ze===!1&&(Ze=We.apply(q,Ve)),Ze}};for(var oe in H.renderer)J(oe);ne.renderer=q}(),H.tokenizer&&function(){var q=Oe.defaults.tokenizer||new x,J=function(pe){var We=q[pe];q[pe]=function(){for(var Ne=arguments.length,Ve=new Array(Ne),Xe=0;Xe<Ne;Xe++)Ve[Xe]=arguments[Xe];var Ze=H.tokenizer[pe].apply(q,Ve);return Ze===!1&&(Ze=We.apply(q,Ve)),Ze}};for(var oe in H.tokenizer)J(oe);ne.tokenizer=q}(),H.walkTokens){var he=Oe.defaults.walkTokens;ne.walkTokens=function(q){H.walkTokens(q),he&&he(q)}}Oe.setOptions(ne)},Oe.walkTokens=function(H,ne){for(var he=A(H),q;!(q=he()).done;){var J=q.value;switch(ne(J),J.type){case"table":{for(var oe=A(J.tokens.header),fe;!(fe=oe()).done;){var pe=fe.value;Oe.walkTokens(pe,ne)}for(var We=A(J.tokens.cells),Ne;!(Ne=We()).done;)for(var Ve=Ne.value,Xe=A(Ve),Ze;!(Ze=Xe()).done;){var ct=Ze.value;Oe.walkTokens(ct,ne)}break}case"list":{Oe.walkTokens(J.items,ne);break}default:J.tokens&&Oe.walkTokens(J.tokens,ne)}}},Oe.parseInline=function(H,ne){if(typeof H=="undefined"||H===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");ne=qe({},Oe.defaults,ne||{}),V(ne);try{var he=te.lexInline(H,ne);return ne.walkTokens&&Oe.walkTokens(he,ne.walkTokens),_e.parseInline(he,ne)}catch(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+X(q.message+"",!0)+"</pre>";throw q}},Oe.Parser=_e,Oe.parser=_e.parse,Oe.Renderer=Me,Oe.TextRenderer=ge,Oe.Lexer=te,Oe.lexer=te.lex,Oe.Tokenizer=x,Oe.Slugger=Ce,Oe.parse=Oe;var et=Oe;return et}),define(be[78],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(S,I,y){return Math.min(Math.max(S,I),y)}e.clamp=E;function k(S,I){return(I+S%I)%I}e.rot=k;class A{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=A;class T{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T});"use strict";(function(){function ie(A){const T=[];typeof A=="number"&&T.push("code/timeOrigin",A);function S(y){T.push(y,Date.now())}function I(){const y=[];for(let n=0;n<T.length;n+=2)y.push({name:T[n],startTime:T[n+1]});return y}return{mark:S,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const S of performance.getEntriesByType("mark"))T.push({name:S.name,startTime:Math.round(A+S.startTime)});return T}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function E(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=E(k))})(),define(be[21],we([0,1]),function(ie,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const k="en";let A=!1,T=!1,S=!1,I=!1,y=!1,n=!1,R=!1,C,v=k,m,i;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof e.globals.vscode!="undefined"?s=e.globals.vscode.process:typeof process!="undefined"&&(s=process);const p=typeof((E=s==null?void 0:s.versions)===null||E===void 0?void 0:E.electron)=="string"&&s.type==="renderer";if(e.isElectronSandboxed=p&&(s==null?void 0:s.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const o=s==null?void 0:s.env.VSCODE_BROWSER_CODE_LOADING;if(typeof o=="string")return o==="none"||o==="code"||o==="bypassHeatCheck"||o==="bypassHeatCheckAndEagerCompile"?o:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!p)i=navigator.userAgent,A=i.indexOf("Windows")>=0,T=i.indexOf("Macintosh")>=0,R=(i.indexOf("Macintosh")>=0||i.indexOf("iPad")>=0||i.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=i.indexOf("Linux")>=0,n=!0,C=navigator.language,v=C;else if(typeof s=="object"){A=s.platform==="win32",T=s.platform==="darwin",S=s.platform==="linux",I=S&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,C=k,v=k;const o=s.env.VSCODE_NLS_CONFIG;if(o)try{const a=JSON.parse(o),f=a.availableLanguages["*"];C=a.locale,v=f||k,m=a._translationsConfigFile}catch(a){}y=!0}else console.error("Unable to resolve platform.");var h;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function w(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let _=0;T?_=1:A?_=3:S&&(_=2),e.isWindows=A,e.isMacintosh=T,e.isLinux=S,e.isLinuxSnap=I,e.isNative=y,e.isWeb=n,e.isIOS=R,e.platform=_,e.userAgent=i,e.language=v;var c;(function(o){function a(){return e.language}o.value=a;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=f;function b(){return e.language==="en"}o.isDefault=b})(c=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeSetImmediateId)for(let d=0,g=f.length;d<g;d++){const P=f[d];if(P.id===D.data.vscodeSetImmediateId){f.splice(d,1),P.callback();return}}});let b=0;return D=>{const d=++b;f.push({id:d,callback:D}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(typeof(s==null?void 0:s.nextTick)=="function")return s.nextTick.bind(s);const a=Promise.resolve();return f=>a.then(f)}();var l;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||R?2:A?1:3;let t=!0,r=!1;function u(){if(!r){r=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,t=new Uint16Array(o.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=u}),define(be[45],we([0,1,21]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let k;if(typeof E.globals.vscode!="undefined"){const A=E.globals.vscode.process;k={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(T){return(0,E.setImmediate)(T)}}}else typeof process!="undefined"?k={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:k={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},nextTick(A){return(0,E.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick}),define(be[11],we([0,1,45]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,A=97,T=90,S=122,I=46,y=47,n=92,R=58,C=63;class v extends Error{constructor(c,l,t){let r;typeof l=="string"&&l.indexOf("not ")===0?(r="must not be",l=l.replace(/^not /,"")):r="must be";const u=c.indexOf(".")!==-1?"property":"argument";let o=`The "${c}" ${u} ${r} of type ${l}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function m(_,c){if(typeof _!="string")throw new v(c,"string",_)}function i(_){return _===y||_===n}function s(_){return _===y}function p(_){return _>=k&&_<=T||_>=A&&_<=S}function h(_,c,l,t){let r="",u=0,o=-1,a=0,f=0;for(let b=0;b<=_.length;++b){if(b<_.length)f=_.charCodeAt(b);else{if(t(f))break;f=y}if(t(f)){if(!(o===b-1||a===1))if(a===2){if(r.length<2||u!==2||r.charCodeAt(r.length-1)!==I||r.charCodeAt(r.length-2)!==I){if(r.length>2){const D=r.lastIndexOf(l);D===-1?(r="",u=0):(r=r.slice(0,D),u=r.length-1-r.lastIndexOf(l)),o=b,a=0;continue}else if(r.length!==0){r="",u=0,o=b,a=0;continue}}c&&(r+=r.length>0?`${l}..`:"..",u=2)}else r.length>0?r+=`${l}${_.slice(o+1,b)}`:r=_.slice(o+1,b),u=b-o-1;o=b,a=0}else f===I&&a!==-1?++a:a=-1}return r}function w(_,c){if(c===null||typeof c!="object")throw new v("pathObject","Object",c);const l=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return l?l===c.root?`${l}${t}`:`${l}${_}${t}`:t}e.win32={resolve(..._){let c="",l="",t=!1;for(let r=_.length-1;r>=-1;r--){let u;if(r>=0){if(u=_[r],m(u,"path"),u.length===0)continue}else c.length===0?u=E.cwd():(u=E.env[`=${c}`]||E.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==c.toLowerCase()&&u.charCodeAt(2)===n)&&(u=`${c}\\`));const o=u.length;let a=0,f="",b=!1;const D=u.charCodeAt(0);if(o===1)i(D)&&(a=1,b=!0);else if(i(D))if(b=!0,i(u.charCodeAt(1))){let d=2,g=d;for(;d<o&&!i(u.charCodeAt(d));)d++;if(d<o&&d!==g){const P=u.slice(g,d);for(g=d;d<o&&i(u.charCodeAt(d));)d++;if(d<o&&d!==g){for(g=d;d<o&&!i(u.charCodeAt(d));)d++;(d===o||d!==g)&&(f=`\\\\${P}\\${u.slice(g,d)}`,a=d)}}}else a=1;else p(D)&&u.charCodeAt(1)===R&&(f=u.slice(0,2),a=2,o>2&&i(u.charCodeAt(2))&&(b=!0,a=3));if(f.length>0)if(c.length>0){if(f.toLowerCase()!==c.toLowerCase())continue}else c=f;if(t){if(c.length>0)break}else if(l=`${u.slice(a)}\\${l}`,t=b,b&&c.length>0)break}return l=h(l,!t,"\\",i),t?`${c}\\${l}`:`${c}${l}`||"."},normalize(_){m(_,"path");const c=_.length;if(c===0)return".";let l=0,t,r=!1;const u=_.charCodeAt(0);if(c===1)return s(u)?"\\":_;if(i(u))if(r=!0,i(_.charCodeAt(1))){let a=2,f=a;for(;a<c&&!i(_.charCodeAt(a));)a++;if(a<c&&a!==f){const b=_.slice(f,a);for(f=a;a<c&&i(_.charCodeAt(a));)a++;if(a<c&&a!==f){for(f=a;a<c&&!i(_.charCodeAt(a));)a++;if(a===c)return`\\\\${b}\\${_.slice(f)}\\`;a!==f&&(t=`\\\\${b}\\${_.slice(f,a)}`,l=a)}}}else l=1;else p(u)&&_.charCodeAt(1)===R&&(t=_.slice(0,2),l=2,c>2&&i(_.charCodeAt(2))&&(r=!0,l=3));let o=l<c?h(_.slice(l),!r,"\\",i):"";return o.length===0&&!r&&(o="."),o.length>0&&i(_.charCodeAt(c-1))&&(o+="\\"),t===void 0?r?`\\${o}`:o:r?`${t}\\${o}`:`${t}${o}`},isAbsolute(_){m(_,"path");const c=_.length;if(c===0)return!1;const l=_.charCodeAt(0);return i(l)||c>2&&p(l)&&_.charCodeAt(1)===R&&i(_.charCodeAt(2))},join(..._){if(_.length===0)return".";let c,l;for(let u=0;u<_.length;++u){const o=_[u];m(o,"path"),o.length>0&&(c===void 0?c=l=o:c+=`\\${o}`)}if(c===void 0)return".";let t=!0,r=0;if(typeof l=="string"&&i(l.charCodeAt(0))){++r;const u=l.length;u>1&&i(l.charCodeAt(1))&&(++r,u>2&&(i(l.charCodeAt(2))?++r:t=!1))}if(t){for(;r<c.length&&i(c.charCodeAt(r));)r++;r>=2&&(c=`\\${c.slice(r)}`)}return e.win32.normalize(c)},relative(_,c){if(m(_,"from"),m(c,"to"),_===c)return"";const l=e.win32.resolve(_),t=e.win32.resolve(c);if(l===t||(_=l.toLowerCase(),c=t.toLowerCase(),_===c))return"";let r=0;for(;r<_.length&&_.charCodeAt(r)===n;)r++;let u=_.length;for(;u-1>r&&_.charCodeAt(u-1)===n;)u--;const o=u-r;let a=0;for(;a<c.length&&c.charCodeAt(a)===n;)a++;let f=c.length;for(;f-1>a&&c.charCodeAt(f-1)===n;)f--;const b=f-a,D=o<b?o:b;let d=-1,g=0;for(;g<D;g++){const F=_.charCodeAt(r+g);if(F!==c.charCodeAt(a+g))break;F===n&&(d=g)}if(g!==D){if(d===-1)return t}else{if(b>D){if(c.charCodeAt(a+g)===n)return t.slice(a+g+1);if(g===2)return t.slice(a+g)}o>D&&(_.charCodeAt(r+g)===n?d=g:g===2&&(d=3)),d===-1&&(d=0)}let P="";for(g=r+d+1;g<=u;++g)(g===u||_.charCodeAt(g)===n)&&(P+=P.length===0?"..":"\\..");return a+=d,P.length>0?`${P}${t.slice(a,f)}`:(t.charCodeAt(a)===n&&++a,t.slice(a,f))},toNamespacedPath(_){if(typeof _!="string")return _;if(_.length===0)return"";const c=e.win32.resolve(_);if(c.length<=2)return _;if(c.charCodeAt(0)===n){if(c.charCodeAt(1)===n){const l=c.charCodeAt(2);if(l!==C&&l!==I)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(p(c.charCodeAt(0))&&c.charCodeAt(1)===R&&c.charCodeAt(2)===n)return`\\\\?\\${c}`;return _},dirname(_){m(_,"path");const c=_.length;if(c===0)return".";let l=-1,t=0;const r=_.charCodeAt(0);if(c===1)return i(r)?_:".";if(i(r)){if(l=t=1,i(_.charCodeAt(1))){let a=2,f=a;for(;a<c&&!i(_.charCodeAt(a));)a++;if(a<c&&a!==f){for(f=a;a<c&&i(_.charCodeAt(a));)a++;if(a<c&&a!==f){for(f=a;a<c&&!i(_.charCodeAt(a));)a++;if(a===c)return _;a!==f&&(l=t=a+1)}}}}else p(r)&&_.charCodeAt(1)===R&&(l=c>2&&i(_.charCodeAt(2))?3:2,t=l);let u=-1,o=!0;for(let a=c-1;a>=t;--a)if(i(_.charCodeAt(a))){if(!o){u=a;break}}else o=!1;if(u===-1){if(l===-1)return".";u=l}return _.slice(0,u)},basename(_,c){c!==void 0&&m(c,"ext"),m(_,"path");let l=0,t=-1,r=!0,u;if(_.length>=2&&p(_.charCodeAt(0))&&_.charCodeAt(1)===R&&(l=2),c!==void 0&&c.length>0&&c.length<=_.length){if(c===_)return"";let o=c.length-1,a=-1;for(u=_.length-1;u>=l;--u){const f=_.charCodeAt(u);if(i(f)){if(!r){l=u+1;break}}else a===-1&&(r=!1,a=u+1),o>=0&&(f===c.charCodeAt(o)?--o==-1&&(t=u):(o=-1,t=a))}return l===t?t=a:t===-1&&(t=_.length),_.slice(l,t)}for(u=_.length-1;u>=l;--u)if(i(_.charCodeAt(u))){if(!r){l=u+1;break}}else t===-1&&(r=!1,t=u+1);return t===-1?"":_.slice(l,t)},extname(_){m(_,"path");let c=0,l=-1,t=0,r=-1,u=!0,o=0;_.length>=2&&_.charCodeAt(1)===R&&p(_.charCodeAt(0))&&(c=t=2);for(let a=_.length-1;a>=c;--a){const f=_.charCodeAt(a);if(i(f)){if(!u){t=a+1;break}continue}r===-1&&(u=!1,r=a+1),f===I?l===-1?l=a:o!==1&&(o=1):l!==-1&&(o=-1)}return l===-1||r===-1||o===0||o===1&&l===r-1&&l===t+1?"":_.slice(l,r)},format:w.bind(null,"\\"),parse(_){m(_,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(_.length===0)return c;const l=_.length;let t=0,r=_.charCodeAt(0);if(l===1)return i(r)?(c.root=c.dir=_,c):(c.base=c.name=_,c);if(i(r)){if(t=1,i(_.charCodeAt(1))){let d=2,g=d;for(;d<l&&!i(_.charCodeAt(d));)d++;if(d<l&&d!==g){for(g=d;d<l&&i(_.charCodeAt(d));)d++;if(d<l&&d!==g){for(g=d;d<l&&!i(_.charCodeAt(d));)d++;d===l?t=d:d!==g&&(t=d+1)}}}}else if(p(r)&&_.charCodeAt(1)===R){if(l<=2)return c.root=c.dir=_,c;if(t=2,i(_.charCodeAt(2))){if(l===3)return c.root=c.dir=_,c;t=3}}t>0&&(c.root=_.slice(0,t));let u=-1,o=t,a=-1,f=!0,b=_.length-1,D=0;for(;b>=t;--b){if(r=_.charCodeAt(b),i(r)){if(!f){o=b+1;break}continue}a===-1&&(f=!1,a=b+1),r===I?u===-1?u=b:D!==1&&(D=1):u!==-1&&(D=-1)}return a!==-1&&(u===-1||D===0||D===1&&u===a-1&&u===o+1?c.base=c.name=_.slice(o,a):(c.name=_.slice(o,u),c.base=_.slice(o,a),c.ext=_.slice(u,a))),o>0&&o!==t?c.dir=_.slice(0,o-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(..._){let c="",l=!1;for(let t=_.length-1;t>=-1&&!l;t--){const r=t>=0?_[t]:E.cwd();m(r,"path"),r.length!==0&&(c=`${r}/${c}`,l=r.charCodeAt(0)===y)}return c=h(c,!l,"/",s),l?`/${c}`:c.length>0?c:"."},normalize(_){if(m(_,"path"),_.length===0)return".";const c=_.charCodeAt(0)===y,l=_.charCodeAt(_.length-1)===y;return _=h(_,!c,"/",s),_.length===0?c?"/":l?"./":".":(l&&(_+="/"),c?`/${_}`:_)},isAbsolute(_){return m(_,"path"),_.length>0&&_.charCodeAt(0)===y},join(..._){if(_.length===0)return".";let c;for(let l=0;l<_.length;++l){const t=_[l];m(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(_,c){if(m(_,"from"),m(c,"to"),_===c||(_=e.posix.resolve(_),c=e.posix.resolve(c),_===c))return"";const l=1,t=_.length,r=t-l,u=1,o=c.length-u,a=r<o?r:o;let f=-1,b=0;for(;b<a;b++){const d=_.charCodeAt(l+b);if(d!==c.charCodeAt(u+b))break;d===y&&(f=b)}if(b===a)if(o>a){if(c.charCodeAt(u+b)===y)return c.slice(u+b+1);if(b===0)return c.slice(u+b)}else r>a&&(_.charCodeAt(l+b)===y?f=b:b===0&&(f=0));let D="";for(b=l+f+1;b<=t;++b)(b===t||_.charCodeAt(b)===y)&&(D+=D.length===0?"..":"/..");return`${D}${c.slice(u+f)}`},toNamespacedPath(_){return _},dirname(_){if(m(_,"path"),_.length===0)return".";const c=_.charCodeAt(0)===y;let l=-1,t=!0;for(let r=_.length-1;r>=1;--r)if(_.charCodeAt(r)===y){if(!t){l=r;break}}else t=!1;return l===-1?c?"/":".":c&&l===1?"//":_.slice(0,l)},basename(_,c){c!==void 0&&m(c,"ext"),m(_,"path");let l=0,t=-1,r=!0,u;if(c!==void 0&&c.length>0&&c.length<=_.length){if(c===_)return"";let o=c.length-1,a=-1;for(u=_.length-1;u>=0;--u){const f=_.charCodeAt(u);if(f===y){if(!r){l=u+1;break}}else a===-1&&(r=!1,a=u+1),o>=0&&(f===c.charCodeAt(o)?--o==-1&&(t=u):(o=-1,t=a))}return l===t?t=a:t===-1&&(t=_.length),_.slice(l,t)}for(u=_.length-1;u>=0;--u)if(_.charCodeAt(u)===y){if(!r){l=u+1;break}}else t===-1&&(r=!1,t=u+1);return t===-1?"":_.slice(l,t)},extname(_){m(_,"path");let c=-1,l=0,t=-1,r=!0,u=0;for(let o=_.length-1;o>=0;--o){const a=_.charCodeAt(o);if(a===y){if(!r){l=o+1;break}continue}t===-1&&(r=!1,t=o+1),a===I?c===-1?c=o:u!==1&&(u=1):c!==-1&&(u=-1)}return c===-1||t===-1||u===0||u===1&&c===t-1&&c===l+1?"":_.slice(c,t)},format:w.bind(null,"/"),parse(_){m(_,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(_.length===0)return c;const l=_.charCodeAt(0)===y;let t;l?(c.root="/",t=1):t=0;let r=-1,u=0,o=-1,a=!0,f=_.length-1,b=0;for(;f>=t;--f){const D=_.charCodeAt(f);if(D===y){if(!a){u=f+1;break}continue}o===-1&&(a=!1,o=f+1),D===I?r===-1?r=f:b!==1&&(b=1):r!==-1&&(b=-1)}if(o!==-1){const D=u===0&&l?1:u;r===-1||b===0||b===1&&r===o-1&&r===u+1?c.base=c.name=_.slice(D,o):(c.name=_.slice(D,r),c.base=_.slice(D,o),c.ext=_.slice(r,o))}return u>0?c.dir=_.slice(0,u-1):l&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=E.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E.platform==="win32"?e.win32.join:e.posix.join,e.resolve=E.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=E.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=E.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=E.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=E.platform==="win32"?e.win32.extname:e.posix.extname,e.format=E.platform==="win32"?e.win32.format:e.posix.format,e.parse=E.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=E.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=E.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[55],we([0,1,21]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=E.globals.performance&&typeof E.globals.performance.now=="function";class A{constructor(S){this._highResolution=k&&S,this._startTime=this._now(),this._stopTime=-1}static create(S=!0){return new A(S)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=A}),define(be[3],we([0,1,10,52,6,44,55]),function(ie,e,E,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(h){h.None=()=>A.Disposable.None;function w(W){return(B,K=null,L)=>{let U=!1,x;return x=W(Q=>{if(!U)return x?x.dispose():U=!0,B.call(K,Q)},null,L),U&&x.dispose(),x}}h.once=w;function _(W,B){return o((K,L=null,U)=>W(x=>K.call(L,B(x)),null,U))}h.map=_;function c(W,B){return o((K,L=null,U)=>W(x=>{B(x),K.call(L,x)},null,U))}h.forEach=c;function l(W,B){return o((K,L=null,U)=>W(x=>B(x)&&K.call(L,x),null,U))}h.filter=l;function t(W){return W}h.signal=t;function r(...W){return(B,K=null,L)=>(0,A.combinedDisposable)(...W.map(U=>U(x=>B.call(K,x),null,L)))}h.any=r;function u(W,B,K){let L=K;return _(W,U=>(L=B(L,U),L))}h.reduce=u;function o(W){let B;const K=new v({onFirstListenerAdd(){B=W(K.fire,K)},onLastListenerRemove(){B.dispose()}});return K.event}h.snapshot=o;function a(W,B,K=100,L=!1,U){let x,Q,$,ee=0;const re=new v({leakWarningThreshold:U,onFirstListenerAdd(){x=W(se=>{ee++,Q=B(Q,se),L&&!$&&(re.fire(Q),Q=void 0),clearTimeout($),$=setTimeout(()=>{const ye=Q;Q=void 0,$=void 0,(!L||ee>1)&&re.fire(ye),ee=0},K)})},onLastListenerRemove(){x.dispose()}});return re.event}h.debounce=a;function f(W){const B=new Date().getTime();return _(w(W),K=>new Date().getTime()-B)}h.stopwatch=f;function b(W){let B=!0,K;return l(W,L=>{const U=B||L!==K;return B=!1,K=L,U})}h.latch=b;function D(W,B=!1,K=[]){let L=K.slice(),U=W($=>{L?L.push($):Q.fire($)});const x=()=>{L&&L.forEach($=>Q.fire($)),L=null},Q=new v({onFirstListenerAdd(){U||(U=W($=>Q.fire($)))},onFirstListenerDidAdd(){L&&(B?setTimeout(x):x())},onLastListenerRemove(){U&&U.dispose(),U=null}});return Q.event}h.buffer=D;class d{constructor(B){this.event=B}map(B){return new d(_(this.event,B))}forEach(B){return new d(c(this.event,B))}filter(B){return new d(l(this.event,B))}reduce(B,K){return new d(u(this.event,B,K))}latch(){return new d(b(this.event))}debounce(B,K=100,L=!1,U){return new d(a(this.event,B,K,L,U))}on(B,K,L){return this.event(B,K,L)}once(B,K,L){return w(this.event)(B,K,L)}}function g(W){return new d(W)}h.chain=g;function P(W,B,K=L=>L){const L=(...$)=>Q.fire(K(...$)),U=()=>W.on(B,L),x=()=>W.removeListener(B,L),Q=new v({onFirstListenerAdd:U,onLastListenerRemove:x});return Q.event}h.fromNodeEventEmitter=P;function F(W,B,K=L=>L){const L=(...$)=>Q.fire(K(...$)),U=()=>W.addEventListener(B,L),x=()=>W.removeEventListener(B,L),Q=new v({onFirstListenerAdd:U,onLastListenerRemove:x});return Q.event}h.fromDOMEventEmitter=F;function z(W){const B=new v;let K=!1;return W.then(void 0,()=>null).then(()=>{K?B.fire(void 0):setTimeout(()=>B.fire(void 0),0)}),K=!0,B.event}h.fromPromise=z;function de(W){return new Promise(B=>w(W)(B))}h.toPromise=de})(I=e.Event||(e.Event={}));class y{constructor(w){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${w}_${y._idPool++}`}start(w){this._stopWatch=new S.StopWatch(!0),this._listenerCount=w}stop(){if(this._stopWatch){const w=this._stopWatch.elapsed();this._elapsedOverall+=w,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${w.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let n=-1;function R(h){const w=n;return n=h,{dispose(){n=w}}}e.setGlobalLeakWarningThreshold=R;class C{constructor(w,_=Math.random().toString(18).slice(2,5)){this.customThreshold=w,this.name=_,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(w){let _=n;if(typeof this.customThreshold=="number"&&(_=this.customThreshold),!(_<=0||w<_)){this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),l=this._stacks.get(c)||0;if(this._stacks.set(c,l+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=_*.5;let t,r=0;for(const[u,o]of this._stacks)(!t||r<o)&&(t=u,r=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}}class v{constructor(w){var _;this._disposed=!1,this._options=w,this._leakageMon=n>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((_=this._options)===null||_===void 0?void 0:_._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(w,_,c)=>{var l;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(_?[w,_]:w);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,w,_);const u=(l=this._leakageMon)===null||l===void 0?void 0:l.check(this._listeners.size);let o;return o={dispose:()=>{u&&u(),o.dispose=v._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof A.DisposableStore?c.add(o):Array.isArray(c)&&c.push(o),o}),this._event}fire(w){var _,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let l of this._listeners)this._deliveryQueue.push([l,w]);for((_=this._perfMon)===null||_===void 0||_.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[l,t]=this._deliveryQueue.shift();try{typeof l=="function"?l.call(void 0,t):l[0].call(l[1],t)}catch(r){(0,E.onUnexpectedError)(r)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var w,_,c;(w=this._listeners)===null||w===void 0||w.clear(),(_=this._deliveryQueue)===null||_===void 0||_.clear(),(c=this._leakageMon)===null||c===void 0||c.dispose(),this._disposed=!0}}e.Emitter=v,v._noop=function(){};class m extends v{constructor(w){super(w);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=w==null?void 0:w.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const w=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(w))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(w){this._listeners&&(this._isPaused!==0?this._eventQueue.push(w):super.fire(w))}}e.PauseableEmitter=m;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(w){const _={event:w,listener:null};this.events.push(_),this.hasListeners&&this.hook(_);const c=()=>{this.hasListeners&&this.unhook(_);const l=this.events.indexOf(_);this.events.splice(l,1)};return(0,A.toDisposable)((0,k.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(w=>this.hook(w))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(w=>this.unhook(w))}hook(w){w.listener=w.event(_=>this.emitter.fire(_))}unhook(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class s{constructor(){this.buffers=[]}wrapEvent(w){return(_,c,l)=>w(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>_.call(c,t)):_.call(c,t)},void 0,l)}bufferEvents(w){const _=[];this.buffers.push(_);const c=w();return this.buffers.pop(),_.forEach(l=>l()),c}}e.EventBufferer=s;class p{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=A.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(w){this.inputEvent=w,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=w(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p}),define(be[20],we([0,1,3]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(I,y){const n=setTimeout(I.bind(y),0);return{dispose(){clearTimeout(n)}}});var A;(function(I){function y(n){return n===I.None||n===I.Cancelled||n instanceof T?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}I.isCancellationToken=y,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(A=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class S{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=A.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=S}),define(be[36],we([0,1,3]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class k{constructor(){this._icons=new Map,this._onDidRegister=new E.Emitter}add(R){const C=this._icons.get(R.id);C?R.description?C.description=R.description:console.error(`Duplicate registration of codicon ${R.id}`):(this._icons.set(R.id,R),this._onDidRegister.fire(R))}get(R){return this._icons.get(R)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const A=new k;e.iconRegistry=A;function T(n,R){return new S(n,R)}e.registerCodicon=T;class S{constructor(R,C,v){this.id=R,this.definition=C,this.description=v,A.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=S;function I(n,R){const C=["codicon","codicon-"+n];return R&&C.push("codicon-modifier-"+R),C}e.getClassNamesArray=I;var y;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const R=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function C(i){if(i instanceof S)return["codicon","codicon-"+i.id];const s=R.exec(i.id);if(!s)return C(S.error);let[,p,h]=s;const w=["codicon","codicon-"+p];return h&&w.push("codicon-modifier-"+h.substr(1)),w}n.asClassNameArray=C;function v(i){return C(i).join(" ")}n.asClassName=v;function m(i){return"."+C(i).join(".")}n.asCSSSelector=m})(y=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(S=e.Codicon||(e.Codicon={}))}),define(be[107],we([0,1,10,6]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(p){const h=p;return h&&[h.on,h.pause,h.resume,h.destroy].every(w=>typeof w=="function")}e.isReadableStream=A;function T(p){const h=p;return h&&A(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean"}e.isReadableBufferedStream=T;function S(p,h){return new I(p,h)}e.newWriteableStream=S;class I{constructor(h,w){this.reducer=h,this.options=w,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){var w;if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof((w=this.options)===null||w===void 0?void 0:w.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(_=>this.pendingWritePromises.push(_))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(w=>w(h))}emitError(h){this.listeners.error.length===0?(0,E.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(w=>w(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,w){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(w),this.resume();break;case"end":this.listeners.end.push(w),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(w),this.state.flowing&&this.flowErrors();break}}removeListener(h,w){if(!this.state.destroyed){let _;switch(h){case"data":_=this.listeners.data;break;case"end":_=this.listeners.end;break;case"error":_=this.listeners.error;break}if(_){const c=_.indexOf(w);c>=0&&_.splice(c,1)}}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const w=[...this.pendingWritePromises];this.pendingWritePromises.length=0,w.forEach(_=>_())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(p,h){const w=[];let _;for(;(_=p.read())!==null;)w.push(_);return h(w)}e.consumeReadable=y;function n(p,h,w){const _=[];let c;for(;(c=p.read())!==null&&_.length<w;)_.push(c);return c===null&&_.length>0?h(_):{read:()=>{if(_.length>0)return _.shift();if(typeof c!="undefined"){const l=c;return c=void 0,l}return p.read()}}}e.peekReadable=n;function R(p,h){return new Promise((w,_)=>{const c=[];C(p,{onData:l=>{h&&c.push(l)},onError:l=>{h?_(l):w(void 0)},onEnd:()=>{w(h?h(c):void 0)}})})}e.consumeStream=R;function C(p,h){p.on("error",w=>h.onError(w)),p.on("end",()=>h.onEnd()),p.on("data",w=>h.onData(w))}e.listenStream=C;function v(p,h){return new Promise((w,_)=>{const c=new k.DisposableStore,l=[],t=o=>{if(l.push(o),l.length>h)return c.dispose(),p.pause(),w({stream:p,buffer:l,ended:!1})},r=o=>_(o),u=()=>w({stream:p,buffer:l,ended:!0});c.add((0,k.toDisposable)(()=>p.removeListener("error",r))),p.on("error",r),c.add((0,k.toDisposable)(()=>p.removeListener("end",u))),p.on("end",u),c.add((0,k.toDisposable)(()=>p.removeListener("data",t))),p.on("data",t)})}e.peekStream=v;function m(p,h){const w=S(h);return w.end(p),w}e.toStream=m;function i(p){let h=!1;return{read:()=>h?null:(h=!0,p)}}e.toReadable=i;function s(p,h,w){const _=S(w);return C(p,{onData:c=>_.write(h.data(c)),onError:c=>_.error(h.error?h.error(c):c),onEnd:()=>_.end()}),_}e.transform=s}),define(be[8],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function E(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=E;const k=/{(\d+)}/g;function A(H,...ne){return ne.length===0?H:H.replace(k,function(he,q){const J=parseInt(q,10);return isNaN(J)||J<0||J>=ne.length?he:ne[J]})}e.format=A;function T(H){return H.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}e.escape=T;function S(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function I(H,ne){let he=0;const q=ne.charCodeAt(0);for(let J=H.length-1;J>=0;J--)H.charCodeAt(J)===q&&he++;return he}e.count=I;function y(H,ne,he="\u2026"){return H.length<=ne?H:`${H.substr(0,ne)}${he}`}e.truncate=y;function n(H,ne=" "){const he=R(H,ne);return C(he,ne)}e.trim=n;function R(H,ne){if(!H||!ne)return H;const he=ne.length;if(he===0||H.length===0)return H;let q=0;for(;H.indexOf(ne,q)===q;)q=q+he;return H.substring(q)}e.ltrim=R;function C(H,ne){if(!H||!ne)return H;const he=ne.length,q=H.length;if(he===0||q===0)return H;let J=q,oe=-1;for(;oe=H.lastIndexOf(ne,J-1),!(oe===-1||oe+he!==J);){if(oe===0)return"";J=oe}return H.substring(0,J)}e.rtrim=C;function v(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function m(H){return H.replace(/\*/g,"")}e.stripWildcards=m;function i(H,ne,he={}){if(!H)throw new Error("Cannot create regex from empty string");ne||(H=S(H)),he.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let q="";return he.global&&(q+="g"),he.matchCase||(q+="i"),he.multiline&&(q+="m"),he.unicode&&(q+="u"),new RegExp(H,q)}e.createRegExp=i;function s(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=s;function p(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function h(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=h;function w(H){return H.split(/\r\n|\r|\n/)}e.splitLines=w;function _(H){for(let ne=0,he=H.length;ne<he;ne++){const q=H.charCodeAt(ne);if(q!==32&&q!==9)return ne}return-1}e.firstNonWhitespaceIndex=_;function c(H,ne=0,he=H.length){for(let q=ne;q<he;q++){const J=H.charCodeAt(q);if(J!==32&&J!==9)return H.substring(ne,q)}return H.substring(ne,he)}e.getLeadingWhitespace=c;function l(H,ne=H.length-1){for(let he=ne;he>=0;he--){const q=H.charCodeAt(he);if(q!==32&&q!==9)return he}return-1}e.lastNonWhitespaceIndex=l;function t(H,ne){return H<ne?-1:H>ne?1:0}e.compare=t;function r(H,ne,he=0,q=H.length,J=0,oe=ne.length){for(;he<q&&J<oe;he++,J++){let We=H.charCodeAt(he),Ne=ne.charCodeAt(J);if(We<Ne)return-1;if(We>Ne)return 1}const fe=q-he,pe=oe-J;return fe<pe?-1:fe>pe?1:0}e.compareSubstring=r;function u(H,ne){return o(H,ne,0,H.length,0,ne.length)}e.compareIgnoreCase=u;function o(H,ne,he=0,q=H.length,J=0,oe=ne.length){for(;he<q&&J<oe;he++,J++){let We=H.charCodeAt(he),Ne=ne.charCodeAt(J);if(We!==Ne){const Ve=We-Ne;if(!(Ve===32&&f(Ne))&&!(Ve===-32&&f(We)))return a(We)&&a(Ne)?Ve:r(H.toLowerCase(),ne.toLowerCase(),he,q,J,oe)}}const fe=q-he,pe=oe-J;return fe<pe?-1:fe>pe?1:0}e.compareSubstringIgnoreCase=o;function a(H){return H>=97&&H<=122}e.isLowerAsciiLetter=a;function f(H){return H>=65&&H<=90}e.isUpperAsciiLetter=f;function b(H){return a(H)||f(H)}function D(H,ne){return H.length===ne.length&&d(H,ne)}e.equalsIgnoreCase=D;function d(H,ne,he=H.length){for(let q=0;q<he;q++){const J=H.charCodeAt(q),oe=ne.charCodeAt(q);if(J!==oe){if(b(J)&&b(oe)){const fe=Math.abs(J-oe);if(fe!==0&&fe!==32)return!1}else if(String.fromCharCode(J).toLowerCase()!==String.fromCharCode(oe).toLowerCase())return!1}}return!0}function g(H,ne){const he=ne.length;return ne.length>H.length?!1:d(H,ne,he)}e.startsWithIgnoreCase=g;function P(H,ne){let he,q=Math.min(H.length,ne.length);for(he=0;he<q;he++)if(H.charCodeAt(he)!==ne.charCodeAt(he))return he;return q}e.commonPrefixLength=P;function F(H,ne){let he,q=Math.min(H.length,ne.length);const J=H.length-1,oe=ne.length-1;for(he=0;he<q;he++)if(H.charCodeAt(J-he)!==ne.charCodeAt(oe-he))return he;return q}e.commonSuffixLength=F;function z(H){return 55296<=H&&H<=56319}e.isHighSurrogate=z;function de(H){return 56320<=H&&H<=57343}e.isLowSurrogate=de;function W(H,ne){return(H-55296<<10)+(ne-56320)+65536}e.computeCodePoint=W;function B(H,ne,he){const q=H.charCodeAt(he);if(z(q)&&he+1<ne){const J=H.charCodeAt(he+1);if(de(J))return W(q,J)}return q}e.getNextCodePoint=B;function K(H,ne){const he=H.charCodeAt(ne-1);if(de(he)&&ne>1){const q=H.charCodeAt(ne-2);if(z(q))return W(q,he)}return he}function L(H,ne){const he=Oe.getInstance(),q=ne,J=H.length,oe=B(H,J,ne);ne+=oe>=65536?2:1;let fe=he.getGraphemeBreakType(oe);for(;ne<J;){const pe=B(H,J,ne),We=he.getGraphemeBreakType(pe);if(Le(fe,We))break;ne+=pe>=65536?2:1,fe=We}return ne-q}e.nextCharLength=L;function U(H,ne){const he=Oe.getInstance(),q=ne,J=K(H,ne);ne-=J>=65536?2:1;let oe=he.getGraphemeBreakType(J);for(;ne>0;){const fe=K(H,ne),pe=he.getGraphemeBreakType(fe);if(Le(pe,oe))break;ne-=fe>=65536?2:1,oe=pe}return q-ne}e.prevCharLength=U;function x(H,ne){const he=Oe.getInstance(),q=H.length,J=ne,oe=B(H,q,ne),fe=he.getGraphemeBreakType(oe);ne+=oe>=65536?2:1;let pe=fe;for(;ne<q;){const Ne=B(H,q,ne),Ve=he.getGraphemeBreakType(Ne);if(Le(pe,Ve))break;ne+=Ne>=65536?2:1,pe=Ve}const We=ne;for(ne=J,pe=fe;ne>0;){const Ne=K(H,ne),Ve=he.getGraphemeBreakType(Ne);if(Le(Ve,pe))break;ne-=Ne>=65536?2:1,pe=Ve}return[ne,We]}function Q(H,ne){return ne>0&&de(H.charCodeAt(ne))?x(H,ne-1):x(H,ne)}e.getCharContainingOffset=Q;function $(H){const ne=H.length;let he=0,q=0;for(;q<ne;){const fe=B(H,ne,q);q+=fe>=65536?2:1,fe<128?he+=1:fe<2048?he+=2:fe<65536?he+=3:he+=4}const J=new Uint8Array(he);q=0;let oe=0;for(;q<ne;){const fe=B(H,ne,q);q+=fe>=65536?2:1,fe<128?J[oe++]=fe:fe<2048?(J[oe++]=192|(fe&1984)>>>6,J[oe++]=128|(fe&63)>>>0):fe<65536?(J[oe++]=224|(fe&61440)>>>12,J[oe++]=128|(fe&4032)>>>6,J[oe++]=128|(fe&63)>>>0):(J[oe++]=240|(fe&1835008)>>>18,J[oe++]=128|(fe&258048)>>>12,J[oe++]=128|(fe&4032)>>>6,J[oe++]=128|(fe&63)>>>0)}return J}e.encodeUTF8=$;function ee(H){const ne=H.byteLength,he=[];let q=0;for(;q<ne;){const J=H[q];let oe;if(J>=240&&q+3<ne?oe=(H[q++]&7)<<18>>>0|(H[q++]&63)<<12>>>0|(H[q++]&63)<<6>>>0|(H[q++]&63)<<0>>>0:J>=224&&q+2<ne?oe=(H[q++]&15)<<12>>>0|(H[q++]&63)<<6>>>0|(H[q++]&63)<<0>>>0:J>=192&&q+1<ne?oe=(H[q++]&31)<<6>>>0|(H[q++]&63)<<0>>>0:oe=H[q++],oe>=0&&oe<=55295||oe>=57344&&oe<=65535)he.push(String.fromCharCode(oe));else if(oe>=65536&&oe<=1114111){const fe=oe-65536,pe=55296+((fe&1047552)>>>10),We=56320+((fe&1023)>>>0);he.push(String.fromCharCode(pe)),he.push(String.fromCharCode(We))}else he.push(String.fromCharCode(65533))}return he.join("")}e.decodeUTF8=ee;const re=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function se(H){return re.test(H)}e.containsRTL=se;const ye=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Ie(H){return ye.test(H)}e.containsEmoji=Ie;const xe=/^[\t\n\r\x20-\x7E]*$/;function Fe(H){return xe.test(H)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ze(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=ze;function N(H){for(let ne=0,he=H.length;ne<he;ne++)if(G(H.charCodeAt(ne)))return!0;return!1}e.containsFullWidthCharacter=N;function G(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=G;function te(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=te;function ae(H,ne){if(H.length<ne)return H;const he=/\b/g;let q=0;for(;he.test(H)&&!(H.length-he.lastIndex<ne);)q=he.lastIndex,he.lastIndex+=1;return H.substring(q).replace(/^\s/,"")}e.lcut=ae;const me=/\x1B\x5B[12]?K/g,Se=/\x1b\[\d+m/g,Me=/\x1b\[0?m/g;function ge(H){return H&&(H=H.replace(me,""),H=H.replace(Se,""),H=H.replace(Me,"")),H}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Pe(H){return Ce(H)?H.substr(1):H}e.stripUTF8BOM=Pe;function $e(H,ne){if(!H||!ne||H.length<ne.length)return!1;const he=ne.length,q=H.toLowerCase();let J=0,oe=-1;for(;J<he;){const fe=q.indexOf(ne[J],oe+1);if(fe<0)return!1;oe=fe,J++}return!0}e.fuzzyContains=$e;function _e(H,ne=!1){return H?(ne&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=_e;function qe(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=qe;function V(H,ne=1){if(ne===0)return"";let he=-1;do he=H.indexOf(`
`,he+1),ne--;while(ne>0&&he>=0);return he===-1?H:(H[he-1]==="\r"&&he--,H.substr(0,he))}e.getNLines=V;function X(H){const ne=90-65+1;return H=H%(2*ne),H<ne?String.fromCharCode(97+H):String.fromCharCode(65+H-ne)}e.singleLetterHash=X;function ve(H){return Oe.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=ve;function Le(H,ne){return H===0?ne!==5&&ne!==7:H===2&&ne===3?!1:H===4||H===2||H===3||ne===4||ne===2||ne===3?!0:!(H===8&&(ne===8||ne===9||ne===11||ne===12)||(H===11||H===9)&&(ne===9||ne===10)||(H===12||H===10)&&ne===10||ne===5||ne===13||ne===7||H===1||H===13&&ne===14||H===6&&ne===6)}e.breakBetweenGraphemeBreakType=Le;var He;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Oe{constructor(){this._data=et()}static getInstance(){return Oe._INSTANCE||(Oe._INSTANCE=new Oe),Oe._INSTANCE}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const he=this._data,q=he.length/3;let J=1;for(;J<=q;)if(ne<he[3*J])J=2*J;else if(ne>he[3*J+1])J=2*J+1;else return he[3*J+2];return 0}}Oe._INSTANCE=null;function et(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(be[24],we([0,1,8,107]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",S=typeof TextDecoder!="undefined";let I,y;class n{constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}static alloc(a){return A?new n(Buffer.allocUnsafe(a)):new n(new Uint8Array(a))}static wrap(a){return A&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new n(a)}static fromString(a,f){return!((f==null?void 0:f.dontUseNodeBuffer)||!1)&&A?new n(Buffer.from(a)):T?(I||(I=new TextEncoder),new n(I.encode(a))):new n(E.encodeUTF8(a))}static concat(a,f){if(typeof f=="undefined"){f=0;for(let d=0,g=a.length;d<g;d++)f+=a[d].byteLength}const b=n.alloc(f);let D=0;for(let d=0,g=a.length;d<g;d++){const P=a[d];b.set(P,D),D+=P.byteLength}return b}toString(){return A?this.buffer.toString():S?(y||(y=new TextDecoder),y.decode(this.buffer)):E.decodeUTF8(this.buffer)}slice(a,f){return new n(this.buffer.subarray(a,f))}set(a,f){a instanceof n?this.buffer.set(a.buffer,f):this.buffer.set(a,f)}readUInt32BE(a){return v(this.buffer,a)}writeUInt32BE(a,f){m(this.buffer,a,f)}readUInt32LE(a){return i(this.buffer,a)}writeUInt32LE(a,f){s(this.buffer,a,f)}readUInt8(a){return p(this.buffer,a)}writeUInt8(a,f){h(this.buffer,a,f)}}e.VSBuffer=n;function R(o,a){return o[a+0]<<0>>>0|o[a+1]<<8>>>0}e.readUInt16LE=R;function C(o,a,f){o[f+0]=a&255,a=a>>>8,o[f+1]=a&255}e.writeUInt16LE=C;function v(o,a){return o[a]*2**24+o[a+1]*2**16+o[a+2]*2**8+o[a+3]}e.readUInt32BE=v;function m(o,a,f){o[f+3]=a,a=a>>>8,o[f+2]=a,a=a>>>8,o[f+1]=a,a=a>>>8,o[f]=a}e.writeUInt32BE=m;function i(o,a){return o[a+0]<<0>>>0|o[a+1]<<8>>>0|o[a+2]<<16>>>0|o[a+3]<<24>>>0}e.readUInt32LE=i;function s(o,a,f){o[f+0]=a&255,a=a>>>8,o[f+1]=a&255,a=a>>>8,o[f+2]=a&255,a=a>>>8,o[f+3]=a&255}e.writeUInt32LE=s;function p(o,a){return o[a]}e.readUInt8=p;function h(o,a,f){o[f]=a}e.writeUInt8=h;function w(o){return k.consumeReadable(o,a=>n.concat(a))}e.readableToBuffer=w;function _(o){return k.toReadable(o)}e.bufferToReadable=_;function c(o){return k.consumeStream(o,a=>n.concat(a))}e.streamToBuffer=c;async function l(o){return o.ended?n.concat(o.buffer):n.concat([...o.buffer,await c(o.stream)])}e.bufferedStreamToBuffer=l;function t(o){return k.toStream(o,a=>n.concat(a))}e.bufferToStream=t;function r(o){return k.transform(o,{data:a=>typeof a=="string"?n.fromString(a):n.wrap(a)},a=>n.concat(a))}e.streamToBufferReadableStream=r;function u(o){return k.newWriteableStream(a=>n.concat(a),o)}e.newWriteableBufferStream=u}),define(be[56],we([0,1,8]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function k(h){return A(h,0)}e.hash=k;function A(h,w){switch(typeof h){case"object":return h===null?T(349,w):Array.isArray(h)?y(h,w):n(h,w);case"string":return I(h,w);case"boolean":return S(h,w);case"number":return T(h,w);case"undefined":return T(937,w);default:return T(617,w)}}e.doHash=A;function T(h,w){return(w<<5)-w+h|0}function S(h,w){return T(h?433:863,w)}function I(h,w){w=T(149417,w);for(let _=0,c=h.length;_<c;_++)w=T(h.charCodeAt(_),w);return w}e.stringHash=I;function y(h,w){return w=T(104579,w),h.reduce((_,c)=>A(c,_),w)}function n(h,w){return w=T(181387,w),Object.keys(h).sort().reduce((_,c)=>(_=I(c,_),A(h[c],_)),w)}class R{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=A(w,this._value),this._value}}e.Hasher=R;var C;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function v(h,w,_=32){const c=_-w,l=~((1<<c)-1);return(h<<w|(l&h)>>>c)>>>0}function m(h,w=0,_=h.byteLength,c=0){for(let l=0;l<_;l++)h[w+l]=c}function i(h,w,_="0"){for(;h.length<w;)h=_+h;return h}function s(h,w=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(_=>_.toString(16).padStart(2,"0")).join(""):i((h>>>0).toString(16),w/4)}e.toHexString=s;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const _=w.length;if(_!==0){const c=this._buff;let l=this._buffLen,t=this._leftoverHighSurrogate,r,u;for(t!==0?(r=t,u=-1,t=0):(r=w.charCodeAt(0),u=0);;){let o=r;if(E.isHighSurrogate(r))if(u+1<_){const a=w.charCodeAt(u+1);E.isLowSurrogate(a)?(u++,o=E.computeCodePoint(r,a)):o=65533}else{t=r;break}else E.isLowSurrogate(r)&&(o=65533);if(l=this._push(c,l,o),u++,u<_)r=w.charCodeAt(u);else break}this._buffLen=l,this._leftoverHighSurrogate=t}}_push(w,_,c){return c<128?w[_++]=c:c<2048?(w[_++]=192|(c&1984)>>>6,w[_++]=128|(c&63)>>>0):c<65536?(w[_++]=224|(c&61440)>>>12,w[_++]=128|(c&4032)>>>6,w[_++]=128|(c&63)>>>0):(w[_++]=240|(c&1835008)>>>18,w[_++]=128|(c&258048)>>>12,w[_++]=128|(c&4032)>>>6,w[_++]=128|(c&63)>>>0),_>=64&&(this._step(),_-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),_}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),s(this._h0)+s(this._h1)+s(this._h2)+s(this._h3)+s(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=p._bigBlock32,_=this._buffDV;for(let b=0;b<64;b+=4)w.setUint32(b,_.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)w.setUint32(b,v(w.getUint32(b-12,!1)^w.getUint32(b-32,!1)^w.getUint32(b-56,!1)^w.getUint32(b-64,!1),1),!1);let c=this._h0,l=this._h1,t=this._h2,r=this._h3,u=this._h4,o,a,f;for(let b=0;b<80;b++)b<20?(o=l&t|~l&r,a=1518500249):b<40?(o=l^t^r,a=1859775393):b<60?(o=l&t|l&r|t&r,a=2400959708):(o=l^t^r,a=3395469782),f=v(c,5)+o+u+a+w.getUint32(b*4,!1)&4294967295,u=r,r=t,t=v(l,30),l=c,c=f;this._h0=this._h0+c&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+u&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),define(be[46],we([0,1,8]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(k||(k={})),function(A){const T="error",S="warning",I="warn",y="info";function n(R){return R?E.equalsIgnoreCase(T,R)?A.Error:E.equalsIgnoreCase(S,R)||E.equalsIgnoreCase(I,R)?A.Warning:E.equalsIgnoreCase(y,R)?A.Info:A.Ignore:A.Ignore}A.fromValue=n}(k||(k={})),e.default=k}),define(be[12],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function E(f){return Array.isArray(f)}e.isArray=E;function k(f){return typeof f=="string"}e.isString=k;function A(f){return Array.isArray(f)&&f.every(b=>k(b))}e.isStringArray=A;function T(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=T;function S(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=S;function I(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=I;function y(f){return f===!0||f===!1}e.isBoolean=y;function n(f){return typeof f=="undefined"}e.isUndefined=n;function R(f){return!C(f)}e.isDefined=R;function C(f){return n(f)||f===null}e.isUndefinedOrNull=C;function v(f,b){if(!f)throw new Error(b?`Unexpected type, expected '${b}'`:"Unexpected type")}e.assertType=v;function m(f){if(C(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=m;function i(...f){const b=[];for(let D=0;D<f.length;D++){const d=f[D];if(C(d))throw new Error(`Assertion Failed: argument at index ${D} is undefined or null`);b.push(d)}return b}e.assertAllDefined=i;const s=Object.prototype.hasOwnProperty;function p(f){if(!T(f))return!1;for(let b in f)if(s.call(f,b))return!1;return!0}e.isEmptyObject=p;function h(f){return typeof f=="function"}e.isFunction=h;function w(...f){return f.length>0&&f.every(h)}e.areFunctions=w;function _(f,b){const D=Math.min(f.length,b.length);for(let d=0;d<D;d++)c(f[d],b[d])}e.validateConstraints=_;function c(f,b){if(k(b)){if(typeof f!==b)throw new Error(`argument does not match constraint: typeof ${b}`)}else if(h(b)){try{if(f instanceof b)return}catch(D){}if(!C(f)&&f.constructor===b||b.length===1&&b.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function l(f){let b=[],D=Object.getPrototypeOf(f);for(;Object.prototype!==D;)b=b.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return b}e.getAllPropertyNames=l;function t(f){const b=[];for(const D of l(f))typeof f[D]=="function"&&b.push(D);return b}e.getAllMethodNames=t;function r(f,b){const D=g=>function(){const P=Array.prototype.slice.call(arguments,0);return b(g,P)};let d={};for(const g of f)d[g]=D(g);return d}e.createProxyObject=r;function u(f){return f===null?void 0:f}e.withNullAsUndefined=u;function o(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=o;function a(f){return class{constructor(){return new Proxy({},{get(b,D){if(b[D])return b[D];throw new Error(`Not Implemented: ${f}->${String(D)}`)}})}}}e.NotImplementedProxy=a}),define(be[37],we([0,1,21,8,11,12]),function(ie,e,E,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function S(r){return r===47||r===92}e.isPathSeparator=S;function I(r){return r.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=I;function y(r,u=A.posix.sep){if(!r)return"";const o=r.length,a=r.charCodeAt(0);if(S(a)){if(S(r.charCodeAt(1))&&!S(r.charCodeAt(2))){let b=3;const D=b;for(;b<o&&!S(r.charCodeAt(b));b++);if(D!==b&&!S(r.charCodeAt(b+1))){for(b+=1;b<o;b++)if(S(r.charCodeAt(b)))return r.slice(0,b+1).replace(/[\\/]/g,u)}}return u}else if(p(a)&&r.charCodeAt(1)===58)return S(r.charCodeAt(2))?r.slice(0,2)+u:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<o;f++)if(S(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.getRoot=y;function n(r){if(!E.isWindows||!r||r.length<5)return!1;let u=r.charCodeAt(0);if(u!==92||(u=r.charCodeAt(1),u!==92))return!1;let o=2;const a=o;for(;o<r.length&&(u=r.charCodeAt(o),u!==92);o++);return!(a===o||(u=r.charCodeAt(o+1),isNaN(u)||u===92))}e.isUNC=n;const R=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(r,u=E.isWindows){const o=u?R:C;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||u&&v.test(r)||r==="."||r===".."||u&&r[r.length-1]==="."||u&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=m;function i(r,u,o){const a=r===u;return!o||a?a:!r||!u?!1:(0,k.equalsIgnoreCase)(r,u)}e.isEqual=i;function s(r,u,o,a=A.sep){if(r===u)return!0;if(!r||!u||u.length>r.length)return!1;if(o){if(!(0,k.startsWithIgnoreCase)(r,u))return!1;if(u.length===r.length)return!0;let b=u.length;return u.charAt(u.length-1)===a&&b--,r.charAt(b)===a}return u.charAt(u.length-1)!==a&&(u+=a),r.indexOf(u)===0}e.isEqualOrParent=s;function p(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=p;function h(r,u){return E.isWindows&&r.endsWith(":")&&(r+=A.sep),(0,A.isAbsolute)(r)||(r=(0,A.join)(u,r)),r=(0,A.normalize)(r),E.isWindows?(r=(0,k.rtrim)(r,A.sep),r.endsWith(":")&&(r+=A.sep)):(r=(0,k.rtrim)(r,A.sep),r||(r=A.sep)),r}e.sanitizeFilePath=h;function w(r){const u=(0,A.normalize)(r);return E.isWindows?r.length>3?!1:_(u)&&(r.length===2||u.charCodeAt(2)===92):u===A.posix.sep}e.isRootOrDriveLetter=w;function _(r){return E.isWindows?p(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=_;function c(r){return _(r)?r[0]:void 0}e.getDriveLetter=c;function l(r,u,o){return u.length>r.length?-1:r===u?0:(o&&(r=r.toLowerCase(),u=u.toLowerCase()),r.indexOf(u))}e.indexOfPath=l;function t(r){const u=r.split(":");let o,a,f;if(u.forEach(b=>{const D=Number(b);(0,T.isNumber)(D)?a===void 0?a=D:f===void 0&&(f=D):o=o?[o,b].join(":"):b}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:a!==void 0?a:void 0,column:f!==void 0?f:a!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(be[23],we([0,1,12]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(i){if(!i||typeof i!="object"||i instanceof RegExp)return i;const s=Array.isArray(i)?[]:{};return Object.keys(i).forEach(p=>{i[p]&&typeof i[p]=="object"?s[p]=k(i[p]):s[p]=i[p]}),s}e.deepClone=k;function A(i){if(!i||typeof i!="object")return i;const s=[i];for(;s.length>0;){const p=s.shift();Object.freeze(p);for(const h in p)if(T.call(p,h)){const w=p[h];typeof w=="object"&&!Object.isFrozen(w)&&s.push(w)}}return i}e.deepFreeze=A;const T=Object.prototype.hasOwnProperty;function S(i,s){return I(i,s,new Set)}e.cloneAndChange=S;function I(i,s,p){if((0,E.isUndefinedOrNull)(i))return i;const h=s(i);if(typeof h!="undefined")return h;if((0,E.isArray)(i)){const w=[];for(const _ of i)w.push(I(_,s,p));return w}if((0,E.isObject)(i)){if(p.has(i))throw new Error("Cannot clone recursive data-structure");p.add(i);const w={};for(let _ in i)T.call(i,_)&&(w[_]=I(i[_],s,p));return p.delete(i),w}return i}function y(i,s,p=!0){return(0,E.isObject)(i)?((0,E.isObject)(s)&&Object.keys(s).forEach(h=>{h in i?p&&((0,E.isObject)(i[h])&&(0,E.isObject)(s[h])?y(i[h],s[h],p):i[h]=s[h]):i[h]=s[h]}),i):s}e.mixin=y;function n(i,s){if(i===s)return!0;if(i==null||s===null||s===void 0||typeof i!=typeof s||typeof i!="object"||Array.isArray(i)!==Array.isArray(s))return!1;let p,h;if(Array.isArray(i)){if(i.length!==s.length)return!1;for(p=0;p<i.length;p++)if(!n(i[p],s[p]))return!1}else{const w=[];for(h in i)w.push(h);w.sort();const _=[];for(h in s)_.push(h);if(_.sort(),!n(w,_))return!1;for(p=0;p<w.length;p++)if(!n(i[w[p]],s[w[p]]))return!1}return!0}e.equals=n;function R(i){const s=new Set;return JSON.stringify(i,(p,h)=>{if((0,E.isObject)(h)||Array.isArray(h)){if(s.has(h))return"[Circular]";s.add(h)}return h})}e.safeStringify=R;function C(i,s,p){const h=s(i);return typeof h=="undefined"?p:h}e.getOrDefault=C;function v(i,s){const p=Object.create(null);return!i||!s||Object.keys(s).forEach(w=>{const _=i[w],c=s[w];n(_,c)||(p[w]=c)}),p}e.distinct=v;function m(i,s){const p=s.toLowerCase(),h=Object.keys(i).find(w=>w.toLowerCase()===p);return h?i[h]:i[s]}e.getCaseInsensitive=m}),define(be[79],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var E;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(E=e.Constants||(e.Constants={}));function k(T){return T<0?0:T>255?255:T|0}e.toUint8=k;function A(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=A}),define(be[2],we([0,1,21,11]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,T=/^\//,S=/^\/\//;function I(u,o){if(!u.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!A.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!T.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(u,o){return!u&&!o?"file":u}function n(u,o){switch(u){case"https":case"http":case"file":o?o[0]!==C&&(o=C+o):o=C;break}return o}const R="",C="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(o,a,f,b,D,d=!1){typeof o=="object"?(this.scheme=o.scheme||R,this.authority=o.authority||R,this.path=o.path||R,this.query=o.query||R,this.fragment=o.fragment||R):(this.scheme=y(o,d),this.authority=a||R,this.path=n(this.scheme,f||R),this.query=b||R,this.fragment=D||R,I(this,d))}static isUri(o){return o instanceof m?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return _(this,!1)}with(o){if(!o)return this;let{scheme:a,authority:f,path:b,query:D,fragment:d}=o;return a===void 0?a=this.scheme:a===null&&(a=R),f===void 0?f=this.authority:f===null&&(f=R),b===void 0?b=this.path:b===null&&(b=R),D===void 0?D=this.query:D===null&&(D=R),d===void 0?d=this.fragment:d===null&&(d=R),a===this.scheme&&f===this.authority&&b===this.path&&D===this.query&&d===this.fragment?this:new s(a,f,b,D,d)}static parse(o,a=!1){const f=v.exec(o);return f?new s(f[2]||R,r(f[4]||R),r(f[5]||R),r(f[7]||R),r(f[9]||R),a):new s(R,R,R,R,R)}static file(o){let a=R;if(E.isWindows&&(o=o.replace(/\\/g,C)),o[0]===C&&o[1]===C){const f=o.indexOf(C,2);f===-1?(a=o.substring(2),o=C):(a=o.substring(2,f),o=o.substring(f)||C)}return new s("file",a,o,R,R)}static from(o){return new s(o.scheme,o.authority,o.path,o.query,o.fragment)}static joinPath(o,...a){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return E.isWindows&&o.scheme==="file"?f=m.file(k.win32.join(_(o,!0),...a)).path:f=k.posix.join(o.path,...a),o.with({path:f})}toString(o=!1){return c(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof m)return o;{const a=new s(o);return a._formatted=o.external,a._fsPath=o._sep===i?o.fsPath:null,a}}else return o}}e.URI=m;const i=E.isWindows?1:void 0;class s extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=_(this,!1)),this._fsPath}toString(o=!1){return o?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=i),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(u,o){let a,f=-1;for(let b=0;b<u.length;b++){const D=u.charCodeAt(b);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||o&&D===47)f!==-1&&(a+=encodeURIComponent(u.substring(f,b)),f=-1),a!==void 0&&(a+=u.charAt(b));else{a===void 0&&(a=u.substr(0,b));const d=p[D];d!==void 0?(f!==-1&&(a+=encodeURIComponent(u.substring(f,b)),f=-1),a+=d):f===-1&&(f=b)}}return f!==-1&&(a+=encodeURIComponent(u.substring(f))),a!==void 0?a:u}function w(u){let o;for(let a=0;a<u.length;a++){const f=u.charCodeAt(a);f===35||f===63?(o===void 0&&(o=u.substr(0,a)),o+=p[f]):o!==void 0&&(o+=u[a])}return o!==void 0?o:u}function _(u,o){let a;return u.authority&&u.path.length>1&&u.scheme==="file"?a=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===47&&(u.path.charCodeAt(1)>=65&&u.path.charCodeAt(1)<=90||u.path.charCodeAt(1)>=97&&u.path.charCodeAt(1)<=122)&&u.path.charCodeAt(2)===58?o?a=u.path.substr(1):a=u.path[1].toLowerCase()+u.path.substr(2):a=u.path,E.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=_;function c(u,o){const a=o?w:h;let f="",{scheme:b,authority:D,path:d,query:g,fragment:P}=u;if(b&&(f+=b,f+=":"),(D||b==="file")&&(f+=C,f+=C),D){let F=D.indexOf("@");if(F!==-1){const z=D.substr(0,F);D=D.substr(F+1),F=z.indexOf(":"),F===-1?f+=a(z,!1):(f+=a(z.substr(0,F),!1),f+=":",f+=a(z.substr(F+1),!1)),f+="@"}D=D.toLowerCase(),F=D.indexOf(":"),F===-1?f+=a(D,!1):(f+=a(D.substr(0,F),!1),f+=D.substr(F))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const F=d.charCodeAt(1);F>=65&&F<=90&&(d=`/${String.fromCharCode(F+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const F=d.charCodeAt(0);F>=65&&F<=90&&(d=`${String.fromCharCode(F+32)}:${d.substr(2)}`)}f+=a(d,!0)}return g&&(f+="?",f+=a(g,!1)),P&&(f+="#",f+=o?P:h(P,!1)),f}function l(u){try{return decodeURIComponent(u)}catch(o){return u.length>3?u.substr(0,3)+l(u.substr(3)):u}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(u){return u.match(t)?u.replace(t,o=>l(o)):u}}),define(be[22],we([0,1,2,8]),function(ie,e,E,k){"use strict";var A,T;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(c,l,t){let r=c.get(l);return r===void 0&&(r=t,c.set(l,r)),r}e.getOrSet=S;function I(c){const l=[];return c.forEach((t,r)=>{l.push(`${r} => ${t}`)}),`Map(${c.size}) {${l.join(", ")}}`}e.mapToString=I;function y(c){const l=[];return c.forEach(t=>{l.push(t)}),`Set(${c.size}) {${l.join(", ")}}`}e.setToString=y;class n{constructor(){this._value="",this._pos=0}reset(l){return this._value=l,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(l){const t=l.charCodeAt(0),r=this._value.charCodeAt(this._pos);return t-r}value(){return this._value[this._pos]}}e.StringIterator=n;class R{constructor(l=!0){this._caseSensitive=l}reset(l){return this._value=l,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(l)this._from++;else break;else l=!1;return this}cmp(l){return this._caseSensitive?(0,k.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class C{constructor(l=!0,t=!0){this._splitOnBackslash=l,this._caseSensitive=t}reset(l){return this._value=l.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(l)this._from++;else break;else l=!1}return this}cmp(l){return this._caseSensitive?(0,k.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=C;var v;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(v||(v={}));class m{constructor(l){this._ignorePathCasing=l,this._states=[],this._stateIdx=0}reset(l){return this._value=l,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new C(!1,!this._ignorePathCasing(l)),this._pathIterator.reset(l.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(l){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(l,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(l,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(l);if(this._states[this._stateIdx]===4)return(0,k.compare)(l,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(l,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=m;class i{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class s{constructor(l){this._iter=l}static forUris(l=()=>!1){return new s(new m(l))}static forPaths(){return new s(new C)}static forStrings(){return new s(new n)}static forConfigKeys(){return new s(new R)}clear(){this._root=void 0}set(l,t){const r=this._iter.reset(l);let u;for(this._root||(this._root=new i,this._root.segment=r.value()),u=this._root;;){const a=r.cmp(u.segment);if(a>0)u.left||(u.left=new i,u.left.segment=r.value()),u=u.left;else if(a<0)u.right||(u.right=new i,u.right.segment=r.value()),u=u.right;else if(r.hasNext())r.next(),u.mid||(u.mid=new i,u.mid.segment=r.value()),u=u.mid;else break}const o=u.value;return u.value=t,u.key=l,o}get(l){var t;return(t=this._getNode(l))===null||t===void 0?void 0:t.value}_getNode(l){const t=this._iter.reset(l);let r=this._root;for(;r;){const u=t.cmp(r.segment);if(u>0)r=r.left;else if(u<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else break}return r}has(l){const t=this._getNode(l);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(l){return this._delete(l,!1)}deleteSuperstr(l){return this._delete(l,!0)}_delete(l,t){const r=this._iter.reset(l),u=[];let o=this._root;for(;o;){const a=r.cmp(o.segment);if(a>0)u.push([1,o]),o=o.left;else if(a<0)u.push([-1,o]),o=o.right;else if(r.hasNext())r.next(),u.push([0,o]),o=o.mid;else{for(t?(o.left=void 0,o.mid=void 0,o.right=void 0):o.value=void 0;u.length>0&&o.isEmpty();){let[f,b]=u.pop();switch(f){case 1:b.left=void 0;break;case 0:b.mid=void 0;break;case-1:b.right=void 0;break}o=b}break}}}findSubstr(l){const t=this._iter.reset(l);let r=this._root,u;for(;r;){const o=t.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(t.hasNext())t.next(),u=r.value||u,r=r.mid;else break}return r&&r.value||u}findSuperstr(l){const t=this._iter.reset(l);let r=this._root;for(;r;){const u=t.cmp(r.segment);if(u>0)r=r.left;else if(u<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(l){for(const[t,r]of this)l(r,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(l){l&&(yield*this._entries(l.left),l.value&&(yield[l.key,l.value]),yield*this._entries(l.mid),yield*this._entries(l.right))}}e.TernarySearchTree=s;class p{constructor(l,t){this[A]="ResourceMap",l instanceof p?(this.map=new Map(l.map),this.toKey=t!=null?t:p.defaultToKey):(this.map=new Map,this.toKey=l!=null?l:p.defaultToKey)}set(l,t){return this.map.set(this.toKey(l),t),this}get(l){return this.map.get(this.toKey(l))}has(l){return this.map.has(this.toKey(l))}get size(){return this.map.size}clear(){this.map.clear()}delete(l){return this.map.delete(this.toKey(l))}forEach(l,t){typeof t!="undefined"&&(l=l.bind(t));for(let[r,u]of this.map)l(u,E.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let l of this.map.keys())yield E.URI.parse(l)}*entries(){for(let l of this.map.entries())yield[E.URI.parse(l[0]),l[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let l of this.map)yield[E.URI.parse(l[0]),l[1]]}}e.ResourceMap=p,p.defaultToKey=c=>c.toString();var h;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class w{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var l;return(l=this._head)===null||l===void 0?void 0:l.value}get last(){var l;return(l=this._tail)===null||l===void 0?void 0:l.value}has(l){return this._map.has(l)}get(l,t=0){const r=this._map.get(l);if(!!r)return t!==0&&this.touch(r,t),r.value}set(l,t,r=0){let u=this._map.get(l);if(u)u.value=t,r!==0&&this.touch(u,r);else{switch(u={key:l,value:t,next:void 0,previous:void 0},r){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(l,u),this._size++}return this}delete(l){return!!this.remove(l)}remove(l){const t=this._map.get(l);if(!!t)return this._map.delete(l),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const l=this._head;return this._map.delete(l.key),this.removeItem(l),this._size--,l.value}}forEach(l,t){const r=this._state;let u=this._head;for(;u;){if(t?l.bind(t)(u.value,u.key,this):l(u.value,u.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const l=this,t=this._state;let r=this._head;const u={[Symbol.iterator](){return u},next(){if(l._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const o={value:r.key,done:!1};return r=r.next,o}else return{value:void 0,done:!0}}};return u}values(){const l=this,t=this._state;let r=this._head;const u={[Symbol.iterator](){return u},next(){if(l._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const o={value:r.value,done:!1};return r=r.next,o}else return{value:void 0,done:!0}}};return u}entries(){const l=this,t=this._state;let r=this._head;const u={[Symbol.iterator](){return u},next(){if(l._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const o={value:[r.key,r.value],done:!1};return r=r.next,o}else return{value:void 0,done:!0}}};return u}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(l){if(!(l>=this.size)){if(l===0){this.clear();return}let t=this._head,r=this.size;for(;t&&r>l;)this._map.delete(t.key),t=t.next,r--;this._head=t,this._size=r,t&&(t.previous=void 0),this._state++}}addItemFirst(l){if(!this._head&&!this._tail)this._tail=l;else if(this._head)l.next=this._head,this._head.previous=l;else throw new Error("Invalid list");this._head=l,this._state++}addItemLast(l){if(!this._head&&!this._tail)this._head=l;else if(this._tail)l.previous=this._tail,this._tail.next=l;else throw new Error("Invalid list");this._tail=l,this._state++}removeItem(l){if(l===this._head&&l===this._tail)this._head=void 0,this._tail=void 0;else if(l===this._head){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this._head=l.next}else if(l===this._tail){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this._tail=l.previous}else{const t=l.next,r=l.previous;if(!t||!r)throw new Error("Invalid list");t.previous=r,r.next=t}l.next=void 0,l.previous=void 0,this._state++}touch(l,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(l===this._head)return;const r=l.next,u=l.previous;l===this._tail?(u.next=void 0,this._tail=u):(r.previous=u,u.next=r),l.previous=void 0,l.next=this._head,this._head.previous=l,this._head=l,this._state++}else if(t===2){if(l===this._tail)return;const r=l.next,u=l.previous;l===this._head?(r.previous=void 0,this._head=r):(r.previous=u,u.next=r),l.next=void 0,l.previous=this._tail,this._tail.next=l,this._tail=l,this._state++}}}toJSON(){const l=[];return this.forEach((t,r)=>{l.push([r,t])}),l}fromJSON(l){this.clear();for(const[t,r]of l)this.set(t,r)}}e.LinkedMap=w;class _ extends w{constructor(l,t=1){super();this._limit=l,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(l){this._limit=l,this.checkTrim()}get ratio(){return this._ratio}set ratio(l){this._ratio=Math.min(Math.max(0,l),1),this.checkTrim()}get(l,t=2){return super.get(l,t)}peek(l){return super.get(l,0)}set(l,t){return super.set(l,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=_}),define(be[108],we([0,1,22,8]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function A(...ge){return function(Ce,Pe){for(let $e=0,_e=ge.length;$e<_e;$e++){const qe=ge[$e](Ce,Pe);if(qe)return qe}return null}}e.or=A,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(ge,Ce,Pe){if(!Pe||Pe.length<Ce.length)return null;let $e;return ge?$e=k.startsWithIgnoreCase(Pe,Ce):$e=Pe.indexOf(Ce)===0,$e?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function S(ge,Ce){const Pe=Ce.toLowerCase().indexOf(ge.toLowerCase());return Pe===-1?null:[{start:Pe,end:Pe+ge.length}]}e.matchesContiguousSubString=S;function I(ge,Ce){return y(ge.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=I;function y(ge,Ce,Pe,$e){if(Pe===ge.length)return[];if($e===Ce.length)return null;if(ge[Pe]===Ce[$e]){let _e=null;return(_e=y(ge,Ce,Pe+1,$e+1))?h({start:$e,end:$e+1},_e):null}return y(ge,Ce,Pe,$e+1)}function n(ge){return 97<=ge&&ge<=122}function R(ge){return 65<=ge&&ge<=90}e.isUpper=R;function C(ge){return 48<=ge&&ge<=57}function v(ge){return ge===32||ge===9||ge===10||ge===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(ge=>m.add(ge.charCodeAt(0)));function i(ge){return v(ge)||m.has(ge)}function s(ge,Ce){return ge===Ce||i(ge)&&i(Ce)}function p(ge){return n(ge)||R(ge)||C(ge)}function h(ge,Ce){return Ce.length===0?Ce=[ge]:ge.end===Ce[0].start?Ce[0].start=ge.start:Ce.unshift(ge),Ce}function w(ge,Ce){for(let Pe=Ce;Pe<ge.length;Pe++){const $e=ge.charCodeAt(Pe);if(R($e)||C($e)||Pe>0&&!p(ge.charCodeAt(Pe-1)))return Pe}return ge.length}function _(ge,Ce,Pe,$e){if(Pe===ge.length)return[];if($e===Ce.length)return null;if(ge[Pe]!==Ce[$e].toLowerCase())return null;{let _e=null,qe=$e+1;for(_e=_(ge,Ce,Pe+1,$e+1);!_e&&(qe=w(Ce,qe))<Ce.length;)_e=_(ge,Ce,Pe+1,qe),qe++;return _e===null?null:h({start:$e,end:$e+1},_e)}}function c(ge){let Ce=0,Pe=0,$e=0,_e=0,qe=0;for(let He=0;He<ge.length;He++)qe=ge.charCodeAt(He),R(qe)&&Ce++,n(qe)&&Pe++,p(qe)&&$e++,C(qe)&&_e++;const V=Ce/ge.length,X=Pe/ge.length,ve=$e/ge.length,Le=_e/ge.length;return{upperPercent:V,lowerPercent:X,alphaPercent:ve,numericPercent:Le}}function l(ge){const{upperPercent:Ce,lowerPercent:Pe}=ge;return Pe===0&&Ce>.6}function t(ge){const{upperPercent:Ce,lowerPercent:Pe,alphaPercent:$e,numericPercent:_e}=ge;return Pe>.2&&Ce<.8&&$e>.6&&_e<.2}function r(ge){let Ce=0,Pe=0,$e=0,_e=0;for(let qe=0;qe<ge.length;qe++)$e=ge.charCodeAt(qe),R($e)&&Ce++,n($e)&&Pe++,v($e)&&_e++;return(Ce===0||Pe===0)&&_e===0?ge.length<=30:Ce<=5}function u(ge,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!r(ge)||Ce.length>60)return null;const Pe=c(Ce);if(!t(Pe)){if(!l(Pe))return null;Ce=Ce.toLowerCase()}let $e=null,_e=0;for(ge=ge.toLowerCase();_e<Ce.length&&($e=_(ge,Ce,0,_e))===null;)_e=w(Ce,_e+1);return $e}e.matchesCamelCase=u;function o(ge,Ce,Pe=!1){if(!Ce||Ce.length===0)return null;let $e=null,_e=0;for(ge=ge.toLowerCase(),Ce=Ce.toLowerCase();_e<Ce.length&&($e=a(ge,Ce,0,_e,Pe))===null;)_e=f(Ce,_e+1);return $e}e.matchesWords=o;function a(ge,Ce,Pe,$e,_e){if(Pe===ge.length)return[];if($e===Ce.length)return null;if(s(ge.charCodeAt(Pe),Ce.charCodeAt($e))){let qe=null,V=$e+1;if(qe=a(ge,Ce,Pe+1,$e+1,_e),!_e)for(;!qe&&(V=f(Ce,V))<Ce.length;)qe=a(ge,Ce,Pe+1,V,_e),V++;return qe===null?null:h({start:$e,end:$e+1},qe)}else return null}function f(ge,Ce){for(let Pe=Ce;Pe<ge.length;Pe++)if(i(ge.charCodeAt(Pe))||Pe>0&&i(ge.charCodeAt(Pe-1)))return Pe;return ge.length}const b=A(e.matchesPrefix,u,S),D=A(e.matchesPrefix,u,I),d=new E.LRUCache(1e4);function g(ge,Ce,Pe=!1){if(typeof ge!="string"||typeof Ce!="string")return null;let $e=d.get(ge);$e||($e=new RegExp(k.convertSimple2RegExpPattern(ge),"i"),d.set(ge,$e));const _e=$e.exec(Ce);return _e?[{start:_e.index,end:_e.index+_e[0].length}]:Pe?D(ge,Ce):b(ge,Ce)}e.matchesFuzzy=g;function P(ge,Ce){const Pe=N(ge,ge.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Pe?z(Pe):null}e.matchesFuzzy2=P;function F(ge,Ce,Pe,$e,_e,qe){const V=Math.min(13,ge.length);for(;Pe<V;Pe++){const X=N(ge,Ce,Pe,$e,_e,qe,!1);if(X)return X}return[0,qe]}e.anyScore=F;function z(ge){if(typeof ge=="undefined")return[];const Ce=[],Pe=ge[1];for(let $e=ge.length-1;$e>1;$e--){const _e=ge[$e]+Pe,qe=Ce[Ce.length-1];qe&&qe.end===_e?qe.end=_e+1:Ce.push({start:_e,end:_e+1})}return Ce}e.createMatches=z;const de=128;function W(){const ge=[],Ce=[];for(let Pe=0;Pe<=de;Pe++)Ce[Pe]=0;for(let Pe=0;Pe<=de;Pe++)ge.push(Ce.slice(0));return ge}function B(ge){const Ce=[];for(let Pe=0;Pe<=ge;Pe++)Ce[Pe]=0;return Ce}const K=B(2*de),L=B(2*de),U=W(),x=W(),Q=W(),$=!1;function ee(ge,Ce,Pe,$e,_e){function qe(X,ve,Le=" "){for(;X.length<ve;)X=Le+X;return X}let V=` |   |${$e.split("").map(X=>qe(X,3)).join("|")}
`;for(let X=0;X<=Pe;X++)X===0?V+=" |":V+=`${Ce[X-1]}|`,V+=ge[X].slice(0,_e+1).map(ve=>qe(ve.toString(),3)).join("|")+`
`;return V}function re(ge,Ce,Pe,$e){ge=ge.substr(Ce),Pe=Pe.substr($e),console.log(ee(x,ge,ge.length,Pe,Pe.length)),console.log(ee(Q,ge,ge.length,Pe,Pe.length)),console.log(ee(U,ge,ge.length,Pe,Pe.length))}function se(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;const Pe=ge.codePointAt(Ce);switch(Pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(Pe)}}function ye(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;switch(ge.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Ie(ge,Ce,Pe){return Ce[ge]!==Pe[ge]}function xe(ge,Ce,Pe,$e,_e,qe,V=!1){for(;Ce<Pe&&_e<qe;)ge[Ce]===$e[_e]&&(V&&(K[Ce]=_e),Ce+=1),_e+=1;return Ce===Pe}e.isPatternInWord=xe;var Fe;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var ze;(function(ge){ge.Default=[-100,0];function Ce(Pe){return!Pe||Pe.length===2&&Pe[0]===-100&&Pe[1]===0}ge.isDefault=Ce})(ze=e.FuzzyScore||(e.FuzzyScore={}));function N(ge,Ce,Pe,$e,_e,qe,V){const X=ge.length>de?de:ge.length,ve=$e.length>de?de:$e.length;if(!(Pe>=X||qe>=ve||X-Pe>ve-qe)&&!!xe(Ce,Pe,X,_e,qe,ve,!0)){G(X,ve,Pe,qe,Ce,_e);let Le=1,He=1,Oe=Pe,et=qe;const H=[!1];for(Le=1,Oe=Pe;Oe<X;Le++,Oe++){const oe=K[Oe],fe=L[Oe],pe=Oe+1<X?L[Oe+1]:ve;for(He=oe-qe+1,et=oe;et<pe;He++,et++){let We=Number.MIN_SAFE_INTEGER,Ne=!1;et<=fe&&(We=te(ge,Ce,Oe,Pe,$e,_e,et,ve,qe,U[Le-1][He-1]===0,H));let Ve=0;We!==Number.MAX_SAFE_INTEGER&&(Ne=!0,Ve=We+x[Le-1][He-1]);const Xe=et>oe,Ze=Xe?x[Le][He-1]+(U[Le][He-1]>0?-5:0):0,ct=et>oe+1&&U[Le][He-1]>0,ot=ct?x[Le][He-2]+(U[Le][He-2]>0?-5:0):0;if(ct&&(!Xe||ot>=Ze)&&(!Ne||ot>=Ve))x[Le][He]=ot,Q[Le][He]=3,U[Le][He]=0;else if(Xe&&(!Ne||Ze>=Ve))x[Le][He]=Ze,Q[Le][He]=2,U[Le][He]=0;else if(Ne)x[Le][He]=Ve,Q[Le][He]=1,U[Le][He]=U[Le-1][He-1]+1;else throw new Error("not possible")}}if($&&re(ge,Pe,$e,qe),!(!H[0]&&!V)){Le--,He--;const ne=[x[Le][He],qe];let he=0,q=0;for(;Le>=1;){let oe=He;do{const fe=Q[Le][oe];if(fe===3)oe=oe-2;else if(fe===2)oe=oe-1;else break}while(oe>=1);he>1&&Ce[Pe+Le-1]===_e[qe+He-1]&&!Ie(oe+qe-1,$e,_e)&&he+1>U[Le][oe]&&(oe=He),oe===He?he++:he=1,q||(q=oe),Le--,He=oe-1,ne.push(He)}ve===X&&(ne[0]+=2);const J=q-X;return ne[0]-=J,ne}}}e.fuzzyScore=N;function G(ge,Ce,Pe,$e,_e,qe){let V=ge-1,X=Ce-1;for(;V>=Pe&&X>=$e;)_e[V]===qe[X]&&(L[V]=X,V--),X--}function te(ge,Ce,Pe,$e,_e,qe,V,X,ve,Le,He){if(Ce[Pe]!==qe[V])return Number.MIN_SAFE_INTEGER;let Oe=1,et=!1;return V===Pe-$e?Oe=ge[Pe]===_e[V]?7:5:Ie(V,_e,qe)&&(V===0||!Ie(V-1,_e,qe))?(Oe=ge[Pe]===_e[V]?7:5,et=!0):se(qe,V)&&(V===0||!se(qe,V-1))?Oe=5:(se(qe,V-1)||ye(qe,V-1))&&(Oe=5,et=!0),Oe>1&&Pe===$e&&(He[0]=!0),et||(et=Ie(V,_e,qe)||se(qe,V-1)||ye(qe,V-1)),Pe===$e?V>ve&&(Oe-=et?3:5):Le?Oe+=et?2:0:Oe+=et?0:1,V+1===X&&(Oe-=et?3:5),Oe}function ae(ge,Ce,Pe,$e,_e,qe,V){return Se(ge,Ce,Pe,$e,_e,qe,!0,V)}e.fuzzyScoreGracefulAggressive=ae;function me(ge,Ce,Pe,$e,_e,qe,V){return Se(ge,Ce,Pe,$e,_e,qe,!1,V)}e.fuzzyScoreGraceful=me;function Se(ge,Ce,Pe,$e,_e,qe,V,X){let ve=N(ge,Ce,Pe,$e,_e,qe,X);if(ve&&!V)return ve;if(ge.length>=3){const Le=Math.min(7,ge.length-1);for(let He=Pe+1;He<Le;He++){const Oe=Me(ge,He);if(Oe){const et=N(Oe,Oe.toLowerCase(),Pe,$e,_e,qe,X);et&&(et[0]-=3,(!ve||et[0]>ve[0])&&(ve=et))}}}return ve}function Me(ge,Ce){if(!(Ce+1>=ge.length)){const Pe=ge[Ce],$e=ge[Ce+1];if(Pe!==$e)return ge.slice(0,Ce)+$e+Pe+ge.slice(Ce+2)}}}),define(be[109],we([0,1,36,108,8]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${T.source}`,"g");function I(s){return s.replace(S,(p,h)=>h?p:`\\${p}`)}e.escapeIcons=I;const y=new RegExp(`\\\\${T.source}`,"g");function n(s){return s.replace(y,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=n;const R=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function C(s){return s.indexOf(e.iconStartMarker)===-1?s:s.replace(R,(p,h,w,_)=>w?p:h||_||"")}e.stripIcons=C;function v(s){const p=s.indexOf(e.iconStartMarker);return p===-1?{text:s}:m(s,p)}e.parseLabelWithIcons=v;function m(s,p){const h=[];let w="";function _(f){if(f){w+=f;for(const b of f)h.push(t)}}let c=-1,l="",t=0,r,u,o=p;const a=s.length;for(_(s.substr(0,p));o<a;)r=s[o],u=s[o+1],r===e.iconStartMarker[0]&&u===e.iconStartMarker[1]?(c=o,_(l),l=e.iconStartMarker,o++):r===")"&&c!==-1?(t+=o-c+1,c=-1,l=""):c!==-1?/^[a-z0-9\-]$/i.test(r)?l+=r:(_(l),c=-1,l=""):_(r),o++;return _(l),{text:w,iconOffsets:h}}function i(s,p,h=!1){const{text:w,iconOffsets:_}=p;if(!_||_.length===0)return(0,k.matchesFuzzy)(s,w,h);const c=(0,A.ltrim)(w," "),l=w.length-c.length,t=(0,k.matchesFuzzy)(s,c,h);if(t)for(const r of t){const u=_[r.start+l]+l;r.start+=u,r.end+=u}return t}e.matchesFuzzyIconAware=i}),define(be[80],we([0,1,15,109,10]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(i){i[i.Paragraph=0]="Paragraph",i[i.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(s="",p=!1){var h,w;if(this.value=s,typeof this.value!="string")throw(0,A.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1):(this.isTrusted=(h=p.isTrusted)!==null&&h!==void 0?h:void 0,this.supportThemeIcons=(w=p.supportThemeIcons)!==null&&w!==void 0?w:!1)}appendText(s,p=0){return this.value+=C(this.supportThemeIcons?(0,k.escapeIcons)(s):s).replace(/([ \t]+)/g,(h,w)=>"&nbsp;".repeat(w.length)).replace(/^>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,p){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=S;function I(i){return y(i)?!i.value:Array.isArray(i)?i.every(I):!0}e.isEmptyMarkdownString=I;function y(i){return i instanceof S?!0:i&&typeof i=="object"?typeof i.value=="string"&&(typeof i.isTrusted=="boolean"||i.isTrusted===void 0)&&(typeof i.supportThemeIcons=="boolean"||i.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function n(i,s){return!i&&!s?!0:!i||!s?!1:Array.isArray(i)&&Array.isArray(s)?(0,E.equals)(i,s,R):y(i)&&y(s)?R(i,s):!1}e.markedStringsEquals=n;function R(i,s){return i===s?!0:!i||!s?!1:i.value===s.value&&i.isTrusted===s.isTrusted&&i.supportThemeIcons===s.supportThemeIcons}function C(i){return i.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function v(i){return i&&i.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=v;function m(i){const s=[],p=i.split("|").map(w=>w.trim());i=p[0];const h=p[1];if(h){const w=/height=(\d+)/.exec(h),_=/width=(\d+)/.exec(h),c=w?w[1]:"",l=_?_[1]:"",t=isFinite(parseInt(l)),r=isFinite(parseInt(c));t&&s.push(`width="${l}"`),r&&s.push(`height="${c}"`)}return{href:i,dimensions:s}}e.parseHrefAndDimensions=m}),define(be[57],we([0,1,24,8,2]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(n){return JSON.stringify(n,I)}e.stringify=T;function S(n){let R=JSON.parse(n);return R=y(R),R}e.parse=S;function I(n,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,k.regExpFlags)(R)}:R}function y(n,R=0){if(!n||R>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return A.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof E.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let C=0;C<n.length;++C)n[C]=y(n[C],R+1);else for(const C in n)Object.hasOwnProperty.call(n,C)&&(n[C]=y(n[C],R+1))}return n}e.revive=y}),define(be[18],we([0,1,2,21]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file"})(A=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,n,R){this._hosts[y]=n,this._ports[y]=R}setConnectionToken(y,n){this._connectionTokens[y]=n}rewrite(y){if(this._delegate)return this._delegate(y);const n=y.authority;let R=this._hosts[n];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const C=this._ports[n],v=this._connectionTokens[n];let m=`path=${encodeURIComponent(y.path)}`;return typeof v=="string"&&(m+=`&tkn=${encodeURIComponent(v)}`),E.URI.from({scheme:k.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${R}:${C}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new T;class S{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,n,R){const C=this.toUri(y,n);return C.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(C):k.isNative&&(R||k.isPreferringBrowserCodeLoad)&&C.scheme===A.file?C.with({scheme:A.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(y,n){const R=this.toUri(y,n);return R.scheme===A.vscodeFileResource?R.with({scheme:A.file,authority:R.authority!==this.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(y,n){return E.URI.isUri(y)?y:E.URI.parse(n.toUrl(y))}}e.FileAccess=new S}),define(be[25],we([0,1,37,11,2,8,18,21]),function(ie,e,E,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(m){return(0,A.uriToFsPath)(m,!0)}e.originalFSPath=y;class n{constructor(i){this._ignorePathCasing=i}compare(i,s,p=!1){return i===s?0:(0,T.compare)(this.getComparisonKey(i,p),this.getComparisonKey(s,p))}isEqual(i,s,p=!1){return i===s?!0:!i||!s?!1:this.getComparisonKey(i,p)===this.getComparisonKey(s,p)}getComparisonKey(i,s=!1){return i.with({path:this._ignorePathCasing(i)?i.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(i){return this._ignorePathCasing(i)}isEqualOrParent(i,s,p=!1){if(i.scheme===s.scheme){if(i.scheme===S.Schemas.file)return E.isEqualOrParent(y(i),y(s),this._ignorePathCasing(i))&&i.query===s.query&&(p||i.fragment===s.fragment);if((0,e.isEqualAuthority)(i.authority,s.authority))return E.isEqualOrParent(i.path,s.path,this._ignorePathCasing(i),"/")&&i.query===s.query&&(p||i.fragment===s.fragment)}return!1}joinPath(i,...s){return A.URI.joinPath(i,...s)}basenameOrAuthority(i){return(0,e.basename)(i)||i.authority}basename(i){return k.posix.basename(i.path)}extname(i){return k.posix.extname(i.path)}dirname(i){if(i.path.length===0)return i;let s;return i.scheme===S.Schemas.file?s=A.URI.file(k.dirname(y(i))).path:(s=k.posix.dirname(i.path),i.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),s="/")),i.with({path:s})}normalizePath(i){if(!i.path.length)return i;let s;return i.scheme===S.Schemas.file?s=A.URI.file(k.normalize(y(i))).path:s=k.posix.normalize(i.path),i.with({path:s})}relativePath(i,s){if(!(i.scheme!==s.scheme||!(0,e.isEqualAuthority)(i.authority,s.authority))){if(i.scheme===S.Schemas.file){const w=k.relative(y(i),y(s));return I.isWindows?E.toSlashes(w):w}let p=i.path||"/",h=s.path||"/";if(this._ignorePathCasing(i)){let w=0;for(const _=Math.min(p.length,h.length);w<_&&!(p.charCodeAt(w)!==h.charCodeAt(w)&&p.charAt(w).toLowerCase()!==h.charAt(w).toLowerCase());w++);p=h.substr(0,w)+p.substr(w)}return k.posix.relative(p,h)}}resolvePath(i,s){if(i.scheme===S.Schemas.file){const p=A.URI.file(k.resolve(y(i),s));return i.with({authority:p.authority,path:p.path})}return s.indexOf("/")===-1&&(s=E.toSlashes(s),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s)),i.with({path:k.posix.resolve(i.path,s)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,s){return i===s||(0,T.equalsIgnoreCase)(i,s)}hasTrailingPathSeparator(i,s=k.sep){if(i.scheme===S.Schemas.file){const p=y(i);return p.length>E.getRoot(p).length&&p[p.length-1]===s}else{const p=i.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,s=k.sep){return(0,e.hasTrailingPathSeparator)(i,s)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,s=k.sep){let p=!1;if(i.scheme===S.Schemas.file){const h=y(i);p=h!==void 0&&h.length===E.getRoot(h).length&&h[h.length-1]===s}else{s="/";const h=i.path;p=h.length===1&&h.charCodeAt(h.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(i,s)?i.with({path:i.path+"/"}):i}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(m=>m.scheme===S.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new n(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(m,i){const s=[];for(let p=0;p<m.length;p++){const h=i(m[p]);m.some((w,_)=>_===p?!1:(0,e.isEqualOrParent)(h,i(w)))||s.push(m[p])}return s}e.distinctParents=R;var C;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function i(s){const p=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(_=>{const[c,l]=_.split(":");c&&l&&p.set(c,l)});const w=s.path.substring(0,s.path.indexOf(";"));return w&&p.set(m.META_DATA_MIME,w),p}m.parseMetaData=i})(C=e.DataUri||(e.DataUri={}));function v(m,i,s){if(i){let p=m.path;return p&&p[0]!==k.posix.sep&&(p=k.posix.sep+p),m.with({scheme:s,authority:i,path:p})}return m.with({scheme:s})}e.toLocalResource=v}),define(be[13],we([0,1,20,10,3,6,44,25]),function(ie,e,E,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(x){return!!x&&typeof x.then=="function"}e.isThenable=y;function n(x){const Q=new E.CancellationTokenSource,$=x(Q.token),ee=new Promise((re,se)=>{Q.token.onCancellationRequested(()=>{se((0,k.canceled)())}),Promise.resolve($).then(ye=>{Q.dispose(),re(ye)},ye=>{Q.dispose(),se(ye)})});return new class{cancel(){Q.cancel()}then(re,se){return ee.then(re,se)}catch(re){return this.then(void 0,re)}finally(re){return ee.finally(re)}}}e.createCancelablePromise=n;function R(x,Q,$){return Promise.race([x,new Promise(ee=>Q.onCancellationRequested(()=>ee($)))])}e.raceCancellation=R;async function C(x){let Q=-1;const $=x.map((re,se)=>re.then(ye=>(Q=se,ye))),ee=await Promise.race($);return x.forEach((re,se)=>{se!==Q&&re.cancel()}),ee}e.raceCancellablePromises=C;function v(x,Q,$){let ee;const re=setTimeout(()=>{ee==null||ee(void 0),$==null||$()},Q);return Promise.race([x.finally(()=>clearTimeout(re)),new Promise(se=>ee=se)])}e.raceTimeout=v;function m(x){return new Promise((Q,$)=>{const ee=x();y(ee)?ee.then(Q,$):Q(ee)})}e.asPromise=m;class i{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const ee=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ee};this.queuedPromise=new Promise(ee=>{this.activePromise.then($,$).then(ee)})}return new Promise(($,ee)=>{this.queuedPromise.then($,ee)})}return this.activePromise=Q(),new Promise(($,ee)=>{this.activePromise.then(re=>{this.activePromise=null,$(re)},re=>{this.activePromise=null,ee(re)})})}}e.Throttler=i;class s{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=s;class p{constructor(){this.promiseMap=new Map}queue(Q,$){var ee;const se=((ee=this.promiseMap.get(Q))!==null&&ee!==void 0?ee:Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(Q)===se&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,se),se}}e.SequencerByKey=p;class h{constructor(Q){this.defaultDelay=Q,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,$=this.defaultDelay){return this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ee,re)=>{this.doResolve=ee,this.doReject=re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ee=this.task;return this.task=null,ee()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},$),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,k.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=h;class w{constructor(Q){this.delayer=new h(Q),this.throttler=new i}trigger(Q,$){return this.delayer.trigger(()=>this.throttler.queue(Q),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class _{constructor(){this._isOpen=!1,this._promise=new Promise((Q,$)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=_;class c extends _{constructor(Q){super();this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function l(x,Q){return Q?new Promise(($,ee)=>{const re=setTimeout($,x);Q.onCancellationRequested(()=>{clearTimeout(re),ee((0,k.canceled)())})}):n($=>l(x,$))}e.timeout=l;function t(x,Q=0){const $=setTimeout(x,Q);return(0,T.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=t;function r(x){return x.then(void 0,Q=>{})}e.ignoreErrors=r;function u(x){const Q=[];let $=0;const ee=x.length;function re(){return $<ee?x[$++]():null}function se(ye){ye!=null&&Q.push(ye);const Ie=re();return Ie?Ie.then(se):Promise.resolve(Q)}return Promise.resolve(null).then(se)}e.sequence=u;function o(x,Q=ee=>!!ee,$=null){let ee=0;const re=x.length,se=()=>{if(ee>=re)return Promise.resolve($);const ye=x[ee++];return Promise.resolve(ye()).then(xe=>Q(xe)?Promise.resolve(xe):se())};return se()}e.first=o;function a(x,Q=ee=>!!ee,$=null){if(x.length===0)return Promise.resolve($);let ee=x.length;const re=()=>{var se,ye;ee=-1;for(const Ie of x)(ye=(se=Ie).cancel)===null||ye===void 0||ye.call(se)};return new Promise((se,ye)=>{for(const Ie of x)Ie.then(xe=>{--ee>=0&&Q(xe)?(re(),se(xe)):ee===0&&se($)}).catch(xe=>{--ee>=0&&(re(),ye(xe))})})}e.firstParallel=a;class f{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Q){return this._size++,new Promise(($,ee)=>{this.outstandingPromises.push({factory:Q,c:$,e:ee}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const $=Q.factory();$.then(Q.c,Q.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class b extends f{constructor(){super(1)}}e.Queue=b;class D{constructor(){this.queues=new Map}queueFor(Q,$=I.extUri){const ee=$.getComparisonKey(Q);let re=this.queues.get(ee);return re||(re=new b,A.Event.once(re.onFinished)(()=>{re==null||re.dispose(),this.queues.delete(ee)}),this.queues.set(ee,re)),re}dispose(){this.queues.forEach(Q=>Q.dispose()),this.queues.clear()}}e.ResourceQueue=D;class d{constructor(Q,$){this._token=-1,typeof Q=="function"&&typeof $=="number"&&this.setIfNotSet(Q,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},$)}setIfNotSet(Q,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},$))}}e.TimeoutTimer=d;class g{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,$){this.cancel(),this._token=setInterval(()=>{Q()},$)}}e.IntervalTimer=g;class P{constructor(Q,$){this.timeoutToken=-1,this.runner=Q,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class F extends P{constructor(Q,$){super(Q,$);this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner&&this.runner(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const x=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=Q=>{const $=setTimeout(()=>Q(x));let ee=!1;return{dispose(){ee||(ee=!0,clearTimeout($))}}}}else e.runWhenIdle=(x,Q)=>{const $=requestIdleCallback(x,typeof Q=="number"?{timeout:Q}:void 0);let ee=!1;return{dispose(){ee||(ee=!0,cancelIdleCallback($))}}}}();class z{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=z;async function de(x,Q,$){let ee;for(let re=0;re<$;re++)try{return await x()}catch(se){ee=se,await l(Q)}throw ee}e.retry=de;class W{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var Q;(Q=this._pending)===null||Q===void 0||Q.cancel()}setPending(Q,$,ee){return this._pending={taskId:Q,cancel:()=>ee==null?void 0:ee(),promise:$},$.then(()=>this.donePending(Q),()=>this.donePending(Q)),$}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let $,ee;const re=new Promise((se,ye)=>{$=se,ee=ye});this._next={run:Q,promise:re,promiseResolve:$,promiseReject:ee}}return this._next.promise}}e.TaskSequentializer=W;class B{constructor(Q){this.interval=Q,this.lastIncrementTime=0,this.value=0}increment(){const Q=Date.now();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class K{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,$)=>{this.completeCallback=Q,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Q){return new Promise($=>{this.completeCallback(Q),this.resolved=!0,$()})}error(Q){return new Promise($=>{this.errorCallback(Q),this.rejected=!0,$()})}cancel(){new Promise(Q=>{this.errorCallback((0,k.canceled)()),this.rejected=!0,Q()})}}e.DeferredPromise=K;class L extends A.Emitter{async fireAsync(Q,$,ee){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const re of this._listeners)this._asyncDeliveryQueue.push([re,Q]);for(;this._asyncDeliveryQueue.size>0&&!$.isCancellationRequested;){const[re,se]=this._asyncDeliveryQueue.shift(),ye=[],Ie=Object.assign(Object.assign({},se),{waitUntil:xe=>{if(Object.isFrozen(ye))throw new Error("waitUntil can NOT be called asynchronous");ee&&(xe=ee(xe,typeof re=="function"?re:re[0])),ye.push(xe)}});try{typeof re=="function"?re.call(void 0,Ie):re[0].call(re[1],Ie)}catch(xe){(0,k.onUnexpectedError)(xe);continue}Object.freeze(ye),await U.settled(ye).catch(xe=>(0,k.onUnexpectedError)(xe))}}}}e.AsyncEmitter=L;var U;(function(x){async function Q(se){return typeof Promise.allSettled=="function"?$(se):ee(se)}x.allSettled=Q;async function $(se){return Promise.allSettled(se)}async function ee(se){return Promise.all(se.map(ye=>ye.then(Ie=>({status:"fulfilled",value:Ie}),Ie=>({status:"rejected",reason:Ie}))))}async function re(se){let ye;const Ie=await Promise.all(se.map(xe=>xe.then(Fe=>Fe,Fe=>{ye||(ye=Fe)})));if(typeof ye!="undefined")throw ye;return Ie}x.settled=re})(U=e.Promises||(e.Promises={}))}),define(be[110],we([0,1,11,13]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const A=new k.IdleValue(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),T=new k.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new k.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(c,l,t=!1){const r=c||"",u=l||"",o=A.value.collator.compare(r,u);return A.value.collatorIsNumeric&&o===0&&r!==u?r<u?-1:1:o}e.compareFileNames=I;function y(c,l){const t=T.value.collator;return c=c||"",l=l||"",s(t,c,l)}e.compareFileNamesDefault=y;function n(c,l,t=!1){t||(c=c&&c.toLowerCase(),l=l&&l.toLowerCase());const[r,u]=m(c),[o,a]=m(l);return r!==o?r<o?-1:1:u===a?0:u<a?-1:1}e.noIntlCompareFileNames=n;function R(c,l){const[t,r]=m(c),[u,o]=m(l);let a=A.value.collator.compare(r,o);if(a===0){if(A.value.collatorIsNumeric&&r!==o)return r<o?-1:1;if(a=A.value.collator.compare(t,u),A.value.collatorIsNumeric&&a===0&&t!==u)return t<u?-1:1}return a}e.compareFileExtensions=R;function C(c,l){c=c||"",l=l||"";const t=i(c),r=i(l),u=T.value.collator,o=S.value.collator;let a;return a=s(o,t,r),a!==0?a:s(u,c,l)}e.compareFileExtensionsDefault=C;const v=/^(.*?)(\.([^.]*))?$/;function m(c,l=!1){const t=c?v.exec(c):[];let r=[t&&t[1]||"",t&&t[3]||""];return l&&(!r[0]&&r[1]||r[0]&&r[0].charAt(0)===".")&&(r=[r[0]+"."+r[1],""]),r}function i(c){const l=c?v.exec(c):[];return l&&l[1]&&l[1].charAt(0)!=="."&&l[3]||""}function s(c,l,t){let r=c.compare(l,t);return r!==0?r:l.length!==t.length?l.length<t.length?-1:1:0}function p(c,l,t=!1){return t||(c=c&&c.toLowerCase(),l=l&&l.toLowerCase()),c===l?0:c<l?-1:1}function h(c,l,t=!1){const r=c.split(E.sep),u=l.split(E.sep),o=r.length-1,a=u.length-1;let f,b;for(let D=0;;D++){if(f=o===D,b=a===D,f&&b)return I(r[D],u[D],t);if(f)return-1;if(b)return 1;const d=p(r[D],u[D],t);if(d!==0)return d}}e.comparePaths=h;function w(c,l,t){const r=c.toLowerCase(),u=l.toLowerCase(),o=_(c,l,t);if(o)return o;const a=r.endsWith(t),f=u.endsWith(t);if(a!==f)return a?-1:1;const b=I(r,u);return b!==0?b:r.localeCompare(u)}e.compareAnything=w;function _(c,l,t){const r=c.toLowerCase(),u=l.toLowerCase(),o=r.startsWith(t),a=u.startsWith(t);if(o!==a)return o?-1:1;if(o&&a){if(r.length<u.length)return-1;if(r.length>u.length)return 1}return 0}e.compareByPrefix=_}),define(be[28],we([0,1,8,37,11,22,13]),function(ie,e,E,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I;const y="**",n="/",R="[/\\\\]",C="[^/\\\\]",v=/\//g;function m($){switch($){case 0:return"";case 1:return`${C}*?`;default:return`(?:${R}|${C}+${R}|${R}${C}+)*?`}}function i($,ee){if(!$)return[];const re=[];let se=!1,ye=!1,Ie="";for(const xe of $){switch(xe){case ee:if(!se&&!ye){re.push(Ie),Ie="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":ye=!0;break;case"]":ye=!1;break}Ie+=xe}return Ie&&re.push(Ie),re}e.splitGlobAware=i;function s($){if(!$)return"";let ee="";const re=i($,n);if(re.every(se=>se===y))ee=".*";else{let se=!1;re.forEach((ye,Ie)=>{if(ye===y){se||(ee+=m(2),se=!0);return}let xe=!1,Fe="",ze=!1,N="";for(const G of ye){if(G!=="}"&&xe){Fe+=G;continue}if(ze&&(G!=="]"||!N)){let te;G==="-"?te=G:(G==="^"||G==="!")&&!N?te="^":G===n?te="":te=E.escapeRegExpCharacters(G),N+=te;continue}switch(G){case"{":xe=!0;continue;case"[":ze=!0;continue;case"}":ee+=`(?:${i(Fe,",").map(me=>s(me)).join("|")})`,xe=!1,Fe="";break;case"]":ee+="["+N+"]",ze=!1,N="";break;case"?":ee+=C;continue;case"*":ee+=m(1);continue;default:ee+=E.escapeRegExpCharacters(G)}}Ie<re.length-1&&(re[Ie+1]!==y||Ie+2<re.length)&&(ee+=R),se=!1})}return ee}const p=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,_=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),r=function(){return!1},u=function(){return null};function o($,ee){if(!$)return u;let re;typeof $!="string"?re=$.pattern:re=$,re=re.trim();const se=`${re}_${!!ee.trimForExclusions}`;let ye=t.get(se);if(ye)return a(ye,$);let Ie;if(p.test(re)){const xe=re.substr(4);ye=function(Fe,ze){return typeof Fe=="string"&&Fe.endsWith(xe)?re:null}}else(Ie=h.exec(f(re,ee)))?ye=b(Ie[1],re):(ee.trimForExclusions?_:w).test(re)?ye=D(re,ee):(Ie=c.exec(f(re,ee)))?ye=d(Ie[1].substr(1),re,!0):(Ie=l.exec(f(re,ee)))?ye=d(Ie[1],re,!1):ye=g(re);return t.set(se,ye),a(ye,$)}function a($,ee){return typeof ee=="string"?$:function(re,se){return k.isEqualOrParent(re,ee.base)?$(A.relative(ee.base,re),se):null}}function f($,ee){return ee.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function b($,ee){const re=`/${$}`,se=`\\${$}`,ye=function(xe,Fe){return typeof xe!="string"?null:Fe?Fe===$?ee:null:xe===$||xe.endsWith(re)||xe.endsWith(se)?ee:null},Ie=[$];return ye.basenames=Ie,ye.patterns=[ee],ye.allBasenames=Ie,ye}function D($,ee){const re=Q($.slice(1,-1).split(",").map(Fe=>o(Fe,ee)).filter(Fe=>Fe!==u),$),se=re.length;if(!se)return u;if(se===1)return re[0];const ye=function(Fe,ze){for(let N=0,G=re.length;N<G;N++)if(re[N](Fe,ze))return $;return null},Ie=re.find(Fe=>!!Fe.allBasenames);Ie&&(ye.allBasenames=Ie.allBasenames);const xe=re.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return xe.length&&(ye.allPaths=xe),ye}function d($,ee,re){const se=A.sep===A.posix.sep,ye=se?$:$.replace(v,A.sep),Ie=A.sep+ye,xe=A.posix.sep+$,Fe=re?function(ze,N){return typeof ze=="string"&&(ze===ye||ze.endsWith(Ie)||!se&&(ze===$||ze.endsWith(xe)))?ee:null}:function(ze,N){return typeof ze=="string"&&(ze===ye||!se&&ze===$)?ee:null};return Fe.allPaths=[(re?"*/":"./")+$],Fe}function g($){try{const ee=new RegExp(`^${s($)}$`);return function(re){return ee.lastIndex=0,typeof re=="string"&&ee.test(re)?$:null}}catch(ee){return u}}function P($,ee,re){return!$||typeof ee!="string"?!1:F($)(ee,void 0,re)}e.match=P;function F($,ee={}){if(!$)return r;if(typeof $=="string"||B($)){const re=o($,ee);if(re===u)return r;const se=function(ye,Ie){return!!re(ye,Ie)};return re.allBasenames&&(se.allBasenames=re.allBasenames),re.allPaths&&(se.allPaths=re.allPaths),se}return U($,ee)}e.parse=F;function z($){if(!!$){let ee;return re=>(ee||(ee=($()||Promise.resolve([])).then(se=>se?W(se):{})),ee.then(se=>!!se[re]))}}e.hasSiblingPromiseFn=z;function de($){if(!!$){let ee;return re=>{if(!ee){const se=$();ee=se?W(se):{}}return!!ee[re]}}}e.hasSiblingFn=de;function W($){const ee={};for(const re of $)ee[re]=!0;return ee}function B($){const ee=$;return ee&&typeof ee.base=="string"&&typeof ee.pattern=="string"}e.isRelativePattern=B;function K($){return $.allBasenames||[]}e.getBasenameTerms=K;function L($){return $.allPaths||[]}e.getPathTerms=L;function U($,ee){const re=Q(Object.getOwnPropertyNames($).map(Fe=>x(Fe,$[Fe],ee)).filter(Fe=>Fe!==u)),se=re.length;if(!se)return u;if(!re.some(Fe=>!!Fe.requiresSiblings)){if(se===1)return re[0];const Fe=function(G,te){for(let ae=0,me=re.length;ae<me;ae++){const Se=re[ae](G,te);if(Se)return Se}return null},ze=re.find(G=>!!G.allBasenames);ze&&(Fe.allBasenames=ze.allBasenames);const N=re.reduce((G,te)=>te.allPaths?G.concat(te.allPaths):G,[]);return N.length&&(Fe.allPaths=N),Fe}const ye=function(Fe,ze,N){let G;for(let te=0,ae=re.length;te<ae;te++){const me=re[te];me.requiresSiblings&&N&&(ze||(ze=A.basename(Fe)),G||(G=ze.substr(0,ze.length-A.extname(Fe).length)));const Se=me(Fe,ze,G,N);if(Se)return Se}return null},Ie=re.find(Fe=>!!Fe.allBasenames);Ie&&(ye.allBasenames=Ie.allBasenames);const xe=re.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return xe.length&&(ye.allPaths=xe),ye}function x($,ee,re){if(ee===!1)return u;const se=o($,re);if(se===u)return u;if(typeof ee=="boolean")return se;if(ee){const ye=ee.when;if(typeof ye=="string"){const Ie=(xe,Fe,ze,N)=>{if(!N||!se(xe,Fe))return null;const G=ye.replace("$(basename)",ze),te=N(G);return(0,S.isThenable)(te)?te.then(ae=>ae?$:null):te?$:null};return Ie.requiresSiblings=!0,Ie}}return se}function Q($,ee){const re=$.filter(Fe=>!!Fe.basenames);if(re.length<2)return $;const se=re.reduce((Fe,ze)=>{const N=ze.basenames;return N?Fe.concat(N):Fe},[]);let ye;if(ee){ye=[];for(let Fe=0,ze=se.length;Fe<ze;Fe++)ye.push(ee)}else ye=re.reduce((Fe,ze)=>{const N=ze.patterns;return N?Fe.concat(N):Fe},[]);const Ie=function(Fe,ze){if(typeof Fe!="string")return null;if(!ze){let G;for(G=Fe.length;G>0;G--){const te=Fe.charCodeAt(G-1);if(te===47||te===92)break}ze=Fe.substr(G)}const N=se.indexOf(ze);return N!==-1?ye[N]:null};Ie.basenames=se,Ie.patterns=ye,Ie.allBasenames=se;const xe=$.filter(Fe=>!Fe.basenames);return xe.push(Ie),xe}}),define(be[58],we([0,1,2,11,8,18,21,25,37]),function(ie,e,E,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(o,a,f){if(typeof o=="string"&&(o=E.URI.file(o)),f){const D=f.getWorkspaceFolder(o);if(D){const d=f.getWorkspace().folders.length>1;let g;if((0,I.isEqual)(D.uri,o)?g="":g=(0,I.relativePath)(D.uri,o),d){const P=D.name?D.name:(0,I.basename)(D.uri);g=g?P+" \u2022 "+g:P}return g}}if(o.scheme!==T.Schemas.file&&o.scheme!==T.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(o.fsPath))return(0,k.normalize)(C(o.fsPath));let b=(0,k.normalize)(o.fsPath);return!S.isWindows&&(a==null?void 0:a.userHome)&&(b=m(b,a.userHome.fsPath)),b}e.getPathLabel=n;function R(o){if(!!o){typeof o=="string"&&(o=E.URI.file(o));const a=(0,I.basename)(o)||(o.scheme===T.Schemas.file?o.fsPath:o.path);return S.isWindows&&(0,y.isRootOrDriveLetter)(a)?C(a):a}}e.getBaseLabel=R;function C(o){return(0,y.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=C;let v=Object.create(null);function m(o,a){if(S.isWindows||!o||!a)return o;let f=v.original===a?v.normalized:void 0;return f||(f=`${(0,A.rtrim)(a,k.posix.sep)}${k.posix.sep}`,v={original:a,normalized:f}),(S.isLinux?o.startsWith(f):(0,A.startsWithIgnoreCase)(o,f))&&(o=`~/${o.substr(f.length)}`),o}e.tildify=m;function i(o,a){return o.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=i;const s="\u2026",p="\\\\",h="~";function w(o,a=k.sep){const f=new Array(o.length);let b=!1;for(let D=0;D<o.length;D++){let d=o[D];if(d===""){f[D]=`.${a}`;continue}if(!d){f[D]=d;continue}b=!0;let g="";d.indexOf(p)===0?(g=d.substr(0,d.indexOf(p)+p.length),d=d.substr(d.indexOf(p)+p.length)):d.indexOf(a)===0?(g=d.substr(0,d.indexOf(a)+a.length),d=d.substr(d.indexOf(a)+a.length)):d.indexOf(h)===0&&(g=d.substr(0,d.indexOf(h)+h.length),d=d.substr(d.indexOf(h)+h.length));const P=d.split(a);for(let F=1;b&&F<=P.length;F++)for(let z=P.length-F;b&&z>=0;z--){b=!1;let de=P.slice(z,z+F).join(a);for(let W=0;!b&&W<o.length;W++)if(W!==D&&o[W]&&o[W].indexOf(de)>-1){const B=z+F===P.length,K=z>0&&o[W].indexOf(a)>-1?a+de:de,L=o[W].endsWith(K);b=!B||L}if(!b){let W="";(P[0].endsWith(":")||g!=="")&&(z===1&&(z=0,F++,de=P[0]+a+de),z>0&&(W=P[0]+a),W=g+W),z>0&&(W=W+s+a),W=W+de,z+F<P.length&&(W=W+a+s),f[D]=W}}b&&(f[D]=d)}return f}e.shorten=w;var _;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(_||(_={}));function c(o,a=Object.create(null)){const f=[];let b=!1,D="";for(const d of o)if(d==="$"||b&&d==="{")D&&f.push({value:D,type:_.TEXT}),D="",b=!0;else if(d==="}"&&b){const g=a[D];if(typeof g=="string")g.length&&f.push({value:g,type:_.VARIABLE});else if(g){const P=f[f.length-1];(!P||P.type!==_.SEPARATOR)&&f.push({value:g.label,type:_.SEPARATOR})}D="",b=!1}else D+=d;return D&&!b&&f.push({value:D,type:_.TEXT}),f.filter((d,g)=>{if(d.type===_.SEPARATOR){const P=f[g-1],F=f[g+1];return[P,F].every(z=>z&&(z.type===_.VARIABLE||z.type===_.TEXT)&&z.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=c;function l(o,a){return S.isMacintosh||a?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.isMacintosh?"&":"&&"):o.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function t(o,a){return S.isMacintosh||a?o.replace(/\(&&\w\)|&&/g,""):S.isWindows?o.replace(/&&|&/g,f=>f==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=r;function u(o){const a=o.indexOf("/")!==-1?k.posix:k.win32,f=a.basename(o),b=a.dirname(o);return f.length?{name:f,parentPath:b}:{name:b,parentPath:""}}e.splitName=u}),define(be[111],we([0,1,2]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(R){return R.toJSON()}class A{constructor(C){this._uriTransformer=C}transformIncoming(C){const v=this._uriTransformer.transformIncoming(C);return v===C?C:k(E.URI.from(v))}transformOutgoing(C){const v=this._uriTransformer.transformOutgoing(C);return v===C?C:k(E.URI.from(v))}transformOutgoingURI(C){const v=this._uriTransformer.transformOutgoing(C);return v===C?C:E.URI.from(v)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function T(R,C,v){if(!R||v>200)return null;if(typeof R=="object"){if(R instanceof E.URI)return C.transformOutgoing(R);for(let m in R)if(Object.hasOwnProperty.call(R,m)){const i=T(R[m],C,v+1);i!==null&&(R[m]=i)}}return null}function S(R,C){const v=T(R,C,0);return v===null?R:v}e.transformOutgoingURIs=S;function I(R,C,v,m){if(!R||m>200)return null;if(typeof R=="object"){if(R.$mid===1)return v?E.URI.revive(C.transformIncoming(R)):C.transformIncoming(R);for(let i in R)if(Object.hasOwnProperty.call(R,i)){const s=I(R[i],C,v,m+1);s!==null&&(R[i]=s)}}return null}function y(R,C){const v=I(R,C,!1,0);return v===null?R:v}e.transformIncomingURIs=y;function n(R,C){const v=I(R,C,!0,0);return v===null?R:v}e.transformAndReviveIncomingURIs=n}),define(be[29],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(y){return E.test(y)}e.isUUID=k;const A=new Uint8Array(16),T=[];for(let y=0;y<256;y++)T.push(y.toString(16).padStart(2,"0"));let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(y){for(let n=0;n<y.length;n++)y[n]=Math.floor(Math.random()*256);return y};function I(){S(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let y=0,n="";return n+=T[A[y++]],n+=T[A[y++]],n+=T[A[y++]],n+=T[A[y++]],n+="-",n+=T[A[y++]],n+=T[A[y++]],n+="-",n+=T[A[y++]],n+=T[A[y++]],n+="-",n+=T[A[y++]],n+=T[A[y++]],n+="-",n+=T[A[y++]],n+=T[A[y++]],n+=T[A[y++]],n+=T[A[y++]],n+=T[A[y++]],n+=T[A[y++]],n}e.generateUuid=I}),define(be[81],we([0,1,79]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class k{constructor(I){let y=(0,E.toUint8)(I);this._defaultValue=y,this._asciiMap=k._createAsciiMap(y),this._map=new Map}static _createAsciiMap(I){let y=new Uint8Array(256);for(let n=0;n<256;n++)y[n]=I;return y}set(I,y){let n=(0,E.toUint8)(y);I>=0&&I<256?this._asciiMap[I]=n:this._map.set(I,n)}get(I){return I>=0&&I<256?this._asciiMap[I]:this._map.get(I)||this._defaultValue}}e.CharacterClassifier=k;var A;(function(S){S[S.False=0]="False",S[S.True=1]="True"})(A||(A={}));class T{constructor(){this._actual=new k(0)}add(I){this._actual.set(I,1)}has(I){return this._actual.get(I)===1}}e.CharacterSet=T}),define(be[112],we([0,1,81]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var k;(function(S){S[S.Regular=0]="Regular",S[S.Whitespace=1]="Whitespace",S[S.WordSeparator=2]="WordSeparator"})(k=e.WordCharacterClass||(e.WordCharacterClass={}));class A extends E.CharacterClassifier{constructor(I){super(0);for(let y=0,n=I.length;y<n;y++)this.set(I.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=A;function T(S){let I={};return y=>(I.hasOwnProperty(y)||(I[y]=S(y)),I[y])}e.getMapForWordSeparators=T(S=>new A(S))}),define(be[38],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class E{constructor(A,T){this.lineNumber=A,this.column=T}with(A=this.lineNumber,T=this.column){return A===this.lineNumber&&T===this.column?this:new E(A,T)}delta(A=0,T=0){return this.with(this.lineNumber+A,this.column+T)}equals(A){return E.equals(this,A)}static equals(A,T){return!A&&!T?!0:!!A&&!!T&&A.lineNumber===T.lineNumber&&A.column===T.column}isBefore(A){return E.isBefore(this,A)}static isBefore(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<T.column}isBeforeOrEqual(A){return E.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<=T.column}static compare(A,T){let S=A.lineNumber|0,I=T.lineNumber|0;if(S===I){let y=A.column|0,n=T.column|0;return y-n}return S-I}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new E(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}}e.Position=E}),define(be[32],we([0,1,38]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class k{constructor(T,S,I,y){T>I||T===I&&S>y?(this.startLineNumber=I,this.startColumn=y,this.endLineNumber=T,this.endColumn=S):(this.startLineNumber=T,this.startColumn=S,this.endLineNumber=I,this.endColumn=y)}isEmpty(){return k.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return k.containsPosition(this,T)}static containsPosition(T,S){return!(S.lineNumber<T.startLineNumber||S.lineNumber>T.endLineNumber||S.lineNumber===T.startLineNumber&&S.column<T.startColumn||S.lineNumber===T.endLineNumber&&S.column>T.endColumn)}containsRange(T){return k.containsRange(this,T)}static containsRange(T,S){return!(S.startLineNumber<T.startLineNumber||S.endLineNumber<T.startLineNumber||S.startLineNumber>T.endLineNumber||S.endLineNumber>T.endLineNumber||S.startLineNumber===T.startLineNumber&&S.startColumn<T.startColumn||S.endLineNumber===T.endLineNumber&&S.endColumn>T.endColumn)}strictContainsRange(T){return k.strictContainsRange(this,T)}static strictContainsRange(T,S){return!(S.startLineNumber<T.startLineNumber||S.endLineNumber<T.startLineNumber||S.startLineNumber>T.endLineNumber||S.endLineNumber>T.endLineNumber||S.startLineNumber===T.startLineNumber&&S.startColumn<=T.startColumn||S.endLineNumber===T.endLineNumber&&S.endColumn>=T.endColumn)}plusRange(T){return k.plusRange(this,T)}static plusRange(T,S){let I,y,n,R;return S.startLineNumber<T.startLineNumber?(I=S.startLineNumber,y=S.startColumn):S.startLineNumber===T.startLineNumber?(I=S.startLineNumber,y=Math.min(S.startColumn,T.startColumn)):(I=T.startLineNumber,y=T.startColumn),S.endLineNumber>T.endLineNumber?(n=S.endLineNumber,R=S.endColumn):S.endLineNumber===T.endLineNumber?(n=S.endLineNumber,R=Math.max(S.endColumn,T.endColumn)):(n=T.endLineNumber,R=T.endColumn),new k(I,y,n,R)}intersectRanges(T){return k.intersectRanges(this,T)}static intersectRanges(T,S){let I=T.startLineNumber,y=T.startColumn,n=T.endLineNumber,R=T.endColumn,C=S.startLineNumber,v=S.startColumn,m=S.endLineNumber,i=S.endColumn;return I<C?(I=C,y=v):I===C&&(y=Math.max(y,v)),n>m?(n=m,R=i):n===m&&(R=Math.min(R,i)),I>n||I===n&&y>R?null:new k(I,y,n,R)}equalsRange(T){return k.equalsRange(this,T)}static equalsRange(T,S){return!!T&&!!S&&T.startLineNumber===S.startLineNumber&&T.startColumn===S.startColumn&&T.endLineNumber===S.endLineNumber&&T.endColumn===S.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(T){return new E.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(T){return new E.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,S){return new k(this.startLineNumber,this.startColumn,T,S)}setStartPosition(T,S){return new k(T,S,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(T){return new k(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,S=T){return new k(T.lineNumber,T.column,S.lineNumber,S.column)}static lift(T){return T?new k(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,S){return!(T.endLineNumber<S.startLineNumber||T.endLineNumber===S.startLineNumber&&T.endColumn<S.startColumn||S.endLineNumber<T.startLineNumber||S.endLineNumber===T.startLineNumber&&S.endColumn<T.startColumn)}static areIntersecting(T,S){return!(T.endLineNumber<S.startLineNumber||T.endLineNumber===S.startLineNumber&&T.endColumn<=S.startColumn||S.endLineNumber<T.startLineNumber||S.endLineNumber===T.startLineNumber&&S.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,S){if(T&&S){const n=T.startLineNumber|0,R=S.startLineNumber|0;if(n===R){const C=T.startColumn|0,v=S.startColumn|0;if(C===v){const m=T.endLineNumber|0,i=S.endLineNumber|0;if(m===i){const s=T.endColumn|0,p=S.endColumn|0;return s-p}return m-i}return C-v}return n-R}return(T?1:0)-(S?1:0)}static compareRangesUsingEnds(T,S){return T.endLineNumber===S.endLineNumber?T.endColumn===S.endColumn?T.startLineNumber===S.startLineNumber?T.startColumn-S.startColumn:T.startLineNumber-S.startLineNumber:T.endColumn-S.endColumn:T.endLineNumber-S.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=k}),define(be[113],we([0,1,38,32]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var A;(function(S){S[S.LTR=0]="LTR",S[S.RTL=1]="RTL"})(A=e.SelectionDirection||(e.SelectionDirection={}));class T extends k.Range{constructor(I,y,n,R){super(I,y,n,R);this.selectionStartLineNumber=I,this.selectionStartColumn=y,this.positionLineNumber=n,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(I){return T.selectionsEqual(this,I)}static selectionsEqual(I,y){return I.selectionStartLineNumber===y.selectionStartLineNumber&&I.selectionStartColumn===y.selectionStartColumn&&I.positionLineNumber===y.positionLineNumber&&I.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(I,y){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,I,y):new T(I,y,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(I,y){return this.getDirection()===0?new T(I,y,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,I,y)}static fromPositions(I,y=I){return new T(I.lineNumber,I.column,y.lineNumber,y.column)}static liftSelection(I){return new T(I.selectionStartLineNumber,I.selectionStartColumn,I.positionLineNumber,I.positionColumn)}static selectionsArrEqual(I,y){if(I&&!y||!I&&y)return!1;if(!I&&!y)return!0;if(I.length!==y.length)return!1;for(let n=0,R=I.length;n<R;n++)if(!this.selectionsEqual(I[n],y[n]))return!1;return!0}static isISelection(I){return I&&typeof I.selectionStartLineNumber=="number"&&typeof I.selectionStartColumn=="number"&&typeof I.positionLineNumber=="number"&&typeof I.positionColumn=="number"}static createWithDirection(I,y,n,R,C){return C===0?new T(I,y,n,R):new T(n,R,I,y)}}e.Selection=T}),define(be[82],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var E;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(E=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{constructor(i){this.tabSize=Math.max(1,i.tabSize|0),this.indentSize=i.tabSize|0,this.insertSpaces=Boolean(i.insertSpaces),this.defaultEOL=i.defaultEOL|0,this.trimAutoWhitespace=Boolean(i.trimAutoWhitespace)}equals(i){return this.tabSize===i.tabSize&&this.indentSize===i.indentSize&&this.insertSpaces===i.insertSpaces&&this.defaultEOL===i.defaultEOL&&this.trimAutoWhitespace===i.trimAutoWhitespace}createChangeEvent(i){return{tabSize:this.tabSize!==i.tabSize,indentSize:this.indentSize!==i.indentSize,insertSpaces:this.insertSpaces!==i.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==i.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class y{constructor(i,s){this.range=i,this.matches=s}}e.FindMatch=y;var n;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var R;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(R=e.ModelConstants||(e.ModelConstants={}));class C{constructor(i,s,p,h,w,_){this.identifier=i,this.range=s,this.text=p,this.forceMoveMarkers=h,this.isAutoWhitespaceEdit=w,this._isTracked=_}}e.ValidAnnotatedEditOperation=C;class v{constructor(i,s,p){this.reverseEdits=i,this.changes=s,this.trimAutoWhitespaceLineNumbers=p}}e.ApplyEditsResult=v}),define(be[114],we([0,1,8,112,38,32,82]),function(ie,e,E,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class y{constructor(_,c,l,t){this.searchString=_,this.isRegex=c,this.matchCase=l,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let _;this.isRegex?_=n(this.searchString):_=this.searchString.indexOf(`
`)>=0;let c=null;try{c=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:_,global:!0,unicode:!0})}catch(t){return null}if(!c)return null;let l=!this.isRegex&&!_;return l&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(l=this.matchCase),new R(c,this.wordSeparators?(0,k.getMapForWordSeparators)(this.wordSeparators):null,l?this.searchString:null)}}e.SearchParams=y;function n(w){if(!w||w.length===0)return!1;for(let _=0,c=w.length;_<c;_++)if(w.charCodeAt(_)===92){if(_++,_>=c)break;const t=w.charCodeAt(_);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class R{constructor(_,c,l){this.regex=_,this.wordSeparators=c,this.simpleSearch=l}}e.SearchData=R;function C(w,_,c){if(!c)return new S.FindMatch(w,null);let l=[];for(let t=0,r=_.length;t<r;t++)l[t]=_[t];return new S.FindMatch(w,l)}e.createFindMatch=C;class v{constructor(_){let c=[],l=0;for(let t=0,r=_.length;t<r;t++)_.charCodeAt(t)===10&&(c[l++]=t);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(_){const c=this._lineFeedsOffsets;let l=0,t=c.length-1;if(t===-1||_<=c[0])return 0;for(;l<t;){const r=l+((t-l)/2>>0);c[r]>=_?t=r-1:c[r+1]>=_?(l=r,t=r):l=r+1}return l+1}}class m{static findMatches(_,c,l,t,r){const u=c.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(_,l,new h(u.wordSeparators,u.regex),t,r):this._doFindMatchesLineByLine(_,l,u,t,r):[]}static _getMultilineMatchRange(_,c,l,t,r,u){let o,a=0;t?(a=t.findLineFeedCountBeforeOffset(r),o=c+r+a):o=c+r;let f;if(t){let g=t.findLineFeedCountBeforeOffset(r+u.length)-a;f=o+u.length+g}else f=o+u.length;const b=_.getPositionAt(o),D=_.getPositionAt(f);return new T.Range(b.lineNumber,b.column,D.lineNumber,D.column)}static _doFindMatchesMultiline(_,c,l,t,r){const u=_.getOffsetAt(c.getStartPosition()),o=_.getValueInRange(c,1),a=_.getEOL()===`\r
`?new v(o):null,f=[];let b=0,D;for(l.reset(0);D=l.next(o);)if(f[b++]=C(this._getMultilineMatchRange(_,u,o,a,D.index,D[0]),D,t),b>=r)return f;return f}static _doFindMatchesLineByLine(_,c,l,t,r){const u=[];let o=0;if(c.startLineNumber===c.endLineNumber){const f=_.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return o=this._findMatchesInLine(l,f,c.startLineNumber,c.startColumn-1,o,u,t,r),u}const a=_.getLineContent(c.startLineNumber).substring(c.startColumn-1);o=this._findMatchesInLine(l,a,c.startLineNumber,c.startColumn-1,o,u,t,r);for(let f=c.startLineNumber+1;f<c.endLineNumber&&o<r;f++)o=this._findMatchesInLine(l,_.getLineContent(f),f,0,o,u,t,r);if(o<r){const f=_.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);o=this._findMatchesInLine(l,f,c.endLineNumber,0,o,u,t,r)}return u}static _findMatchesInLine(_,c,l,t,r,u,o,a){const f=_.wordSeparators;if(!o&&_.simpleSearch){const d=_.simpleSearch,g=d.length,P=c.length;let F=-g;for(;(F=c.indexOf(d,F+g))!==-1;)if((!f||p(f,c,P,F,g))&&(u[r++]=new S.FindMatch(new T.Range(l,F+1+t,l,F+1+g+t),null),r>=a))return r;return r}const b=new h(_.wordSeparators,_.regex);let D;b.reset(0);do if(D=b.next(c),D&&(u[r++]=C(new T.Range(l,D.index+1+t,l,D.index+1+D[0].length+t),D,o),r>=a))return r;while(D);return r}static findNextMatch(_,c,l,t){const r=c.parseSearchRequest();if(!r)return null;const u=new h(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(_,l,u,t):this._doFindNextMatchLineByLine(_,l,u,t)}static _doFindNextMatchMultiline(_,c,l,t){const r=new A.Position(c.lineNumber,1),u=_.getOffsetAt(r),o=_.getLineCount(),a=_.getValueInRange(new T.Range(r.lineNumber,r.column,o,_.getLineMaxColumn(o)),1),f=_.getEOL()===`\r
`?new v(a):null;l.reset(c.column-1);let b=l.next(a);return b?C(this._getMultilineMatchRange(_,u,a,f,b.index,b[0]),b,t):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(_,new A.Position(1,1),l,t):null}static _doFindNextMatchLineByLine(_,c,l,t){const r=_.getLineCount(),u=c.lineNumber,o=_.getLineContent(u),a=this._findFirstMatchInLine(l,o,u,c.column,t);if(a)return a;for(let f=1;f<=r;f++){const b=(u+f-1)%r,D=_.getLineContent(b+1),d=this._findFirstMatchInLine(l,D,b+1,1,t);if(d)return d}return null}static _findFirstMatchInLine(_,c,l,t,r){_.reset(t-1);const u=_.next(c);return u?C(new T.Range(l,u.index+1,l,u.index+1+u[0].length),u,r):null}static findPreviousMatch(_,c,l,t){const r=c.parseSearchRequest();if(!r)return null;const u=new h(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(_,l,u,t):this._doFindPreviousMatchLineByLine(_,l,u,t)}static _doFindPreviousMatchMultiline(_,c,l,t){const r=this._doFindMatchesMultiline(_,new T.Range(1,1,c.lineNumber,c.column),l,t,10*I);if(r.length>0)return r[r.length-1];const u=_.getLineCount();return c.lineNumber!==u||c.column!==_.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(_,new A.Position(u,_.getLineMaxColumn(u)),l,t):null}static _doFindPreviousMatchLineByLine(_,c,l,t){const r=_.getLineCount(),u=c.lineNumber,o=_.getLineContent(u).substring(0,c.column-1),a=this._findLastMatchInLine(l,o,u,t);if(a)return a;for(let f=1;f<=r;f++){const b=(r+u-f-1)%r,D=_.getLineContent(b+1),d=this._findLastMatchInLine(l,D,b+1,t);if(d)return d}return null}static _findLastMatchInLine(_,c,l,t){let r=null,u;for(_.reset(0);u=_.next(c);)r=C(new T.Range(l,u.index+1,l,u.index+1+u[0].length),u,t);return r}}e.TextModelSearch=m;function i(w,_,c,l,t){if(l===0)return!0;const r=_.charCodeAt(l-1);if(w.get(r)!==0||r===13||r===10)return!0;if(t>0){const u=_.charCodeAt(l);if(w.get(u)!==0)return!0}return!1}function s(w,_,c,l,t){if(l+t===c)return!0;const r=_.charCodeAt(l+t);if(w.get(r)!==0||r===13||r===10)return!0;if(t>0){const u=_.charCodeAt(l+t-1);if(w.get(u)!==0)return!0}return!1}function p(w,_,c,l,t){return i(w,_,c,l,t)&&s(w,_,c,l,t)}e.isValidMatch=p;class h{constructor(_,c){this._wordSeparators=_,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(_){this._searchRegex.lastIndex=_,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(_){const c=_.length;let l;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(l=this._searchRegex.exec(_),!l))return null;const t=l.index,r=l[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){E.getNextCodePoint(_,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||p(this._wordSeparators,_,c,t,r))return l}while(l);return null}}e.Searcher=h}),define(be[83],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function E(I=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)I.indexOf(n)>=0||(y+="\\"+n);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=E();function k(I){let y=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)y=I;else{let n="g";I.ignoreCase&&(n+="i"),I.multiline&&(n+="m"),I.unicode&&(n+="u"),y=new RegExp(I.source,n)}return y.lastIndex=0,y}e.ensureValidWordDefinition=k;const A={maxLen:1e3,windowSize:15,timeBudget:150};function T(I,y,n,R,C=A){if(n.length>C.maxLen){let p=I-C.maxLen/2;return p<0?p=0:R+=p,n=n.substring(p,I+C.maxLen/2),T(I,y,n,R,C)}const v=Date.now(),m=I-1-R;let i=-1,s=null;for(let p=1;!(Date.now()-v>=C.timeBudget);p++){const h=m-C.windowSize*p;y.lastIndex=Math.max(0,h);const w=S(y,n,m,i);if(!w&&s||(s=w,h<=0))break;i=h}if(s){let p={word:s[0],startColumn:R+1+s.index,endColumn:R+1+s.index+s[0].length};return y.lastIndex=0,p}return null}e.getWordAtText=T;function S(I,y,n,R){let C;for(;C=I.exec(y);){const v=C.index||0;if(v<=n&&I.lastIndex>=n)return C;if(R>0&&v>R)return null}return null}}),define(be[115],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var E;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(E=e.IndentAction||(e.IndentAction={}));class k{constructor(I){if(this.open=I.open,this.close=I.close,this._standardTokenMask=0,Array.isArray(I.notIn))for(let y=0,n=I.notIn.length;y<n;y++)switch(I.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(I){return(this._standardTokenMask&I)==0}}e.StandardAutoClosingPairConditional=k;class A{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of I)T(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),T(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),T(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),T(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&T(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=A;function T(S,I,y){S.has(I)?S.get(I).push(y):S.set(I,[y])}}),define(be[59],we([0,1,28,11]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function A(T,S,I,y){if(Array.isArray(T)){let n=0;for(const R of T){const C=A(R,S,I,y);if(C===10)return C;C>n&&(n=C)}return n}else{if(typeof T=="string")return y?T==="*"?5:T===I?10:0:0;if(T){const{language:n,pattern:R,scheme:C,hasAccessToAllModels:v}=T;if(!y&&!v)return 0;let m=0;if(C)if(C===S.scheme)m=10;else if(C==="*")m=5;else return 0;if(n)if(n===I)m=10;else if(n==="*")m=Math.max(m,5);else return 0;if(R){let i;if(typeof R=="string"?i=R:i=Object.assign(Object.assign({},R),{base:(0,k.normalize)(R.base)}),i===S.fsPath||(0,E.match)(i,S.fsPath))m=10;else return 0}return m}else return 0}}e.score=A}),define(be[116],we([0,1,81]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var k;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(k=e.State||(e.State={}));class A{constructor(i,s,p){const h=new Uint8Array(i*s);for(let w=0,_=i*s;w<_;w++)h[w]=p;this._data=h,this.rows=i,this.cols=s}get(i,s){return this._data[i*this.cols+s]}set(i,s,p){this._data[i*this.cols+s]=p}}e.Uint8Matrix=A;class T{constructor(i){let s=0,p=0;for(let w=0,_=i.length;w<_;w++){let[c,l,t]=i[w];l>s&&(s=l),c>p&&(p=c),t>p&&(p=t)}s++,p++;let h=new A(p,s,0);for(let w=0,_=i.length;w<_;w++){let[c,l,t]=i[w];h.set(c,l,t)}this._states=h,this._maxCharCode=s}nextState(i,s){return s<0||s>=this._maxCharCode?0:this._states.get(i,s)}}e.StateMachine=T;let S=null;function I(){return S===null&&(S=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),S}var y;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let n=null;function R(){if(n===null){n=new E.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let s=0;s<m.length;s++)n.set(m.charCodeAt(s),1);const i=".,;";for(let s=0;s<i.length;s++)n.set(i.charCodeAt(s),2)}return n}class C{static _createLink(i,s,p,h,w){let _=w-1;do{const c=s.charCodeAt(_);if(i.get(c)!==2)break;_--}while(_>h);if(h>0){const c=s.charCodeAt(h-1),l=s.charCodeAt(_);(c===40&&l===41||c===91&&l===93||c===123&&l===125)&&_--}return{range:{startLineNumber:p,startColumn:h+1,endLineNumber:p,endColumn:_+2},url:s.substring(h,_+1)}}static computeLinks(i,s=I()){const p=R();let h=[];for(let w=1,_=i.getLineCount();w<=_;w++){const c=i.getLineContent(w),l=c.length;let t=0,r=0,u=0,o=1,a=!1,f=!1,b=!1,D=!1;for(;t<l;){let d=!1;const g=c.charCodeAt(t);if(o===13){let P;switch(g){case 40:a=!0,P=0;break;case 41:P=a?0:1;break;case 91:b=!0,f=!0,P=0;break;case 93:b=!1,P=f?0:1;break;case 123:D=!0,P=0;break;case 125:P=D?0:1;break;case 39:P=u===34||u===96?0:1;break;case 34:P=u===39||u===96?0:1;break;case 96:P=u===39||u===34?0:1;break;case 42:P=u===42?1:0;break;case 124:P=u===124?1:0;break;case 32:P=b?0:1;break;default:P=p.get(g)}P===1&&(h.push(C._createLink(p,c,w,r,t)),d=!0)}else if(o===12){let P;g===91?(f=!0,P=0):P=p.get(g),P===1?d=!0:o=13}else o=s.nextState(o,g),o===0&&(d=!0);d&&(o=1,a=!1,f=!1,D=!1,r=t+1,u=g),t++}o===13&&h.push(C._createLink(p,c,w,r,l))}return h}}e.LinkComputer=C;function v(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:C.computeLinks(m)}e.computeLinks=v}),define(be[117],we([0,1,3,6]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class A{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(S){this._onDidChange.fire({changedLanguages:S,changedColorMap:!1})}register(S,I){return this._map.set(S,I),this.fire([S]),(0,k.toDisposable)(()=>{this._map.get(S)===I&&(this._map.delete(S),this.fire([S]))})}registerPromise(S,I){let y=null,n=!1;return this._promises.set(S,I.then(R=>{this._promises.delete(S),!(n||!R)&&(y=this.register(S,R))})),(0,k.toDisposable)(()=>{n=!0,y&&y.dispose()})}getPromise(S){const I=this.get(S);if(I)return Promise.resolve(I);const y=this._promises.get(S);return y?y.then(n=>this.get(S)):null}get(S){return this._map.get(S)||null}setColorMap(S){this._colorMap=S,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=A}),define(be[84],we([0,1,24,21]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var A;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(A||(A={}));function T(C){for(let v=0,m=C.length;v<m;v+=4){const i=C[v+0],s=C[v+1],p=C[v+2],h=C[v+3];C[v+0]=h,C[v+1]=p,C[v+2]=s,C[v+3]=i}}function S(C){const v=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return k.isLittleEndian()||T(v),E.VSBuffer.wrap(v)}function I(C){const v=C.buffer;if(k.isLittleEndian()||T(v),v.byteOffset%4==0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const m=new Uint8Array(v.byteLength);return m.set(v),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function y(C){const v=new Uint32Array(n(C));let m=0;if(v[m++]=C.id,C.type==="full")v[m++]=1,v[m++]=C.data.length,v.set(C.data,m),m+=C.data.length;else{v[m++]=2,v[m++]=C.deltas.length;for(const i of C.deltas)v[m++]=i.start,v[m++]=i.deleteCount,i.data?(v[m++]=i.data.length,v.set(i.data,m),m+=i.data.length):v[m++]=0}return S(v)}e.encodeSemanticTokensDto=y;function n(C){let v=0;if(v+=1+1,C.type==="full")v+=1+C.data.length;else{v+=1,v+=(1+1+1)*C.deltas.length;for(const m of C.deltas)m.data&&(v+=m.data.length)}return v}function R(C){const v=I(C);let m=0;const i=v[m++];if(v[m++]===1){const w=v[m++],_=v.subarray(m,m+w);return m+=w,{id:i,type:"full",data:_}}const p=v[m++];let h=[];for(let w=0;w<p;w++){const _=v[m++],c=v[m++],l=v[m++];let t;l>0&&(t=v.subarray(m,m+l),m+=l),h[w]={start:_,deleteCount:c,data:t}}return{id:i,type:"delta",deltas:h}}e.decodeSemanticTokensDto=R}),define(be[85],we([0,1,79]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class k{constructor(S,I){this.index=S,this.remainder=I}}e.PrefixSumIndexOfResult=k;class A{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,I){S=(0,E.toUint32)(S);const y=this.values,n=this.prefixSum,R=I.length;return R===0?!1:(this.values=new Uint32Array(y.length+R),this.values.set(y.subarray(0,S),0),this.values.set(y.subarray(S),S+R),this.values.set(I,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(S,I){return S=(0,E.toUint32)(S),I=(0,E.toUint32)(I),this.values[S]===I?!1:(this.values[S]=I,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,I){S=(0,E.toUint32)(S),I=(0,E.toUint32)(I);const y=this.values,n=this.prefixSum;if(S>=y.length)return!1;let R=y.length-S;return I>=R&&(I=R),I===0?!1:(this.values=new Uint32Array(y.length-I),this.values.set(y.subarray(0,S),0),this.values.set(y.subarray(S+I),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(S){return S<0?0:(S=(0,E.toUint32)(S),this._getAccumulatedValue(S))}_getAccumulatedValue(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),S>=this.values.length&&(S=this.values.length-1);for(let y=I;y<=S;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalValue();let I=0,y=this.values.length-1,n=0,R=0,C=0;for(;I<=y;)if(n=I+(y-I)/2|0,R=this.prefixSum[n],C=R-this.values[n],S<C)y=n-1;else if(S>=R)I=n+1;else break;return new k(n,S-C)}}e.PrefixSumComputer=A}),define(be[118],we([0,1,8,38,85]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(I,y,n,R){this._uri=I,this._lines=y,this._eol=n,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(I){I.eol&&I.eol!==this._eol&&(this._eol=I.eol,this._lineStarts=null);const y=I.changes;for(const n of y)this._acceptDeleteRange(n.range),this._acceptInsertText(new k.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=I.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const I=this._eol.length,y=this._lines.length,n=new Uint32Array(y);for(let R=0;R<y;R++)n[R]=this._lines[R].length+I;this._lineStarts=new A.PrefixSumComputer(n)}}_setLineText(I,y){this._lines[I]=y,this._lineStarts&&this._lineStarts.changeValue(I,this._lines[I].length+this._eol.length)}_acceptDeleteRange(I){if(I.startLineNumber===I.endLineNumber){if(I.startColumn===I.endColumn)return;this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.startLineNumber-1].substring(I.endColumn-1));return}this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.endLineNumber-1].substring(I.endColumn-1)),this._lines.splice(I.startLineNumber,I.endLineNumber-I.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(I.startLineNumber,I.endLineNumber-I.startLineNumber)}_acceptInsertText(I,y){if(y.length!==0){let n=(0,E.splitLines)(y);if(n.length===1){this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+n[0]+this._lines[I.lineNumber-1].substring(I.column-1));return}n[n.length-1]+=this._lines[I.lineNumber-1].substring(I.column-1),this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+n[0]);let R=new Uint32Array(n.length-1);for(let C=1;C<n.length;C++)this._lines.splice(I.lineNumber+C-1,0,n[C]),R[C-1]=n[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(I.lineNumber,R)}}}e.MirrorTextModel=T}),define(be[119],we([16,17]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(be[60],we([0,1,119,12,15]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(n,R){return R&&(n.stack||n.stacktrace)?E.localize(0,null,I(n),S(n.stack)||S(n.stacktrace)):I(n)}function S(n){return Array.isArray(n)?n.join(`
`):n}function I(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?E.localize(1,null,n.message):n.message||E.localize(2,null)}function y(n=null,R=!1){if(!n)return E.localize(3,null);if(Array.isArray(n)){const C=A.coalesce(n),v=y(C[0],R);return C.length>1?E.localize(4,null,v,C.length):v}if(k.isString(n))return n;if(n.detail){const C=n.detail;if(C.error)return T(C.error,R);if(C.exception)return T(C.exception,R)}return n.stack?T(n,R):n.message?n.message:E.localize(5,null)}e.toErrorMessage=y}),define(be[120],we([16,17]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(be[121],we([0,1,120,21,83]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=S;class I{constructor(){this._values=[]}_read(X){return this._values[X]}get(X){return this._values[X]}_write(X,ve){this._values[X]=ve}}e.ValidatedEditorOptions=I;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class n{constructor(X,ve,Le,He){this.id=X,this.name=ve,this.defaultValue=Le,this.schema=He}compute(X,ve,Le){return Le}}class R{constructor(X,ve=null){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(X){return this.defaultValue}}class C{constructor(X,ve,Le,He){this.id=X,this.name=ve,this.defaultValue=Le,this.schema=He}validate(X){return typeof X=="undefined"?this.defaultValue:X}compute(X,ve,Le){return Le}}function v(V,X){return typeof V=="undefined"?X:V==="false"?!1:Boolean(V)}e.boolean=v;class m extends C{constructor(X,ve,Le,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Le),super(X,ve,Le,He)}validate(X){return v(X,this.defaultValue)}}class i extends C{constructor(X,ve,Le,He,Oe,et=void 0){typeof et!="undefined"&&(et.type="integer",et.default=Le,et.minimum=He,et.maximum=Oe),super(X,ve,Le,et),this.minimum=He,this.maximum=Oe}static clampedInt(X,ve,Le,He){if(typeof X=="undefined")return ve;let Oe=parseInt(X,10);return isNaN(Oe)?ve:(Oe=Math.max(Le,Oe),Oe=Math.min(He,Oe),Oe|0)}validate(X){return i.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class s extends C{constructor(X,ve,Le,He,Oe){typeof Oe!="undefined"&&(Oe.type="number",Oe.default=Le),super(X,ve,Le,Oe),this.validationFn=He}static clamp(X,ve,Le){return X<ve?ve:X>Le?Le:X}static float(X,ve){if(typeof X=="number")return X;if(typeof X=="undefined")return ve;const Le=parseFloat(X);return isNaN(Le)?ve:Le}validate(X){return this.validationFn(s.float(X,this.defaultValue))}}class p extends C{static string(X,ve){return typeof X!="string"?ve:X}constructor(X,ve,Le,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Le),super(X,ve,Le,He)}validate(X){return p.string(X,this.defaultValue)}}function h(V,X,ve){return typeof V!="string"||ve.indexOf(V)===-1?X:V}e.stringSet=h;class w extends C{constructor(X,ve,Le,He,Oe=void 0){typeof Oe!="undefined"&&(Oe.type="string",Oe.enum=He,Oe.default=Le),super(X,ve,Le,Oe),this._allowedValues=He}validate(X){return h(X,this.defaultValue,this._allowedValues)}}class _ extends n{constructor(X,ve,Le,He,Oe,et,H=void 0){typeof H!="undefined"&&(H.type="string",H.enum=Oe,H.default=He),super(X,ve,Le,H),this._allowedValues=Oe,this._convert=et}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function c(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[E.localize(0,null),E.localize(1,null),E.localize(2,null)],default:"auto",description:E.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,ve,Le){return Le===0?X.accessibilitySupport:Le}}class t extends n{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:E.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:E.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{insertSpace:v(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function u(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var o;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(o=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(V){switch(V){case o.Line:return"line";case o.Block:return"block";case o.Underline:return"underline";case o.LineThin:return"line-thin";case o.BlockOutline:return"block-outline";case o.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function f(V){switch(V){case"line":return o.Line;case"block":return o.Block;case"underline":return o.Underline;case"line-thin":return o.LineThin;case"block-outline":return o.BlockOutline;case"underline-thin":return o.UnderlineThin}}class b extends R{constructor(){super(123,[62,31])}compute(X,ve,Le){const He=["monaco-editor"];return ve.get(31)&&He.push(ve.get(31)),X.extraEditorClassName&&He.push(X.extraEditorClassName),ve.get(62)==="default"?He.push("mouse-default"):ve.get(62)==="copy"&&He.push("mouse-copy"),ve.get(97)&&He.push("showUnused"),ve.get(121)&&He.push("showDeprecated"),He.join(" ")}}class D extends m{constructor(){super(30,"emptySelectionClipboard",!0,{description:E.localize(6,null)})}compute(X,ve,Le){return Le&&X.emptySelectionClipboard}}class d extends n{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:E.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:X.seedSearchStringFromSelection,description:E.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[E.localize(9,null),E.localize(10,null),E.localize(11,null)],description:E.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:E.localize(13,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:E.localize(14,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:E.localize(15,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{cursorMoveOnType:v(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:v(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":h(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(ve.loop,this.defaultValue.loop)}}}class g extends n{constructor(){super(41,"fontLigatures",g.OFF,{anyOf:[{type:"boolean",description:E.localize(16,null)},{type:"string",description:E.localize(17,null)}],description:E.localize(18,null),default:!1})}validate(X){return typeof X=="undefined"?this.defaultValue:typeof X=="string"?X==="false"?g.OFF:X==="true"?g.ON:X:Boolean(X)?g.ON:g.OFF}}e.EditorFontLigatures=g,g.OFF='"liga" off, "calt" off',g.ON='"liga" on, "calt" on';class P extends R{constructor(){super(40)}compute(X,ve,Le){return X.fontInfo}}class F extends C{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:E.localize(19,null)})}validate(X){let ve=s.float(X,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(ve,6,100)}compute(X,ve,Le){return X.fontInfo.fontSize}}class z extends n{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:E.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:E.localize(21,null)})}validate(X){return X==="normal"||X==="bold"?X:String(i.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class de extends n{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[E.localize(22,null),E.localize(23,null),E.localize(24,null)]};super(47,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:E.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:E.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:E.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:E.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:E.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:E.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,description:E.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,description:E.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,description:E.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,description:E.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,description:E.localize(35,null)}})}validate(X){var ve,Le,He,Oe,et;if(!X||typeof X!="object")return this.defaultValue;const H=X;return{multiple:h(H.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=H.multipleDefinitions)!==null&&ve!==void 0?ve:h(H.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Le=H.multipleTypeDefinitions)!==null&&Le!==void 0?Le:h(H.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=H.multipleDeclarations)!==null&&He!==void 0?He:h(H.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Oe=H.multipleImplementations)!==null&&Oe!==void 0?Oe:h(H.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(et=H.multipleReferences)!==null&&et!==void 0?et:h(H.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(H.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(H.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(H.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(H.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(H.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class W extends n{constructor(){const X={enabled:!0,delay:300,sticky:!0};super(50,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:E.localize(36,null)},"editor.hover.delay":{type:"number",default:X.delay,description:E.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:E.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:v(ve.enabled,this.defaultValue.enabled),delay:i.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:v(ve.sticky,this.defaultValue.sticky)}}}var B;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class K extends R{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(X,ve,Le){return K.computeLayout(ve,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const ve=X.height/X.lineHeight,Le=X.scrollBeyondLastLine?ve-1:0,He=(X.viewLineCount+Le)/(X.pixelRatio*X.height),Oe=Math.floor(X.viewLineCount/He);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Le,desiredRatio:He,minimapLineCount:Oe}}static _computeMinimapLayout(X,ve){const Le=X.outerWidth,He=X.outerHeight,Oe=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Oe*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const et=ve.stableMinimapLayoutInput,H=et&&X.outerHeight===et.outerHeight&&X.lineHeight===et.lineHeight&&X.typicalHalfwidthCharacterWidth===et.typicalHalfwidthCharacterWidth&&X.pixelRatio===et.pixelRatio&&X.scrollBeyondLastLine===et.scrollBeyondLastLine&&X.minimap.enabled===et.minimap.enabled&&X.minimap.side===et.minimap.side&&X.minimap.size===et.minimap.size&&X.minimap.showSlider===et.minimap.showSlider&&X.minimap.renderCharacters===et.minimap.renderCharacters&&X.minimap.maxColumn===et.minimap.maxColumn&&X.minimap.scale===et.minimap.scale&&X.verticalScrollbarWidth===et.verticalScrollbarWidth&&X.isViewportWrapping===et.isViewportWrapping,ne=X.lineHeight,he=X.typicalHalfwidthCharacterWidth,q=X.scrollBeyondLastLine,J=X.minimap.renderCharacters;let oe=Oe>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const fe=X.minimap.maxColumn,pe=X.minimap.size,We=X.minimap.side,Ne=X.verticalScrollbarWidth,Ve=X.viewLineCount,Xe=X.remainingWidth,Ze=X.isViewportWrapping,ct=J?2:3;let ot=Math.floor(Oe*He);const nt=ot/Oe;let ue=!1,De=!1,le=ct*oe,j=oe/Oe,Ae=1;if(pe==="fill"||pe==="fit"){const{typicalViewportLineCount:ut,extraLinesBeyondLastLine:st,desiredRatio:gt,minimapLineCount:wt}=K.computeContainedMinimapLineCount({viewLineCount:Ve,scrollBeyondLastLine:q,height:He,lineHeight:ne,pixelRatio:Oe});if(Ve/wt>1)ue=!0,De=!0,oe=1,le=1,j=oe/Oe;else{let vt=!1,Et=oe+1;if(pe==="fit"){const pt=Math.ceil((Ve+st)*le);Ze&&H&&Xe<=ve.stableFitRemainingWidth?(vt=!0,Et=ve.stableFitMaxMinimapScale):(vt=pt>ot,Ze&&vt?(ve.stableMinimapLayoutInput=X,ve.stableFitRemainingWidth=Xe):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0))}if(pe==="fill"||vt){ue=!0;const pt=oe;le=Math.min(ne*Oe,Math.max(1,Math.floor(1/gt))),oe=Math.min(Et,Math.max(1,Math.floor(le/ct))),oe>pt&&(Ae=Math.min(2,oe/pt)),j=oe/Oe/Ae,ot=Math.ceil(Math.max(ut,Ve+st)*le),Ze&&vt&&(ve.stableFitMaxMinimapScale=oe)}}}const Te=Math.floor(fe*j),Ye=Math.min(Te,Math.max(0,Math.floor((Xe-Ne-2)*j/(he+j)))+e.MINIMAP_GUTTER_WIDTH);let Ge=Math.floor(Oe*Ye);const rt=Ge/Oe;Ge=Math.floor(Ge*Ae);const at=J?1:2,Qe=We==="left"?0:Le-Ye-Ne;return{renderMinimap:at,minimapLeft:Qe,minimapWidth:Ye,minimapHeightIsEditorHeight:ue,minimapIsSampling:De,minimapScale:oe,minimapLineHeight:le,minimapCanvasInnerWidth:Ge,minimapCanvasInnerHeight:ot,minimapCanvasOuterWidth:rt,minimapCanvasOuterHeight:nt}}static computeLayout(X,ve){const Le=ve.outerWidth|0,He=ve.outerHeight|0,Oe=ve.lineHeight|0,et=ve.lineNumbersDigitCount|0,H=ve.typicalHalfwidthCharacterWidth,ne=ve.maxDigitWidth,he=ve.pixelRatio,q=ve.viewLineCount,J=X.get(118),oe=J==="inherit"?X.get(117):J,fe=oe==="inherit"?X.get(113):oe,pe=X.get(116),We=X.get(2),Ne=ve.isDominatedByLongLines,Ve=X.get(46),Xe=X.get(56).renderType!==0,Ze=X.get(57),ct=X.get(91),ot=X.get(61),nt=X.get(89),ue=nt.verticalScrollbarSize,De=nt.verticalHasArrows,le=nt.arrowSize,j=nt.horizontalScrollbarSize,Ae=X.get(54),Te=X.get(35);let Ye;if(typeof Ae=="string"&&/^\d+(\.\d+)?ch$/.test(Ae)){const ft=parseFloat(Ae.substr(0,Ae.length-2));Ye=i.clampedInt(ft*H,0,0,1e3)}else Ye=i.clampedInt(Ae,0,0,1e3);Te&&(Ye+=16);let Ge=0;if(Xe){const ft=Math.max(et,Ze);Ge=Math.round(ft*ne)}let rt=0;Ve&&(rt=Oe);let at=0,Qe=at+rt,ut=Qe+Ge,st=ut+Ye;const gt=Le-rt-Ge-Ye;let wt=!1,St=!1,vt=-1;We!==2&&(oe==="inherit"&&Ne?(wt=!0,St=!0):fe==="on"||fe==="bounded"?St=!0:fe==="wordWrapColumn"&&(vt=pe));const Et=K._computeMinimapLayout({outerWidth:Le,outerHeight:He,lineHeight:Oe,typicalHalfwidthCharacterWidth:H,pixelRatio:he,scrollBeyondLastLine:ct,minimap:ot,verticalScrollbarWidth:ue,viewLineCount:q,remainingWidth:gt,isViewportWrapping:St},ve.memory||new y);Et.renderMinimap!==0&&Et.minimapLeft===0&&(at+=Et.minimapWidth,Qe+=Et.minimapWidth,ut+=Et.minimapWidth,st+=Et.minimapWidth);const pt=gt-Et.minimapWidth,Rt=Math.max(1,Math.floor((pt-ue-2)/H)),Ft=De?le:0;return St&&(vt=Math.max(1,Rt),fe==="bounded"&&(vt=Math.min(vt,pe))),{width:Le,height:He,glyphMarginLeft:at,glyphMarginWidth:rt,lineNumbersLeft:Qe,lineNumbersWidth:Ge,decorationsLeft:ut,decorationsWidth:Ye,contentLeft:st,contentWidth:pt,minimap:Et,viewportColumn:Rt,isWordWrapMinified:wt,isViewportWrapping:St,wrappingColumn:vt,verticalScrollbarWidth:ue,horizontalScrollbarHeight:j,overviewRuler:{top:Ft,width:ue,height:He-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=K;class L extends n{constructor(){const X={enabled:!0};super(53,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:E.localize(39,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:v(X.enabled,this.defaultValue.enabled)}}}class U extends n{constructor(){const X={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",X,{"editor.inlineHints.enabled":{type:"boolean",default:X.enabled,description:E.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:X.fontSize,description:E.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:X.fontFamily,description:E.localize(42,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:v(ve.enabled,this.defaultValue.enabled),fontSize:i.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class x extends i{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:E.localize(43,null)})}compute(X,ve,Le){return X.fontInfo.lineHeight}}class Q extends n{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:E.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[E.localize(45,null),E.localize(46,null),E.localize(47,null)],default:X.size,description:E.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:E.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:E.localize(50,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:E.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:E.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:E.localize(53,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:v(ve.enabled,this.defaultValue.enabled),size:h(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(ve.side,this.defaultValue.side,["right","left"]),showSlider:h(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(ve.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(ve.scale,1,1,3),maxColumn:i.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function $(V){return V==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ee extends n{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(55,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{top:i.clampedInt(ve.top,0,0,1e3),bottom:i.clampedInt(ve.bottom,0,0,1e3)}}}class re extends n{constructor(){const X={enabled:!0,cycle:!1};super(72,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:E.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:E.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:v(ve.enabled,this.defaultValue.enabled),cycle:v(ve.cycle,this.defaultValue.cycle)}}}class se extends R{constructor(){super(124)}compute(X,ve,Le){return X.pixelRatio}}class ye extends n{constructor(){const X={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",X,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:X.strings,description:E.localize(58,null)},comments:{type:"boolean",default:X.comments,description:E.localize(59,null)},other:{type:"boolean",default:X.other,description:E.localize(60,null)}}}],default:X,description:E.localize(61,null)});this.defaultValue=X}validate(X){if(typeof X=="boolean")return X;if(X&&typeof X=="object"){const ve=X,Le={other:v(ve.other,this.defaultValue.other),comments:v(ve.comments,this.defaultValue.comments),strings:v(ve.strings,this.defaultValue.strings)};return Le.other&&Le.comments&&Le.strings?!0:!Le.other&&!Le.comments&&!Le.strings?!1:Le}return this.defaultValue}}var Ie;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Ie=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class xe extends n{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[E.localize(62,null),E.localize(63,null),E.localize(64,null),E.localize(65,null)],default:"on",description:E.localize(66,null)})}validate(X){let ve=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof X!="undefined"&&(typeof X=="function"?(ve=4,Le=X):X==="interval"?ve=3:X==="relative"?ve=2:X==="on"?ve=1:ve=0),{renderType:ve,renderFn:Le}}}function Fe(V){const X=V.get(84);return X==="editable"?V.get(77):X!=="on"}e.filterValidationDecorations=Fe;class ze extends n{constructor(){const X=[],ve={type:"number",description:E.localize(67,null)};super(88,"rulers",X,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:E.localize(68,null),format:"color-hex"}}}]},default:X,description:E.localize(69,null)})}validate(X){if(Array.isArray(X)){let ve=[];for(let Le of X)if(typeof Le=="number")ve.push({column:i.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const He=Le;ve.push({column:i.clampedInt(He.column,0,0,1e4),color:He.color})}return ve.sort((Le,He)=>Le.column-He.column),ve}return this.defaultValue}}function N(V,X){if(typeof V!="string")return X;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class G extends n{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X,Le=i.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=i.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(ve.vertical,this.defaultValue.vertical),horizontal:N(ve.horizontal,this.defaultValue.horizontal),useShadows:v(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:i.clampedInt(ve.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:He,verticalSliderSize:i.clampedInt(ve.verticalSliderSize,He,0,1e3),scrollByPage:v(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class te extends n{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[E.localize(70,null),E.localize(71,null)],default:X.insertMode,description:E.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:E.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:E.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:E.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:E.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:E.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:E.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:E.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:E.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:E.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:E.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:E.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:E.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:E.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:E.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:E.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:E.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:E.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:E.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:E.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:E.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:E.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:E.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:E.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:E.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:E.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:E.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:E.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:E.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:E.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:E.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:E.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:E.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:E.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:E.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:E.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:E.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:E.localize(109,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{insertMode:h(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(ve.showIcons,this.defaultValue.showIcons),showStatusBar:v(ve.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:v(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(ve.showMethods,this.defaultValue.showMethods),showFunctions:v(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:v(ve.showConstructors,this.defaultValue.showConstructors),showFields:v(ve.showFields,this.defaultValue.showFields),showVariables:v(ve.showVariables,this.defaultValue.showVariables),showClasses:v(ve.showClasses,this.defaultValue.showClasses),showStructs:v(ve.showStructs,this.defaultValue.showStructs),showInterfaces:v(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:v(ve.showModules,this.defaultValue.showModules),showProperties:v(ve.showProperties,this.defaultValue.showProperties),showEvents:v(ve.showEvents,this.defaultValue.showEvents),showOperators:v(ve.showOperators,this.defaultValue.showOperators),showUnits:v(ve.showUnits,this.defaultValue.showUnits),showValues:v(ve.showValues,this.defaultValue.showValues),showConstants:v(ve.showConstants,this.defaultValue.showConstants),showEnums:v(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:v(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(ve.showKeywords,this.defaultValue.showKeywords),showWords:v(ve.showWords,this.defaultValue.showWords),showColors:v(ve.showColors,this.defaultValue.showColors),showFiles:v(ve.showFiles,this.defaultValue.showFiles),showReferences:v(ve.showReferences,this.defaultValue.showReferences),showFolders:v(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:v(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(ve.showSnippets,this.defaultValue.showSnippets),showUsers:v(ve.showUsers,this.defaultValue.showUsers),showIssues:v(ve.showIssues,this.defaultValue.showIssues)}}}class ae extends n{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:E.localize(110,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class me extends R{constructor(){super(125,[77])}compute(X,ve,Le){return ve.get(77)?!0:X.tabFocusMode}}var Se;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(Se=e.WrappingIndent||(e.WrappingIndent={}));function Me(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends R{constructor(){super(127,[126])}compute(X,ve,Le){const He=ve.get(126);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Pe="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?Pe:k.isLinux?$e:Ce,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function _e(V){return e.editorOptionsRegistry[V.id]=V,V}var qe;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.codeLens=12]="codeLens",V[V.codeLensFontFamily=13]="codeLensFontFamily",V[V.codeLensFontSize=14]="codeLensFontSize",V[V.colorDecorators=15]="colorDecorators",V[V.columnSelection=16]="columnSelection",V[V.comments=17]="comments",V[V.contextmenu=18]="contextmenu",V[V.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",V[V.cursorBlinking=20]="cursorBlinking",V[V.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",V[V.cursorStyle=22]="cursorStyle",V[V.cursorSurroundingLines=23]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",V[V.cursorWidth=25]="cursorWidth",V[V.disableLayerHinting=26]="disableLayerHinting",V[V.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",V[V.domReadOnly=28]="domReadOnly",V[V.dragAndDrop=29]="dragAndDrop",V[V.emptySelectionClipboard=30]="emptySelectionClipboard",V[V.extraEditorClassName=31]="extraEditorClassName",V[V.fastScrollSensitivity=32]="fastScrollSensitivity",V[V.find=33]="find",V[V.fixedOverflowWidgets=34]="fixedOverflowWidgets",V[V.folding=35]="folding",V[V.foldingStrategy=36]="foldingStrategy",V[V.foldingHighlight=37]="foldingHighlight",V[V.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=39]="fontFamily",V[V.fontInfo=40]="fontInfo",V[V.fontLigatures=41]="fontLigatures",V[V.fontSize=42]="fontSize",V[V.fontWeight=43]="fontWeight",V[V.formatOnPaste=44]="formatOnPaste",V[V.formatOnType=45]="formatOnType",V[V.glyphMargin=46]="glyphMargin",V[V.gotoLocation=47]="gotoLocation",V[V.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",V[V.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",V[V.hover=50]="hover",V[V.inDiffEditor=51]="inDiffEditor",V[V.letterSpacing=52]="letterSpacing",V[V.lightbulb=53]="lightbulb",V[V.lineDecorationsWidth=54]="lineDecorationsWidth",V[V.lineHeight=55]="lineHeight",V[V.lineNumbers=56]="lineNumbers",V[V.lineNumbersMinChars=57]="lineNumbersMinChars",V[V.linkedEditing=58]="linkedEditing",V[V.links=59]="links",V[V.matchBrackets=60]="matchBrackets",V[V.minimap=61]="minimap",V[V.mouseStyle=62]="mouseStyle",V[V.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=64]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",V[V.multiCursorModifier=66]="multiCursorModifier",V[V.multiCursorPaste=67]="multiCursorPaste",V[V.occurrencesHighlight=68]="occurrencesHighlight",V[V.overviewRulerBorder=69]="overviewRulerBorder",V[V.overviewRulerLanes=70]="overviewRulerLanes",V[V.padding=71]="padding",V[V.parameterHints=72]="parameterHints",V[V.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",V[V.quickSuggestions=75]="quickSuggestions",V[V.quickSuggestionsDelay=76]="quickSuggestionsDelay",V[V.readOnly=77]="readOnly",V[V.renameOnType=78]="renameOnType",V[V.renderControlCharacters=79]="renderControlCharacters",V[V.renderIndentGuides=80]="renderIndentGuides",V[V.renderFinalNewline=81]="renderFinalNewline",V[V.renderLineHighlight=82]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=84]="renderValidationDecorations",V[V.renderWhitespace=85]="renderWhitespace",V[V.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",V[V.roundedSelection=87]="roundedSelection",V[V.rulers=88]="rulers",V[V.scrollbar=89]="scrollbar",V[V.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=91]="scrollBeyondLastLine",V[V.scrollPredominantAxis=92]="scrollPredominantAxis",V[V.selectionClipboard=93]="selectionClipboard",V[V.selectionHighlight=94]="selectionHighlight",V[V.selectOnLineNumbers=95]="selectOnLineNumbers",V[V.showFoldingControls=96]="showFoldingControls",V[V.showUnused=97]="showUnused",V[V.snippetSuggestions=98]="snippetSuggestions",V[V.smartSelect=99]="smartSelect",V[V.smoothScrolling=100]="smoothScrolling",V[V.stickyTabStops=101]="stickyTabStops",V[V.stopRenderingLineAfter=102]="stopRenderingLineAfter",V[V.suggest=103]="suggest",V[V.suggestFontSize=104]="suggestFontSize",V[V.suggestLineHeight=105]="suggestLineHeight",V[V.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",V[V.suggestSelection=107]="suggestSelection",V[V.tabCompletion=108]="tabCompletion",V[V.tabIndex=109]="tabIndex",V[V.unusualLineTerminators=110]="unusualLineTerminators",V[V.useTabStops=111]="useTabStops",V[V.wordSeparators=112]="wordSeparators",V[V.wordWrap=113]="wordWrap",V[V.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=116]="wordWrapColumn",V[V.wordWrapOverride1=117]="wordWrapOverride1",V[V.wordWrapOverride2=118]="wordWrapOverride2",V[V.wrappingIndent=119]="wrappingIndent",V[V.wrappingStrategy=120]="wrappingStrategy",V[V.showDeprecated=121]="showDeprecated",V[V.inlineHints=122]="inlineHints",V[V.editorClassName=123]="editorClassName",V[V.pixelRatio=124]="pixelRatio",V[V.tabFocusMode=125]="tabFocusMode",V[V.layoutInfo=126]="layoutInfo",V[V.wrappingInfo=127]="wrappingInfo"})(qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:E.localize(111,null)})),acceptSuggestionOnEnter:_e(new w(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",E.localize(112,null),""],markdownDescription:E.localize(113,null)})),accessibilitySupport:_e(new l),accessibilityPageSize:_e(new i(3,"accessibilityPageSize",10,1,1073741824,{description:E.localize(114,null)})),ariaLabel:_e(new p(4,"ariaLabel",E.localize(115,null))),autoClosingBrackets:_e(new w(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(116,null),E.localize(117,null),""],description:E.localize(118,null)})),autoClosingDelete:_e(new w(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",E.localize(119,null),""],description:E.localize(120,null)})),autoClosingOvertype:_e(new w(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",E.localize(121,null),""],description:E.localize(122,null)})),autoClosingQuotes:_e(new w(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(123,null),E.localize(124,null),""],description:E.localize(125,null)})),autoIndent:_e(new _(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[E.localize(126,null),E.localize(127,null),E.localize(128,null),E.localize(129,null),E.localize(130,null)],description:E.localize(131,null)})),automaticLayout:_e(new m(10,"automaticLayout",!1)),autoSurround:_e(new w(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[E.localize(132,null),E.localize(133,null),E.localize(134,null),""],description:E.localize(135,null)})),stickyTabStops:_e(new m(101,"stickyTabStops",!1,{description:E.localize(136,null)})),codeLens:_e(new m(12,"codeLens",!0,{description:E.localize(137,null)})),codeLensFontFamily:_e(new p(13,"codeLensFontFamily","",{description:E.localize(138,null)})),codeLensFontSize:_e(new i(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:E.localize(139,null)})),colorDecorators:_e(new m(15,"colorDecorators",!0,{description:E.localize(140,null)})),columnSelection:_e(new m(16,"columnSelection",!1,{description:E.localize(141,null)})),comments:_e(new t),contextmenu:_e(new m(18,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new m(19,"copyWithSyntaxHighlighting",!0,{description:E.localize(142,null)})),cursorBlinking:_e(new _(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:E.localize(143,null)})),cursorSmoothCaretAnimation:_e(new m(21,"cursorSmoothCaretAnimation",!1,{description:E.localize(144,null)})),cursorStyle:_e(new _(22,"cursorStyle",o.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],f,{description:E.localize(145,null)})),cursorSurroundingLines:_e(new i(23,"cursorSurroundingLines",0,0,1073741824,{description:E.localize(146,null)})),cursorSurroundingLinesStyle:_e(new w(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[E.localize(147,null),E.localize(148,null)],description:E.localize(149,null)})),cursorWidth:_e(new i(25,"cursorWidth",0,0,1073741824,{markdownDescription:E.localize(150,null)})),disableLayerHinting:_e(new m(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new m(27,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new m(28,"domReadOnly",!1)),dragAndDrop:_e(new m(29,"dragAndDrop",!0,{description:E.localize(151,null)})),emptySelectionClipboard:_e(new D),extraEditorClassName:_e(new p(31,"extraEditorClassName","")),fastScrollSensitivity:_e(new s(32,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:E.localize(152,null)})),find:_e(new d),fixedOverflowWidgets:_e(new m(34,"fixedOverflowWidgets",!1)),folding:_e(new m(35,"folding",!0,{description:E.localize(153,null)})),foldingStrategy:_e(new w(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[E.localize(154,null),E.localize(155,null)],description:E.localize(156,null)})),foldingHighlight:_e(new m(37,"foldingHighlight",!0,{description:E.localize(157,null)})),unfoldOnClickAfterEndOfLine:_e(new m(38,"unfoldOnClickAfterEndOfLine",!1,{description:E.localize(158,null)})),fontFamily:_e(new p(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:E.localize(159,null)})),fontInfo:_e(new P),fontLigatures2:_e(new g),fontSize:_e(new F),fontWeight:_e(new z),formatOnPaste:_e(new m(44,"formatOnPaste",!1,{description:E.localize(160,null)})),formatOnType:_e(new m(45,"formatOnType",!1,{description:E.localize(161,null)})),glyphMargin:_e(new m(46,"glyphMargin",!0,{description:E.localize(162,null)})),gotoLocation:_e(new de),hideCursorInOverviewRuler:_e(new m(48,"hideCursorInOverviewRuler",!1,{description:E.localize(163,null)})),highlightActiveIndentGuide:_e(new m(49,"highlightActiveIndentGuide",!0,{description:E.localize(164,null)})),hover:_e(new W),inDiffEditor:_e(new m(51,"inDiffEditor",!1)),letterSpacing:_e(new s(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>s.clamp(V,-5,20),{description:E.localize(165,null)})),lightbulb:_e(new L),lineDecorationsWidth:_e(new C(54,"lineDecorationsWidth",10)),lineHeight:_e(new x),lineNumbers:_e(new xe),lineNumbersMinChars:_e(new i(57,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new m(58,"linkedEditing",!1,{description:E.localize(166,null)})),links:_e(new m(59,"links",!0,{description:E.localize(167,null)})),matchBrackets:_e(new w(60,"matchBrackets","always",["always","near","never"],{description:E.localize(168,null)})),minimap:_e(new Q),mouseStyle:_e(new w(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new s(63,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:E.localize(169,null)})),mouseWheelZoom:_e(new m(64,"mouseWheelZoom",!1,{markdownDescription:E.localize(170,null)})),multiCursorMergeOverlapping:_e(new m(65,"multiCursorMergeOverlapping",!0,{description:E.localize(171,null)})),multiCursorModifier:_e(new _(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],$,{markdownEnumDescriptions:[E.localize(172,null),E.localize(173,null)],markdownDescription:E.localize(174,null)})),multiCursorPaste:_e(new w(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[E.localize(175,null),E.localize(176,null)],markdownDescription:E.localize(177,null)})),occurrencesHighlight:_e(new m(68,"occurrencesHighlight",!0,{description:E.localize(178,null)})),overviewRulerBorder:_e(new m(69,"overviewRulerBorder",!0,{description:E.localize(179,null)})),overviewRulerLanes:_e(new i(70,"overviewRulerLanes",3,0,3)),padding:_e(new ee),parameterHints:_e(new re),peekWidgetDefaultFocus:_e(new w(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[E.localize(180,null),E.localize(181,null)],description:E.localize(182,null)})),definitionLinkOpensInPeek:_e(new m(74,"definitionLinkOpensInPeek",!1,{description:E.localize(183,null)})),quickSuggestions:_e(new ye),quickSuggestionsDelay:_e(new i(76,"quickSuggestionsDelay",10,0,1073741824,{description:E.localize(184,null)})),readOnly:_e(new m(77,"readOnly",!1)),renameOnType:_e(new m(78,"renameOnType",!1,{description:E.localize(185,null),markdownDeprecationMessage:E.localize(186,null)})),renderControlCharacters:_e(new m(79,"renderControlCharacters",!1,{description:E.localize(187,null)})),renderIndentGuides:_e(new m(80,"renderIndentGuides",!0,{description:E.localize(188,null)})),renderFinalNewline:_e(new m(81,"renderFinalNewline",!0,{description:E.localize(189,null)})),renderLineHighlight:_e(new w(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",E.localize(190,null)],description:E.localize(191,null)})),renderLineHighlightOnlyWhenFocus:_e(new m(83,"renderLineHighlightOnlyWhenFocus",!1,{description:E.localize(192,null)})),renderValidationDecorations:_e(new w(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new w(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",E.localize(193,null),E.localize(194,null),E.localize(195,null),""],description:E.localize(196,null)})),revealHorizontalRightPadding:_e(new i(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new m(87,"roundedSelection",!0,{description:E.localize(197,null)})),rulers:_e(new ze),scrollbar:_e(new G),scrollBeyondLastColumn:_e(new i(90,"scrollBeyondLastColumn",5,0,1073741824,{description:E.localize(198,null)})),scrollBeyondLastLine:_e(new m(91,"scrollBeyondLastLine",!0,{description:E.localize(199,null)})),scrollPredominantAxis:_e(new m(92,"scrollPredominantAxis",!0,{description:E.localize(200,null)})),selectionClipboard:_e(new m(93,"selectionClipboard",!0,{description:E.localize(201,null),included:k.isLinux})),selectionHighlight:_e(new m(94,"selectionHighlight",!0,{description:E.localize(202,null)})),selectOnLineNumbers:_e(new m(95,"selectOnLineNumbers",!0)),showFoldingControls:_e(new w(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[E.localize(203,null),E.localize(204,null)],description:E.localize(205,null)})),showUnused:_e(new m(97,"showUnused",!0,{description:E.localize(206,null)})),showDeprecated:_e(new m(121,"showDeprecated",!0,{description:E.localize(207,null)})),inlineHints:_e(new U),snippetSuggestions:_e(new w(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[E.localize(208,null),E.localize(209,null),E.localize(210,null),E.localize(211,null)],description:E.localize(212,null)})),smartSelect:_e(new ae),smoothScrolling:_e(new m(100,"smoothScrolling",!1,{description:E.localize(213,null)})),stopRenderingLineAfter:_e(new i(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new te),suggestFontSize:_e(new i(104,"suggestFontSize",0,0,1e3,{markdownDescription:E.localize(214,null)})),suggestLineHeight:_e(new i(105,"suggestLineHeight",0,0,1e3,{markdownDescription:E.localize(215,null)})),suggestOnTriggerCharacters:_e(new m(106,"suggestOnTriggerCharacters",!0,{description:E.localize(216,null)})),suggestSelection:_e(new w(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[E.localize(217,null),E.localize(218,null),E.localize(219,null)],description:E.localize(220,null)})),tabCompletion:_e(new w(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[E.localize(221,null),E.localize(222,null),E.localize(223,null)],description:E.localize(224,null)})),tabIndex:_e(new i(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new w(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[E.localize(225,null),E.localize(226,null),E.localize(227,null)],description:E.localize(228,null)})),useTabStops:_e(new m(111,"useTabStops",!0,{description:E.localize(229,null)})),wordSeparators:_e(new p(112,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:E.localize(230,null)})),wordWrap:_e(new w(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[E.localize(231,null),E.localize(232,null),E.localize(233,null),E.localize(234,null)],description:E.localize(235,null)})),wordWrapBreakAfterCharacters:_e(new p(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new p(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new i(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:E.localize(236,null)})),wordWrapOverride1:_e(new w(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new w(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new _(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Me,{enumDescriptions:[E.localize(237,null),E.localize(238,null),E.localize(239,null),E.localize(240,null)],description:E.localize(241,null)})),wrappingStrategy:_e(new w(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[E.localize(242,null),E.localize(243,null)],description:E.localize(244,null)})),editorClassName:_e(new b),pixelRatio:_e(new se),tabFocusMode:_e(new me),layoutInfo:_e(new K),wrappingInfo:_e(new ge)}}),define(be[122],we([16,17]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[123],we([16,17]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[124],we([16,17]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(be[125],we([16,17]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(be[126],we([16,17]),function(ie,e){return ie.create("vs/platform/theme/common/iconRegistry",e)}),define(be[127],we([16,17]),function(ie,e){return ie.create("vs/platform/workspaces/common/workspaces",e)}),define(be[128],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHost.api.impl",e)}),define(be[129],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[130],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(be[131],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[132],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(be[133],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[134],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[135],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[136],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[137],we([16,17]),function(ie,e){return ie.create("vs/workbench/common/views",e)}),define(be[138],we([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[139],we([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[140],we([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[141],we([16,17]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[142],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var E;(function(S){S[S.ACTIVATE=0]="ACTIVATE",S[S.RESTORE=1]="RESTORE",S[S.PRESERVE=2]="PRESERVE"})(E=e.EditorActivation||(e.EditorActivation={}));var k;(function(S){S[S.PICK=1]="PICK",S[S.DISABLED=2]="DISABLED"})(k=e.EditorOverride||(e.EditorOverride={}));var A;(function(S){S[S.API=0]="API",S[S.USER=1]="USER"})(A=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(S){S[S.Center=0]="Center",S[S.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",S[S.NearTop=2]="NearTop",S[S.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[143],we([0,1,123]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(C){return C=C.trim(),C==="*"||k.test(C)}e.isValidVersionStr=A;function T(C){if(!A(C))return null;if(C=C.trim(),C==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=C.match(k);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=T;function S(C){if(!C)return null;let v=C.majorBase,m=C.majorMustEqual,i=C.minorBase,s=C.minorMustEqual,p=C.patchBase,h=C.patchMustEqual;return C.hasCaret&&(v===0||(s=!1),h=!1),{majorBase:v,majorMustEqual:m,minorBase:i,minorMustEqual:s,patchBase:p,patchMustEqual:h,isMinimum:C.hasGreaterEquals}}e.normalizeVersion=S;function I(C,v){let m;typeof C=="string"?m=S(T(C)):m=C;let i;if(typeof v=="string"?i=S(T(v)):i=v,!m||!i)return!1;let s=m.majorBase,p=m.minorBase,h=m.patchBase,w=i.majorBase,_=i.minorBase,c=i.patchBase,l=i.majorMustEqual,t=i.minorMustEqual,r=i.patchMustEqual;return i.isMinimum?s>w?!0:s<w?!1:p>_?!0:p<_?!1:h>=c:(s===1&&w===0&&(!l||!t||!r)&&(w=1,_=0,c=0,l=!0,t=!1,r=!1),s<w?!1:s>w?!l:p<_?!1:p>_?!t:h<c?!1:h>c?!r:!0)}e.isValidVersion=I;function y(C,v,m){return v.isBuiltin||typeof v.main=="undefined"?!0:R(C,v.engines.vscode,m)}e.isValidExtensionVersion=y;function n(C,v){return C==="*"||R(v,C)}e.isEngineValid=n;function R(C,v,m=[]){let i=S(T(v));if(!i)return m.push(E.localize(0,null,v)),!1;if(i.majorBase===0){if(!i.majorMustEqual||!i.minorMustEqual)return m.push(E.localize(1,null,v)),!1}else if(!i.majorMustEqual)return m.push(E.localize(2,null,v)),!1;return I(C,i)?!0:(m.push(E.localize(3,null,C,v)),!1)}e.isVersionValid=R}),define(be[86],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class E{constructor(T,S=[],I=!1){this.ctor=T,this.staticArguments=S,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=E;const k=(A,...T)=>new E(A,T);e.createSyncDescriptor=k}),define(be[61],we([0,1,86]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function A(S,I,y){I instanceof E.SyncDescriptor||(I=new E.SyncDescriptor(I,[],y)),k.push([S,I])}e.registerSingleton=A;function T(){return k}e.getSingletonServiceDescriptors=T}),define(be[144],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=E;class k{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let S of this._nodes.values())S.outgoing.size===0&&T.push(S);return T}insertEdge(T,S){const I=this.lookupOrInsertNode(T),y=this.lookupOrInsertNode(S);I.outgoing.set(this._hashFn(S),y),y.incoming.set(this._hashFn(T),I)}removeNode(T){const S=this._hashFn(T);this._nodes.delete(S);for(let I of this._nodes.values())I.outgoing.delete(S),I.incoming.delete(S)}lookupOrInsertNode(T){const S=this._hashFn(T);let I=this._nodes.get(S);return I||(I=new E(T),this._nodes.set(S,I)),I}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[S,I]of this._nodes)T.push(`${S}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return T.join(`
`)}}e.Graph=k}),define(be[4],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function y(n){return n[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=y})(E=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function k(I,y,n,R){y[E.DI_TARGET]===y?y[E.DI_DEPENDENCIES].push({id:I,index:n,optional:R}):(y[E.DI_DEPENDENCIES]=[{id:I,index:n,optional:R}],y[E.DI_TARGET]=y)}function A(I){if(E.serviceIds.has(I))return E.serviceIds.get(I);const y=function(n,R,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(y,n,C,!1)};return y.toString=()=>I,E.serviceIds.set(I,y),y}e.createDecorator=A;function T(I){return I}e.refineServiceDecorator=T;function S(I){return function(y,n,R){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(I,y,R,!0)}}e.optional=S}),define(be[145],we([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,E.createDecorator)("modelService");function k(A){return!A.isTooLargeForSyncing()&&!A.isForSimpleWidget}e.shouldSynchronizeModel=k}),define(be[146],we([0,1,3,56,6,22,78,59,145]),function(ie,e,E,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(v){return typeof v=="string"?!1:Array.isArray(v)?v.every(n):!!v.exclusive}class R{constructor(){this._clock=0,this._entries=[],this._onDidChange=new E.Emitter}get onDidChange(){return this._onDidChange.event}register(m,i){let s={selector:m,provider:i,_score:-1,_time:this._clock++};return this._entries.push(s),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,A.toDisposable)(()=>{if(s){let p=this._entries.indexOf(s);p>=0&&(this._entries.splice(p,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),s=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const i=[];for(let s of this._entries)s._score>0&&i.push(s.provider);return i}ordered(m){const i=[];return this._orderedForEach(m,s=>i.push(s.provider)),i}orderedGroups(m){const i=[];let s,p;return this._orderedForEach(m,h=>{s&&p===h._score?s.push(h.provider):(p=h._score,s=[h.provider],i.push(s))}),i}_orderedForEach(m,i){if(!!m){this._updateScores(m);for(const s of this._entries)s._score>0&&i(s)}}_updateScores(m){let i={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===i.language&&this._lastCandidate.uri===i.uri)){this._lastCandidate=i;for(let s of this._entries)if(s._score=(0,I.score)(s.selector,m.uri,m.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(m)),n(s.selector)&&s._score>0){for(let p of this._entries)p._score=0;s._score=1e3;break}this._entries.sort(R._compareByScoreAndTime)}}static _compareByScoreAndTime(m,i){return m._score<i._score?1:m._score>i._score?-1:m._time<i._time?1:m._time>i._time?-1:0}}e.LanguageFeatureRegistry=R;class C{constructor(m,i,s=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=i,this.max=s,this._cache=new T.LRUCache(50,.7)}_key(m){return m.id+(0,k.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const i=this._key(m),s=this._cache.get(i);return this._clamp(s==null?void 0:s.value)}update(m,i){const s=this._key(m);let p=this._cache.get(s);return p||(p=new S.MovingAverage,this._cache.set(s,p)),p.update(i),this.get(m)}}e.LanguageFeatureRequestDelays=C}),define(be[62],we([0,1,2,32,146,117,36]),function(ie,e,E,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var I;(function(d){d[d.Null=0]="Null",d[d.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));class y{constructor(g,P){this.language=g,this.id=P}}e.LanguageIdentifier=y;var n;(function(d){d[d.NotSet=-1]="NotSet",d[d.None=0]="None",d[d.Italic=1]="Italic",d[d.Bold=2]="Bold",d[d.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var R;(function(d){d[d.None=0]="None",d[d.DefaultForeground=1]="DefaultForeground",d[d.DefaultBackground=2]="DefaultBackground"})(R=e.ColorId||(e.ColorId={}));var C;(function(d){d[d.Other=0]="Other",d[d.Comment=1]="Comment",d[d.String=2]="String",d[d.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var v;(function(d){d[d.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",d[d.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",d[d.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",d[d.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",d[d.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",d[d.ITALIC_MASK=2048]="ITALIC_MASK",d[d.BOLD_MASK=4096]="BOLD_MASK",d[d.UNDERLINE_MASK=8192]="UNDERLINE_MASK",d[d.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",d[d.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",d[d.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",d[d.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",d[d.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",d[d.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",d[d.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",d[d.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",d[d.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",d[d.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(v=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(g){return(g&255)>>>0}static getTokenType(g){return(g&1792)>>>8}static getFontStyle(g){return(g&14336)>>>11}static getForeground(g){return(g&8372224)>>>14}static getBackground(g){return(g&4286578688)>>>23}static getClassNameFromMetadata(g){let P=this.getForeground(g),F="mtk"+P,z=this.getFontStyle(g);return z&1&&(F+=" mtki"),z&2&&(F+=" mtkb"),z&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(g,P){const F=this.getForeground(g),z=this.getFontStyle(g);let de=`color: ${P[F]};`;return z&1&&(de+="font-style: italic;"),z&2&&(de+="font-weight: bold;"),z&4&&(de+="text-decoration: underline;"),de}}e.TokenMetadata=m;var i;(function(d){d[d.Method=0]="Method",d[d.Function=1]="Function",d[d.Constructor=2]="Constructor",d[d.Field=3]="Field",d[d.Variable=4]="Variable",d[d.Class=5]="Class",d[d.Struct=6]="Struct",d[d.Interface=7]="Interface",d[d.Module=8]="Module",d[d.Property=9]="Property",d[d.Event=10]="Event",d[d.Operator=11]="Operator",d[d.Unit=12]="Unit",d[d.Value=13]="Value",d[d.Constant=14]="Constant",d[d.Enum=15]="Enum",d[d.EnumMember=16]="EnumMember",d[d.Keyword=17]="Keyword",d[d.Text=18]="Text",d[d.Color=19]="Color",d[d.File=20]="File",d[d.Reference=21]="Reference",d[d.Customcolor=22]="Customcolor",d[d.Folder=23]="Folder",d[d.TypeParameter=24]="TypeParameter",d[d.User=25]="User",d[d.Issue=26]="Issue",d[d.Snippet=27]="Snippet"})(i=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let d=Object.create(null);return d[0]="symbol-method",d[1]="symbol-function",d[2]="symbol-constructor",d[3]="symbol-field",d[4]="symbol-variable",d[5]="symbol-class",d[6]="symbol-struct",d[7]="symbol-interface",d[8]="symbol-module",d[9]="symbol-property",d[10]="symbol-event",d[11]="symbol-operator",d[12]="symbol-unit",d[13]="symbol-value",d[14]="symbol-constant",d[15]="symbol-enum",d[16]="symbol-enum-member",d[17]="symbol-keyword",d[27]="symbol-snippet",d[18]="symbol-text",d[19]="symbol-color",d[20]="symbol-file",d[21]="symbol-reference",d[22]="symbol-customcolor",d[23]="symbol-folder",d[24]="symbol-type-parameter",d[25]="account",d[26]="issues",function(g){const P=d[g];let F=P&&S.iconRegistry.get(P);return F||(console.info("No codicon found for CompletionItemKind "+g),F=S.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let d=Object.create(null);return d.method=0,d.function=1,d.constructor=2,d.field=3,d.variable=4,d.class=5,d.struct=6,d.interface=7,d.module=8,d.property=9,d.event=10,d.operator=11,d.unit=12,d.value=13,d.constant=14,d.enum=15,d["enum-member"]=16,d.enumMember=16,d.keyword=17,d.snippet=27,d.text=18,d.color=19,d.file=20,d.reference=21,d.customcolor=22,d.folder=23,d["type-parameter"]=24,d.typeParameter=24,d.account=25,d.issue=26,function(g,P){let F=d[g];return typeof F=="undefined"&&!P&&(F=9),F}}();var s;(function(d){d[d.Deprecated=1]="Deprecated"})(s=e.CompletionItemTag||(e.CompletionItemTag={}));var p;(function(d){d[d.KeepWhitespace=1]="KeepWhitespace",d[d.InsertAsSnippet=4]="InsertAsSnippet"})(p=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var h;(function(d){d[d.Invoke=0]="Invoke",d[d.TriggerCharacter=1]="TriggerCharacter",d[d.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(d){d[d.Invoke=1]="Invoke",d[d.Auto=2]="Auto"})(w=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var _;(function(d){d[d.Invoke=1]="Invoke",d[d.TriggerCharacter=2]="TriggerCharacter",d[d.ContentChange=3]="ContentChange"})(_=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var c;(function(d){d[d.Text=0]="Text",d[d.Read=1]="Read",d[d.Write=2]="Write"})(c=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function l(d){return d&&E.URI.isUri(d.uri)&&k.Range.isIRange(d.range)&&(k.Range.isIRange(d.originSelectionRange)||k.Range.isIRange(d.targetSelectionRange))}e.isLocationLink=l;var t;(function(d){d[d.File=0]="File",d[d.Module=1]="Module",d[d.Namespace=2]="Namespace",d[d.Package=3]="Package",d[d.Class=4]="Class",d[d.Method=5]="Method",d[d.Property=6]="Property",d[d.Field=7]="Field",d[d.Constructor=8]="Constructor",d[d.Enum=9]="Enum",d[d.Interface=10]="Interface",d[d.Function=11]="Function",d[d.Variable=12]="Variable",d[d.Constant=13]="Constant",d[d.String=14]="String",d[d.Number=15]="Number",d[d.Boolean=16]="Boolean",d[d.Array=17]="Array",d[d.Object=18]="Object",d[d.Key=19]="Key",d[d.Null=20]="Null",d[d.EnumMember=21]="EnumMember",d[d.Struct=22]="Struct",d[d.Event=23]="Event",d[d.Operator=24]="Operator",d[d.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var r;(function(d){d[d.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var u;(function(d){const g=new Map;g.set("file",0),g.set("module",1),g.set("namespace",2),g.set("package",3),g.set("class",4),g.set("method",5),g.set("property",6),g.set("field",7),g.set("constructor",8),g.set("enum",9),g.set("interface",10),g.set("function",11),g.set("variable",12),g.set("constant",13),g.set("string",14),g.set("number",15),g.set("boolean",16),g.set("array",17),g.set("object",18),g.set("key",19),g.set("null",20),g.set("enum-member",21),g.set("struct",22),g.set("event",23),g.set("operator",24),g.set("type-parameter",25);const P=new Map;P.set(0,"file"),P.set(1,"module"),P.set(2,"namespace"),P.set(3,"package"),P.set(4,"class"),P.set(5,"method"),P.set(6,"property"),P.set(7,"field"),P.set(8,"constructor"),P.set(9,"enum"),P.set(10,"interface"),P.set(11,"function"),P.set(12,"variable"),P.set(13,"constant"),P.set(14,"string"),P.set(15,"number"),P.set(16,"boolean"),P.set(17,"array"),P.set(18,"object"),P.set(19,"key"),P.set(20,"null"),P.set(21,"enum-member"),P.set(22,"struct"),P.set(23,"event"),P.set(24,"operator"),P.set(25,"type-parameter");function F(W){return g.get(W)}d.fromString=F;function z(W){return P.get(W)}d.toString=z;function de(W,B){const K=P.get(W);let L=K&&S.iconRegistry.get("symbol-"+K);return L||(console.info("No codicon found for SymbolKind "+W),L=S.Codicon.symbolProperty),`${B?"inline":"block"} ${L.classNames}`}d.toCssClassName=de})(u=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(g){this.value=g}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var a;(function(d){d[d.Collapsed=0]="Collapsed",d[d.Expanded=1]="Expanded"})(a=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var f;(function(d){d[d.Editing=0]="Editing",d[d.Preview=1]="Preview"})(f=e.CommentMode||(e.CommentMode={}));var b;(function(d){d[d.Other=0]="Other",d[d.Type=1]="Type",d[d.Parameter=2]="Parameter"})(b=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new A.LanguageFeatureRegistry,e.RenameProviderRegistry=new A.LanguageFeatureRegistry,e.CompletionProviderRegistry=new A.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new A.LanguageFeatureRegistry,e.HoverProviderRegistry=new A.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new A.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new A.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new A.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new A.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new A.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new A.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.LinkProviderRegistry=new A.LanguageFeatureRegistry,e.ColorProviderRegistry=new A.LanguageFeatureRegistry,e.SelectionRangeRegistry=new A.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var D;(function(d){d[d.None=0]="None",d[d.Option=1]="Option",d[d.Default=2]="Default",d[d.Preferred=3]="Preferred"})(D=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[147],we([0,1,6,12,4,3,44,54]),function(ie,e,E,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,A.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,n){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:y,handler:n})}if(y.description){const i=[];for(let p of y.description.args)i.push(p.constraint);const s=y.handler;y.handler=function(p,...h){return(0,k.validateConstraints)(h,i),s(p,...h)}}const{id:R}=y;let C=this._commands.get(R);C||(C=new S.LinkedList,this._commands.set(R,C));let v=C.unshift(y),m=(0,E.toDisposable)(()=>{v();const i=this._commands.get(R);(i==null?void 0:i.isEmpty())&&this._commands.delete(R)});return this._onDidRegisterCommand.fire(R),m}registerCommandAlias(y,n){return e.CommandsRegistry.registerCommand(y,(R,...C)=>R.get(e.ICommandService).executeCommand(n,...C))}getCommand(y){const n=this._commands.get(y);if(!(!n||n.isEmpty()))return I.Iterable.first(n)}getCommands(){const y=new Map;for(const n of this._commands.keys()){const R=this.getCommand(n);R&&y.set(n,R)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>E.Disposable.None,onDidExecuteCommand:()=>E.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(be[63],we([0,1,8,4,21]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=A.userAgent||"";const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",A.isMacintosh),S.set("isLinux",A.isLinux),S.set("isWindows",A.isWindows),S.set("isWeb",A.isWeb),S.set("isMacNative",A.isMacintosh&&!A.isWeb),S.set("isEdge",T.indexOf("Edg/")>=0),S.set("isFirefox",T.indexOf("Firefox")>=0),S.set("isChrome",T.indexOf("Chrome")>=0),S.set("isSafari",T.indexOf("Safari")>=0),S.set("isIPad",T.indexOf("iPad")>=0);const I=Object.prototype.hasOwnProperty;var y;(function(d){d[d.False=0]="False",d[d.True=1]="True",d[d.Defined=2]="Defined",d[d.Not=3]="Not",d[d.Equals=4]="Equals",d[d.NotEquals=5]="NotEquals",d[d.And=6]="And",d[d.Regex=7]="Regex",d[d.NotRegex=8]="NotRegex",d[d.Or=9]="Or",d[d.In=10]="In",d[d.NotIn=11]="NotIn",d[d.Greater=12]="Greater",d[d.GreaterEquals=13]="GreaterEquals",d[d.Smaller=14]="Smaller",d[d.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return C.INSTANCE}static true(){return v.INSTANCE}static has(g){return m.create(g)}static equals(g,P){return i.create(g,P)}static notEquals(g,P){return h.create(g,P)}static regex(g,P){return r.create(g,P)}static in(g,P){return s.create(g,P)}static not(g){return w.create(g)}static and(...g){return o.create(g)}static or(...g){return a.create(g)}static greater(g,P){return _.create(g,P)}static less(g,P){return l.create(g,P)}static deserialize(g,P=!1){if(!!g)return this._deserializeOrExpression(g,P)}static _deserializeOrExpression(g,P){let F=g.split("||");return a.create(F.map(z=>this._deserializeAndExpression(z,P)))}static _deserializeAndExpression(g,P){let F=g.split("&&");return o.create(F.map(z=>this._deserializeOne(z,P)))}static _deserializeOne(g,P){if(g=g.trim(),g.indexOf("!=")>=0){let F=g.split("!=");return h.create(F[0].trim(),this._deserializeValue(F[1],P))}if(g.indexOf("==")>=0){let F=g.split("==");return i.create(F[0].trim(),this._deserializeValue(F[1],P))}if(g.indexOf("=~")>=0){let F=g.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],P))}if(g.indexOf(" in ")>=0){let F=g.split(" in ");return s.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(g)){const F=g.split(">=");return c.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(g)){const F=g.split(">");return _.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(g)){const F=g.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(g)){const F=g.split("<");return l.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(g)?w.create(g.substr(1).trim()):m.create(g)}static _deserializeValue(g,P){if(g=g.trim(),g==="true")return!0;if(g==="false")return!1;let F=/^'([^']*)'$/.exec(g);return F?F[1].trim():g}static _deserializeRegexValue(g,P){if((0,E.isFalsyOrWhitespace)(g)){if(P)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=g.indexOf("/"),z=g.lastIndexOf("/");if(F===z||F<0){if(P)throw new Error(`bad regexp-value '${g}', missing /-enclosure`);return console.warn(`bad regexp-value '${g}', missing /-enclosure`),null}let de=g.slice(F+1,z),W=g[z+1]==="i"?"i":"";try{return new RegExp(de,W)}catch(B){if(P)throw new Error(`bad regexp-value '${g}', parse error: ${B}`);return console.warn(`bad regexp-value '${g}', parse error: ${B}`),null}}}e.ContextKeyExpr=n;function R(d,g){return d.cmp(g)}class C{constructor(){this.type=0}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}evaluate(g){return!1}serialize(){return"false"}keys(){return[]}map(g){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class v{constructor(){this.type=1}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}evaluate(g){return!0}serialize(){return"true"}keys(){return[]}map(g){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class m{constructor(g){this.key=g,this.type=2}static create(g){const P=S.get(g);return typeof P=="boolean"?P?v.INSTANCE:C.INSTANCE:new m(g)}cmp(g){return g.type!==this.type?this.type-g.type:b(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}evaluate(g){return!!g.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(g){return g.mapDefined(this.key)}negate(){return w.create(this.key)}}e.ContextKeyDefinedExpr=m;class i{constructor(g,P){this.key=g,this.value=P,this.type=4}static create(g,P){if(typeof P=="boolean")return P?m.create(g):w.create(g);const F=S.get(g);return typeof F=="boolean"?P===(F?"true":"false")?v.INSTANCE:C.INSTANCE:new i(g,P)}cmp(g){return g.type!==this.type?this.type-g.type:D(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return g.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(g){return g.mapEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeyEqualsExpr=i;class s{constructor(g,P){this.key=g,this.valueKey=P,this.type=10}static create(g,P){return new s(g,P)}cmp(g){return g.type!==this.type?this.type-g.type:D(this.key,this.valueKey,g.key,g.valueKey)}equals(g){return g.type===this.type?this.key===g.key&&this.valueKey===g.valueKey:!1}evaluate(g){const P=g.getValue(this.valueKey),F=g.getValue(this.key);return Array.isArray(P)?P.indexOf(F)>=0:typeof F=="string"&&typeof P=="object"&&P!==null?I.call(P,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(g){return g.mapIn(this.key,this.valueKey)}negate(){return p.create(this)}}e.ContextKeyInExpr=s;class p{constructor(g){this._actual=g,this.type=11}static create(g){return new p(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new p(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class h{constructor(g,P){this.key=g,this.value=P,this.type=5}static create(g,P){if(typeof P=="boolean")return P?w.create(g):m.create(g);const F=S.get(g);return typeof F=="boolean"?P===(F?"true":"false")?C.INSTANCE:v.INSTANCE:new h(g,P)}cmp(g){return g.type!==this.type?this.type-g.type:D(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return g.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(g){return g.mapNotEquals(this.key,this.value)}negate(){return i.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=h;class w{constructor(g){this.key=g,this.type=3}static create(g){const P=S.get(g);return typeof P=="boolean"?P?C.INSTANCE:v.INSTANCE:new w(g)}cmp(g){return g.type!==this.type?this.type-g.type:b(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}evaluate(g){return!g.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(g){return g.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=w;class _{constructor(g,P){this.key=g,this.value=P,this.type=12}static create(g,P){return new _(g,P)}cmp(g){return g.type!==this.type?this.type-g.type:D(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=_;class c{constructor(g,P){this.key=g,this.value=P,this.type=13}static create(g,P){return new c(g,P)}cmp(g){return g.type!==this.type?this.type-g.type:D(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreaterEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class l{constructor(g,P){this.key=g,this.value=P,this.type=14}static create(g,P){return new l(g,P)}cmp(g){return g.type!==this.type?this.type-g.type:D(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=l;class t{constructor(g,P){this.key=g,this.value=P,this.type=15}static create(g,P){return new t(g,P)}cmp(g){return g.type!==this.type?this.type-g.type:D(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmallerEquals(this.key,this.value)}negate(){return _.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(g,P){this.key=g,this.regexp=P,this.type=7}static create(g,P){return new r(g,P)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.key<g.key)return-1;if(this.key>g.key)return 1;const P=this.regexp?this.regexp.source:"",F=g.regexp?g.regexp.source:"";return P<F?-1:P>F?1:0}equals(g){if(g.type===this.type){const P=this.regexp?this.regexp.source:"",F=g.regexp?g.regexp.source:"";return this.key===g.key&&P===F}return!1}evaluate(g){let P=g.getValue(this.key);return this.regexp?this.regexp.test(P):!1}serialize(){const g=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${g}`}keys(){return[this.key]}map(g){return g.mapRegex(this.key,this.regexp)}negate(){return u.create(this)}}e.ContextKeyRegexExpr=r;class u{constructor(g){this._actual=g,this.type=8}static create(g){return new u(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new u(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=u;class o{constructor(g){this.expr=g,this.type=6}static create(g){return o._normalizeArr(g)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let P=0,F=this.expr.length;P<F;P++){const z=R(this.expr[P],g.expr[P]);if(z!==0)return z}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].equals(g.expr[P]))return!1;return!0}return!1}evaluate(g){for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].evaluate(g))return!1;return!0}static _normalizeArr(g){const P=[];let F=!1;for(const z of g)if(!!z){if(z.type===1){F=!0;continue}if(z.type===0)return C.INSTANCE;if(z.type===6){P.push(...z.expr);continue}P.push(z)}if(P.length===0&&F)return v.INSTANCE;if(P.length!==0){if(P.length===1)return P[0];for(P.sort(R);P.length>1;){const z=P[P.length-1];if(z.type!==9)break;P.pop();const de=P.pop(),W=a.create(z.expr.map(B=>o.create([B,de])));W&&(P.push(W),P.sort(R))}return P.length===1?P[0]:new o(P)}}serialize(){return this.expr.map(g=>g.serialize()).join(" && ")}keys(){const g=[];for(let P of this.expr)g.push(...P.keys());return g}map(g){return new o(this.expr.map(P=>P.map(g)))}negate(){let g=[];for(let P of this.expr)g.push(P.negate());return a.create(g)}}e.ContextKeyAndExpr=o;class a{constructor(g){this.expr=g,this.type=9}static create(g){const P=a._normalizeArr(g);if(P.length!==0)return P.length===1?P[0]:new a(P)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let P=0,F=this.expr.length;P<F;P++){const z=R(this.expr[P],g.expr[P]);if(z!==0)return z}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].equals(g.expr[P]))return!1;return!0}return!1}evaluate(g){for(let P=0,F=this.expr.length;P<F;P++)if(this.expr[P].evaluate(g))return!0;return!1}static _normalizeArr(g){let P=[],F=!1;if(g){for(let z=0,de=g.length;z<de;z++){const W=g[z];if(!!W){if(W.type===0){F=!0;continue}if(W.type===1)return[v.INSTANCE];if(W.type===9){P=P.concat(W.expr);continue}P.push(W)}}if(P.length===0&&F)return[C.INSTANCE];P.sort(R)}return P}serialize(){return this.expr.map(g=>g.serialize()).join(" || ")}keys(){const g=[];for(let P of this.expr)g.push(...P.keys());return g}map(g){return new a(this.expr.map(P=>P.map(g)))}negate(){let g=[];for(let F of this.expr)g.push(F.negate());const P=F=>F.type===9?F.expr:[F];for(;g.length>1;){const F=g.shift(),z=g.shift(),de=[];for(const W of P(F))for(const B of P(z))de.push(n.and(W,B));g.unshift(n.or(...de))}return g[0]}}e.ContextKeyOrExpr=a;class f extends m{constructor(g,P,F){super(g);this.key=g,this._defaultValue=P,typeof F=="object"?f._info.push(Object.assign(Object.assign({},F),{key:g})):F!==!0&&f._info.push({key:g,description:F,type:P!=null?typeof P:void 0})}static all(){return f._info.values()}bindTo(g){return g.createKey(this.key,this._defaultValue)}getValue(g){return g.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(g){return n.equals(this.key,g)}notEqualsTo(g){return n.notEquals(this.key,g)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function b(d,g){return d<g?-1:d>g?1:0}function D(d,g,P,F){return d<P?-1:d>P?1:g<F?-1:g>F?1:0}}),define(be[148],we([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(be[26],we([0,1,8,4]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.getExtensionWorkspaceTrustRequestType=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(R){return R&&typeof R=="object"&&typeof R.id=="string"&&(!R.uuid||typeof R.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(R){R[R.System=0]="System",R[R.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class S{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,v){if(typeof C=="undefined"||C===null)return typeof v=="undefined"||v===null;if(typeof v=="undefined"||v===null)return!1;if(typeof C=="string"||typeof v=="string"){let m=typeof C=="string"?C:C.value,i=typeof v=="string"?v:v.value;return E.equalsIgnoreCase(m,i)}return C._lower===v._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=S;function I(R){return R.contributes&&R.contributes.localizations?R.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function y(R){return R.contributes&&R.contributes.authentication?R.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y;function n(R){var C;return((C=R.workspaceTrust)===null||C===void 0?void 0:C.request)!==void 0?R.workspaceTrust.request:R.main?"onStart":"never"}e.getExtensionWorkspaceTrustRequestType=n,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[149],we([0,1,8,26]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(m,i){return m.uuid&&i.uuid?m.uuid===i.uuid:m.id===i.id?!0:(0,E.compareIgnoreCase)(m.id,i.id)===0}e.areSameExtensions=A;class T{constructor(i,s){this.version=s,this.id=i.id,this.uuid=i.uuid}key(){return`${this.id}-${this.version}`}equals(i){return i instanceof T?A(this,i)&&this.version===i.version:!1}}e.ExtensionIdentifierWithVersion=T;function S(m,i){return`${m}.${i}`}e.getExtensionId=S;function I(m){return m.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function y(m,i){return I(S(m,i))}e.getGalleryExtensionId=y;function n(m,i){const s=[],p=h=>{for(const w of s)if(w.some(_=>A(i(_),i(h))))return w;return null};for(const h of m){const w=p(h);w?w.push(h):s.push([h])}return s}e.groupByExtension=n;function R(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function C(m){return Object.assign({id:m.identifier.id,name:m.name,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0)},m.telemetryData)}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function v(m){const i=new Set;for(const s of m)s.malicious&&i.add(s.id.id);return i}e.getMaliciousExtensionsSet=v}),define(be[64],we([0,1,124,11,2,4,8,12,22]),function(ie,e,E,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function n(W){return W.create===!0}e.isFileOpenForWriteOptions=n;var R;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var C;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=v;function m(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=m;function i(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=i;function s(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=s;var p;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(B,K){super(B);this.code=K}}e.FileSystemProviderError=h;function w(W,B){const K=new h(W.toString(),B);return c(K,B),K}e.createFileSystemProviderError=w;function _(W){return W||w((0,E.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=_;function c(W,B){return W.name=B?`${B} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=c;function l(W){if(!W)return p.Unknown;if(W instanceof h)return W.code;const B=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!B)return p.Unknown;switch(B[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=l;function t(W){if(W instanceof b)return W.fileOperationResult;switch(l(W)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var r;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class u{constructor(B,K,L){this.resource=B,this.operation=K,this.target=L}isOperation(B){return this.operation===B}}e.FileOperationEvent=u;var o;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class a{constructor(B,K){this.ignorePathCasing=K,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=B;for(const L of B)switch(L.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(L.resource,L);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(L.resource,L);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(L.resource,L);break}}contains(B,...K){return this.doContains(B,{includeChildren:!1},...K)}affects(B,...K){return this.doContains(B,{includeChildren:!0},...K)}doContains(B,K,...L){var U,x,Q,$,ee,re;if(!B)return!1;const se=L.length>0;return!!((!se||L.includes(1))&&(((U=this.added)===null||U===void 0?void 0:U.get(B))||K.includeChildren&&((x=this.added)===null||x===void 0?void 0:x.findSuperstr(B)))||(!se||L.includes(0))&&(((Q=this.updated)===null||Q===void 0?void 0:Q.get(B))||K.includeChildren&&(($=this.updated)===null||$===void 0?void 0:$.findSuperstr(B)))||(!se||L.includes(2))&&(((ee=this.deleted)===null||ee===void 0?void 0:ee.findSubstr(B))||K.includeChildren&&((re=this.deleted)===null||re===void 0?void 0:re.findSuperstr(B))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(B){const K=[],L=B===1?this.added:B===0?this.updated:this.deleted;if(L)for(const[,U]of L)K.push(U);return K}filter(B){return new a(this.changes.filter(K=>B(K)),this.ignorePathCasing)}}e.FileChangesEvent=a;function f(W,B,K){return!W||!B||W===B||B.length>W.length?!1:(B.charAt(B.length-1)!==k.sep&&(B+=k.sep),K?(0,S.startsWithIgnoreCase)(W,B):W.indexOf(B)===0)}e.isParent=f;class b extends Error{constructor(B,K,L){super(B);this.fileOperationResult=K,this.options=L}static isFileOperationError(B){return B instanceof Error&&!(0,I.isUndefinedOrNull)(B.fileOperationResult)}}e.FileOperationError=b;var D;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(D=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var d;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(d=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function g(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=g;async function P(W,B){if(!B.canHandleResource(A.URI.from({scheme:W.scheme})))return new Promise(K=>{const L=B.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===W.scheme&&U.added&&(L.dispose(),K())})})}e.whenProviderRegistered=P,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(B){return(0,I.isNumber)(B)||(B=0),B<F.KB?(0,E.localize)(1,null,B.toFixed(0)):B<F.MB?(0,E.localize)(2,null,(B/F.KB).toFixed(2)):B<F.GB?(0,E.localize)(3,null,(B/F.MB).toFixed(2)):B<F.TB?(0,E.localize)(4,null,(B/F.GB).toFixed(2)):(0,E.localize)(5,null,(B/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var z;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function de(W){return{maxFileSize:W===0?300*F.MB:16*F.GB,maxHeapSize:W===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=de}),define(be[65],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...A){this._entries=new Map;for(let[T,S]of A)this.set(T,S)}set(A,T){const S=this._entries.get(A);return this._entries.set(A,T),S}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=E}),define(be[150],we([0,1,10,144,86,4,65,13]),function(ie,e,E,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class n extends Error{constructor(i){super("cyclic dependency between services");this.message=i.toString()}}class R{constructor(i=new S.ServiceCollection,s=!1,p){this._activeInstantiations=new Set,this._services=i,this._strict=s,this._parent=p,this._services.set(T.IInstantiationService,this)}createChild(i){return new R(i,this._strict,this)}invokeFunction(i,...s){let p=v.traceInvocation(i),h=!1;try{return i({get:(_,c)=>{if(h)throw(0,E.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(_,p);if(!l&&c!==T.optional)throw new Error(`[invokeFunction] unknown service '${_}'`);return l}},...s)}finally{h=!0,p.stop()}}createInstance(i,...s){let p,h;return i instanceof A.SyncDescriptor?(p=v.traceCreation(i.ctor),h=this._createInstance(i.ctor,i.staticArguments.concat(s),p)):(p=v.traceCreation(i),h=this._createInstance(i,s,p)),p.stop(),h}_createInstance(i,s=[],p){let h=T._util.getServiceDependencies(i).sort((c,l)=>c.index-l.index),w=[];for(const c of h){let l=this._getOrCreateServiceInstance(c.id,p);if(!l&&this._strict&&!c.optional)throw new Error(`[createInstance] ${i.name} depends on UNKNOWN service ${c.id}.`);w.push(l)}let _=h.length>0?h[0].index:s.length;if(s.length!==_){console.warn(`[createInstance] First service dependency of ${i.name} at position ${_+1} conflicts with ${s.length} static arguments`);let c=_-s.length;c>0?s=s.concat(new Array(c)):s=s.slice(0,_)}return new i(...[...s,...w])}_setServiceInstance(i,s){if(this._services.get(i)instanceof A.SyncDescriptor)this._services.set(i,s);else if(this._parent)this._parent._setServiceInstance(i,s);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(i){let s=this._services.get(i);return!s&&this._parent?this._parent._getServiceInstanceOrDescriptor(i):s}_getOrCreateServiceInstance(i,s){let p=this._getServiceInstanceOrDescriptor(i);return p instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(i,p,s.branch(i,!0)):(s.branch(i,!1),p)}_safeCreateAndCacheServiceInstance(i,s,p){if(this._activeInstantiations.has(i))throw new Error(`illegal state - RECURSIVELY instantiating service '${i}'`);this._activeInstantiations.add(i);try{return this._createAndCacheServiceInstance(i,s,p)}finally{this._activeInstantiations.delete(i)}}_createAndCacheServiceInstance(i,s,p){const h=new k.Graph(c=>c.id.toString());let w=0;const _=[{id:i,desc:s,_trace:p}];for(;_.length;){const c=_.pop();if(h.lookupOrInsertNode(c),w++>1e3)throw new n(h);for(let l of T._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(l.id);if(!t&&!l.optional&&console.warn(`[createInstance] ${i} depends on ${l.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const r={id:l.id,desc:t,_trace:c._trace.branch(l.id,!0)};h.insertEdge(c,r),_.push(r)}}}for(;;){const c=h.roots();if(c.length===0){if(!h.isEmpty())throw new n(h);break}for(const{data:l}of c){if(this._getServiceInstanceOrDescriptor(l.id)instanceof A.SyncDescriptor){const r=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,r)}h.removeNode(l)}}return this._getServiceInstanceOrDescriptor(i)}_createServiceInstanceWithOwner(i,s,p=[],h,w){if(this._services.get(i)instanceof A.SyncDescriptor)return this._createServiceInstance(s,p,h,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(i,s,p,h,w);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}_createServiceInstance(i,s=[],p,h){if(p){const w=new I.IdleValue(()=>this._createInstance(i,s,h));return new Proxy(Object.create(null),{get(_,c){if(c in _)return _[c];let l=w.value,t=l[c];return typeof t!="function"||(t=t.bind(l),_[c]=t),t},set(_,c,l){return w.value[c]=l,!0}})}else return this._createInstance(i,s,h)}}e.InstantiationService=R;var C;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(C||(C={}));class v{constructor(i,s){this.type=i,this.name=s,this._start=Date.now(),this._dep=[]}static traceInvocation(i){return y?new v(1,i.name||i.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(i){return y?new v(0,i.name):v._None}branch(i,s){let p=new v(2,i.toString());return this._dep.push([i,s,p]),p}stop(){let i=Date.now()-this._start;v._totals+=i;let s=!1;function p(w,_){let c=[],l=new Array(w+1).join("	");for(const[t,r,u]of _._dep)if(r&&u){s=!0,c.push(`${l}CREATES -> ${t}`);let o=p(w+1,u);o&&c.push(o)}else c.push(`${l}uses -> ${t}`);return c.join(`
`)}let h=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${i.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(i>2||s)&&console.log(h.join(`
`))}}v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(be[19],we([0,1,4,6,21,3,60]),function(ie,e,E,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function I(){return new Date().toISOString()}var y;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class n extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class R extends n{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(y.Error))if(t instanceof Error){const u=Array.prototype.slice.call(arguments);u[0]=t.stack,this.log(y.Error,this.format(u))}else this.log(y.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let u=0;u<t.length;u++){let o=t[u];if(typeof o=="object")try{o=JSON.stringify(o)}catch(a){}r+=(u>0?" ":"")+o}return r}}e.AbstractMessageLogger=R;class C extends n{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...r){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...r):console.log(`[main ${I()}]`,t,...r))}debug(t,...r){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...r):console.log(`[main ${I()}]`,t,...r))}info(t,...r){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...r):console.log(`[main ${I()}]`,t,...r))}warn(t,...r){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,t,...r):console.warn(`[main ${I()}]`,t,...r))}error(t,...r){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,t,...r):console.error(`[main ${I()}]`,t,...r))}critical(t,...r){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,t,...r):console.error(`[main ${I()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class v extends n{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=v;class m extends n{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,S.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class i extends n{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const u of this.logServices)u.trace(t,...r)}debug(t,...r){for(const u of this.logServices)u.debug(t,...r)}info(t,...r){for(const u of this.logServices)u.info(t,...r)}warn(t,...r){for(const u of this.logServices)u.warn(t,...r)}error(t,...r){for(const u of this.logServices)u.error(t,...r)}critical(t,...r){for(const u of this.logServices)u.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=i;class s extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=s;class p extends k.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(u=>{this.logLevel=u,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(u))}))}createLogger(t,r){let u=this.loggers.get(t.toString());return u||(u=this.doCreateLogger(t,(r==null?void 0:r.always)?y.Trace:this.logLevel,r),this.loggers.set(t.toString(),u),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(u)),u}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class h{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=h;function w(l){if(l.verbose)return y.Trace;if(typeof l.logLevel=="string"){const t=_(l.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function _(l){switch(l){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=_;function c(l){switch(l){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=c}),define(be[87],we([0,1,4,125,46]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var S;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function n(i,s){return s-i}y.compare=n;const R=Object.create(null);R[y.Error]=(0,k.localize)(0,null),R[y.Warning]=(0,k.localize)(1,null),R[y.Info]=(0,k.localize)(2,null);function C(i){return R[i]||""}y.toString=C;function v(i){switch(i){case A.default.Error:return y.Error;case A.default.Warning:return y.Warning;case A.default.Info:return y.Info;case A.default.Ignore:return y.Hint}}y.fromSeverity=v;function m(i){switch(i){case y.Error:return A.default.Error;case y.Warning:return A.default.Warning;case y.Info:return A.default.Info;case y.Hint:return A.default.Ignore}}y.toSeverity=m}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(y){const n="";function R(v){return C(v,!0)}y.makeKey=R;function C(v,m){let i=[n];return v.source?i.push(v.source.replace("\xA6","\\\xA6")):i.push(n),v.code?typeof v.code=="string"?i.push(v.code.replace("\xA6","\\\xA6")):i.push(v.code.value.replace("\xA6","\\\xA6")):i.push(n),v.severity!==void 0&&v.severity!==null?i.push(S.toString(v.severity)):i.push(n),v.message&&m?i.push(v.message.replace("\xA6","\\\xA6")):i.push(n),v.startLineNumber!==void 0&&v.startLineNumber!==null?i.push(v.startLineNumber.toString()):i.push(n),v.startColumn!==void 0&&v.startColumn!==null?i.push(v.startColumn.toString()):i.push(n),v.endLineNumber!==void 0&&v.endLineNumber!==null?i.push(v.endLineNumber.toString()):i.push(n),v.endColumn!==void 0&&v.endColumn!==null?i.push(v.endColumn.toString()):i.push(n),i.push(n),i.join("\xA6")}y.makeKeyOptionalMessage=C})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(be[151],we([0,1,46,4,3]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=E.default,e.INotificationService=(0,k.createDecorator)("notificationService");var T;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new y,this.onDidClose=A.Event.None,this.onDidChangeVisibility=A.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=I;class y{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=y});var je=this&&this.__decorate||function(ie,e,E,k){var A=arguments.length,T=A<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,E):k,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(ie,e,E,k);else for(var I=ie.length-1;I>=0;I--)(S=ie[I])&&(T=(A<3?S(T):A>3?S(e,E,T):S(e,E))||T);return A>3&&T&&Object.defineProperty(e,E,T),T},Ke=this&&this.__param||function(ie,e){return function(E,k){e(E,k,ie)}};define(be[152],we([0,1,4,20,6,13]),function(ie,e,E,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,E.createDecorator)("progressService");var S;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let y=class extends A.Disposable{constructor(C,v){super();this.deferred=new T.DeferredPromise,v.withProgress(C,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,A.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};y=je([Ke(1,e.IProgressService)],y),e.UnmanagedProgress=y;class n extends A.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new A.DisposableStore)}start(C){this.stop();const v=++this.currentOperationId,m=new k.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{v===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,A.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,A.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,A.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:v,token:m.token,stop:()=>this.doStop(v),isCurrent:()=>this.currentOperationId===v}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=n,e.IEditorProgressService=(0,E.createDecorator)("editorProgressService")}),define(be[30],we([0,1,12,42]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(S,I){k.ok(E.isString(S)),k.ok(E.isObject(I)),k.ok(!this.data.has(S),"There is already an extension with this id"),this.data.set(S,I)}knows(S){return this.data.has(S)}as(S){return this.data.get(S)||null}}e.Registry=new A}),define(be[88],we([0,1,30,3]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class T{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,n){this.schemasById[A(y)]=n,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const S=new T;E.Registry.add(e.Extensions.JSONContribution,S)}),define(be[66],we([0,1,122,3,30,12,88]),function(ie,e,E,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=A.Registry.as(S.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:E.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(h,w=!0){this.registerConfigurations([h],w)}registerConfigurations(h,w=!0){const _=[];h.forEach(c=>{_.push(...this.validateAndRegisterProperties(c,w)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}deregisterConfigurations(h){const w=[],_=c=>{if(c.properties)for(const l in c.properties)w.push(l),delete this.configurationProperties[l],this.removeFromSchema(l,c.properties[l]);c.allOf&&c.allOf.forEach(l=>_(l))};for(const c of h){_(c);const l=this.configurationContributors.indexOf(c);l!==-1&&this.configurationContributors.splice(l,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}registerDefaultConfigurations(h){const w=[],_=[];for(const c of h)for(const l in c)if(w.push(l),e.OVERRIDE_PROPERTY_PATTERN.test(l)){this.defaultValues[l]=Object.assign(Object.assign({},this.defaultValues[l]||{}),c[l]);const t={type:"object",default:this.defaultValues[l],description:E.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId};_.push(C(l)),this.configurationProperties[l]=t,this.defaultLanguageConfigurationOverridesNode.properties[l]=t}else{this.defaultValues[l]=c[l];const t=this.configurationProperties[l];t&&(this.updatePropertyDefaultValue(l,t),this.updateSchema(l,t))}this.registerOverrideIdentifiers(_),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}deregisterDefaultConfigurations(h){const w=[];for(const _ of h)for(const c in _)if(w.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const l=this.configurationProperties[c];l&&(this.updatePropertyDefaultValue(c,l),this.updateSchema(c,l))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){for(const w of h)this.overrideIdentifiers.add(w);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(h,w=!0,_=3,c){_=T.isUndefinedOrNull(h.scope)?_:h.scope,c=T.isUndefinedOrNull(h.requiresTrustedWorkspace)?T.isUndefined(c)?!1:c:h.requiresTrustedWorkspace;let l=[],t=h.properties;if(t)for(let u in t){if(w&&i(u)){delete t[u];continue}const o=t[u];if(this.updatePropertyDefaultValue(u,o),e.OVERRIDE_PROPERTY_PATTERN.test(u)?o.scope=void 0:(o.scope=T.isUndefinedOrNull(o.scope)?_:o.scope,o.requiresTrustedWorkspace=T.isUndefinedOrNull(o.requiresTrustedWorkspace)?c:o.requiresTrustedWorkspace),t[u].hasOwnProperty("included")&&!t[u].included){this.excludedConfigurationProperties[u]=t[u],delete t[u];continue}else this.configurationProperties[u]=t[u];!t[u].deprecationMessage&&t[u].markdownDeprecationMessage&&(t[u].deprecationMessage=t[u].markdownDeprecationMessage),l.push(u)}let r=h.allOf;if(r)for(let u of r)l.push(...this.validateAndRegisterProperties(u,w,_,c));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(h){const w=_=>{let c=_.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let l=_.allOf;l&&l.forEach(w)};w(h)}updateSchema(h,w){switch(e.allSettings.properties[h]=w,w.scope){case 1:e.applicationSettings.properties[h]=w;break;case 2:e.machineSettings.properties[h]=w;break;case 6:e.machineOverridableSettings.properties[h]=w;break;case 3:e.windowSettings.properties[h]=w;break;case 4:e.resourceSettings.properties[h]=w;break;case 5:e.resourceSettings.properties[h]=w,this.resourceLanguageSettingsSchema.properties[h]=w;break}}removeFromSchema(h,w){switch(delete e.allSettings.properties[h],w.scope){case 1:delete e.applicationSettings.properties[h];break;case 2:delete e.machineSettings.properties[h];break;case 6:delete e.machineOverridableSettings.properties[h];break;case 3:delete e.windowSettings.properties[h];break;case 4:case 5:delete e.resourceSettings.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const w=`[${h}]`,_={type:"object",description:E.localize(2,null),errorMessage:E.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(w,_),e.allSettings.properties[w]=_,e.applicationSettings.properties[w]=_,e.machineSettings.properties[w]=_,e.machineOverridableSettings.properties[w]=_,e.windowSettings.properties[w]=_,e.resourceSettings.properties[w]=_}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,w){let _=this.defaultValues[h];T.isUndefined(_)&&(_=w.default),T.isUndefined(_)&&(_=v(w.type)),w.default=_}}const R="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(R);function C(p){return p.substring(1,p.length-1)}e.overrideIdentifierFromKey=C;function v(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const m=new n;A.Registry.add(e.Extensions.Configuration,m);function i(p){return p.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(p)?E.localize(5,null,p):m.getConfigurationProperties()[p]!==void 0?E.localize(6,null,p):null:E.localize(4,null)}e.validateProperty=i;function s(){const p=[],h=m.getConfigurationProperties();for(const w of Object.keys(h))p.push([w,h[w].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=s}),define(be[89],we([0,1,23,12,2,30,4,66]),function(ie,e,E,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function y(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof A.URI)}e.isConfigurationOverrides=y;var n;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function R(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=R;function C(r,u){const o=u?r?u.keys.filter(P=>r.keys.indexOf(P)===-1):[...u.keys]:[],a=r?u?r.keys.filter(P=>u.keys.indexOf(P)===-1):[...r.keys]:[],f=[];if(u&&r){for(const P of r.keys)if(u.keys.indexOf(P)!==-1){const F=h(r.contents,P),z=h(u.contents,P);E.equals(F,z)||f.push(P)}}const b=[],D=P=>{const F={};for(const z of P)for(const de of z.identifiers)F[l(de)]=z;return F},d=u?D(u.overrides):{},g=r?D(r.overrides):{};if(Object.keys(d).length)for(const P of o){const F=d[P];F&&b.push([(0,I.overrideIdentifierFromKey)(P),F.keys])}if(Object.keys(g).length)for(const P of a){const F=g[P];F&&b.push([(0,I.overrideIdentifierFromKey)(P),F.keys])}if(Object.keys(d).length&&Object.keys(g).length)for(const P of f){const F=g[P],z=d[P];if(F&&z){const de=C({contents:F.contents,keys:F.keys,overrides:[]},{contents:z.contents,keys:z.keys,overrides:[]});b.push([(0,I.overrideIdentifierFromKey)(P),[...de.added,...de.removed,...de.updated]])}}return{added:o,removed:a,updated:f,overrides:b}}e.compare=C;function v(r,u){const o=[];for(const a of Object.keys(r))if(I.OVERRIDE_PROPERTY_PATTERN.test(a)){const f={};for(const b in r[a])f[b]=r[a][b];o.push({identifiers:[(0,I.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(f),contents:m(f,u)})}return o}e.toOverrides=v;function m(r,u){const o=Object.create(null);for(let a in r)i(o,a,r[a],u);return o}e.toValuesTree=m;function i(r,u,o,a){const f=u.split("."),b=f.pop();let D=r;for(let d=0;d<f.length;d++){let g=f[d],P=D[g];switch(typeof P){case"undefined":P=D[g]=Object.create(null);break;case"object":break;default:a(`Ignoring ${u} as ${f.slice(0,d+1).join(".")} is ${JSON.stringify(P)}`);return}D=P}if(typeof D=="object"&&D!==null)try{D[b]=o}catch(d){a(`Ignoring ${u} as ${f.join(".")} is ${JSON.stringify(D)}`)}else a(`Ignoring ${u} as ${f.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=i;function s(r,u){const o=u.split(".");p(r,o)}e.removeFromValueTree=s;function p(r,u){const o=u.shift();if(u.length===0){delete r[o];return}if(Object.keys(r).indexOf(o)!==-1){const a=r[o];typeof a=="object"&&!Array.isArray(a)&&(p(a,u),Object.keys(a).length===0&&delete r[o])}}function h(r,u,o){function a(D,d){let g=D;for(const P of d){if(typeof g!="object"||g===null)return;g=g[P]}return g}const f=u.split("."),b=a(r,f);return typeof b=="undefined"?o:b}e.getConfigurationValue=h;function w(r,u,o){Object.keys(u).forEach(a=>{a!=="__proto__"&&(a in r?k.isObject(r[a])&&k.isObject(u[a])?w(r[a],u[a],o):o&&(r[a]=u[a]):r[a]=u[a])})}e.merge=w;function _(){const r=T.Registry.as(I.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=_;function c(){const r=Object.create(null),u=T.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(let o in u){let a=u[o].default;i(r,o,a,f=>console.error(`Conflict in default settings: ${f}`))}return r}e.getDefaultValues=c;function l(r){return`[${r}]`}e.keyFromOverrideIdentifier=l;function t(r,u,o){const a=r.inspect(u),f=r.inspect(o);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:a.defaultValue}e.getMigratedSettingValue=t}),define(be[153],we([0,1,43,22,15,12,23,2,66,89,30,6,3]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},r=[],u=[]){this._contents=t,this._keys=r,this._overrides=u,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const u=this.getContentsForOverrideIdentifer(r);return u?t?(0,n.getConfigurationValue)(u,t):u:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let u={};for(const o of A.distinct([...Object.keys(this.contents),...Object.keys(r)])){let a=this.contents[o],f=r[o];f&&(typeof a=="object"&&typeof f=="object"?(a=S.deepClone(a),this.mergeContents(a,f)):a=f),u[o]=a}return new m(u,this.keys,this.overrides)}merge(...t){const r=S.deepClone(this.contents),u=S.deepClone(this.overrides),o=[...this.keys];for(const a of t){this.mergeContents(r,a.contents);for(const f of a.overrides){const[b]=u.filter(D=>A.equals(D.identifiers,f.identifiers));b?this.mergeContents(b.contents,f.contents):u.push(S.deepClone(f))}for(const f of a.keys)o.indexOf(f)===-1&&o.push(f)}return new m(r,o,u)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const u of Object.keys(r)){if(u in t&&T.isObject(t[u])&&T.isObject(r[u])){this.mergeContents(t[u],r[u]);continue}t[u]=S.deepClone(r[u])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?S.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,n.addToValueTree)(this.contents,t,r,u=>{throw new Error(u)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let u=0;u<r;u++)t.indexOf(this.keys[u])===0&&(r=u);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=m;class i extends m{constructor(){const t=(0,n.getDefaultValues)(),r=(0,n.getConfigurationKeys)(),u=[];for(const o of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(o)&&u.push({identifiers:[(0,y.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(t[o]),contents:(0,n.toValuesTree)(t[o],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,r,u)}}e.DefaultConfigurationModel=i;class s{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._excludedUnsafeConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get excludedUnsafeConfigurations(){return this._excludedUnsafeConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!T.isUndefinedOrNull(t)){const u=this.doParseContent(t);this.parseRaw(u,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:u,keys:o,overrides:a,unsafeConfigurations:f}=this.doParseRaw(t,r);this._configurationModel=new m(u,o,a),this._excludedUnsafeConfigurations=f||[]}doParseContent(t){let r={},u=null,o=[],a=[],f=[];function b(d){Array.isArray(o)?o.push(d):u&&(o[u]=d)}let D={onObjectBegin:()=>{let d={};b(d),a.push(o),o=d,u=null},onObjectProperty:d=>{u=d},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{let d=[];b(d),a.push(o),o=d,u=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:b,onError:(d,g,P)=>{f.push({error:d,offset:g,length:P})}};if(t)try{E.visit(t,D),r=o[0]||{}}catch(d){console.error(`Error while parsing settings file ${this._name}: ${d}`),this._parseErrors=[d]}return r}doParseRaw(t,r){const u=R.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,u,!0,r);t=o.raw;const a=(0,n.toValuesTree)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),f=Object.keys(t),b=(0,n.toOverrides)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:a,keys:f,overrides:b,unsafeConfigurations:o.unsafeConfigurations}}filter(t,r,u,o){if(!(o==null?void 0:o.scopes)&&!(o==null?void 0:o.excludeUnsafeConfigurations))return{raw:t,unsafeConfigurations:[]};const a={},f=[];for(let b in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(b)&&u){const D=this.filter(t[b],r,!1,o);a[b]=D.raw,f.push(...D.unsafeConfigurations)}else{const D=r[b],d=D?typeof D.scope!="undefined"?D.scope:3:void 0;(d===void 0||o.scopes===void 0||o.scopes.includes(d))&&(o.excludeUnsafeConfigurations&&(D==null?void 0:D.requiresTrustedWorkspace)?f.push(b):a[b]=t[b])}return{raw:a,unsafeConfigurations:f}}}e.ConfigurationModelParser=s;class p extends C.Disposable{constructor(t,r,u,o){super();this.userSettingsResource=t,this.scopes=r,this.fileService=o,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new s(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(u.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(v.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}}e.UserSettings=p;class h{constructor(t,r,u=new m,o=new m,a=new k.ResourceMap,f=new m,b=new k.ResourceMap,D=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=u,this._workspaceConfiguration=o,this._folderConfigurations=a,this._memoryConfiguration=f,this._memoryConfigurationByResource=b,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,r,u){return this.getConsolidateConfigurationModel(r,u).getValue(t)}updateValue(t,r,u={}){let o;u.resource?(o=this._memoryConfigurationByResource.get(u.resource),o||(o=new m,this._memoryConfigurationByResource.set(u.resource,o))):o=this._memoryConfiguration,r===void 0?o.removeValue(t):o.setValue(t,r),u.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,u){const o=this.getConsolidateConfigurationModel(r,u),a=this.getFolderConfigurationModelForResource(r.resource,u),f=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,b=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),D=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),d=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),g=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),P=u?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=a?r.overrideIdentifier?a.freeze().override(r.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,z=r.overrideIdentifier?f.override(r.overrideIdentifier).getValue(t):f.getValue(t),de=o.getValue(t),W=A.distinct(A.flatten(o.overrides.map(B=>B.identifiers))).filter(B=>o.getOverrideValue(t,B)!==void 0);return{defaultValue:b,userValue:D,userLocalValue:d,userRemoteValue:g,workspaceValue:P,workspaceFolderValue:F,memoryValue:z,value:de,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:d!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:g!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:P!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:a==null?void 0:a.freeze().getValue(t),override:r.overrideIdentifier?a==null?void 0:a.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:f.getValue(t),override:r.overrideIdentifier?f.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const u=r.filter(o=>y.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const a=(0,y.overrideIdentifierFromKey)(o),f=this._defaultConfiguration.getKeysForOverrideIdentifier(a),b=t.getKeysForOverrideIdentifier(a),D=[...b.filter(d=>f.indexOf(d)===-1),...f.filter(d=>b.indexOf(d)===-1),...f.filter(d=>!S.equals(this._defaultConfiguration.override(a).getValue(d),t.override(a).getValue(d)))];return[a,D]});return this.updateDefaultConfiguration(t),{keys:r,overrides:u}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:u,removed:o,overrides:a}=(0,n.compare)(this.localUserConfiguration,t),f=[...r,...u,...o];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:u,removed:o,overrides:a}=(0,n.compare)(this.remoteUserConfiguration,t);let f=[...r,...u,...o];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:u,removed:o,overrides:a}=(0,n.compare)(this.workspaceConfiguration,t);let f=[...r,...u,...o];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:a}}compareAndUpdateFolderConfiguration(t,r){const u=this.folderConfigurations.get(t),{added:o,updated:a,removed:f,overrides:b}=(0,n.compare)(u,r);let D=[...o,...a,...f];return(D.length||!u)&&this.updateFolderConfiguration(t,r),{keys:D,overrides:b}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:u,updated:o,removed:a,overrides:f}=(0,n.compare)(r,void 0);return{keys:[...u,...o,...a],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let u=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?u.override(t.overrideIdentifier):u}getConsolidatedConfigurationModelForResource({resource:t},r){let u=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const o=r.getFolder(t);o&&(u=this.getFolderConsolidatedConfiguration(o.uri)||u);const a=this._memoryConfigurationByResource.get(t);a&&(u=u.merge(a))}return u}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const u=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(r=u.merge(o),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=u}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const u=r.getFolder(t);if(u)return this._folderConfigurations.get(u.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:u,overrides:o,keys:a}=this._folderConfigurations.get(r);return t.push([r,{contents:u,overrides:o,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(u=>t.add(u))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(u=>r.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(u=>r.add(u)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(u=>r.add(u)),this._folderConfigurations.forEach(u=>u.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),u=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((f,b)=>(f.set(I.URI.revive(b[0]),this.parseConfigurationModel(b[1])),f),new k.ResourceMap);return new h(r,u,new m,o,a,new m,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=h;function w(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const t=new Set,r=new Map;for(const o of l)o.keys.forEach(a=>t.add(a)),o.overrides.forEach(([a,f])=>{const b=(0,k.getOrSet)(r,a,new Set);f.forEach(D=>b.add(D))});const u=[];return r.forEach((o,a)=>u.push([a,[...o.values()]])),{keys:[...t.values()],overrides:u}}e.mergeChanges=w;class _{constructor(t,r,u,o){this.change=t,this.previous=r,this.currentConfiguraiton=u,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(b=>a.add(b)),t.overrides.forEach(([,b])=>b.forEach(D=>a.add(D))),this.affectedKeys=[...a.values()];const f=new m;this.affectedKeys.forEach(b=>f.setValue(b,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var u;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(u=this.previous)===null||u===void 0?void 0:u.workspace):void 0,a=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!S.equals(o,a)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let u=(0,n.toValuesTree)({[r]:!0},()=>{}),o;for(;typeof u=="object"&&(o=Object.keys(u)[0]);){if(t=t[o],!t)return!1;u=u[o]}return!0}}e.ConfigurationChangeEvent=_;class c extends _{constructor(t,r,u,o){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=u,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=c}),define(be[90],we([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,E.createDecorator)("remoteAuthorityResolverService");var k;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(S,I=k.Unknown,y){super(S);this._message=S,this._code=I,this._detail=y,this.isHandled=I===k.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(S){return S instanceof A&&S._code===k.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof A&&S._code===k.NoResolverFound}static isHandled(S){return S instanceof A&&S.isHandled}}e.RemoteAuthorityResolverError=A}),define(be[91],we([0,1,18]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function k(T){return T.scheme===E.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=k;function A(T){if(!!T){const S=T.indexOf("+");return S<0?T:T.substr(0,S)}}e.getRemoteName=A}),define(be[154],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class E{constructor(A){this._callback=A,this._terminalBufferMap=new Map}dispose(){for(const A of this._terminalBufferMap.values())A.dispose()}startBuffering(A,T,S=5){let I;return I=T(y=>{const n=typeof y=="string"?y:y.data;let R=this._terminalBufferMap.get(A);if(R){R.data.push(n);return}const C=setTimeout(()=>this.flushBuffer(A),S);R={data:[n],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(A),I.dispose()}},this._terminalBufferMap.set(A,R)}),I}stopBuffering(A){const T=this._terminalBufferMap.get(A);T&&T.dispose()}flushBuffer(A){const T=this._terminalBufferMap.get(A);T&&(this._terminalBufferMap.delete(A),this._callback(A,T.data.join("")))}}e.TerminalDataBufferer=E}),define(be[155],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var E;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST="hc"})(E=e.ColorScheme||(e.ColorScheme={}))}),define(be[156],we([0,1,4,6,30,3,155,36]),function(ie,e,E,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,E.createDecorator)("themeService");var y;(function(p){function h(w){return w&&typeof w=="object"&&typeof w.id=="string"}p.isThemeColor=h})(y=e.ThemeColor||(e.ThemeColor={}));function n(p){return{id:p}}e.themeColorFromId=n;var R;(function(p){function h(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}p.isThemeIcon=h;const w=new RegExp(`^\\$\\((${I.CSSIcon.iconNameExpression}(?:${I.CSSIcon.iconModifierExpression})?)\\)$`);function _(t){const r=w.exec(t);if(!!r){let[,u]=r;return{id:u}}}p.fromString=_;function c(t,r){let u=t.id;const o=u.lastIndexOf("~");return o!==-1&&(u=u.substring(0,o)),r&&(u=`${u}~${r}`),{id:u}}p.modify=c;function l(t,r){var u,o;return t.id===r.id&&((u=t.color)===null||u===void 0?void 0:u.id)===((o=r.color)===null||o===void 0?void 0:o.id)}p.isEqual=l,p.asClassNameArray=I.CSSIcon.asClassNameArray,p.asClassName=I.CSSIcon.asClassName,p.asCSSSelector=I.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=I.Codicon.file,e.FolderThemeIcon=I.Codicon.folder;function C(p){switch(p){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(h){return this.themingParticipants.push(h),this.onThemingParticipantAddedEmitter.fire(h),(0,k.toDisposable)(()=>{const w=this.themingParticipants.indexOf(h);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new v;A.Registry.add(e.Extensions.ThemingContribution,m);function i(p){return m.onColorThemeChange(p)}e.registerThemingParticipant=i;class s extends k.Disposable{constructor(h){super();this.themeService=h,this.theme=h.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(h){this.theme=h,this.updateStyles()}updateStyles(){}getColor(h,w){let _=this.theme.getColor(h);return _&&w&&(_=w(_,this.theme)),_?_.toString():null}}e.Themable=s}),define(be[157],we([0,1,30,156,3,126,88,13,36]),function(ie,e,E,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(h,w,_,c){const l=this.iconsById[h];if(l){if(_&&!l.description){l.description=_,this.iconSchema.properties[h].markdownDescription=`${_} $(${h})`;const u=this.iconReferenceSchema.enum.indexOf(h);u!==-1&&(this.iconReferenceSchema.enumDescriptions[u]=_),this._onDidChange.fire()}return l}let t={id:h,description:_,defaults:w,deprecationMessage:c};this.iconsById[h]=t;let r={$ref:"#/definitions/icons"};return c&&(r.deprecationMessage=c),_&&(r.markdownDescription=`${_}: $(${h})`),this.iconSchema.properties[h]=r,this.iconReferenceSchema.enum.push(h),this.iconReferenceSchema.enumDescriptions.push(_||""),this._onDidChange.fire(),{id:h}}deregisterIcon(h){delete this.iconsById[h],delete this.iconSchema.properties[h];const w=this.iconReferenceSchema.enum.indexOf(h);w!==-1&&(this.iconReferenceSchema.enum.splice(w,1),this.iconReferenceSchema.enumDescriptions.splice(w,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(h=>this.iconsById[h])}getIcon(h){return this.iconsById[h]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(h,w){const _=this.iconFontsById[h];if(_)return _;let c={id:h,definition:w};return this.iconFontsById[h]=c,this._onDidChange.fire(),c}deregisterIconFont(h){delete this.iconFontsById[h]}getIconFonts(){return Object.keys(this.iconFontsById).map(h=>this.iconFontsById[h])}getIconFont(h){return this.iconFontsById[h]}toString(){const h=(l,t)=>l.id.localeCompare(t.id),w=l=>{for(;k.ThemeIcon.isThemeIcon(l.defaults);)l=this.iconsById[l.defaults.id];return`codicon codicon-${l?l.id:""}`};let _=[];_.push("| preview     | identifier                        | default codicon ID                | description"),_.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(l=>this.iconsById[l]);for(const l of c.filter(t=>!!t.description).sort(h))_.push(`|<i class="${w(l)}"></i>|${l.id}|${k.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);_.push("| preview     | identifier                        "),_.push("| ----------- | --------------------------------- |");for(const l of c.filter(t=>!k.ThemeIcon.isThemeIcon(t.defaults)).sort(h))_.push(`|<i class="${w(l)}"></i>|${l.id}|`);return _.join(`
`)}}const R=new n;E.Registry.add(e.Extensions.IconContribution,R);function C(p,h,w,_){return R.registerIcon(p,h,w,_)}e.registerIcon=C;function v(){return R}e.getIconRegistry=v;function m(){for(const p of y.iconRegistry.all)R.registerIcon(p.id,p.definition,p.description);y.iconRegistry.onDidRegister(p=>R.registerIcon(p.id,p.definition,p.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let i=E.Registry.as(S.Extensions.JSONContribution);i.registerSchema(e.iconsSchemaId,R.getIconSchema());const s=new I.RunOnceScheduler(()=>i.notifySchemaChanged(e.iconsSchemaId),200);R.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.widgetClose=C("widget-close",y.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",y.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",y.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=k.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(be[47],we([0,1,2,25,4,22]),function(ie,e,E,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var S;(function(v){v[v.EMPTY=1]="EMPTY",v[v.FOLDER=2]="FOLDER",v[v.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function I(v){const m=v;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=I;function y(v){const m=v;return!!(m&&typeof m=="object"&&E.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=y;class n{constructor(m,i,s,p){this._id=m,this._configuration=s,this._ignorePathCasing=p,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=i}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class R{constructor(m,i){this.raw=i,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,k.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function C(v){return new R({uri:v,index:0,name:(0,k.basenameOrAuthority)(v)},{uri:v.toString()})}e.toWorkspaceFolder=C}),define(be[158],we([0,1,4,127,47,2,21,11,25,105,43,18,58,37,91]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const s=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(K){return(typeof K=="string"?(0,I.extname)(K):(0,y.extname)(K))===s}e.hasWorkspaceFileExtension=p,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function h(K){return K.hasOwnProperty("workspace")}e.isRecentWorkspace=h;function w(K){return K.hasOwnProperty("folderUri")}e.isRecentFolder=w;function _(K){return K.hasOwnProperty("fileUri")}e.isRecentFile=_;function c(K){const L=K;return typeof(L==null?void 0:L.id)=="string"&&T.URI.isUri(L.uri)}e.isSingleFolderWorkspaceIdentifier=c;function l(K){if(K.configuration)return{id:K.id,configPath:K.configuration};if(K.folders.length===1)return{id:K.id,uri:K.folders[0].uri}}e.toWorkspaceIdentifier=l;function t(K){const L=K;return typeof(L==null?void 0:L.id)=="string"&&T.URI.isUri(L.configPath)}e.isWorkspaceIdentifier=t;function r(K){const L=K;if(L==null?void 0:L.uri)return{id:L.id,uri:T.URI.revive(L.uri)};const U=K;if(U==null?void 0:U.configPath)return{id:U.id,configPath:T.URI.revive(U.configPath)};if(K==null?void 0:K.id)return{id:K.id}}e.reviveIdentifier=r;function u(K,L){return y.extUriBiasedIgnorePathCase.isEqualOrParent(K,L.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function o(K){return a(K)||f(K)}e.isStoredWorkspaceFolder=o;function a(K){const L=K;return typeof(L==null?void 0:L.path)=="string"&&(!L.name||typeof L.name=="string")}e.isRawFileWorkspaceFolder=a;function f(K){const L=K;return typeof(L==null?void 0:L.uri)=="string"&&(!L.name||typeof L.name=="string")}e.isRawUriWorkspaceFolder=f;function b(K,L,U,x,Q=!S.isWindows,$){if(K.scheme!==x.scheme)return{name:U,uri:K.toString(!0)};let ee=L?void 0:$.relativePath(x,K);if(ee!==void 0)ee.length===0?ee=".":S.isWindows&&K.scheme===C.Schemas.file&&!Q&&(ee=ee.replace(/\//g,"\\"));else if(K.scheme===C.Schemas.file)ee=K.fsPath,S.isWindows&&(ee=(0,v.normalizeDriveLetter)(ee),Q&&(ee=(0,m.toSlashes)(ee)));else{if(!$.isEqualAuthority(K.authority,x.authority))return{name:U,uri:K.toString(!0)};ee=K.path}return{name:U,path:ee}}e.getStoredWorkspaceFolder=b;function D(K,L,U){let x=[],Q=new Set;const $=U.dirname(L);for(let ee of K){let re=null;if(a(ee))ee.path&&(re=U.resolvePath($,ee.path));else if(f(ee))try{re=T.URI.parse(ee.uri),re.path[0]!=="/"&&(re=re.with({path:"/"+re.path}))}catch(se){console.warn(se)}if(re){let se=U.getComparisonKey(re);if(!Q.has(se)){Q.add(se);const ye=ee.name||U.basenameOrAuthority(re);x.push(new A.WorkspaceFolder({uri:re,name:ye,index:x.length},ee))}}}return x}e.toWorkspaceFolders=D;function d(K,L,U,x,Q){let $=g(L,K);const ee=Q.dirname(L),re=Q.dirname(x),se=[],ye=P($.folders);for(const ze of $.folders){const N=a(ze)?Q.resolvePath(ee,ze.path):T.URI.parse(ze.uri);let G;U?G=!1:G=!a(ze)||(0,I.isAbsolute)(ze.path),se.push(b(N,G,ze.name,re,ye,Q))}const Ie={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},xe=n.setProperty(K,["folders"],se,Ie);let Fe=n.applyEdits(K,xe);return $.remoteAuthority===(0,i.getRemoteAuthority)(x)&&(Fe=n.applyEdits(Fe,n.removeProperty(Fe,["remoteAuthority"],Ie))),Fe}e.rewriteWorkspaceFileForNewLocation=d;function g(K,L){let U=R.parse(L);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(x=>o(x));else throw new Error(`${K} looks like an invalid workspace file.`);return U}function P(K){return S.isWindows?K.some(L=>a(L)&&L.path.indexOf("/")>=0):!0}e.useSlashForPath=P;function F(K){return K.workspace&&typeof K.workspace=="object"&&typeof K.workspace.id=="string"&&typeof K.workspace.configPath=="string"}function z(K){return typeof K.folderUri=="string"}function de(K){return typeof K.fileUri=="string"}function W(K,L){const U={workspaces:[],files:[]};if(K){const x=function($,ee){for(let re=0;re<$.length;re++)try{ee($[re],re)}catch(se){L.warn(`Error restoring recent entry ${JSON.stringify($[re])}: ${se.toString()}. Skip entry.`)}},Q=K;if(Array.isArray(Q.entries))x(Q.entries,$=>{const ee=$.label,re=$.remoteAuthority;F($)?U.workspaces.push({label:ee,remoteAuthority:re,workspace:{id:$.workspace.id,configPath:T.URI.parse($.workspace.configPath)}}):z($)?U.workspaces.push({label:ee,remoteAuthority:re,folderUri:T.URI.parse($.folderUri)}):de($)&&U.files.push({label:ee,remoteAuthority:re,fileUri:T.URI.parse($.fileUri)})});else{const $=K;Array.isArray($.workspaces3)&&x($.workspaces3,(ee,re)=>{const se=Array.isArray($.workspaceLabels)&&$.workspaceLabels[re]||void 0;typeof ee=="object"&&typeof ee.id=="string"&&typeof ee.configURIPath=="string"?U.workspaces.push({label:se,workspace:{id:ee.id,configPath:T.URI.parse(ee.configURIPath)}}):typeof ee=="string"&&U.workspaces.push({label:se,folderUri:T.URI.parse(ee)})}),Array.isArray($.files2)&&x($.files2,(ee,re)=>{const se=Array.isArray($.fileLabels)&&$.fileLabels[re]||void 0;typeof ee=="string"&&U.files.push({label:se,fileUri:T.URI.parse(ee)})})}}return U}e.restoreRecentlyOpened=W;function B(K){const L={entries:[]};for(const U of K.workspaces)w(U)?L.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):L.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of K.files)L.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return L}e.toStoreData=B}),define(be[92],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class E{constructor(A){this.id=A,this._data=new Map,this._idPool=1}add(A){const T=this._idPool++;return this._data.set(T,A),this.logDebugInfo(),T}get(A,T){return this._data.has(A)?this._data.get(A)[T]:void 0}delete(A){this._data.delete(A),this.logDebugInfo()}logDebugInfo(){!E.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=E,E.enableDebugLogging=!1}),define(be[159],we([0,1,2,3]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class A{constructor(){this._onDidChangeTabs=new k.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(S){this._tabs=S.map(I=>({name:I.name,group:I.group,resource:E.URI.revive(I.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(be[48],we([0,1,18,4]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(E.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(S,I){I===null?this._providerInfo.delete(S):this._providerInfo.set(S,I)}isFreeScheme(S){return!this._providerInfo.has(S)&&!this._systemSchemes.has(S)}getCapabilities(S){return this._providerInfo.get(S)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(be[27],we([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,E.createDecorator)("IExtHostInitDataService")}),define(be[160],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class E{constructor(T,S,I){this._id=T,this._shared=S,this._storage=I,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)})}get whenReady(){return this._init}get(T,S){let I=this._value[T];return typeof I=="undefined"&&(I=S),I}update(T,S){return this._value[T]=S,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=E;class k extends E{constructor(T,S){super(T.identifier.value,!0,S);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=k}),define(be[14],we([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,E.createDecorator)("IExtHostRpcService");class k{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=k});var tt=this&&this.__classPrivateFieldSet||function(ie,e,E,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(ie,E):A?A.value=E:e.set(ie,E),E},Ue=this&&this.__classPrivateFieldGet||function(ie,e,E,k){if(E==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?k:E==="a"?k.call(ie):k?k.value:e.get(ie)};define(be[161],we([0,1,26,3]),function(ie,e,E,k){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(I,y){A.set(this,void 0),this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._id=E.ExtensionIdentifier.toKey(I.identifier),tt(this,A,y,"f"),Ue(this,A,"f").onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(I){return Ue(this,A,"f").get(this._id,I)}store(I,y){return Ue(this,A,"f").store(this._id,I,y)}delete(I){return Ue(this,A,"f").delete(this._id,I)}}e.ExtensionSecrets=T,A=new WeakMap}),define(be[93],we([0,1,4,3]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class A{constructor(){this._onDidChangeTelemetryEnabled=new k.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(S){this._enabled=S}$onDidChangeTelemetryEnabled(S){this._enabled=S,this._onDidChangeTelemetryEnabled.fire(S)}}e.ExtHostTelemetry=A,e.IExtHostTelemetry=(0,E.createDecorator)("IExtHostTelemetry")}),define(be[67],we([0,1,4,3,14]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(I){function y(R){return{remoteAddress:R.remoteAddress,localAddress:R.localAddress,public:!!R.public}}I.fromApiTunnel=y;function n(R){return{remoteAddress:{host:R.tunnelRemoteHost,port:R.tunnelRemotePort},localAddress:R.localAddress,public:R.public}}I.fromServiceTunnel=n})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,E.createDecorator)("IExtHostTunnelService");let S=class{constructor(y){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,n){return{dispose:()=>{}}}async $providePortAttributes(y,n,R,C,v){return[]}async $forwardPort(y,n){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};S=je([Ke(0,A.IExtHostRpcService)],S),e.ExtHostTunnelService=S});var tt=this&&this.__classPrivateFieldSet||function(ie,e,E,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(ie,E):A?A.value=E:e.set(ie,E),E},Ue=this&&this.__classPrivateFieldGet||function(ie,e,E,k){if(E==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?k:E==="a"?k.call(ie):k?k.value:e.get(ie)};define(be[7],we([0,1,15,10,80,22,12,2,29,64,90]),function(ie,e,E,k,A,T,S,I,y,n,R){"use strict";var C,v,m,i,s,p,h,w,_,c,l,t,r,u,o,a,f,b;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItem=e.TestChildrenCollection=e.TestItemHookProperty=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function D(O){function M(){return Reflect.construct(O,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(O,"name")),Object.setPrototypeOf(M,O),Object.setPrototypeOf(M.prototype,O.prototype),M}let d=s=class{constructor(M){C.set(this,void 0),tt(this,C,M,"f")}static from(...M){let Z=M;return new s(function(){if(Z){for(const Ee of Z)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();Z=void 0}})}dispose(){typeof Ue(this,C,"f")=="function"&&(Ue(this,C,"f").call(this),tt(this,C,void 0,"f"))}};C=new WeakMap,d=s=je([D],d),e.Disposable=d;let g=p=class{constructor(M,Z){if(M<0)throw(0,k.illegalArgument)("line must be non-negative");if(Z<0)throw(0,k.illegalArgument)("character must be non-negative");this._line=M,this._character=Z}static Min(...M){if(M.length===0)throw new TypeError;let Z=M[0];for(let Ee=1;Ee<M.length;Ee++){const Be=M[Ee];Be.isBefore(Z)&&(Z=Be)}return Z}static Max(...M){if(M.length===0)throw new TypeError;let Z=M[0];for(let Ee=1;Ee<M.length;Ee++){const Be=M[Ee];Be.isAfter(Z)&&(Z=Be)}return Z}static isPosition(M){if(!M)return!1;if(M instanceof p)return!0;let{line:Z,character:Ee}=M;return typeof Z=="number"&&typeof Ee=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,Z=0){if(M===null||Z===null)throw(0,k.illegalArgument)();let Ee;return typeof M=="undefined"?Ee=0:typeof M=="number"?Ee=M:(Ee=typeof M.lineDelta=="number"?M.lineDelta:0,Z=typeof M.characterDelta=="number"?M.characterDelta:0),Ee===0&&Z===0?this:new p(this.line+Ee,this.character+Z)}with(M,Z=this.character){if(M===null||Z===null)throw(0,k.illegalArgument)();let Ee;return typeof M=="undefined"?Ee=this.line:typeof M=="number"?Ee=M:(Ee=typeof M.line=="number"?M.line:this.line,Z=typeof M.character=="number"?M.character:this.character),Ee===this.line&&Z===this.character?this:new p(Ee,Z)}toJSON(){return{line:this.line,character:this.character}}};g=p=je([D],g),e.Position=g;let P=h=class{constructor(M,Z,Ee,Be){let Je,it;if(typeof M=="number"&&typeof Z=="number"&&typeof Ee=="number"&&typeof Be=="number"?(Je=new g(M,Z),it=new g(Ee,Be)):M instanceof g&&Z instanceof g&&(Je=M,it=Z),!Je||!it)throw new Error("Invalid arguments");Je.isBefore(it)?(this._start=Je,this._end=it):(this._start=it,this._end=Je)}static isRange(M){return M instanceof h?!0:M?g.isPosition(M.start)&&g.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof h?this.contains(M._start)&&this.contains(M._end):M instanceof g?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const Z=g.Max(M.start,this._start),Ee=g.Min(M.end,this._end);if(!Z.isAfter(Ee))return new h(Z,Ee)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const Z=g.Min(M.start,this._start),Ee=g.Max(M.end,this.end);return new h(Z,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,Z=this.end){if(M===null||Z===null)throw(0,k.illegalArgument)();let Ee;return M?g.isPosition(M)?Ee=M:(Ee=M.start||this.start,Z=M.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&Z.isEqual(this.end)?this:new h(Ee,Z)}toJSON(){return[this.start,this.end]}};P=h=je([D],P),e.Range=P;let F=w=class extends P{constructor(M,Z,Ee,Be){let Je,it;if(typeof M=="number"&&typeof Z=="number"&&typeof Ee=="number"&&typeof Be=="number"?(Je=new g(M,Z),it=new g(Ee,Be)):M instanceof g&&Z instanceof g&&(Je=M,it=Z),!Je||!it)throw new Error("Invalid arguments");super(Je,it);this._anchor=Je,this._active=it}static isSelection(M){return M instanceof w?!0:M?P.isRange(M)&&g.isPosition(M.anchor)&&g.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};F=w=je([D],F),e.Selection=F;class z{constructor(M,Z,Ee){if(typeof M!="string"||M.length===0)throw(0,k.illegalArgument)("host");if(typeof Z!="number"||Z===0||Math.round(Z)!==Z)throw(0,k.illegalArgument)("port");if(typeof Ee!="undefined"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,k.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(Z),this.connectionToken=Ee}}e.ResolvedAuthority=z;class de extends Error{constructor(M,Z=R.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(M);this._message=M,this._code=Z,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,de.prototype)}static NotAvailable(M,Z){return new de(M,R.RemoteAuthorityResolverErrorCode.NotAvailable,Z)}static TemporarilyNotAvailable(M){return new de(M,R.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=de;var W;(function(O){O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var B;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(B=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let K=_=class{constructor(M,Z){this._range=M,this._newText=Z}static isTextEdit(M){return M instanceof _?!0:M?P.isRange(M)&&typeof M.newText=="string":!1}static replace(M,Z){return new _(M,Z)}static insert(M,Z){return _.replace(new P(M,M),Z)}static delete(M){return _.replace(M,"")}static setEndOfLine(M){const Z=new _(new P(new g(0,0),new g(0,0)),"");return Z.newEol=M,Z}get range(){return this._range}set range(M){if(M&&!P.isRange(M))throw(0,k.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,k.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,k.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};K=_=je([D],K),e.TextEdit=K;var L;(function(O){O[O.File=1]="File",O[O.Text=2]="Text",O[O.Cell=3]="Cell",O[O.CellOutput=4]="CellOutput",O[O.CellReplace=5]="CellReplace",O[O.CellOutputItem=6]="CellOutputItem"})(L=e.FileEditType||(e.FileEditType={}));let U=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,Z,Ee,Be){this._edits.push({_type:1,from:M,to:Z,options:Ee,metadata:Be})}createFile(M,Z,Ee){this._edits.push({_type:1,from:void 0,to:M,options:Z,metadata:Ee})}deleteFile(M,Z,Ee){this._edits.push({_type:1,from:M,to:void 0,options:Z,metadata:Ee})}replaceNotebookMetadata(M,Z,Ee){this._edits.push({_type:3,metadata:Ee,uri:M,edit:{editType:5,metadata:Z},notebookMetadata:Z})}replaceNotebookCells(M,Z,Ee,Be,Je){(Z!==Ee||Be.length>0)&&this._edits.push({_type:5,uri:M,index:Z,count:Ee-Z,cells:Be,metadata:Je})}replaceNotebookCellOutput(M,Z,Ee,Be){this._editNotebookCellOutput(M,Z,!1,Ee,Be)}appendNotebookCellOutput(M,Z,Ee,Be){this._editNotebookCellOutput(M,Z,!0,Ee,Be)}replaceNotebookCellOutputItems(M,Z,Ee,Be,Je){this._editNotebookCellOutputItems(M,Z,Ee,!1,Be,Je)}appendNotebookCellOutputItems(M,Z,Ee,Be,Je){this._editNotebookCellOutputItems(M,Z,Ee,!0,Be,Je)}_editNotebookCellOutputItems(M,Z,Ee,Be,Je,it){this._edits.push({_type:6,metadata:it,uri:M,index:Z,outputId:Ee,append:Be,newOutputItems:Je})}_editNotebookCellOutput(M,Z,Ee,Be,Je){this._edits.push({_type:4,metadata:Je,uri:M,index:Z,append:Ee,newOutputs:Be,newMetadata:void 0})}replaceNotebookCellMetadata(M,Z,Ee,Be){this._edits.push({_type:3,metadata:Be,uri:M,edit:{editType:11,index:Z,metadata:Ee}})}replace(M,Z,Ee,Be){this._edits.push({_type:2,uri:M,edit:new K(Z,Ee),metadata:Be})}insert(M,Z,Ee,Be){this.replace(M,new P(Z,Z),Ee,Be)}delete(M,Z,Ee){this.replace(M,Z,"",Ee)}has(M){return this._edits.some(Z=>Z._type===2&&Z.uri.toString()===M.toString())}set(M,Z){if(Z)for(const Ee of Z)Ee&&this._edits.push({_type:2,uri:M,edit:Ee});else{for(let Ee=0;Ee<this._edits.length;Ee++){const Be=this._edits[Ee];Be._type===2&&Be.uri.toString()===M.toString()&&(this._edits[Ee]=void 0)}(0,E.coalesceInPlace)(this._edits)}}get(M){const Z=[];for(let Ee of this._edits)Ee._type===2&&Ee.uri.toString()===M.toString()&&Z.push(Ee.edit);return Z}entries(){const M=new T.ResourceMap;for(let Z of this._edits)if(Z._type===2){let Ee=M.get(Z.uri);Ee||(Ee=[Z.uri,[]],M.set(Z.uri,Ee)),Ee[1].push(Z.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};U=je([D],U),e.WorkspaceEdit=U;let x=c=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof c?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=c._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,Z=this._tabstop++){if(typeof M=="function"){const Ee=new c;Ee._tabstop=this._tabstop,M(Ee),this._tabstop=Ee._tabstop,M=Ee.value}else M=c._escape(M);return this.value+="${",this.value+=Z,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,Z=this._tabstop++){const Ee=M.map(Be=>Be.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Z,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(M,Z){if(typeof Z=="function"){const Ee=new c;Ee._tabstop=this._tabstop,Z(Ee),this._tabstop=Ee._tabstop,Z=Ee.value}else typeof Z=="string"&&(Z=Z.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,Z&&(this.value+=":",this.value+=Z),this.value+="}",this}};x=c=je([D],x),e.SnippetString=x;var Q;(function(O){O[O.Unnecessary=1]="Unnecessary",O[O.Deprecated=2]="Deprecated"})(Q=e.DiagnosticTag||(e.DiagnosticTag={}));var $;(function(O){O[O.Hint=3]="Hint",O[O.Information=2]="Information",O[O.Warning=1]="Warning",O[O.Error=0]="Error"})($=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ee=l=class{constructor(M,Z){if(this.uri=M,Z)if(Z instanceof P)this.range=Z;else if(Z instanceof g)this.range=new P(Z,Z);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof l?!0:M?P.isRange(M.range)&&I.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ee=l=je([D],ee),e.Location=ee;let re=class{constructor(M,Z){this.location=M,this.message=Z}static is(M){return M?typeof M.message=="string"&&M.location&&P.isRange(M.location.range)&&I.URI.isUri(M.location.uri):!1}static isEqual(M,Z){return M===Z?!0:!M||!Z?!1:M.message===Z.message&&M.location.range.isEqual(Z.location.range)&&M.location.uri.toString()===Z.location.uri.toString()}};re=je([D],re),e.DiagnosticRelatedInformation=re;let se=class{constructor(M,Z,Ee=$.Error){if(!P.isRange(M))throw new TypeError("range must be set");if(!Z)throw new TypeError("message must be set");this.range=M,this.message=Z,this.severity=Ee}toJSON(){return{severity:$[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,Z){return M===Z?!0:!M||!Z?!1:M.message===Z.message&&M.severity===Z.severity&&M.code===Z.code&&M.severity===Z.severity&&M.source===Z.source&&M.range.isEqual(Z.range)&&(0,E.equals)(M.tags,Z.tags)&&(0,E.equals)(M.relatedInformation,Z.relatedInformation,re.isEqual)}};se=je([D],se),e.Diagnostic=se;let ye=class{constructor(M,Z){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:(0,A.isMarkdownString)(M)?this.contents=[M]:this.contents=[M],this.range=Z}};ye=je([D],ye),e.Hover=ye;var Ie;(function(O){O[O.Text=0]="Text",O[O.Read=1]="Read",O[O.Write=2]="Write"})(Ie=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let xe=class{constructor(M,Z=Ie.Text){this.range=M,this.kind=Z}toJSON(){return{range:this.range,kind:Ie[this.kind]}}};xe=je([D],xe),e.DocumentHighlight=xe;var Fe;(function(O){O[O.File=0]="File",O[O.Module=1]="Module",O[O.Namespace=2]="Namespace",O[O.Package=3]="Package",O[O.Class=4]="Class",O[O.Method=5]="Method",O[O.Property=6]="Property",O[O.Field=7]="Field",O[O.Constructor=8]="Constructor",O[O.Enum=9]="Enum",O[O.Interface=10]="Interface",O[O.Function=11]="Function",O[O.Variable=12]="Variable",O[O.Constant=13]="Constant",O[O.String=14]="String",O[O.Number=15]="Number",O[O.Boolean=16]="Boolean",O[O.Array=17]="Array",O[O.Object=18]="Object",O[O.Key=19]="Key",O[O.Null=20]="Null",O[O.EnumMember=21]="EnumMember",O[O.Struct=22]="Struct",O[O.Event=23]="Event",O[O.Operator=24]="Operator",O[O.TypeParameter=25]="TypeParameter"})(Fe=e.SymbolKind||(e.SymbolKind={}));var ze;(function(O){O[O.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let N=t=class{constructor(M,Z,Ee,Be,Je){this.name=M,this.kind=Z,this.containerName=Je,typeof Ee=="string"&&(this.containerName=Ee),Be instanceof ee?this.location=Be:Ee instanceof P&&(this.location=new ee(Be,Ee)),t.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Fe[this.kind],location:this.location,containerName:this.containerName}}};N=t=je([D],N),e.SymbolInformation=N;let G=r=class{constructor(M,Z,Ee,Be,Je){this.name=M,this.detail=Z,this.kind=Ee,this.range=Be,this.selectionRange=Je,this.children=[],r.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(r.validate)}};G=r=je([D],G),e.DocumentSymbol=G;var te;(function(O){O[O.Invoke=1]="Invoke",O[O.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(M,Z){this.title=M,this.kind=Z}};ae=je([D],ae),e.CodeAction=ae;let me=u=class{constructor(M){this.value=M}append(M){return new u(this.value?this.value+u.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+u.sep)}};me.sep=".",me=u=je([D],me),e.CodeActionKind=me,me.Empty=new me(""),me.QuickFix=me.Empty.append("quickfix"),me.Refactor=me.Empty.append("refactor"),me.RefactorExtract=me.Refactor.append("extract"),me.RefactorInline=me.Refactor.append("inline"),me.RefactorRewrite=me.Refactor.append("rewrite"),me.Source=me.Empty.append("source"),me.SourceOrganizeImports=me.Source.append("organizeImports"),me.SourceFixAll=me.Source.append("fixAll");let Se=class{constructor(M,Z){if(this.range=M,this.parent=Z,Z&&!Z.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Se=je([D],Se),e.SelectionRange=Se;class Me{constructor(M,Z,Ee,Be,Je,it){this.kind=M,this.name=Z,this.detail=Ee,this.uri=Be,this.range=Je,this.selectionRange=it}}e.CallHierarchyItem=Me;class ge{constructor(M,Z){this.fromRanges=Z,this.from=M}}e.CallHierarchyIncomingCall=ge;class Ce{constructor(M,Z){this.fromRanges=Z,this.to=M}}e.CallHierarchyOutgoingCall=Ce;let Pe=class{constructor(M,Z){this.range=M,this.command=Z}get isResolved(){return!!this.command}};Pe=je([D],Pe),e.CodeLens=Pe;let $e=o=class{constructor(M,Z=!1){v.set(this,void 0),tt(this,v,new A.MarkdownString(M,{supportThemeIcons:Z}),"f")}static isMarkdownString(M){return M instanceof o?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return Ue(this,v,"f").value}set value(M){Ue(this,v,"f").value=M}get isTrusted(){return Ue(this,v,"f").isTrusted}set isTrusted(M){Ue(this,v,"f").isTrusted=M}get supportThemeIcons(){return Ue(this,v,"f").supportThemeIcons}appendText(M){return Ue(this,v,"f").appendText(M),this}appendMarkdown(M){return Ue(this,v,"f").appendMarkdown(M),this}appendCodeblock(M,Z){return Ue(this,v,"f").appendCodeblock(Z!=null?Z:"",M),this}};v=new WeakMap,$e=o=je([D],$e),e.MarkdownString=$e;let _e=class{constructor(M,Z){this.label=M,this.documentation=Z}};_e=je([D],_e),e.ParameterInformation=_e;let qe=class{constructor(M,Z){this.label=M,this.documentation=Z,this.parameters=[]}};qe=je([D],qe),e.SignatureInformation=qe;let V=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};V=je([D],V),e.SignatureHelp=V;var X;(function(O){O[O.Invoke=1]="Invoke",O[O.TriggerCharacter=2]="TriggerCharacter",O[O.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ve;(function(O){O[O.Other=0]="Other",O[O.Type=1]="Type",O[O.Parameter=2]="Parameter"})(ve=e.InlineHintKind||(e.InlineHintKind={}));let Le=class{constructor(M,Z,Ee){this.text=M,this.range=Z,this.kind=Ee}};Le=je([D],Le),e.InlineHint=Le;var He;(function(O){O[O.Invoke=0]="Invoke",O[O.TriggerCharacter=1]="TriggerCharacter",O[O.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Oe;(function(O){O[O.Text=0]="Text",O[O.Method=1]="Method",O[O.Function=2]="Function",O[O.Constructor=3]="Constructor",O[O.Field=4]="Field",O[O.Variable=5]="Variable",O[O.Class=6]="Class",O[O.Interface=7]="Interface",O[O.Module=8]="Module",O[O.Property=9]="Property",O[O.Unit=10]="Unit",O[O.Value=11]="Value",O[O.Enum=12]="Enum",O[O.Keyword=13]="Keyword",O[O.Snippet=14]="Snippet",O[O.Color=15]="Color",O[O.File=16]="File",O[O.Reference=17]="Reference",O[O.Folder=18]="Folder",O[O.EnumMember=19]="EnumMember",O[O.Constant=20]="Constant",O[O.Struct=21]="Struct",O[O.Event=22]="Event",O[O.Operator=23]="Operator",O[O.TypeParameter=24]="TypeParameter",O[O.User=25]="User",O[O.Issue=26]="Issue"})(Oe=e.CompletionItemKind||(e.CompletionItemKind={}));var et;(function(O){O[O.Deprecated=1]="Deprecated"})(et=e.CompletionItemTag||(e.CompletionItemTag={}));let H=class{constructor(M,Z){this.label=M,this.kind=Z}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Oe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};H=je([D],H),e.CompletionItem=H;let ne=class{constructor(M=[],Z=!1){this.items=M,this.isIncomplete=Z}};ne=je([D],ne),e.CompletionList=ne;var he;(function(O){O[O.Active=-1]="Active",O[O.Beside=-2]="Beside",O[O.One=1]="One",O[O.Two=2]="Two",O[O.Three=3]="Three",O[O.Four=4]="Four",O[O.Five=5]="Five",O[O.Six=6]="Six",O[O.Seven=7]="Seven",O[O.Eight=8]="Eight",O[O.Nine=9]="Nine"})(he=e.ViewColumn||(e.ViewColumn={}));var q;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(q=e.StatusBarAlignment||(e.StatusBarAlignment={}));var J;(function(O){O[O.Off=0]="Off",O[O.On=1]="On",O[O.Relative=2]="Relative"})(J=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var oe;(function(O){O[O.Manual=1]="Manual",O[O.AfterDelay=2]="AfterDelay",O[O.FocusOut=3]="FocusOut"})(oe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var fe;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(fe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pe;(function(O){O[O.Keyboard=1]="Keyboard",O[O.Mouse=2]="Mouse",O[O.Command=3]="Command"})(pe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var We;(function(O){O[O.OpenOpen=0]="OpenOpen",O[O.ClosedClosed=1]="ClosedClosed",O[O.OpenClosed=2]="OpenClosed",O[O.ClosedOpen=3]="ClosedOpen"})(We=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(O){function M(Z){switch(Z){case"keyboard":return O.Keyboard;case"mouse":return O.Mouse;case"api":return O.Command}}O.fromValue=M}(pe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ne=class{constructor(M,Z){if(Z&&!I.URI.isUri(Z))throw(0,k.illegalArgument)("target");if(!P.isRange(M)||M.isEmpty)throw(0,k.illegalArgument)("range");this.range=M,this.target=Z}};Ne=je([D],Ne),e.DocumentLink=Ne;let Ve=class{constructor(M,Z,Ee,Be){this.red=M,this.green=Z,this.blue=Ee,this.alpha=Be}};Ve=je([D],Ve),e.Color=Ve;let Xe=class{constructor(M,Z){if(Z&&!(Z instanceof Ve))throw(0,k.illegalArgument)("color");if(!P.isRange(M)||M.isEmpty)throw(0,k.illegalArgument)("range");this.range=M,this.color=Z}};Xe=je([D],Xe),e.ColorInformation=Xe;let Ze=class{constructor(M){if(!M||typeof M!="string")throw(0,k.illegalArgument)("label");this.label=M}};Ze=je([D],Ze),e.ColorPresentation=Ze;var ct;(function(O){O[O.RGB=0]="RGB",O[O.HEX=1]="HEX",O[O.HSL=2]="HSL"})(ct=e.ColorFormat||(e.ColorFormat={}));var ot;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information"})(ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var nt;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(nt=e.TaskRevealKind||(e.TaskRevealKind={}));var ue;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(ue=e.TaskPanelKind||(e.TaskPanelKind={}));let De=a=class{constructor(M,Z){if(typeof M!="string"||typeof Z!="string")throw(0,k.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};De.Clean=new a("clean","Clean"),De.Build=new a("build","Build"),De.Rebuild=new a("rebuild","Rebuild"),De.Test=new a("test","Test"),De=a=je([D],De),e.TaskGroup=De;function le(O){let M="";for(let Z=0;Z<O.length;Z++)M+=O[Z].replace(/,/g,",,")+",";return M}let j=class{constructor(M,Z,Ee){if(typeof M!="string")throw(0,k.illegalArgument)("process");this._args=[],this._process=M,Z!==void 0&&(Array.isArray(Z)?(this._args=Z,this._options=Ee):this._options=Z)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,k.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let Z of this._args)M.push(Z);return le(M)}};j=je([D],j),e.ProcessExecution=j;let Ae=class{constructor(M,Z,Ee){if(this._args=[],Array.isArray(Z)){if(!M)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,k.illegalArgument)("command");this._command=M,this._args=Z,this._options=Ee}else{if(typeof M!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=M,this._options=Z}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,k.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let Z of this._args)M.push(typeof Z=="string"?Z:Z.value);return le(M)}};Ae=je([D],Ae),e.ShellExecution=Ae;var Te;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(Te=e.ShellQuoting||(e.ShellQuoting={}));var Ye;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace"})(Ye=e.TaskScope||(e.TaskScope={}));class Ge{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=Ge;let rt=f=class{constructor(M,Z,Ee,Be,Je,it){this.__deprecated=!1,this._definition=this.definition=M;let dt;typeof Z=="string"?(this._name=this.name=Z,this._source=this.source=Ee,this.execution=Be,dt=Je,this.__deprecated=!0):Z===Ye.Global||Z===Ye.Workspace?(this.target=Z,this._name=this.name=Ee,this._source=this.source=Be,this.execution=Je,dt=it):(this.target=Z,this._name=this.name=Ee,this._source=this.source=Be,this.execution=Je,dt=it),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof j?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ae?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof Ge?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,k.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const Z=this._definition.type;(f.EmptyType===Z||f.ProcessType===Z||f.ShellType===Z||f.ExtensionCallbackType===Z)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};rt.ExtensionCallbackType="customExecution",rt.ProcessType="process",rt.ShellType="shell",rt.EmptyType="$empty",rt=f=je([D],rt),e.Task=rt;var at;(function(O){O[O.SourceControl=1]="SourceControl",O[O.Window=10]="Window",O[O.Notification=15]="Notification"})(at=e.ProgressLocation||(e.ProgressLocation={}));let Qe=class{constructor(M,Z=ut.None){this.collapsibleState=Z,I.URI.isUri(M)?this.resourceUri=M:this.label=M}};Qe=je([D],Qe),e.TreeItem=Qe;var ut;(function(O){O[O.None=0]="None",O[O.Collapsed=1]="Collapsed",O[O.Expanded=2]="Expanded"})(ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let st=class{constructor(M,Z){this.id=M,this.color=Z}};st=je([D],st),e.ThemeIcon=st,st.File=new st("file"),st.Folder=new st("folder");let gt=class{constructor(M){this.id=M}};gt=je([D],gt),e.ThemeColor=gt;var wt;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.WorkspaceFolder=3]="WorkspaceFolder"})(wt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let St=class{constructor(M,Z){if(typeof M!="string"&&(!M||!I.URI.isUri(M)&&!I.URI.isUri(M.uri)))throw(0,k.illegalArgument)("base");if(typeof Z!="string")throw(0,k.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=I.URI.file(M),this.base=M):I.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=Z}};St=je([D],St),e.RelativePattern=St;let vt=class{constructor(M,Z,Ee,Be){this.enabled=typeof M=="boolean"?M:!0,typeof Z=="string"&&(this.condition=Z),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Be=="string"&&(this.logMessage=Be)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};vt=je([D],vt),e.Breakpoint=vt;let Et=class extends vt{constructor(M,Z,Ee,Be,Je){super(Z,Ee,Be,Je);if(M===null)throw(0,k.illegalArgument)("location");this.location=M}};Et=je([D],Et),e.SourceBreakpoint=Et;let pt=class extends vt{constructor(M,Z,Ee,Be,Je){super(Z,Ee,Be,Je);this.functionName=M}};pt=je([D],pt),e.FunctionBreakpoint=pt;let Rt=class extends vt{constructor(M,Z,Ee,Be,Je,it,dt){super(Be,Je,it,dt);if(!Z)throw(0,k.illegalArgument)("dataId");this.label=M,this.dataId=Z,this.canPersist=Ee}};Rt=je([D],Rt),e.DataBreakpoint=Rt;let Ft=class{constructor(M,Z,Ee){this.command=M,this.args=Z||[],this.options=Ee}};Ft=je([D],Ft),e.DebugAdapterExecutable=Ft;let ft=class{constructor(M,Z){this.port=M,this.host=Z}};ft=je([D],ft),e.DebugAdapterServer=ft;let yt=class{constructor(M){this.path=M}};yt=je([D],yt),e.DebugAdapterNamedPipeServer=yt;let Bt=class{constructor(M){this.implementation=M}};Bt=je([D],Bt),e.DebugAdapterInlineImplementation=Bt;let qt=class{constructor(M,Z){this.range=M,this.expression=Z}};qt=je([D],qt),e.EvaluatableExpression=qt;let Lt=class{constructor(M,Z){this.range=M,this.text=Z}};Lt=je([D],Lt),e.InlineValueText=Lt;let ht=class{constructor(M,Z,Ee=!0){this.range=M,this.variableName=Z,this.caseSensitiveLookup=Ee}};ht=je([D],ht),e.InlineValueVariableLookup=ht;let Kt=class{constructor(M,Z){this.range=M,this.expression=Z}};Kt=je([D],Kt),e.InlineValueEvaluatableExpression=Kt;let Ct=class{constructor(M,Z){this.frameId=M,this.stoppedLocation=Z}};Ct=je([D],Ct),e.InlineValueContext=Ct;var Ot;(function(O){O[O.Changed=1]="Changed",O[O.Created=2]="Created",O[O.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Ht=b=class extends Error{constructor(M,Z=n.FileSystemProviderErrorCode.Unknown,Ee){var Be;super(I.URI.isUri(M)?M.toString(!0):M);this.code=(Be=Ee==null?void 0:Ee.name)!==null&&Be!==void 0?Be:"Unknown",(0,n.markAsFileSystemProviderError)(this,Z),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}static FileExists(M){return new b(M,n.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(M){return new b(M,n.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(M){return new b(M,n.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(M){return new b(M,n.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(M){return new b(M,n.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(M){return new b(M,n.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};Ht=b=je([D],Ht),e.FileSystemError=Ht;let Gt=class{constructor(M,Z,Ee){this.start=M,this.end=Z,this.kind=Ee}};Gt=je([D],Gt),e.FoldingRange=Gt;var en;(function(O){O[O.Comment=1]="Comment",O[O.Imports=2]="Imports",O[O.Region=3]="Region"})(en=e.FoldingRangeKind||(e.FoldingRangeKind={}));var dn;(function(O){O[O.Collapsed=0]="Collapsed",O[O.Expanded=1]="Expanded"})(dn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var tn;(function(O){O[O.Editing=0]="Editing",O[O.Preview=1]="Preview"})(tn=e.CommentMode||(e.CommentMode={}));class Mt{constructor(M,Z=[]){this.tokenTypes=M,this.tokenModifiers=Z}}e.SemanticTokensLegend=Mt;function hn(O){return typeof O=="undefined"||(0,S.isStringArray)(O)}class Nt{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let Z=0,Ee=M.tokenTypes.length;Z<Ee;Z++)this._tokenTypeStrToInt.set(M.tokenTypes[Z],Z);for(let Z=0,Ee=M.tokenModifiers.length;Z<Ee;Z++)this._tokenModifierStrToInt.set(M.tokenModifiers[Z],Z)}}push(M,Z,Ee,Be,Je){if(typeof M=="number"&&typeof Z=="number"&&typeof Ee=="number"&&typeof Be=="number"&&(typeof Je=="number"||typeof Je=="undefined"))return typeof Je=="undefined"&&(Je=0),this._pushEncoded(M,Z,Ee,Be,Je);if(P.isRange(M)&&typeof Z=="string"&&hn(Ee))return this._push(M,Z,Ee);throw(0,k.illegalArgument)()}_push(M,Z,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Z))throw new Error("`tokenType` is not in the provided legend");const Be=M.start.line,Je=M.start.character,it=M.end.character-M.start.character,dt=this._tokenTypeStrToInt.get(Z);let bt=0;if(Ee)for(const Dt of Ee){if(!this._tokenModifierStrToInt.has(Dt))throw new Error("`tokenModifier` is not in the provided legend");const kt=this._tokenModifierStrToInt.get(Dt);bt|=1<<kt>>>0}this._pushEncoded(Be,Je,it,dt,bt)}_pushEncoded(M,Z,Ee,Be,Je){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&Z<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const bt=this._data.length/5|0;let Dt=0,kt=0;for(let It=0;It<bt;It++){let At=this._data[5*It],Xt=this._data[5*It+1];At===0?(At=Dt,Xt+=kt):At+=Dt,this._data[5*It]=At,this._data[5*It+1]=Xt,Dt=At,kt=Xt}}let it=M,dt=Z;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(it-=this._prevLine,it===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=it,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=Be,this._data[this._dataLen++]=Je,this._prevLine=M,this._prevChar=Z}static _sortAndDeltaEncode(M){let Z=[];const Ee=M.length/5|0;for(let dt=0;dt<Ee;dt++)Z[dt]=dt;Z.sort((dt,bt)=>{const Dt=M[5*dt],kt=M[5*bt];if(Dt===kt){const It=M[5*dt+1],At=M[5*bt+1];return It-At}return Dt-kt});const Be=new Uint32Array(M.length);let Je=0,it=0;for(let dt=0;dt<Ee;dt++){const bt=5*Z[dt],Dt=M[bt+0],kt=M[bt+1],It=M[bt+2],At=M[bt+3],Xt=M[bt+4],Cn=Dt-Je,An=Cn===0?kt-it:kt,Zt=5*dt;Be[Zt+0]=Cn,Be[Zt+1]=An,Be[Zt+2]=It,Be[Zt+3]=At,Be[Zt+4]=Xt,Je=Dt,it=kt}return Be}build(M){return this._dataIsSortedAndDeltaEncoded?new Ut(new Uint32Array(this._data),M):new Ut(Nt._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=Nt;class Ut{constructor(M,Z){this.resultId=Z,this.data=M}}e.SemanticTokens=Ut;class fn{constructor(M,Z,Ee){this.start=M,this.deleteCount=Z,this.data=Ee}}e.SemanticTokensEdit=fn;class mn{constructor(M,Z){this.resultId=Z,this.edits=M}}e.SemanticTokensEdits=mn;var Pt;(function(O){O[O.Separate=0]="Separate",O[O.MergeWithParent=1]="MergeWithParent"})(Pt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var gn;(function(O){O[O.Initial=1]="Initial",O[O.Dynamic=2]="Dynamic"})(gn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let zt=class{constructor(){}};zt.Back={iconPath:new st("arrow-left")},zt=je([D],zt),e.QuickInputButtons=zt;var pn;(function(O){O[O.UI=1]="UI",O[O.Workspace=2]="Workspace"})(pn=e.ExtensionKind||(e.ExtensionKind={}));class vn{constructor(M,Z,Ee){this.badge=M,this.tooltip=Z,this.color=Ee}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=vn;let xt=class{constructor(M){this.kind=M}};xt=je([D],xt),e.ColorTheme=xt;var nn;(function(O){O[O.Light=1]="Light",O[O.Dark=2]="Dark",O[O.HighContrast=3]="HighContrast"})(nn=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(M,Z){if(M<0)throw(0,k.illegalArgument)("start must be positive");if(Z<M)throw(0,k.illegalArgument)("end cannot be smaller than start");this._start=M,this._end=Z}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(M){let Z=this._start,Ee=this._end;return M.start!==void 0&&(Z=M.start),M.end!==void 0&&(Ee=M.end),Z===this._start&&Ee===this._end?this:new Vt(Z,Ee)}}e.NotebookCellRange=Vt;class $t{constructor(M,Z,Ee,Be,Je,it,dt){this.editable=M,this.breakpointMargin=Z,this.hasExecutionOrder=Ee,this.statusMessage=Be,this.inputCollapsed=Je,this.outputCollapsed=it,this.custom=dt}with(M){let{editable:Z,breakpointMargin:Ee,hasExecutionOrder:Be,statusMessage:Je,inputCollapsed:it,outputCollapsed:dt,custom:bt}=M;return Z===void 0?Z=this.editable:Z===null&&(Z=void 0),Ee===void 0?Ee=this.breakpointMargin:Ee===null&&(Ee=void 0),Be===void 0?Be=this.hasExecutionOrder:Be===null&&(Be=void 0),Je===void 0?Je=this.statusMessage:Je===null&&(Je=void 0),it===void 0?it=this.inputCollapsed:it===null&&(it=void 0),dt===void 0?dt=this.outputCollapsed:dt===null&&(dt=void 0),bt===void 0?bt=this.custom:bt===null&&(bt=void 0),Z===this.editable&&Ee===this.breakpointMargin&&Be===this.hasExecutionOrder&&Je===this.statusMessage&&it===this.inputCollapsed&&dt===this.outputCollapsed&&bt===this.custom?this:new $t(Z,Ee,Be,Je,it,dt,bt)}}e.NotebookCellMetadata=$t;class Re{constructor(M=!0,Z=!0,Ee=!0,Be={},Je=!0){this.editable=M,this.cellEditable=Z,this.cellHasExecutionOrder=Ee,this.custom=Be,this.trusted=Je}with(M){let{editable:Z,cellEditable:Ee,cellHasExecutionOrder:Be,custom:Je,trusted:it}=M;return Z===void 0?Z=this.editable:Z===null&&(Z=void 0),Ee===void 0?Ee=this.cellEditable:Ee===null&&(Ee=void 0),Be===void 0?Be=this.cellHasExecutionOrder:Be===null&&(Be=void 0),Je===void 0?Je=this.custom:Je===null&&(Je=void 0),it===void 0?it=this.trusted:it===null&&(it=void 0),Z===this.editable&&Ee===this.cellEditable&&Be===this.cellHasExecutionOrder&&Je===this.custom&&it===this.trusted?this:new Re(Z,Ee,Be,Je,it)}}e.NotebookDocumentMetadata=Re;class Qt{constructor(M,Z,Ee,Be,Je,it){this.kind=M,this.source=Z,this.language=Ee,this.outputs=Be!=null?Be:[],this.metadata=Je,this.latestExecutionSummary=it}}e.NotebookCellData=Qt;class Jt{constructor(M,Z){this.cells=M,this.metadata=Z!=null?Z:new Re}}e.NotebookData=Jt;class mt{constructor(M,Z,Ee){this.mime=M,this.value=Z,this.metadata=Ee}static isNotebookCellOutputItem(M){return M instanceof mt}}e.NotebookCellOutputItem=mt;class _n{constructor(M,Z,Ee){this.outputs=M,typeof Z=="string"?(this.id=Z,this.metadata=Ee):(this.id=(0,y.generateUuid)(),this.metadata=Z!=null?Z:Ee)}}e.NotebookCellOutput=_n;var bn;(function(O){O[O.Markdown=1]="Markdown",O[O.Code=2]="Code"})(bn=e.NotebookCellKind||(e.NotebookCellKind={}));var rn;(function(O){O[O.Idle=1]="Idle",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(rn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var sn;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(sn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var wn;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(wn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let Yt=class{constructor(M,Z){this.label=M,this.timestamp=Z}};Yt=je([D],Yt),e.TimelineItem=Yt;var En;(function(O){O[O.Production=1]="Production",O[O.Development=2]="Development",O[O.Test=3]="Test"})(En=e.ExtensionMode||(e.ExtensionMode={}));var yn;(function(O){O[O.Node=1]="Node",O[O.Webworker=2]="Webworker"})(yn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var on;(function(O){O[O.Other=0]="Other",O[O.Comment=1]="Comment",O[O.String=2]="String",O[O.RegEx=4]="RegEx"})(on=e.StandardTokenType||(e.StandardTokenType={}));class Sn{constructor(M,Z){this.ranges=M,this.wordPattern=Z}}e.LinkedEditingRanges=Sn;var Dn;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(Dn=e.TestResultState||(e.TestResultState={}));var an;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information",O[O.Hint=3]="Hint"})(an=e.TestMessageSeverity||(e.TestMessageSeverity={})),e.TestItemHookProperty=Symbol("TestItemHookProperty");const jt=(O,M,Z)=>{let Ee=Z;return{enumerable:!0,configurable:!1,get(){return Ee},set(Be){var Je;(Je=O[e.TestItemHookProperty])===null||Je===void 0||Je.setProp(M,Be),Ee=Be}}};class ln{constructor(M){m.set(this,new Map),i.set(this,void 0),tt(this,i,M,"f")}get size(){return Ue(this,m,"f").size}add(M){const Z=Ue(this,m,"f"),Ee=Ue(this,i,"f").call(this),Be=Z.get(M.id);Be!==M&&(Be&&(Ee==null||Ee.delete(M.id)),Z.set(M.id,M),Ee==null||Ee.created(M))}get(M){return Ue(this,m,"f").get(M)}clear(){for(const M of Ue(this,m,"f").keys())this.delete(M)}delete(M){var Z;const Ee=typeof M=="string"?M:M.id;Ue(this,m,"f").has(Ee)&&(Ue(this,m,"f").delete(Ee),(Z=Ue(this,i,"f").call(this))===null||Z===void 0||Z.delete(Ee))}toJSON(){return[...Ue(this,m,"f").values()]}[(m=new WeakMap,i=new WeakMap,Symbol.iterator)](){return Ue(this,m,"f").values()}}e.TestChildrenCollection=ln;class Y{constructor(M,Z,Ee,Be){this.label=Z,this.expandable=Be,Object.defineProperties(this,{id:{value:M,enumerable:!0,writable:!1},uri:{value:Ee,enumerable:!0,writable:!1},children:{value:new ln(()=>this[e.TestItemHookProperty]),enumerable:!0,writable:!1},[e.TestItemHookProperty]:{enumerable:!1,writable:!0,configurable:!1},range:jt(this,"range",void 0),description:jt(this,"description",void 0),runnable:jt(this,"runnable",!0),debuggable:jt(this,"debuggable",!0)})}invalidate(){var M;(M=this[e.TestItemHookProperty])===null||M===void 0||M.invalidate(this.id)}discoverChildren(M,Z){M.report({busy:!1})}}e.TestItem=Y;class ce{constructor(M){this.message=M,this.severity=an.Error}static diff(M,Z,Ee){const Be=new ce(M);return Be.expectedOutput=Z,Be.actualOutput=Ee,Be}}e.TestMessage=ce;var ke;(function(O){O[O.None=0]="None",O[O.Option=1]="Option",O[O.Default=2]="Default",O[O.Preferred=3]="Preferred"})(ke=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var lt;(function(O){O[O.Untrusted=0]="Untrusted",O[O.Trusted=1]="Trusted",O[O.Unspecified=2]="Unspecified"})(lt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var _t;(function(O){O[O.Notify=1]="Notify",O[O.OpenBrowser=2]="OpenBrowser",O[O.OpenPreview=3]="OpenPreview",O[O.Silent=4]="Silent",O[O.Ignore=5]="Ignore"})(_t=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(be[94],we([0,1,42,18,8,118,83,7,15]),function(ie,e,E,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function R(i,s){s?n.set(i,s):n.delete(i)}e.setWordDefinitionFor=R;function C(i){return n.get(i)}e.getWordDefinitionFor=C;class v extends T.MirrorTextModel{constructor(s,p,h,w,_,c,l,t){super(p,h,w,_);this._proxy=s,this._languageId=c,this._isDirty=l,this._notebook=t,this._isDisposed=!1}dispose(){(0,E.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(s){return(0,y.equals)(this._lines,s)}get document(){if(!this._document){const s=this;this._document={get uri(){return s._uri},get fileName(){return s._uri.fsPath},get isUntitled(){return s._uri.scheme===k.Schemas.untitled},get languageId(){return s._languageId},get version(){return s._versionId},get isClosed(){return s._isDisposed},get isDirty(){return s._isDirty},get notebook(){return s._notebook},save(){return s._save()},getText(p){return p?s._getTextInRange(p):s.getText()},get eol(){return s._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return s._lines.length},lineAt(p){return s._lineAt(p)},offsetAt(p){return s._offsetAt(p)},positionAt(p){return s._positionAt(p)},validateRange(p){return s._validateRange(p)},validatePosition(p){return s._validatePosition(p)},getWordRangeAtPosition(p,h){return s._getWordRangeAtPosition(p,h)}}}return Object.freeze(this._document)}_acceptLanguageId(s){(0,E.ok)(!this._isDisposed),this._languageId=s}_acceptIsDirty(s){(0,E.ok)(!this._isDisposed),this._isDirty=s}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(s){const p=this._validateRange(s);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const h=this._eol,w=p.start.line,_=p.end.line,c=[];c.push(this._lines[w].substring(p.start.character));for(let l=w+1;l<_;l++)c.push(this._lines[l]);return c.push(this._lines[_].substring(0,p.end.character)),c.join(h)}_lineAt(s){let p;if(s instanceof I.Position?p=s.line:typeof s=="number"&&(p=s),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new m(p,this._lines[p],p===this._lines.length-1)}_offsetAt(s){return s=this._validatePosition(s),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(s.line-1)+s.character}_positionAt(s){s=Math.floor(s),s=Math.max(0,s),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(s),h=this._lines[p.index].length;return new I.Position(p.index,Math.min(p.remainder,h))}_validateRange(s){if(!(s instanceof I.Range))throw new Error("Invalid argument");const p=this._validatePosition(s.start),h=this._validatePosition(s.end);return p===s.start&&h===s.end?s:new I.Range(p.line,p.character,h.line,h.character)}_validatePosition(s){if(!(s instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return s.with(0,0);let{line:p,character:h}=s,w=!1;if(p<0)p=0,h=0,w=!0;else if(p>=this._lines.length)p=this._lines.length-1,h=this._lines[p].length,w=!0;else{const _=this._lines[p].length;h<0?(h=0,w=!0):h>_&&(h=_,w=!0)}return w?new I.Position(p,h):s}_getWordRangeAtPosition(s,p){const h=this._validatePosition(s);if(!p)p=C(this._languageId);else if((0,A.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const w=(0,S.getWordAtText)(h.character+1,(0,S.ensureValidWordDefinition)(p),this._lines[h.line],0);if(w)return new I.Range(h.line,w.startColumn-1,h.line,w.endColumn-1)}}e.ExtHostDocumentData=v;class m{constructor(s,p,h){this._line=s,this._text=p,this._isLastLine=h}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(be[162],we([0,1,7,3,85,6,59,22,2,29]),function(ie,e,E,k,A,T,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(v,m,i,s){this._notebook=i,this._selector=s,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,n.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(h=>{const w=this._cellUris.get(h.document.uri);w!==void 0&&(this._cellLengths.changeValue(w,this._cells[w].document.getText().length+1),this._cellLines.changeValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=h=>{h===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(v.onDidChangeNotebookCells(h=>p(h.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const v=[],m=[];for(const i of this._notebook.getCells())i.kind===E.NotebookCellKind.Code&&(!this._selector||(0,S.score)(this._selector,i.document.uri,i.document.languageId,!0))&&(this._cellUris.set(i.document.uri,this._cells.length),this._cells.push(i),v.push(i.document.getText().length+1),m.push(i.document.lineCount));this._cellLengths=new A.PrefixSumComputer(new Uint32Array(v)),this._cellLines=new A.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(v){var m,i;if(!v){let _="";for(const c of this._cells)_+=c.document.getText()+`
`;return _=_.slice(0,-1),_}if(v.isEmpty)return"";const s=this.locationAt(v.start),p=this.locationAt(v.end),h=this._cells[(m=this._cellUris.get(s.uri))!==null&&m!==void 0?m:-1],w=this._cells[(i=this._cellUris.get(p.uri))!==null&&i!==void 0?i:-1];if(!h||!w)return"";if(h===w)return h.document.getText(new E.Range(s.range.start,p.range.end));{const _=h.document.getText(new E.Range(s.range.start,new E.Position(h.document.lineCount,0))),c=w.document.getText(new E.Range(new E.Position(0,0),p.range.end));return _+`
`+c}}offsetAt(v){const m=this._cellLines.getIndexOf(v.line),i=this._cellLengths.getAccumulatedValue(m.index-1),s=this._cells[m.index].document.offsetAt(v.with(m.remainder));return i+s}positionAt(v){if(typeof v=="number"){const i=this._cellLengths.getIndexOf(v),s=this._cellLines.getAccumulatedValue(i.index-1);return this._cells[i.index].document.positionAt(i.remainder).translate(s)}const m=this._cellUris.get(v.uri);if(m!==void 0){const i=this._cellLines.getAccumulatedValue(m-1);return new E.Position(i+v.range.start.line,v.range.start.character)}return new E.Position(0,0)}locationAt(v){E.Range.isRange(v)||(v=new E.Range(v,v));const m=this._cellLines.getIndexOf(v.start.line);let i=m;v.isEmpty||(i=this._cellLines.getIndexOf(v.end.line));const s=new E.Position(m.remainder,v.start.character),p=new E.Position(i.remainder,v.end.character),h=new E.Range(s,p),w=this._cells[m.index];return new E.Location(w.document.uri,w.document.validateRange(h))}contains(v){return this._cellUris.has(v)}validateRange(v){const m=this.validatePosition(v.start),i=this.validatePosition(v.end);return v.with(m,i)}validatePosition(v){const m=this._cellLines.getIndexOf(v.line),i=new E.Position(m.remainder,v.character),s=this._cells[m.index].document.validatePosition(i),p=this._cellLines.getAccumulatedValue(m.index-1);return new E.Position(p+s.line,s.character)}}e.ExtHostNotebookConcatDocument=R}),define(be[163],we([0,1,7,14,3]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(I){this._actual=new E.ColorTheme(E.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new A.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let y=I==="light"?E.ColorThemeKind.Light:I==="dark"?E.ColorThemeKind.Dark:E.ColorThemeKind.HighContrast;this._actual=new E.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=je([Ke(0,k.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(be[68],we([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,E.createDecorator)("IURITransformerService");class k{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=k}),define(be[164],we([0,1,24]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class k{constructor(){this.buffers=[]}add(y){let n=this.buffers.indexOf(y);return n<0&&(n=this.buffers.length,this.buffers.push(y)),n}}function A(I,y){if(y){const n=new k,R=(m,i)=>{if(i instanceof ArrayBuffer){const s=n.add(i);return{$$vscode_array_buffer_reference$$:!0,index:s}}else if(ArrayBuffer.isView(i)){const s=T(i);if(s){const p=n.add(i.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:s,byteLength:i.byteLength,byteOffset:i.byteOffset}}}}return i},C=JSON.stringify(I,R),v=n.buffers.map(m=>{const i=new Uint8Array(m);return E.VSBuffer.wrap(i)});return{message:C,buffers:v}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=A;function T(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(I,y){const n=y.map(v=>{const m=new ArrayBuffer(v.byteLength);return new Uint8Array(m).set(v.buffer),m}),R=y.length?(v,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const i=m,{index:s}=i,p=n[s];if(i.view)switch(i.view.type){case 1:return new Int8Array(p,i.view.byteOffset,i.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,i.view.byteOffset,i.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,i.view.byteOffset,i.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,i.view.byteOffset,i.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,i.view.byteOffset,i.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,i.view.byteOffset,i.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,i.view.byteOffset,i.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,i.view.byteOffset,i.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,i.view.byteOffset,i.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,i.view.byteOffset,i.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,i.view.byteOffset,i.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return m}:void 0;return{message:JSON.parse(I,R),arrayBuffers:n}}e.deserializeWebviewMessage=S}),define(be[69],we([0,1,2]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function k(T,S,I){const y=T.webviewResourceRoot.replace("{{resource}}",I.scheme+A(I)).replace("{{uuid}}",S);return E.URI.parse(y)}e.asWebviewUri=k;function A(T){return T.toString().replace(/^\S+?:/,"")}}),define(be[165],we([0,1,3,6,69,29]),function(ie,e,E,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(y,n,R){this._proxy=y,this._editors=n,this._initData=R,this._handlePool=0,this._disposables=new k.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const C=n.getVisibleTextEditors();for(const v of this._insets.values())C.indexOf(v.editor)<0&&v.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,n,R,C,v){let m;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===y){m=c;break}if(!m)throw new Error("not a visible editor");const i=this,s=this._handlePool++,p=new E.Emitter,h=new E.Emitter,w=new class{constructor(){this._uuid=(0,T.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,A.asWebviewUri)(i._initData,this._uuid,c)}get cspSource(){return i._initData.webviewCspSource}set options(c){this._options=c,i._proxy.$setOptions(s,c)}get options(){return this._options}set html(c){this._html=c,i._proxy.$setHtml(s,c)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(c){return i._proxy.$postMessage(s,c)}},_=new class{constructor(){this.editor=y,this.line=n,this.height=R,this.webview=w,this.onDidDispose=h.event}dispose(){i._insets.has(s)&&(i._insets.delete(s),i._proxy.$disposeEditorInset(s),h.fire(),h.dispose(),p.dispose())}};return this._proxy.$createEditorInset(s,m.id,m.value.document.uri,n+1,R,C||{},v.identifier,v.extensionLocation),this._insets.set(s,{editor:y,inset:_,onDidReceiveMessage:p}),_}$onDidDispose(y){const n=this._insets.get(y);n&&n.inset.dispose()}$onDidReceiveMessage(y,n){const R=this._insets.get(y);R&&R.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=S}),define(be[166],we([0,1,3,63,137,4,6,22,30,15,50,23,36,157]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",v.Codicon.window,(0,A.localize)(0,null));var i;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(i=e.Extensions||(e.Extensions={}));var s;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel"})(s=e.ViewContainerLocation||(e.ViewContainerLocation={}));function p(a){switch(a){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=p;function h(a){return`viewContainer.${a}.enabled`}e.getEnabledViewContainerContextKey=h;class w extends S.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new E.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new E.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,n.flatten)([...this.viewContainers.values()])}registerViewContainer(f,b,D){var d;const g=this.get(f.id);if(g)return g;const P=f;return P.openCommandActionDescriptor=(D==null?void 0:D.donotRegisterOpenCommand)?void 0:(d=P.openCommandActionDescriptor)!==null&&d!==void 0?d:{id:P.id},(0,I.getOrSet)(this.viewContainers,b,[]).push(P),(D==null?void 0:D.isDefault)&&this.defaultViewContainers.push(P),this._onDidRegister.fire({viewContainer:P,viewContainerLocation:b}),P}deregisterViewContainer(f){for(const b of this.viewContainers.keys()){const D=this.viewContainers.get(b),d=D==null?void 0:D.indexOf(f);if(d!==-1){D==null||D.splice(d,1),D.length===0&&this.viewContainers.delete(b),this._onDidDeregister.fire({viewContainer:f,viewContainerLocation:b});return}}}get(f){return this.all.filter(b=>b.id===f)[0]}getViewContainers(f){return[...this.viewContainers.get(f)||[]]}getViewContainerLocation(f){return[...this.viewContainers.keys()].filter(b=>this.getViewContainers(b).filter(D=>(D==null?void 0:D.id)===f.id).length>0)[0]}getDefaultViewContainer(f){return this.defaultViewContainers.find(b=>this.getViewContainerLocation(b)===f)}}y.Registry.add(i.ViewContainersRegistry,new w);var _;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(_=e.ViewContentGroups||(e.ViewContentGroups={}));function c(a,f){var b,D,d,g;const P=(b=a.group)!==null&&b!==void 0?b:_.More,F=(D=f.group)!==null&&D!==void 0?D:_.More;return P!==F?P.localeCompare(F):((d=a.order)!==null&&d!==void 0?d:5)-((g=f.order)!==null&&g!==void 0?g:5)}class l extends S.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new E.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new E.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new E.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new E.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new R.SetMap}registerViews(f,b){this.registerViews2([{views:f,viewContainer:b}])}registerViews2(f){f.forEach(({views:b,viewContainer:D})=>this.addViews(b,D)),this._onViewsRegistered.fire(f)}deregisterViews(f,b){const D=this.removeViews(f,b);D.length&&this._onViewsDeregistered.fire({views:D,viewContainer:b})}moveViews(f,b){for(const D of this._views.keys())if(D!==b){const d=this.removeViews(f,D);d.length&&(this.addViews(d,b),this._onDidChangeContainer.fire({views:d,from:D,to:b}))}}getViews(f){return this._views.get(f)||[]}getView(f){for(const b of this._viewContainers){const D=(this._views.get(b)||[]).filter(d=>d.id===f)[0];if(D)return D}return null}getViewContainer(f){for(const b of this._viewContainers)if((this._views.get(b)||[]).filter(d=>d.id===f)[0])return b;return null}registerViewWelcomeContent(f,b){return this._viewWelcomeContents.add(f,b),this._onDidChangeViewWelcomeContent.fire(f),(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(f,b),this._onDidChangeViewWelcomeContent.fire(f)})}registerViewWelcomeContent2(f,b){const D=new Map;for(const[d,g]of b)this._viewWelcomeContents.add(f,g),D.set(d,(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(f,g),this._onDidChangeViewWelcomeContent.fire(f)}));return this._onDidChangeViewWelcomeContent.fire(f),D}getViewWelcomeContent(f){const b=[];return this._viewWelcomeContents.forEach(f,D=>b.push(D)),b.sort(c)}addViews(f,b){let D=this._views.get(b);D||(D=[],this._views.set(b,D),this._viewContainers.push(b));for(const d of f){if(this.getView(d.id)!==null)throw new Error((0,A.localize)(1,null,d.id));D.push(d)}}removeViews(f,b){const D=this._views.get(b);if(!D)return[];const d=[],g=[];for(const P of D)f.includes(P)?d.push(P):g.push(P);return d.length&&(g.length?this._views.set(b,g):(this._views.delete(b),this._viewContainers.splice(this._viewContainers.indexOf(b),1))),d}}y.Registry.add(i.ViewsRegistry,new l),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new k.RawContextKey("focusedView","",(0,A.localize)(2,null));function t(a){return`view.${a}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var r;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var u;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(u=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class o{constructor(f,b){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,f),this._hasResolve=!!b,this.resolve=async D=>{var d,g;if(b&&!this.resolved){const P=await b(D);P&&(this.tooltip=(d=this.tooltip)!==null&&d!==void 0?d:P.tooltip,this.command=(g=this.command)!==null&&g!==void 0?g:P.command)}D.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=o}),define(be[167],we([0,1,2,147,158,19,148,166]),function(ie,e,E,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(s){return(p,...h)=>s(p.get(k.ICommandService),...h)}class n{static execute(p,h){const w={forceReuseWindow:h&&h.reuseWindow,remoteAuthority:h&&h.remoteAuthority};return p.executeCommand("_files.newWindow",w)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",k.CommandsRegistry.registerCommand({id:n.ID,handler:y(n.execute),description:{description:"Opens an new window",args:[]}}),k.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(s,p){return s.get(A.IWorkspacesService).removeRecentlyOpened([p])});class R{static execute(p,h){return typeof h=="string"?h=h.match(/^[^:/?#]+:\/\//)?E.URI.parse(h):E.URI.file(h):h=E.URI.revive(h),p.executeCommand("_workbench.removeFromRecentlyOpened",h)}}e.RemoveFromRecentlyOpenedAPICommand=R,R.ID="vscode.removeFromRecentlyOpened",k.CommandsRegistry.registerCommand(R.ID,y(R.execute));class C{static execute(p,h){const w=typeof h=="string"?{extensionId:h}:h;return p.executeCommand("workbench.action.openIssueReporter",w)}}e.OpenIssueReporter=C,C.ID="vscode.openIssueReporter",k.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(s,p){const h=s.get(A.IWorkspacesService);let w;const _=p.uri,c=p.label,l=p.remoteAuthority;return p.type==="workspace"?w={workspace:await h.getWorkspaceIdentifier(_),label:c,remoteAuthority:l}:p.type==="folder"?w={folderUri:_,label:c,remoteAuthority:l}:w={fileUri:_,label:c,remoteAuthority:l},h.addRecentlyOpened([w])}),k.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(s){return s.get(A.IWorkspacesService).getRecentlyOpened()}),k.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(s,p){const h=s.get(T.ILogService),w=s.get(S.IEnvironmentService);w.isExtensionDevelopment&&!!w.extensionTestsLocationURI&&h.setLevel(p)}),k.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(s){return s.get(T.ILogService).getLevel()}),k.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(s,p){const h=s.get(I.IViewDescriptorService),w=h.getViewContainerById(p.destinationId);if(!!w){for(const _ of p.viewIds){const c=h.getViewDescriptorById(_);(c==null?void 0:c.canMoveView)&&h.moveViewsToContainer([c],w,I.ViewVisibilityState.Default)}await s.get(I.IViewsService).openViewContainer(w.id,!0)}});class v{static execute(p,h){return!Array.isArray(h==null?void 0:h.viewIds)||typeof(h==null?void 0:h.destinationId)!="string"?Promise.reject("Invalid arguments"):p.executeCommand("_workbench.action.moveViews",h)}}e.MoveViewsAPICommand=v,v.ID="vscode.moveViews",k.CommandsRegistry.registerCommand({id:v.ID,handler:y(v.execute),description:{description:"Move Views",args:[]}});class m{static execute(p,h){return p.executeCommand("_workbench.open",h)}}m.ID="vscode.open",k.CommandsRegistry.registerCommand(m.ID,y(m.execute));class i{static execute(p,h,w,_,c){return p.executeCommand("_workbench.diff",[h,w,_])}}i.ID="vscode.diff",k.CommandsRegistry.registerCommand(i.ID,y(i.execute))}),define(be[168],we([0,1,3,13,138]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new E.Emitter,this._onExit=new E.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,y,n,R){const C={command:I};if(y&&Object.keys(y).length>0&&(C.arguments=y),this.internalSend("request",C),typeof R=="number"){const v=setTimeout(()=>{clearTimeout(v);const m=this.pendingRequests.get(C.seq);if(m){this.pendingRequests.delete(C.seq);const i={type:"response",seq:0,request_seq:C.seq,success:!1,command:I,message:(0,A.localize)(0,null,R,I)};m(i)}},R)}return n&&this.pendingRequests.set(C.seq,n),C.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,y){return I.type!=="event"||y.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,k.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":const y=I,n=this.pendingRequests.get(y.request_seq);n&&(this.pendingRequests.delete(y.request_seq),n(y));break}}}internalSend(I,y){y.type=I,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((y,n)=>I.set(n,y)),await(0,k.timeout)(500),I.forEach((y,n)=>{y({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(be[169],we([0,1,8,2,11,23,18]),function(ie,e,E,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function y(r,u,o){return r.replace(I,function(a,f){return u&&f.length>0&&f[0]!=="_"?a:o&&o.hasOwnProperty(f)?o[f]:a})}e.formatPII=y;function n(r){const u={};for(const o of Object.keys(r))o.startsWith("!")||(u[o]=r[o]);return u}e.filterExceptionsFromTelemetry=n;function R(r){return r.configuration.request==="attach"&&!C(r)}e.isSessionAttach=R;function C(r){let u=r.configuration.type;if(!!u)return u==="vslsShare"&&(u=r.configuration.adapterProxy.configuration.type),(0,E.equalsIgnoreCase)(u,"extensionhost")||(0,E.equalsIgnoreCase)(u,"pwa-extensionhost")?r:r.parentSession?C(r.parentSession):void 0}e.getExtensionHostDebugSession=C;function v(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=v;function m(r,u,o){let a,f=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,D=null;for(;D=b.exec(r);){let d=D.index+1,g=d+D[0].length;if(d<=u&&g>=o){a=D[0],f=d;break}}if(a){let d=/\w+/g,g=null;for(;(g=d.exec(a))&&!(g.index+1+f+g[0].length>=o););g&&(a=a.substring(0,d.lastIndex))}return a?{start:f,end:f+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function s(r){return!!(r&&r.match(i))}e.isUri=s;function p(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(s(r.path))return k.URI.parse(r.path);if((0,A.isAbsolute)(r.path))return k.URI.file(r.path)}return r.path}function h(r){if(typeof r.path=="object"){const u=k.URI.revive(r.path);if(u)return u.scheme===S.Schemas.file?u.fsPath:u.toString()}return r.path}function w(r,u){const o=u?p:h,a=(0,T.deepClone)(r);return c(a,(f,b)=>{f&&b&&(b.path=o(b))}),a}e.convertToDAPaths=w;function _(r,u){const o=u?p:h,a=(0,T.deepClone)(r);return c(a,(f,b)=>{!f&&b&&(b.path=o(b))}),a}e.convertToVSCPaths=_;function c(r,u){switch(r.type){case"event":const o=r;switch(o.event){case"output":u(!1,o.body.source);break;case"loadedSource":u(!1,o.body.source);break;case"breakpoint":u(!1,o.body.breakpoint.source);break;default:break}break;case"request":const a=r;switch(a.command){case"setBreakpoints":u(!0,a.arguments.source);break;case"breakpointLocations":u(!0,a.arguments.source);break;case"source":u(!0,a.arguments.source);break;case"gotoTargets":u(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(b=>u(!1,b));break;default:break}break;case"response":const f=r;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(b=>u(!1,b.source));break;case"loadedSources":f.body.sources.forEach(b=>u(!1,b));break;case"scopes":f.body.scopes.forEach(b=>u(!1,b.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(b=>u(!1,b.source));break;case"setBreakpoints":f.body.breakpoints.forEach(b=>u(!1,b.source));break;default:break}break}}function l(r){return r.filter(u=>{var o;return!((o=u.presentation)===null||o===void 0?void 0:o.hidden)}).sort((u,o)=>u.presentation?o.presentation?u.presentation.group?o.presentation.group?u.presentation.group!==o.presentation.group?u.presentation.group.localeCompare(o.presentation.group):t(u.presentation.order,o.presentation.order):-1:o.presentation.group?1:t(u.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=l;function t(r,u){return typeof r!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:r-u}}),define(be[70],we([0,1,28,18,11,21,63]),function(ie,e,E,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var I;(function(P){P[P.Markdown=1]="Markdown",P[P.Code=2]="Code"})(I=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(P){P[P.Running=1]="Running",P[P.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,cellEditable:!0,cellHasExecutionOrder:!0,custom:{},trusted:!0};var n;(function(P){P[P.Idle=1]="Idle",P[P.Pending=2]="Pending",P[P.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var R;(function(P){P[P.ModelChange=1]="ModelChange",P[P.Move=2]="Move",P[P.CellClearOutput=3]="CellClearOutput",P[P.CellsClearOutput=4]="CellsClearOutput",P[P.ChangeLanguage=5]="ChangeLanguage",P[P.Initialize=6]="Initialize",P[P.ChangeCellMetadata=7]="ChangeCellMetadata",P[P.Output=8]="Output",P[P.OutputItem=9]="OutputItem",P[P.ChangeCellContent=10]="ChangeCellContent",P[P.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",P[P.Unknown=12]="Unknown"})(R=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var C;(function(P){P[P.Handle=0]="Handle",P[P.Index=1]="Index"})(C=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(P){P[P.Replace=1]="Replace",P[P.Output=2]="Output",P[P.Metadata=3]="Metadata",P[P.CellLanguage=4]="CellLanguage",P[P.DocumentMetadata=5]="DocumentMetadata",P[P.OutputsSplice=6]="OutputsSplice",P[P.Move=7]="Move",P[P.Unknown=8]="Unknown",P[P.CellContent=9]="CellContent",P[P.OutputItems=10]="OutputItems",P[P.PartialMetadata=11]="PartialMetadata"})(v=e.CellEditType||(e.CellEditType={}));function m(P){const F=i.parse(P);return F?F.notebook.toString():P.toString()}e.getCellUndoRedoComparisonKey=m;var i;(function(P){P.scheme=k.Schemas.vscodeNotebookCell;const F=/^ch(\d{7,})/;function z(K,L){return K.with({scheme:P.scheme,fragment:`ch${L.toString().padStart(7,"0")}${K.scheme!==k.Schemas.file?K.scheme:""}`})}P.generate=z;function de(K){if(K.scheme===P.scheme){const L=F.exec(K.fragment);if(!!L)return{handle:Number(L[1]),notebook:K.with({scheme:K.fragment.substr(L[0].length)||k.Schemas.file,fragment:null})}}}P.parse=de;function W(K,L){return K.with({scheme:k.Schemas.vscodeNotebookCellMetadata,fragment:`ch${L.toString().padStart(7,"0")}${K.scheme!==k.Schemas.file?K.scheme:""}`})}P.generateCellMetadataUri=W;function B(K){if(K.scheme===k.Schemas.vscodeNotebookCellMetadata){const L=F.exec(K.fragment);if(!!L)return{handle:Number(L[1]),notebook:K.with({scheme:K.fragment.substr(L[0].length)||k.Schemas.file,fragment:null})}}}P.parseCellMetadataUri=B})(i=e.CellUri||(e.CellUri={}));const s=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function p(P){var F,z;return(z=(F=s.get(P))===null||F===void 0?void 0:F.alwaysSecure)!==null&&z!==void 0?z:!1}e.mimeTypeIsAlwaysSecure=p;function h(P){var F,z;return(z=(F=s.get(P))===null||F===void 0?void 0:F.supportedByCore)!==null&&z!==void 0?z:!1}e.mimeTypeSupportedByCore=h;function w(P){var F,z;return(z=(F=s.get(P))===null||F===void 0?void 0:F.mergeable)!==null&&z!==void 0?z:!1}e.mimeTypeIsMergeable=w;function _(P,F){return T.isWindows&&(P=P.replace(/\//g,"\\"),F=F.replace(/\//g,"\\")),E.match(P,F)}function c(P,F,z){let de=0;for(let W=0;W<F.length;W++){if(_(F[W],P))return de;de++}for(let W=0;W<z.length;W++){if(_(z[W],P))return de;de++}return de}function l(P,F,z){return P.sort((de,W)=>c(de,F,z)-c(W,F,z))}e.sortMimeTypes=l;function t(P,F,z,de=(W,B)=>W===B){const W=[];function B(U,x,Q){if(!(x===0&&Q.length===0)){const $=W[W.length-1];$&&$.start+$.deleteCount===U?($.deleteCount+=x,$.toInsert.push(...Q)):W.push({start:U,deleteCount:x,toInsert:Q})}}let K=0,L=0;for(;;){if(K===P.length){B(K,0,F.slice(L));break}if(L===F.length){B(K,P.length-K,[]);break}const U=P[K],x=F[L];if(de(U,x)){K+=1,L+=1;continue}z(x)?(B(K,1,[]),K+=1):(B(K,0,[x]),L+=1)}return W}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new S.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var r;(function(P){P.default="default",P.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(P){const F=P;return!!((typeof F.include=="string"||E.isRelativePattern(F.include))&&(typeof F.exclude=="string"||E.isRelativePattern(F.exclude)))}e.isDocumentExcludePattern=u;function o(P,F,z){if(Array.isArray(P.viewType)&&P.viewType.indexOf(F)>=0||P.viewType===F)return!0;if(P.filenamePattern){let de=u(P.filenamePattern)?P.filenamePattern.include:P.filenamePattern,W=u(P.filenamePattern)?P.filenamePattern.exclude:void 0;if(E.match(de,(0,A.basename)(z.fsPath).toLowerCase()))return!(W&&E.match(W,(0,A.basename)(z.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class a{constructor(F){this.textModel=F}getElements(){const F=new Int32Array(this.textModel.cells.length);for(let z=0;z<this.textModel.cells.length;z++)F[z]=this.textModel.cells[z].getHashValue();return F}}e.CellSequence=a,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var f;(function(P){P[P.LEFT=0]="LEFT",P[P.RIGHT=1]="RIGHT"})(f=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function b(P){P.sort((z,de)=>z-de);const F=P.shift();return F===void 0?[]:P.reduce(function(z,de){return de<=z[0][1]?z[0][1]=de+1:z.unshift([de,de+1]),z},[[F,F+1]]).reverse().map(z=>({start:z[0],end:z[1]}))}e.cellIndexesToRanges=b;function D(P){return P.reduce((z,de)=>{for(let W=de.start;W<de.end;W++)z.push(W);return z},[])}e.cellRangesToIndexes=D;function d(P){const F=P.sort((de,W)=>de.start-W.start),z=F[0];return z?F.reduce((de,W)=>{const B=de[de.length-1];return B.end>=W.start?B.end=Math.max(B.end,W.end):de.push(W),de},[z]):[]}e.reduceRanges=d;function g(P,F){return F.start>=P.start&&F.end<=P.end}e.cellRangeContains=g}),define(be[170],we([0,1,140,4,63]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new A.RawContextKey("customExecutionSupported",!0,E.localize(0,null)),e.ShellExecutionSupportedContext=new A.RawContextKey("shellExecutionSupported",!1,E.localize(1,null)),e.ProcessExecutionSupportedContext=new A.RawContextKey("processExecutionSupported",!1,E.localize(2,null)),e.ITaskService=(0,k.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[171],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function E(A){return[...A.entries()]}e.serializeEnvironmentVariableCollection=E;function k(A){return new Map(A)}e.deserializeEnvironmentVariableCollection=k}),define(be[95],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var E;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(y,n)=>{n.expand!==void 0&&(y.expand=n.expand),n.item!==void 0&&Object.assign(y.item,n.item)};e.applyTestItemUpdate=k;var A;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.DeltaRootsComplete=3]="DeltaRootsComplete",y[y.Retire=4]="Retire"})(A=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(y,n)=>`${y}:${n.toString()}`;e.getTestSubscriptionKey=T;class S{add(n){}update(n){}remove(n,R){}complete(){}}e.IncrementalChangeCollector=S;class I{constructor(){this.items=new Map,this.roots=new Set,this.busyProviderCount=0,this.pendingRootCount=0}apply(n){const R=this.createChangeCollector();for(const C of n)switch(C[0]){case 0:{const v=C[1];if(v.parent){if(this.items.has(v.parent)){const m=this.items.get(v.parent);m.children.add(v.item.extId);const i=this.createItem(v,m);this.items.set(v.item.extId,i),R.add(i)}}else{this.roots.add(v.item.extId);const m=this.createItem(v);this.items.set(v.item.extId,m),R.add(m)}v.expand===2&&this.updateBusyProviders(1);break}case 1:{const v=C[1],m=this.items.get(v.extId);if(!m)break;(0,e.applyTestItemUpdate)(m,v),R.update(m),v.expand!==void 0&&m.expand===2&&v.expand!==2&&this.updateBusyProviders(-1);break}case 2:{const v=this.items.get(C[1]);if(!v)break;v.parent?this.items.get(v.parent).children.delete(v.item.extId):this.roots.delete(v.item.extId);const m=[[C[1]]];for(;m.length;)for(const i of m.pop()){const s=this.items.get(i);s&&(m.push(s.children),this.items.delete(i),R.remove(s,s!==v),s.expand===2&&this.updateBusyProviders(-1))}break}case 4:this.retireTest(C[1]);break;case 3:this.updatePendingRoots(C[1]);break}R.complete()}retireTest(n){}updateBusyProviders(n){this.busyProviderCount+=n}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new S}}e.AbstractIncrementalTestCollection=I}),define(be[172],we([0,1,11,45,12,23,21,58,141]),function(ie,e,E,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(C,v,m,i){if(this._contributedVariables=new Map,this._context=C,this._labelService=v,m)if(S.isWindows){const s=Object.create(null);this._envVariables=s,Object.keys(m).forEach(p=>{s[p.toLowerCase()]=m[p]})}else this._envVariables=m}resolveWithEnvironment(C,v,m){return this.recursiveResolve(C,v?v.uri:void 0,m)}async resolveAsync(C,v){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,v)}resolve(C,v){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,v)}resolveAnyBase(C,v,m,i){const s=T.deepClone(v);return S.isWindows&&s.windows?Object.keys(s.windows).forEach(p=>s[p]=s.windows[p]):S.isMacintosh&&s.osx?Object.keys(s.osx).forEach(p=>s[p]=s.osx[p]):S.isLinux&&s.linux&&Object.keys(s.linux).forEach(p=>s[p]=s.linux[p]),delete s.windows,delete s.osx,delete s.linux,this.recursiveResolve(this._envVariables,C?C.uri:void 0,s,m,i)}resolveAny(C,v,m){return this.resolveAnyBase(C,v,m)}async resolveAnyAsync(C,v,m){return this.resolveAnyBase(C,v,m)}resolveAnyMap(C,v,m){const i=new Map;return{newConfig:this.resolveAnyBase(C,v,m,i),resolvedVariables:i}}resolveWithInteractionReplace(C,v,m,i){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,v,m,i){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,v){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,v)}recursiveResolve(C,v,m,i,s){if(A.isString(m))return this.resolveString(C,v,m,i,s);if(A.isArray(m))return m.map(p=>this.recursiveResolve(C,v,p,i,s));if(A.isObject(m)){let p=Object.create(null);return Object.keys(m).forEach(h=>{const w=this.resolveString(C,v,h,i,s);p[w]=this.recursiveResolve(C,v,m[h],i,s)}),p}return m}resolveString(C,v,m,i,s){return m.replace(n.VARIABLE_REGEXP,(h,w)=>{if(w.includes(n.VARIABLE_LHS))return h;let _=this.evaluateSingleVariable(C,h,w,v,i);return s&&s.set(w,_),_})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,v,m,i,s){let p;const h=m.split(":");h.length>1&&(m=h[0],p=h[1]);const w=()=>{const l=this._context.getFilePath();if(l)return l;throw new Error((0,y.localize)(0,null,v))},_=()=>{const l=w();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,v,E.basename(l)))},c=()=>{if(p){const l=this._context.getFolderUri(p);if(l)return l;throw new Error((0,y.localize)(2,null,v,p))}if(i)return i;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,v)):new Error((0,y.localize)(4,null,v))};switch(m){case"env":if(p){if(C){const l=C[S.isWindows?p.toLowerCase():p];if(A.isString(l))return l}return""}throw new Error((0,y.localize)(5,null,v));case"config":if(p){const l=this._context.getConfigurationValue(i,p);if(A.isUndefinedOrNull(l))throw new Error((0,y.localize)(6,null,v,p));if(A.isObject(l))throw new Error((0,y.localize)(7,null,v,p));return l}throw new Error((0,y.localize)(8,null,v));case"command":return this.resolveFromMap(v,p,s,"command");case"input":return this.resolveFromMap(v,p,s,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return i||p?(0,I.normalizeDriveLetter)(this.fsPath(c())):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return E.basename(this.fsPath(c()));case"lineNumber":const l=this._context.getLineNumber();if(l)return l;throw new Error((0,y.localize)(9,null,v));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,v));case"file":return w();case"fileWorkspaceFolder":return _();case"relativeFile":return i||p?E.relative(this.fsPath(c()),w()):w();case"relativeFileDirname":const r=E.dirname(w());if(i||p){const f=E.relative(this.fsPath(c()),r);return f.length===0?".":f}return r;case"fileDirname":return E.dirname(w());case"fileExtname":return E.extname(w());case"fileBasename":return E.basename(w());case"fileBasenameNoExtension":const u=E.basename(w());return u.slice(0,u.length-E.extname(u).length);case"fileDirnameBasename":return E.basename(E.dirname(w()));case"execPath":const o=this._context.getExecPath();return o||v;case"execInstallFolder":const a=this._context.getAppRoot();return a||v;case"pathSeparator":return E.sep;default:try{const f=p?`${m}:${p}`:m;return this.resolveFromMap(v,f,s,void 0)}catch(f){return v}}}}resolveFromMap(C,v,m,i){if(v&&m){const s=i===void 0?m[v]:m[i+":"+v];if(typeof s=="string")return s;throw new Error((0,y.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[173],we([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,E.createDecorator)("editorGroupsService");var k;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var A;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var S;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(S=e.GroupsArrangement||(e.GroupsArrangement={}));var I;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(I=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(v){v[v.GROUP_ACTIVE=0]="GROUP_ACTIVE",v[v.GROUP_INDEX=1]="GROUP_INDEX",v[v.EDITOR_OPEN=2]="EDITOR_OPEN",v[v.EDITOR_CLOSE=3]="EDITOR_CLOSE",v[v.EDITOR_MOVE=4]="EDITOR_MOVE",v[v.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",v[v.EDITOR_LABEL=6]="EDITOR_LABEL",v[v.EDITOR_PIN=7]="EDITOR_PIN",v[v.EDITOR_STICKY=8]="EDITOR_STICKY",v[v.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var R;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(R=e.OpenEditorContext||(e.OpenEditorContext={}));function C(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(be[174],we([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,E.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(be[9],we([0,1,15,80,227,57,23,12,2,32,62,142,87,70,174,7]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookDocumentContentOptions=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var p;(function(ue){function De(j){const{selectionStartLineNumber:Ae,selectionStartColumn:Te,positionLineNumber:Ye,positionColumn:Ge}=j,rt=new s.Position(Ae-1,Te-1),at=new s.Position(Ye-1,Ge-1);return new s.Selection(rt,at)}ue.to=De;function le(j){const{anchor:Ae,active:Te}=j;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}ue.from=le})(p=e.Selection||(e.Selection={}));var h;(function(ue){function De(j){if(!!j){const{start:Ae,end:Te}=j;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}}ue.from=De;function le(j){if(!!j){const{startLineNumber:Ae,startColumn:Te,endLineNumber:Ye,endColumn:Ge}=j;return new s.Range(Ae-1,Te-1,Ye-1,Ge-1)}}ue.to=le})(h=e.Range||(e.Range={}));var w;(function(ue){function De(le){switch(le){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 4:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}ue.to=De})(w=e.TokenType||(e.TokenType={}));var _;(function(ue){function De(j){return new s.Position(j.lineNumber-1,j.column-1)}ue.to=De;function le(j){return{lineNumber:j.line+1,column:j.character+1}}ue.from=le})(_=e.Position||(e.Position={}));var c;(function(ue){function De(j){switch(j){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}ue.from=De;function le(j){switch(j){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}ue.to=le})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var l;(function(ue){function De(j){let Ae;return j.code&&((0,I.isString)(j.code)||(0,I.isNumber)(j.code)?Ae=String(j.code):Ae={value:String(j.code.value),target:j.code.target}),Object.assign(Object.assign({},h.from(j.range)),{message:j.message,source:j.source,code:Ae,severity:r.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(t.from),tags:Array.isArray(j.tags)?(0,E.coalesce)(j.tags.map(c.from)):void 0})}ue.from=De;function le(j){var Ae;const Te=new s.Diagnostic(h.to(j),j.message,r.to(j.severity));return Te.source=j.source,Te.code=(0,I.isString)(j.code)?j.code:(Ae=j.code)===null||Ae===void 0?void 0:Ae.value,Te.relatedInformation=j.relatedInformation&&j.relatedInformation.map(t.to),Te.tags=j.tags&&(0,E.coalesce)(j.tags.map(c.to)),Te}ue.to=le})(l=e.Diagnostic||(e.Diagnostic={}));var t;(function(ue){function De(j){return Object.assign(Object.assign({},h.from(j.location.range)),{message:j.message,resource:j.location.uri})}ue.from=De;function le(j){return new s.DiagnosticRelatedInformation(new s.Location(j.resource,h.to(j)),j.message)}ue.to=le})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var r;(function(ue){function De(j){switch(j){case s.DiagnosticSeverity.Error:return v.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return v.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return v.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return v.MarkerSeverity.Hint}return v.MarkerSeverity.Error}ue.from=De;function le(j){switch(j){case v.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case v.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case v.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case v.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}ue.to=le})(r=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var u;(function(ue){function De(j){return typeof j=="number"&&j>=s.ViewColumn.One?j-1:j===s.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}ue.from=De;function le(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}ue.to=le})(u=e.ViewColumn||(e.ViewColumn={}));function o(ue){return typeof ue.range!="undefined"}function a(ue){return ue.length===0?!0:!!o(ue[0])}e.isDecorationOptionsArr=a;var f;(function(ue){function De(Ge){return Ge.map(ue.from)}ue.fromMany=De;function le(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function j(Ge){let rt;if(le(Ge)){const{language:st,value:gt}=Ge;rt={value:"```"+st+`
`+gt+"\n```\n"}}else s.MarkdownString.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const at=Object.create(null);rt.uris=at;const Qe=st=>{try{let gt=y.URI.parse(st,!0);gt=gt.with({query:Ae(gt.query,at)}),at[st]=gt}catch(gt){}return""},ut=new A.Renderer;return ut.link=Qe,ut.image=st=>Qe(k.parseHrefAndDimensions(st).href),A(rt.value,{renderer:ut}),rt}ue.from=j;function Ae(Ge,rt){if(!Ge)return Ge;let at;try{at=(0,T.parse)(Ge)}catch(ut){}if(!at)return Ge;let Qe=!1;return at=(0,S.cloneAndChange)(at,ut=>{if(y.URI.isUri(ut)){const st=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[st]=ut,Qe=!0,st}else return}),Qe?JSON.stringify(at):Ge}function Te(Ge){const rt=new s.MarkdownString(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt}ue.to=Te;function Ye(Ge){if(!!Ge)return typeof Ge=="string"?Ge:ue.from(Ge)}ue.fromStrict=Ye})(f=e.MarkdownString||(e.MarkdownString={}));function b(ue){return a(ue)?ue.map(De=>({range:h.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?f.fromMany(De.hoverMessage):De.hoverMessage?f.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):ue.map(De=>({range:h.from(De)}))}e.fromRangeOrRangeWithMessage=b;function D(ue){return typeof ue=="undefined"?ue:typeof ue=="string"?y.URI.file(ue):ue}e.pathOrURIToURI=D;var d;(function(ue){function De(le){return typeof le=="undefined"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?D(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}ue.from=De})(d=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var g;(function(ue){function De(le){return typeof le=="undefined"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?D(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?d.from(le.before):void 0,after:le.after?d.from(le.after):void 0}}ue.from=De})(g=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var P;(function(ue){function De(le){if(typeof le=="undefined")return le;switch(le){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}ue.from=De})(P=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var F;(function(ue){function De(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?P.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?g.from(le.light):void 0,dark:le.dark?g.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?D(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?d.from(le.before):void 0,after:le.after?d.from(le.after):void 0}}ue.from=De})(F=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(ue){function De(j){return{text:j.newText,eol:j.newEol&&X.from(j.newEol),range:h.from(j.range)}}ue.from=De;function le(j){const Ae=new s.TextEdit(h.to(j.range),j.text);return Ae.newEol=typeof j.eol=="undefined"?void 0:X.to(j.eol),Ae}ue.to=le})(z=e.TextEdit||(e.TextEdit={}));var de;(function(ue){function De(j,Ae,Te){var Ye,Ge,rt;const at={edits:[]};if(j instanceof s.WorkspaceEdit)for(let Qe of j._allEntries())if(Qe._type===1)at.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata});else if(Qe._type===2){const ut=Ae==null?void 0:Ae.getDocument(Qe.uri);at.edits.push({_type:2,resource:Qe.uri,edit:z.from(Qe.edit),modelVersionId:ut==null?void 0:ut.version,metadata:Qe.metadata})}else Qe._type===3?at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:(Ye=Te==null?void 0:Te.lookupNotebookDocument(Qe.uri))===null||Ye===void 0?void 0:Ye.notebookDocument.version}):Qe._type===4?(Qe.newOutputs&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:2,index:Qe.index,append:Qe.append,outputs:Qe.newOutputs.map(We.from)}}),Qe.newMetadata&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:11,index:Qe.index,metadata:Qe.newMetadata}})):Qe._type===5?at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:(Ge=Te==null?void 0:Te.lookupNotebookDocument(Qe.uri))===null||Ge===void 0?void 0:Ge.notebookDocument.version,edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(fe.from)}}):Qe._type===6&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:10,outputId:Qe.outputId,items:((rt=Qe.newOutputItems)===null||rt===void 0?void 0:rt.map(pe.from))||[],append:Qe.append}});return at}ue.from=De;function le(j){const Ae=new s.WorkspaceEdit;for(const Te of j.edits)Te.edit?Ae.replace(y.URI.revive(Te.resource),h.to(Te.edit.range),Te.edit.text):Ae.renameFile(y.URI.revive(Te.oldUri),y.URI.revive(Te.newUri),Te.options);return Ae}ue.to=le})(de=e.WorkspaceEdit||(e.WorkspaceEdit={}));var W;(function(ue){const De=Object.create(null);De[s.SymbolKind.File]=0,De[s.SymbolKind.Module]=1,De[s.SymbolKind.Namespace]=2,De[s.SymbolKind.Package]=3,De[s.SymbolKind.Class]=4,De[s.SymbolKind.Method]=5,De[s.SymbolKind.Property]=6,De[s.SymbolKind.Field]=7,De[s.SymbolKind.Constructor]=8,De[s.SymbolKind.Enum]=9,De[s.SymbolKind.Interface]=10,De[s.SymbolKind.Function]=11,De[s.SymbolKind.Variable]=12,De[s.SymbolKind.Constant]=13,De[s.SymbolKind.String]=14,De[s.SymbolKind.Number]=15,De[s.SymbolKind.Boolean]=16,De[s.SymbolKind.Array]=17,De[s.SymbolKind.Object]=18,De[s.SymbolKind.Key]=19,De[s.SymbolKind.Null]=20,De[s.SymbolKind.EnumMember]=21,De[s.SymbolKind.Struct]=22,De[s.SymbolKind.Event]=23,De[s.SymbolKind.Operator]=24,De[s.SymbolKind.TypeParameter]=25;function le(Ae){return typeof De[Ae]=="number"?De[Ae]:6}ue.from=le;function j(Ae){for(const Te in De)if(De[Te]===Ae)return Number(Te);return s.SymbolKind.Property}ue.to=j})(W=e.SymbolKind||(e.SymbolKind={}));var B;(function(ue){function De(j){switch(j){case s.SymbolTag.Deprecated:return 1}}ue.from=De;function le(j){switch(j){case 1:return s.SymbolTag.Deprecated}}ue.to=le})(B=e.SymbolTag||(e.SymbolTag={}));var K;(function(ue){function De(j){return{name:j.name,kind:W.from(j.kind),tags:j.tags&&j.tags.map(B.from),containerName:j.containerName,location:$.from(j.location)}}ue.from=De;function le(j){const Ae=new s.SymbolInformation(j.name,W.to(j.kind),j.containerName,$.to(j.location));return Ae.tags=j.tags&&j.tags.map(B.to),Ae}ue.to=le})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var L;(function(ue){function De(j){var Ae,Te;const Ye={name:j.name||"!!MISSING: name!!",detail:j.detail,range:h.from(j.range),selectionRange:h.from(j.selectionRange),kind:W.from(j.kind),tags:(Te=(Ae=j.tags)===null||Ae===void 0?void 0:Ae.map(B.from))!==null&&Te!==void 0?Te:[]};return j.children&&(Ye.children=j.children.map(De)),Ye}ue.from=De;function le(j){const Ae=new s.DocumentSymbol(j.name,j.detail,W.to(j.kind),h.to(j.range),h.to(j.selectionRange));return(0,E.isNonEmptyArray)(j.tags)&&(Ae.tags=j.tags.map(B.to)),j.children&&(Ae.children=j.children.map(le)),Ae}ue.to=le})(L=e.DocumentSymbol||(e.DocumentSymbol={}));var U;(function(ue){function De(le){const j=new s.CallHierarchyItem(W.to(le.kind),le.name,le.detail||"",y.URI.revive(le.uri),h.to(le.range),h.to(le.selectionRange));return j._sessionId=le._sessionId,j._itemId=le._itemId,j}ue.to=De})(U=e.CallHierarchyItem||(e.CallHierarchyItem={}));var x;(function(ue){function De(le){return new s.CallHierarchyIncomingCall(U.to(le.from),le.fromRanges.map(j=>h.to(j)))}ue.to=De})(x=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Q;(function(ue){function De(le){return new s.CallHierarchyOutgoingCall(U.to(le.to),le.fromRanges.map(j=>h.to(j)))}ue.to=De})(Q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var $;(function(ue){function De(j){return{range:j.range&&h.from(j.range),uri:j.uri}}ue.from=De;function le(j){return new s.Location(y.URI.revive(j.uri),h.to(j.range))}ue.to=le})($=e.location||(e.location={}));var ee;(function(ue){function De(j){const Ae=j,Te=j;return{originSelectionRange:Ae.originSelectionRange?h.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Te.uri,range:h.from(Ae.targetRange?Ae.targetRange:Te.range),targetSelectionRange:Ae.targetSelectionRange?h.from(Ae.targetSelectionRange):void 0}}ue.from=De;function le(j){return{targetUri:y.URI.revive(j.uri),targetRange:h.to(j.range),targetSelectionRange:j.targetSelectionRange?h.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?h.to(j.originSelectionRange):void 0}}ue.to=le})(ee=e.DefinitionLink||(e.DefinitionLink={}));var re;(function(ue){function De(j){return{range:h.from(j.range),contents:f.fromMany(j.contents)}}ue.from=De;function le(j){return new s.Hover(j.contents.map(f.to),h.to(j.range))}ue.to=le})(re=e.Hover||(e.Hover={}));var se;(function(ue){function De(j){return{range:h.from(j.range),expression:j.expression}}ue.from=De;function le(j){return new s.EvaluatableExpression(h.to(j.range),j.expression)}ue.to=le})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(ue){function De(j){if(j instanceof s.InlineValueText)return{type:"text",range:h.from(j.range),text:j.text};if(j instanceof s.InlineValueVariableLookup)return{type:"variable",range:h.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:h.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}ue.from=De;function le(j){switch(j.type){case"text":return{range:h.to(j.range),text:j.text};case"variable":return{range:h.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:h.to(j.range),expression:j.expression}}}ue.to=le})(ye=e.InlineValue||(e.InlineValue={}));var Ie;(function(ue){function De(j){return{frameId:j.frameId,stoppedLocation:h.from(j.stoppedLocation)}}ue.from=De;function le(j){return new s.InlineValueContext(j.frameId,h.to(j.stoppedLocation))}ue.to=le})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var xe;(function(ue){function De(j){return{range:h.from(j.range),kind:j.kind}}ue.from=De;function le(j){return new s.DocumentHighlight(h.to(j.range),j.kind)}ue.to=le})(xe=e.DocumentHighlight||(e.DocumentHighlight={}));var Fe;(function(ue){function De(le){switch(le){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}ue.to=De})(Fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(ue){function De(le){return{triggerKind:Fe.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}ue.to=De})(ze=e.CompletionContext||(e.CompletionContext={}));var N;(function(ue){function De(j){switch(j){case s.CompletionItemTag.Deprecated:return 1}}ue.from=De;function le(j){switch(j){case 1:return s.CompletionItemTag.Deprecated}}ue.to=le})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var G;(function(ue){const De=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function le(Te){var Ye;return(Ye=De.get(Te))!==null&&Ye!==void 0?Ye:9}ue.from=le;const j=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Ae(Te){var Ye;return(Ye=j.get(Te))!==null&&Ye!==void 0?Ye:s.CompletionItemKind.Property}ue.to=Ae})(G=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(ue){function De(le,j){var Ae;const Te=new s.CompletionItem(typeof le.label=="string"?le.label:le.label.name);return typeof le.label!="string"&&(Te.label2=le.label),Te.insertText=le.insertText,Te.kind=G.to(le.kind),Te.tags=(Ae=le.tags)===null||Ae===void 0?void 0:Ae.map(N.to),Te.detail=le.detail,Te.documentation=k.isMarkdownString(le.documentation)?f.to(le.documentation):le.documentation,Te.sortText=le.sortText,Te.filterText=le.filterText,Te.preselect=le.preselect,Te.commitCharacters=le.commitCharacters,n.Range.isIRange(le.range)?Te.range=h.to(le.range):typeof le.range=="object"&&(Te.range={inserting:h.to(le.range.insert),replacing:h.to(le.range.replace)}),Te.keepWhitespace=typeof le.insertTextRules=="undefined"?!1:Boolean(le.insertTextRules&1),typeof le.insertTextRules!="undefined"&&le.insertTextRules&4?Te.insertText=new s.SnippetString(le.insertText):(Te.insertText=le.insertText,Te.textEdit=Te.range instanceof s.Range?new s.TextEdit(Te.range,Te.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Te.additionalTextEdits=le.additionalTextEdits.map(Ye=>z.to(Ye))),Te.command=j&&le.command?j.fromInternal(le.command):void 0,Te}ue.to=De})(te=e.CompletionItem||(e.CompletionItem={}));var ae;(function(ue){function De(j){return{label:j.label,documentation:j.documentation?f.fromStrict(j.documentation):void 0}}ue.from=De;function le(j){return{label:j.label,documentation:k.isMarkdownString(j.documentation)?f.to(j.documentation):j.documentation}}ue.to=le})(ae=e.ParameterInformation||(e.ParameterInformation={}));var me;(function(ue){function De(j){return{label:j.label,documentation:j.documentation?f.fromStrict(j.documentation):void 0,parameters:Array.isArray(j.parameters)?j.parameters.map(ae.from):[],activeParameter:j.activeParameter}}ue.from=De;function le(j){return{label:j.label,documentation:k.isMarkdownString(j.documentation)?f.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(ae.to):[],activeParameter:j.activeParameter}}ue.to=le})(me=e.SignatureInformation||(e.SignatureInformation={}));var Se;(function(ue){function De(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(me.from):[]}}ue.from=De;function le(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(me.to):[]}}ue.to=le})(Se=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(ue){function De(j){var Ae;return{text:j.text,range:h.from(j.range),kind:ge.from((Ae=j.kind)!==null&&Ae!==void 0?Ae:s.InlineHintKind.Other),description:j.description&&f.fromStrict(j.description),whitespaceBefore:j.whitespaceBefore,whitespaceAfter:j.whitespaceAfter}}ue.from=De;function le(j){const Ae=new s.InlineHint(j.text,h.to(j.range),ge.to(j.kind));return Ae.whitespaceAfter=j.whitespaceAfter,Ae.whitespaceBefore=j.whitespaceBefore,Ae.description=k.isMarkdownString(j.description)?f.to(j.description):j.description,Ae}ue.to=le})(Me=e.InlineHint||(e.InlineHint={}));var ge;(function(ue){function De(j){return j}ue.from=De;function le(j){return j}ue.to=le})(ge=e.InlineHintKind||(e.InlineHintKind={}));var Ce;(function(ue){function De(j){return{range:h.from(j.range),url:j.target,tooltip:j.tooltip}}ue.from=De;function le(j){let Ae;if(j.url)try{Ae=typeof j.url=="string"?y.URI.parse(j.url,!0):y.URI.revive(j.url)}catch(Te){}return new s.DocumentLink(h.to(j.range),Ae)}ue.to=le})(Ce=e.DocumentLink||(e.DocumentLink={}));var Pe;(function(ue){function De(j){const Ae=new s.ColorPresentation(j.label);return j.textEdit&&(Ae.textEdit=z.to(j.textEdit)),j.additionalTextEdits&&(Ae.additionalTextEdits=j.additionalTextEdits.map(Te=>z.to(Te))),Ae}ue.to=De;function le(j){return{label:j.label,textEdit:j.textEdit?z.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(Ae=>z.from(Ae)):void 0}}ue.from=le})(Pe=e.ColorPresentation||(e.ColorPresentation={}));var $e;(function(ue){function De(j){return new s.Color(j[0],j[1],j[2],j[3])}ue.to=De;function le(j){return[j.red,j.green,j.blue,j.alpha]}ue.from=le})($e=e.Color||(e.Color={}));var _e;(function(ue){function De(j){return{range:h.from(j.range)}}ue.from=De;function le(j){return new s.SelectionRange(h.to(j.range))}ue.to=le})(_e=e.SelectionRange||(e.SelectionRange={}));var qe;(function(ue){function De(le){switch(le){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}ue.to=De})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var V;(function(ue){function De(j){switch(j){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}ue.from=De;function le(j){switch(j){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}ue.to=le})(V=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var X;(function(ue){function De(j){if(j===s.EndOfLine.CRLF)return 1;if(j===s.EndOfLine.LF)return 0}ue.from=De;function le(j){if(j===1)return s.EndOfLine.CRLF;if(j===0)return s.EndOfLine.LF}ue.to=le})(X=e.EndOfLine||(e.EndOfLine={}));var ve;(function(ue){function De(le){if(typeof le=="object")return le.viewId;switch(le){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ue.from=De})(ve=e.ProgressLocation||(e.ProgressLocation={}));var Le;(function(ue){function De(le){const j={start:le.start+1,end:le.end+1};return le.kind&&(j.kind=He.from(le.kind)),j}ue.from=De})(Le=e.FoldingRange||(e.FoldingRange={}));var He;(function(ue){function De(le){if(le)switch(le){case s.FoldingRangeKind.Comment:return R.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return R.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return R.FoldingRangeKind.Region}}ue.from=De})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Oe;(function(ue){function De(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?h.from(le.selection):void 0,override:typeof le.override=="boolean"?C.EditorOverride.DISABLED:void 0}}ue.from=De})(Oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var et;(function(ue){function De(j){return j instanceof s.RelativePattern||typeof j=="string"?j:le(j)?new s.RelativePattern(j.base,j.pattern):j}ue.from=De;function le(j){const Ae=j;return Ae&&typeof Ae.base=="string"&&typeof Ae.pattern=="string"}})(et=e.GlobPattern||(e.GlobPattern={}));var H;(function(ue){function De(le){if(le){if(Array.isArray(le))return le.map(De);if(typeof le=="string")return le;{const j=le;return{language:j.language,scheme:j.scheme,pattern:typeof j.pattern=="undefined"?void 0:et.from(j.pattern),exclusive:j.exclusive}}}else return}ue.from=De})(H=e.LanguageSelector||(e.LanguageSelector={}));var ne;(function(ue){function De(j){return{start:j.start,end:j.end}}ue.from=De;function le(j){return new s.NotebookCellRange(j.start,j.end)}ue.to=le})(ne=e.NotebookCellRange||(e.NotebookCellRange={}));var he;(function(ue){function De(le){return new s.NotebookCellMetadata(le.editable,le.breakpointMargin,le.hasExecutionOrder,le.statusMessage,le.inputCollapsed,le.outputCollapsed,le.custom)}ue.to=De})(he=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var q;(function(ue){function De(j){return j}ue.from=De;function le(j){return new s.NotebookDocumentMetadata(j.editable,j.cellEditable,j.cellHasExecutionOrder,j.custom,j.trusted)}ue.to=le})(q=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var J;(function(ue){function De(j){return{duration:j.lastRunDuration,executionOrder:j.executionOrder,success:j.lastRunSuccess}}ue.to=De;function le(j){return{lastRunSuccess:j.success,lastRunDuration:j.duration,executionOrder:j.executionOrder}}ue.from=le})(J=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var oe;(function(ue){function De(j){switch(j){case s.NotebookCellKind.Markdown:return m.CellKind.Markdown;case s.NotebookCellKind.Code:default:return m.CellKind.Code}}ue.from=De;function le(j){switch(j){case m.CellKind.Markdown:return s.NotebookCellKind.Markdown;case m.CellKind.Code:default:return s.NotebookCellKind.Code}}ue.to=le})(oe=e.NotebookCellKind||(e.NotebookCellKind={}));var fe;(function(ue){function De(j){var Ae;return{cellKind:oe.from(j.kind),language:j.language,source:j.source,metadata:Object.assign(Object.assign({},j.metadata),J.from((Ae=j.latestExecutionSummary)!==null&&Ae!==void 0?Ae:{})),outputs:j.outputs?j.outputs.map(We.from):[]}}ue.from=De;function le(j){return new s.NotebookCellData(oe.to(j.cellKind),j.source,j.language,j.outputs?j.outputs.map(We.to):void 0,j.metadata?he.to(j.metadata):void 0)}ue.to=le})(fe=e.NotebookCellData||(e.NotebookCellData={}));var pe;(function(ue){function De(j){return{mime:j.mime,value:j.value,metadata:j.metadata}}ue.from=De;function le(j){return new s.NotebookCellOutputItem(j.mime,j.value,j.metadata)}ue.to=le})(pe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var We;(function(ue){function De(j){return{outputId:j.id,outputs:j.outputs.map(pe.from),metadata:j.metadata}}ue.from=De;function le(j){const Ae=j.outputs.map(pe.to);return new s.NotebookCellOutput(Ae,j.outputId,j.metadata)}ue.to=le})(We=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ne;(function(ue){function De(Te){if(Te!=null){if(Te instanceof s.RelativePattern||typeof Te=="string")return Te;if(Ae(Te))return new s.RelativePattern(Te.base,Te.pattern);if(j(Te))return{include:et.from(Te.include)||void 0,exclude:et.from(Te.exclude)||void 0}}}ue.from=De;function le(Te){return typeof Te=="string"?Te:Ae(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}ue.to=le;function j(Te){const Ye=Te,Ge=et.from(Ye.include);if(!(Ge&&Ge instanceof s.RelativePattern||typeof Ge=="string"))return!1;const rt=et.from(Ye.exclude);return!!(rt&&rt instanceof s.RelativePattern||typeof rt=="string")}function Ae(Te){const Ye=Te;return Ye&&typeof Ye.base=="string"&&typeof Ye.pattern=="string"}})(Ne=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ve;(function(ue){function De(le){return{backgroundColor:le.backgroundColor,borderColor:le.borderColor,top:le.top?d.from(le.top):void 0}}ue.from=De})(Ve=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Xe;(function(ue){function De(le){var j;return{transientOutputs:le?le.transientOutputs:!1,transientMetadata:Object.assign(Object.assign({},(j=le==null?void 0:le.transientMetadata)!==null&&j!==void 0?j:{}),{executionOrder:!0,lastRunDuration:!0,runState:!0,runStartTime:!0,lastRunSuccess:!0})}}ue.from=De})(Xe=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ze;(function(ue){function De(j){return{message:f.fromStrict(j.message)||"",severity:j.severity,expectedOutput:j.expectedOutput,actualOutput:j.actualOutput,location:j.location?$.from(j.location):void 0}}ue.from=De;function le(j){const Ae=new s.TestMessage(typeof j.message=="string"?j.message:f.to(j.message));return Ae.severity=j.severity,Ae.actualOutput=j.actualOutput,Ae.expectedOutput=j.expectedOutput,Ae}ue.to=le})(Ze=e.TestMessage||(e.TestMessage={}));var ct;(function(ue){function De(Te){var Ye,Ge;return{extId:Te.id,label:Te.label,uri:Te.uri,range:h.from(Te.range),debuggable:(Ye=Te.debuggable)!==null&&Ye!==void 0?Ye:!1,description:Te.description,runnable:(Ge=Te.runnable)!==null&&Ge!==void 0?Ge:!0,expandable:Te.expandable}}ue.from=De;function le(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:h.from(Te.range),debuggable:!1,description:Te.description,runnable:!0,expandable:!0}}ue.fromResultSnapshot=le;function j(Te){return{id:Te.extId,label:Te.label,uri:y.URI.revive(Te.uri),range:h.to(Te.range),expandable:Te.expandable,debuggable:Te.debuggable,description:Te.description,runnable:Te.runnable}}ue.toPlain=j;function Ae(Te){const Ye=new s.TestItem(Te.extId,Te.label,y.URI.revive(Te.uri),Te.expandable);return Ye.range=h.to(Te.range),Ye.debuggable=Te.debuggable,Ye.description=Te.description,Ye.runnable=Te.runnable,Ye}ue.to=Ae})(ct=e.TestItem||(e.TestItem={}));var ot;(function(ue){function De(Ae,Te){var Ye,Ge,rt;const at={completedAt:Te.completedAt,id:Ae,items:[]},Qe=[[null,Te.results]];for(;Qe.length;){const[ut,st]=Qe.pop();for(const gt of st){const wt={children:(Ge=(Ye=gt.children)===null||Ye===void 0?void 0:Ye.map(St=>St.id))!==null&&Ge!==void 0?Ge:[],computedState:gt.state,item:ct.fromResultSnapshot(gt),state:{state:gt.state,duration:gt.duration,messages:gt.messages.map(Ze.from)},retired:void 0,expand:3,parent:(rt=ut==null?void 0:ut.item.extId)!==null&&rt!==void 0?rt:null,src:{provider:"",tree:-1},direct:!ut};at.items.push(wt),gt.children&&Qe.push([wt,gt.children])}}return at}ue.from=De;const le=(Ae,Te)=>Object.assign(Object.assign({},ct.toPlain(Ae.item)),{state:Ae.state.state,duration:Ae.state.duration,messages:Ae.state.messages.map(Ze.to),children:Ae.children.map(Ye=>Te.get(Ye)).filter(I.isDefined).map(Ye=>le(Ye,Te))});function j(Ae){const Te=[],Ye=new Map;for(const Ge of Ae.items)Ye.set(Ge.item.extId,Ge),Ge.direct&&Te.push(Ge);return{completedAt:Ae.completedAt,results:Te.map(Ge=>le(Ge,Ye))}}ue.to=j})(ot=e.TestResults||(e.TestResults={}));var nt;(function(ue){function De(le){switch(le){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}ue.to=De})(nt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(be[175],we([0,1,2,10,7,9,44]),function(ie,e,E,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(n,R,C,v={timeout:1500,errors:3}){this._logService=n,this._documents=R,this._mainThreadBulkEdits=C,this._thresholds=v,this._callbacks=new S.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(R,C,v)=>{const i={dispose:this._callbacks.push([R,C,n])};return Array.isArray(v)&&v.push(i),i}}async $participateInSave(n,R){const C=E.URI.revive(n);let v=!1;const m=setTimeout(()=>v=!0,this._thresholds.timeout),i=[];try{for(let s of[...this._callbacks]){if(v)break;const p=this._documents.getDocument(C),h=await this._deliverEventAsyncAndBlameBadListeners(s,{document:p,reason:T.TextDocumentSaveReason.to(R)});i.push(h)}}finally{clearTimeout(m)}return i}_deliverEventAsyncAndBlameBadListeners([n,R,C],v){const m=this._badListeners.get(n);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,n,R,v).then(()=>!0,i=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(i),!(i instanceof Error)||i.message!=="concurrent_edits"){const s=this._badListeners.get(n);this._badListeners.set(n,s?s+1:1),typeof s=="number"&&s>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,R,C,v){const m=[],i=Date.now(),{document:s,reason:p}=v,{version:h}=s,w=Object.freeze({document:s,reason:p,waitUntil(_){if(Object.isFrozen(m))throw(0,k.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(_))}});try{R.apply(C,[w])}catch(_){return Promise.reject(_)}return Object.freeze(m),new Promise((_,c)=>{const l=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-i}ms`),clearTimeout(l),_(t)}).catch(t=>{clearTimeout(l),c(t)})}).then(_=>{const c={edits:[]};for(const l of _)if(Array.isArray(l)&&l.every(t=>t instanceof A.TextEdit))for(const{newText:t,newEol:r,range:u}of l)c.edits.push({_type:2,resource:s.uri,edit:{range:u&&T.Range.from(u),text:t,eol:r&&T.EndOfLine.from(r)}});if(c.edits.length!==0)return h===s.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(be[176],we([0,1,3,13,28,2,9,7]),function(ie,e,E,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(C,v,m,i,s){this._onDidCreate=new E.Emitter,this._onDidChange=new E.Emitter,this._onDidDelete=new E.Emitter,this._config=0,m&&(this._config+=1),i&&(this._config+=2),s&&(this._config+=4);const p=(0,A.parse)(v),h=C(w=>{if(!m)for(let _ of w.created){const c=T.URI.revive(_);p(c.fsPath)&&this._onDidCreate.fire(c)}if(!i)for(let _ of w.changed){const c=T.URI.revive(_);p(c.fsPath)&&this._onDidChange.fire(c)}if(!s)for(let _ of w.deleted){const c=T.URI.revive(_);p(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=I.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,h)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class n{constructor(C,v,m){this._logService=v,this._extHostDocumentsAndEditors=m,this._onFileSystemEvent=new E.Emitter,this._onDidRenameFile=new E.Emitter,this._onDidCreateFile=new E.Emitter,this._onDidDeleteFile=new E.Emitter,this._onWillRenameFile=new k.AsyncEmitter,this._onWillCreateFile=new k.AsyncEmitter,this._onWillDeleteFile=new k.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,v,m,i){return new y(this._onFileSystemEvent.event,C,v,m,i)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,v){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:v.map(m=>({oldUri:T.URI.revive(m.source),newUri:T.URI.revive(m.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:v.map(m=>T.URI.revive(m.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:v.map(m=>T.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,v){return(m,i,s)=>{const p=function(w){m.call(i,w)};return p.extension=C,v.event(p,void 0,s)}}async $onWillRunFileOperation(C,v,m,i){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:v.map(s=>({oldUri:T.URI.revive(s.source),newUri:T.URI.revive(s.target)}))},m,i);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:v.map(s=>T.URI.revive(s.target))},m,i);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:v.map(s=>T.URI.revive(s.target))},m,i)}}async _fireWillEvent(C,v,m,i){const s=new Set,p=[];if(await C.fireAsync(v,i,async(w,_)=>{var c;const l=Date.now(),t=await Promise.resolve(w);t instanceof I.WorkspaceEdit&&(p.push(t),s.add((c=_.extension.displayName)!==null&&c!==void 0?c:_.extension.identifier.value)),Date.now()-l>m&&this._logService.warn("SLOW file-participant",_.extension.identifier)}),!i.isCancellationRequested&&p.length!==0){const h={edits:[]};for(let w of p){let{edits:_}=S.WorkspaceEdit.from(w,this._extHostDocumentsAndEditors);h.edits=h.edits.concat(_)}return{edit:h,extensionNames:Array.from(s)}}}}e.ExtHostFileSystemEventService=n}),define(be[177],we([0,1,3,6,18,23,2,9,7,70]),function(ie,e,E,k,A,T,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(i,s,p,h){this.start=i,this.deletedCount=s,this.deletedItems=p,this.items=h}static asApiEvents(i){return i.map(s=>({start:s.start,deletedCount:s.deletedCount,deletedItems:s.deletedItems,items:s.items.map(p=>p.cell)}))}}class C{constructor(i,s,p){var h;this._notebook=i,this._extHostDocument=s,this._cellData=p,this._onDidDispose=new E.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=p.handle,this.uri=S.URI.revive(p.uri),this.cellKind=p.cellKind,this._outputs=p.outputs.map(I.NotebookCellOutput.to),this._internalMetadata=(h=p.metadata)!==null&&h!==void 0?h:{},this._metadata=I.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=I.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(i,s){return{EOL:s.eol,lines:s.source,modeId:s.language,uri:s.uri,isDirty:!1,versionId:1,notebook:i}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const i=this,s=this._extHostDocument.getDocument(this.uri);if(!s)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return i._notebook.getCellIndex(i)},notebook:i._notebook.notebookDocument,kind:I.NotebookCellKind.to(this._cellData.cellKind),document:s.document,get outputs(){return i._outputs.slice(0)},get metadata(){return i._metadata},get latestExecutionSummary(){return i._previousResult}})}return this._cell}setOutputs(i){this._outputs=i.map(I.NotebookCellOutput.to)}setOutputItems(i,s,p){const h=p.map(I.NotebookCellOutputItem.to),w=this._outputs.find(_=>_.id===i);w&&(s||(w.outputs.length=0),w.outputs.push(...h))}setMetadata(i){this._internalMetadata=i,this._metadata=I.NotebookCellMetadata.to(i),this._previousResult=I.NotebookCellPreviousExecutionResult.to(i)}}e.ExtHostCell=C;class v extends k.Disposable{constructor(i,s,p,h,w,_,c){super();this._proxy=i,this._textDocumentsAndEditors=s,this._textDocuments=p,this._emitter=h,this._viewType=w,this._metadata=_,this.uri=c,this.handle=v._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,k.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const i=this;this._notebook=Object.freeze({get uri(){return i.uri},get version(){return i._versionId},get fileName(){return i.uri.fsPath},get viewType(){return i._viewType},get isDirty(){return i._isDirty},get isUntitled(){return i.uri.scheme===A.Schemas.untitled},get isClosed(){return i._disposed},get metadata(){return i._metadata},get cellCount(){return i._cells.length},cellAt(s){return s=i._validateIndex(s),i._cells[s].cell},getCells(s){return(s?i._getCells(s):i._cells).map(h=>h.cell)},save(){return i._save()}})}return this._notebook}updateBackup(i){var s;(s=this._backup)===null||s===void 0||s.delete(),this._backup=i}disposeBackup(){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(i){i.metadata&&(this._metadata=this._metadata.with(i.metadata))}acceptModelChanged(i,s){this._versionId=i.versionId,this._isDirty=s;for(const p of i.rawEvents)p.kind===n.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(p.changes,!0),p.kind===n.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(p.changes,!1):p.kind===n.NotebookCellsChangeType.Move?this._moveCell(p.index,p.newIdx):p.kind===n.NotebookCellsChangeType.Output?this._setCellOutputs(p.index,p.outputs):p.kind===n.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(p.index,p.outputId,p.append,p.outputItems):p.kind===n.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(p.index,p.language):p.kind===n.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(p.index,p.metadata)}_validateIndex(i){return i<0?0:i>=this._cells.length?this._cells.length-1:i}_validateRange(i){return i.start<0&&(i=i.with({start:0})),i.end>this._cells.length&&(i=i.with({end:this._cells.length})),i}_getCells(i){i=this._validateRange(i);const s=[];for(let p=i.start;p<i.end;p++)s.push(this._cells[p]);return s}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(i,s){if(!this._disposed){const p=[],h=[],w=[];i.reverse().forEach(_=>{var c;const t=_[2].map(o=>{const a=new C(this,this._textDocumentsAndEditors,o);if(s||h.push(C.asModelAddData(this.notebookDocument,o)),!this._cellDisposableMapping.has(a.handle)){const f=new k.DisposableStore;f.add(a),this._cellDisposableMapping.set(a.handle,f)}return a});for(let o=_[0];o<_[0]+_[1];o++)(c=this._cellDisposableMapping.get(this._cells[o].handle))===null||c===void 0||c.dispose(),this._cellDisposableMapping.delete(this._cells[o].handle);const r=new R(_[0],_[1],[],t),u=this._cells.splice(_[0],_[1],...t);for(let o of u)w.push(o.uri),r.deletedItems.push(o.cell);p.push(r)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:w}),s||this._emitter.emitModelChange((0,T.deepFreeze)({document:this.notebookDocument,changes:R.asApiEvents(p)}))}}_moveCell(i,s){const p=this._cells.splice(i,1);this._cells.splice(s,0,...p);const h=[new R(i,1,p.map(w=>w.cell),[]),new R(s,0,[],p)];this._emitter.emitModelChange((0,T.deepFreeze)({document:this.notebookDocument,changes:R.asApiEvents(h)}))}_setCellOutputs(i,s){const p=this._cells[i];p.setOutputs(s),this._emitter.emitCellOutputsChange((0,T.deepFreeze)({document:this.notebookDocument,cells:[p.cell]}))}_setCellOutputItems(i,s,p,h){const w=this._cells[i];w.setOutputItems(s,p,h),this._emitter.emitCellOutputsChange((0,T.deepFreeze)({document:this.notebookDocument,cells:[w.cell]}))}_changeCellLanguage(i,s){const p=this._cells[i];p.cell.document.languageId!==s&&this._textDocuments.$acceptModelModeChanged(p.uri,s)}_changeCellMetadata(i,s){var p;const h=this._cells[i],w=h.internalMetadata,_=h.cell.metadata;h.setMetadata(s);const c=h.cell.metadata;if((0,T.equals)(_,c)||this._emitter.emitCellMetadataChange((0,T.deepFreeze)({document:this.notebookDocument,cell:h.cell})),w.runState!==s.runState){const l=(p=s.runState)!==null&&p!==void 0?p:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,T.deepFreeze)({document:this.notebookDocument,cell:h.cell,executionState:l}))}}getCellFromIndex(i){return this._cells[i]}getCell(i){return this._cells.find(s=>s.handle===i)}getCellIndex(i){return this._cells.indexOf(i)}}e.ExtHostNotebookDocument=v,v._handlePool=0}),define(be[178],we([0,1,3,7,9]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,n){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:y,metadata:n})}replaceCellOutput(y,n){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:y,outputs:n.map(R=>A.NotebookCellOutput.from(R))})}replaceCells(y,n,R){this._throwIfFinalized(),!(y===n&&R.length===0)&&this._collectedEdits.push({editType:1,index:y,count:n-y,cells:R.map(A.NotebookCellData.from)})}}class S{constructor(y,n,R,C,v,m){this.id=y,this._proxy=n,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._onDidDispose=new E.Emitter,this.onDidDispose=this._onDidDispose.event,this._selections=v,this._visibleRanges=C,this._viewColumn=m}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get editor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.notebookDocument},get selection(){var n;const R=y._selections[0];return R&&((n=y.notebookData.getCellFromIndex(R.start))===null||n===void 0?void 0:n.cell)},get selections(){return y._selections},get visibleRanges(){return y._visibleRanges},revealRange(n,R){y._proxy.$tryRevealRange(y.id,A.NotebookCellRange.from(n),R!=null?R:k.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},get onDidDispose(){return y.onDidDispose},edit(n){const R=new T(this.document.version);return n(R),y._applyEdit(R.finalize())},get kernel(){return y._kernel},setDecorations(n,R){return y.setDecorations(n,R)}}}return this._editor}_acceptKernel(y){this._kernel=y}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const n=[];let R=-1;for(let C=0;C<y.cellEdits.length;C++){if(R<0){n.push(y.cellEdits[C]),R++;continue}const m=n[R],i=y.cellEdits[C];if(m.editType===1&&i.editType===1&&m.index===i.index){m.cells.push(...y.cellEdits[C].cells),m.count+=y.cellEdits[C].count;continue}n.push(y.cellEdits[C]),R++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,n)}setDecorations(y,n){if(!(n.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return n.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,A.NotebookCellRange.from(n),y.key)}}e.ExtHostNotebookEditor=S}),define(be[179],we([0,1,9,152,132,20,51]),function(ie,e,E,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class I{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,v,m){const i=this._handles++,{title:s,location:p,cancellable:h}=v,w={label:(0,A.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(i,{location:E.ProgressLocation.from(p),title:s,source:w,cancellable:h},C),this._withProgress(i,m,!!h)}_withProgress(C,v,m){let i;m&&(i=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,i));const s=h=>{this._proxy.$progressEnd(h),this._mapHandleToCancellationSource.delete(h),i&&i.dispose()};let p;try{p=v(new n(this._proxy,C),m&&i?i.token:T.CancellationToken.None)}catch(h){throw s(C),h}return p.then(h=>s(C),h=>s(C)),p}$acceptProgressCanceled(C){const v=this._mapHandleToCancellationSource.get(C);v&&(v.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=I;function y(R,C){return R.message=C.message,typeof C.increment=="number"&&(typeof R.increment=="number"?R.increment+=C.increment:R.increment=C.increment),R}class n extends k.Progress{constructor(C,v){super(m=>this.throttledReport(m));this._proxy=C,this._handle=v}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}je([(0,S.throttle)(100,(R,C)=>y(R,C),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(be[96],we([0,1,42,10,53,9,7]),function(ie,e,E,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(v,m){const i=I._Keys.nextId();v.$registerTextEditorDecorationType(i,T.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:i,dispose(){v.$removeTextEditorDecorationType(i)}})}}e.TextEditorDecorationType=I,I._Keys=new A.IdGenerator("TextEditorDecorationType");class y{constructor(v,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=v,this._documentVersionId=v.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(v,m){this._throwIfFinalized();let i=null;if(v instanceof S.Position)i=new S.Range(v,v);else if(v instanceof S.Range)i=v;else throw new Error("Unrecognized location");this._pushEdit(i,m,!1)}insert(v,m){this._throwIfFinalized(),this._pushEdit(new S.Range(v,v),m,!0)}delete(v){this._throwIfFinalized();let m=null;if(v instanceof S.Range)m=v;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(v,m,i){const s=this._document.validateRange(v);this._collectedEdits.push({range:s,text:m,forceMoveMarkers:i})}setEndOfLine(v){if(this._throwIfFinalized(),v!==S.EndOfLine.LF&&v!==S.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this._setEndOfLine=v}}e.TextEditorEdit=y;class n{constructor(v,m,i,s){this._proxy=v,this._id=m,this._accept(i),this._logService=s;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(h){p._setTabSize(h)},get insertSpaces(){return p._insertSpaces},set insertSpaces(h){p._setInsertSpaces(h)},get cursorStyle(){return p._cursorStyle},set cursorStyle(h){p._setCursorStyle(h)},get lineNumbers(){return p._lineNumbers},set lineNumbers(h){p._setLineNumbers(h)}}}_accept(v){this._tabSize=v.tabSize,this._insertSpaces=v.insertSpaces,this._cursorStyle=v.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(v.lineNumbers)}_validateTabSize(v){if(v==="auto")return"auto";if(typeof v=="number"){const m=Math.floor(v);return m>0?m:null}if(typeof v=="string"){const m=parseInt(v,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(v){const m=this._validateTabSize(v);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(v){return v==="auto"?"auto":v==="false"?!1:Boolean(v)}_setInsertSpaces(v){const m=this._validateInsertSpaces(v);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(v){this._cursorStyle!==v&&(this._cursorStyle=v,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:v})))}_setLineNumbers(v){this._lineNumbers!==v&&(this._lineNumbers=v,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(v)})))}assign(v){const m={};let i=!1;if(typeof v.tabSize!="undefined"){const s=this._validateTabSize(v.tabSize);s==="auto"?(i=!0,m.tabSize=s):typeof s=="number"&&this._tabSize!==s&&(this._tabSize=s,i=!0,m.tabSize=s)}if(typeof v.insertSpaces!="undefined"){const s=this._validateInsertSpaces(v.insertSpaces);s==="auto"?(i=!0,m.insertSpaces=s):this._insertSpaces!==s&&(this._insertSpaces=s,i=!0,m.insertSpaces=s)}typeof v.cursorStyle!="undefined"&&this._cursorStyle!==v.cursorStyle&&(this._cursorStyle=v.cursorStyle,i=!0,m.cursorStyle=v.cursorStyle),typeof v.lineNumbers!="undefined"&&this._lineNumbers!==v.lineNumbers&&(this._lineNumbers=v.lineNumbers,i=!0,m.lineNumbers=T.TextEditorLineNumbersStyle.from(v.lineNumbers)),i&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(v){v.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=n;class R{constructor(v,m,i,s,p,h,w,_){this.id=v,this._proxy=m,this._logService=i,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new n(this._proxy,this.id,h,i),this._visibleRanges=w,this._viewColumn=_;const c=this;this.value=Object.freeze({get document(){return s.getValue()},set document(l){throw(0,k.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(l){if(!(l instanceof S.Selection))throw(0,k.illegalArgument)("selection");c._selections=[l],c._trySetSelection()},get selections(){return c._selections},set selections(l){if(!Array.isArray(l)||l.some(t=>!(t instanceof S.Selection)))throw(0,k.illegalArgument)("selections");c._selections=l,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(l){throw(0,k.readonly)("visibleRanges")},get options(){return c._options.value},set options(l){c._disposed||c._options.assign(l)},get viewColumn(){return c._viewColumn},set viewColumn(l){throw(0,k.readonly)("viewColumn")},edit(l,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new y(s.getValue(),t);return l(r),c._applyEdit(r)},insertSnippet(l,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!t||Array.isArray(t)&&t.length===0)u=c._selections.map(o=>T.Range.from(o));else if(t instanceof S.Position){const{lineNumber:o,column:a}=T.Position.from(t);u=[{startLineNumber:o,startColumn:a,endLineNumber:o,endColumn:a}]}else if(t instanceof S.Range)u=[T.Range.from(t)];else{u=[];for(const o of t)if(o instanceof S.Range)u.push(T.Range.from(o));else{const{lineNumber:a,column:f}=T.Position.from(o);u.push({startLineNumber:a,startColumn:f,endLineNumber:a,endColumn:f})}}return m.$tryInsertSnippet(v,l.value,u,r)},setDecorations(l,t){const r=t.length===0;r&&!c._hasDecorationsForKey.has(l.key)||(r?c._hasDecorationsForKey.delete(l.key):c._hasDecorationsForKey.add(l.key),c._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return m.$trySetDecorations(v,l.key,T.fromRangeOrRangeWithMessage(t));{const u=new Array(4*t.length);for(let o=0,a=t.length;o<a;o++){const f=t[o];u[4*o]=f.start.line+1,u[4*o+1]=f.start.character+1,u[4*o+2]=f.end.line+1,u[4*o+3]=f.end.character+1}return m.$trySetDecorationsFast(v,l.key,u)}}))},revealRange(l,t){c._runOnProxy(()=>m.$tryRevealRange(v,T.Range.from(l),t||S.TextEditorRevealType.Default))},show(l){m.$tryShowEditor(v,T.ViewColumn.from(l))},hide(){m.$tryHideEditor(v)}})}dispose(){(0,E.ok)(!this._disposed),this._disposed=!0}_acceptOptions(v){(0,E.ok)(!this._disposed),this._options._accept(v)}_acceptVisibleRanges(v){(0,E.ok)(!this._disposed),this._visibleRanges=v}_acceptViewColumn(v){(0,E.ok)(!this._disposed),this._viewColumn=v}_acceptSelections(v){(0,E.ok)(!this._disposed),this._selections=v}async _trySetSelection(){const v=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,v)),this.value}_applyEdit(v){const m=v.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const i=m.edits.map(p=>p.range);i.sort((p,h)=>p.end.line===h.end.line?p.end.character===h.end.character?p.start.line===h.start.line?p.start.character-h.start.character:p.start.line-h.start.line:p.end.character-h.end.character:p.end.line-h.end.line);for(let p=0,h=i.length-1;p<h;p++){const w=i[p].end;if(i[p+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=m.edits.map(p=>({range:T.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,s,{setEndOfLine:typeof m.setEndOfLine=="number"?T.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(v){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=R}),define(be[180],we([0,1,135,25,2,3,6,13,7,12,15,9,20]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(p,h){if((0,n.isString)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let w;return Array.isArray(p.highlights)&&(w=p.highlights.filter(_=>_.length===2&&typeof _[0]=="number"&&typeof _[1]=="number"),w=w.length?w:void 0),{label:p.label,highlights:w}}}class i{constructor(h,w,_){this._proxy=h,this.commands=w,this.logService=_,this.treeViews=new Map;function c(l){return l&&l.$treeViewId&&l.$treeItemHandle}w.registerArgumentProcessor({processArgument:l=>c(l)?this.convertArgument(l):Array.isArray(l)&&l.length>0?l.map(t=>c(t)?this.convertArgument(t):t):l})}registerTreeDataProvider(h,w,_){const c=this.createTreeView(h,{treeDataProvider:w},_);return{dispose:()=>c.dispose()}}createTreeView(h,w,_){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=this._proxy.$registerTreeViewDataProvider(h,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany}),l=this.createExtHostTreeView(h,w,_);return{get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get message(){return l.message},set message(t){l.message=t},get title(){return l.title},set title(t){l.title=t},get description(){return l.description},set description(t){l.description=t},reveal:(t,r)=>l.reveal(t,r),dispose:async()=>{await c,this.treeViews.delete(h),l.dispose()}}}$getChildren(h,w){const _=this.treeViews.get(h);return _?_.getChildren(w):Promise.reject(new Error((0,E.localize)(0,null,h)))}async $hasResolve(h){const w=this.treeViews.get(h);if(!w)throw new Error((0,E.localize)(1,null,h));return w.hasResolve}$resolve(h,w,_){const c=this.treeViews.get(h);if(!c)throw new Error((0,E.localize)(2,null,h));return c.resolveTreeItem(w,_)}$setExpanded(h,w,_){const c=this.treeViews.get(h);if(!c)throw new Error((0,E.localize)(3,null,h));c.setExpanded(w,_)}$setSelection(h,w){const _=this.treeViews.get(h);if(!_)throw new Error((0,E.localize)(4,null,h));_.setSelection(w)}$setVisible(h,w){const _=this.treeViews.get(h);if(!_)throw new Error((0,E.localize)(5,null,h));_.setVisible(w)}createExtHostTreeView(h,w,_){const c=new s(h,w,this._proxy,this.commands.converter,this.logService,_);return this.treeViews.set(h,c),c}convertArgument(h){const w=this.treeViews.get(h.$treeViewId);return w?w.getExtensionElement(h.$treeItemHandle):null}}e.ExtHostTreeViews=i;class s extends S.Disposable{constructor(h,w,_,c,l,t){super();if(this.viewId=h,this.proxy=_,this.commands=c,this.logService=l,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new v.CancellationTokenSource,t.contributes&&t.contributes.views)for(const o in t.contributes.views)for(const a of t.contributes.views[o])a.id===h&&(this._title=a.name);this.dataProvider=w.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let r,u;this._register(T.Event.debounce(this._onDidChangeData.event,(o,a)=>(o||(o={message:!1,elements:[]}),a.element!==!1&&(r||(r=new Promise(f=>u=f),this.refreshPromise=this.refreshPromise.then(()=>r)),o.elements.push(a.element)),a.message&&(o.message=!0),o),200,!0)(({message:o,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=u;return r=null,this.refresh(a).then(()=>f())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(h=>this.getExtensionElement(h)).filter(h=>!(0,n.isUndefinedOrNull)(h))}getChildren(h){const w=h?this.getExtensionElement(h):void 0;if(h&&!w)return this.logService.error(`No tree item with id '${h}' found.`),Promise.resolve([]);const _=this.getChildrenNodes(h);return(_?Promise.resolve(_):this.fetchChildrenNodes(w)).then(c=>c.map(l=>l.item))}getExtensionElement(h){return this.elements.get(h)}reveal(h,w){w=w||{select:!0,focus:!1};const _=(0,n.isUndefinedOrNull)(w.select)?!0:w.select,c=(0,n.isUndefinedOrNull)(w.focus)?!1:w.focus,l=(0,n.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.refreshPromise.then(()=>this.resolveUnknownParentChain(h)).then(t=>this.resolveTreeNode(h,t[t.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:t.map(u=>u.item)},{select:_,focus:c,expand:l})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:_,focus:c,expand:l})}get message(){return this._message}set message(h){this._message=h,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(h){this._title=h,this.proxy.$setTitle(this.viewId,h,this._description)}get description(){return this._description}set description(h){this._description=h,this.proxy.$setTitle(this.viewId,this._title,h)}setExpanded(h,w){const _=this.getExtensionElement(h);_&&(w?this._onDidExpandElement.fire(Object.freeze({element:_})):this._onDidCollapseElement.fire(Object.freeze({element:_})))}setSelection(h){(0,R.equals)(this._selectedHandles,h)||(this._selectedHandles=h,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(h){h!==this._visible&&(this._visible=h,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(h,w){var _;if(!!this.dataProvider.resolveTreeItem){const c=this.elements.get(h);if(c){const l=this.nodes.get(c);if(l){const t=(_=await this.dataProvider.resolveTreeItem(l.extensionItem,c,w))!==null&&_!==void 0?_:l.extensionItem;return l.item.tooltip=this.getTooltip(t.tooltip),l.item.command=this.getCommand(l.disposableStore,t.command),l.item}}}}resolveUnknownParentChain(h){return this.resolveParent(h).then(w=>w?this.resolveUnknownParentChain(w).then(_=>this.resolveTreeNode(w,_[_.length-1]).then(c=>(_.push(c),_))):Promise.resolve([]))}resolveParent(h){const w=this.nodes.get(h);return w?Promise.resolve(w.parent?this.elements.get(w.parent.item.handle):void 0):(0,I.asPromise)(()=>this.dataProvider.getParent(h))}resolveTreeNode(h,w){const _=this.nodes.get(h);return _?Promise.resolve(_):(0,I.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(c=>this.createHandle(h,c,w,!0)).then(c=>this.getChildren(w?w.item.handle:void 0).then(()=>{const l=this.getExtensionElement(c);if(l){const t=this.nodes.get(l);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(h){if(h){let w;if(typeof h=="string"){const _=this.getExtensionElement(h);w=_?this.nodes.get(_):void 0}else w=h;return w&&w.children||null}return this.roots}async fetchChildrenNodes(h){this.clearChildren(h);const w=new v.CancellationTokenSource(this._refreshCancellationSource.token);try{const _=h?this.nodes.get(h):void 0,c=await this.dataProvider.getChildren(h);if(w.token.isCancellationRequested)return[];const l=await Promise.all((0,R.coalesce)(c||[]).map(async t=>{const r=await this.dataProvider.getTreeItem(t);return r&&!w.token.isCancellationRequested?this.createAndRegisterTreeNode(t,r,_):null}));return w.token.isCancellationRequested?[]:(0,R.coalesce)(l)}finally{w.dispose()}}refresh(h){if(h.some(_=>!_))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new v.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const _=this.getHandlesToRefresh(h);if(_.length)return this.refreshHandles(_)}return Promise.resolve(void 0)}getHandlesToRefresh(h){const w=new Set,_=h.map(l=>this.nodes.get(l));for(const l of _)if(l&&!w.has(l.item.handle)){let t=l;for(;t&&t.parent&&_.findIndex(r=>t&&t.parent&&r&&r.item.handle===t.parent.item.handle)===-1;){const r=this.elements.get(t.parent.item.handle);t=r?this.nodes.get(r):void 0}t&&!t.parent&&w.add(l.item.handle)}const c=[];return w.forEach(l=>{const t=this.elements.get(l);if(t){const r=this.nodes.get(t);r&&(!r.parent||!w.has(r.parent.item.handle))&&c.push(l)}}),c}refreshHandles(h){const w={};return Promise.all(h.map(_=>this.refreshNode(_).then(c=>{c&&(w[_]=c.item)}))).then(()=>Object.keys(w).length?this.proxy.$refresh(this.viewId,w):void 0)}refreshNode(h){const w=this.getExtensionElement(h);if(w){const _=this.nodes.get(w);if(_)return this.clearChildren(w),(0,I.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(c=>{if(c){const l=this.createTreeNode(w,c,_.parent);return this.updateNodeCache(w,l,_,_.parent),_.dispose(),l}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(h,w,_){const c=this.createTreeNode(h,w,_);if(w.id&&this.elements.has(c.item.handle))throw new Error((0,E.localize)(6,null,w.id));return this.addNodeToCache(h,c),this.addNodeToParentCache(c,_),c}getTooltip(h){return y.MarkdownString.isMarkdownString(h)?C.MarkdownString.from(h):h}getCommand(h,w){return w?this.commands.toInternal(w,h):void 0}createTreeNode(h,w,_){const c=new S.DisposableStore,l=this.createHandle(h,w,_),t=this.getLightIconPath(w);return{item:{handle:l,parentHandle:_?_.item.handle:void 0,label:m(w.label,this.extension),description:w.description,resourceUri:w.resourceUri,tooltip:this.getTooltip(w.tooltip),command:this.getCommand(c,w.command),contextValue:w.contextValue,icon:t,iconDark:this.getDarkIconPath(w)||t,themeIcon:this.getThemeIcon(w),collapsibleState:(0,n.isUndefinedOrNull)(w.collapsibleState)?y.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation},extensionItem:w,parent:_,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(h){return h.iconPath instanceof y.ThemeIcon?h.iconPath:void 0}createHandle(h,{id:w,label:_,resourceUri:c},l,t){if(w)return`${s.ID_HANDLE_PREFIX}/${w}`;const r=m(_,this.extension),u=l?l.item.handle:s.LABEL_HANDLE_PREFIX;let o=r?r.label:c?(0,k.basename)(c):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const a=this.nodes.has(h)?this.nodes.get(h).item.handle:void 0,f=this.getChildrenNodes(l)||[];let b,D=0;do{if(b=`${u}/${D}:${o}`,t||!this.elements.has(b)||a===b)break;D++}while(D<=f.length);return b}getLightIconPath(h){if(h.iconPath&&!(h.iconPath instanceof y.ThemeIcon))return typeof h.iconPath=="string"||A.URI.isUri(h.iconPath)?this.getIconPath(h.iconPath):this.getIconPath(h.iconPath.light)}getDarkIconPath(h){if(h.iconPath&&!(h.iconPath instanceof y.ThemeIcon)&&h.iconPath.dark)return this.getIconPath(h.iconPath.dark)}getIconPath(h){return A.URI.isUri(h)?h:A.URI.file(h)}addNodeToCache(h,w){this.elements.set(w.item.handle,h),this.nodes.set(h,w)}updateNodeCache(h,w,_,c){this.elements.delete(w.item.handle),this.nodes.delete(h),w.item.handle!==_.item.handle&&this.elements.delete(_.item.handle),this.addNodeToCache(h,w);const l=this.getChildrenNodes(c)||[],t=l.filter(r=>r.item.handle===_.item.handle)[0];t&&l.splice(l.indexOf(t),1,w)}addNodeToParentCache(h,w){w?(w.children||(w.children=[]),w.children.push(h)):(this.roots||(this.roots=[]),this.roots.push(h))}clearChildren(h){if(h){const w=this.nodes.get(h);if(w){if(w.children)for(const _ of w.children){const c=this.elements.get(_.item.handle);c&&this.clear(c)}w.children=void 0}}else this.clearAll()}clear(h){const w=this.nodes.get(h);if(w){if(w.children)for(const _ of w.children){const c=this.elements.get(_.item.handle);c&&this.clear(c)}this.nodes.delete(h),this.elements.delete(w.item.handle),w.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(h=>h.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}s.LABEL_HANDLE_PREFIX="0",s.ID_HANDLE_PREFIX="1"}),define(be[181],we([0,1,15,13,20,9,7,95]),function(ie,e,E,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class y{constructor(){this.testIdsToInternal=new Map}getTestById(i,s){if(s!==void 0){const p=this.testIdsToInternal.get(s),h=p==null?void 0:p.get(i);if(h)return[p,h]}return(0,E.mapFind)(this.testIdsToInternal.values(),p=>{const h=p.get(i);return h&&[p,h]})}createForHierarchy(i=()=>{}){return new v(this.createIdMap(R++),i)}createIdMap(i){const s=new C(i);return this.testIdsToInternal.set(s.id,s),{object:s,dispose:()=>this.testIdsToInternal.delete(s.id)}}}e.OwnedTestCollection=y;var n;(function(m){m[m.Disconnected=0]="Disconnected",m[m.IsChild=1]="IsChild",m[m.IsParent=2]="IsParent",m[m.IsSame=3]="IsSame"})(n=e.TestPosition||(e.TestPosition={}));let R=0;class C{constructor(i){this.id=i,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(i){if(this.map.has(i.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${i.item.extId}`);this.map.set(i.item.extId,i),i.parent||this._roots.add(i)}has(i){return this.map.has(i)}delete(i){const s=this.map.get(i);return s?(this.map.delete(i),this._roots.delete(s),!0):!1}get(i){return this.map.get(i)}comparePositions(i,s){const p=typeof i=="string"?this.map.get(i):i,h=typeof s=="string"?this.map.get(s):s;if(!p||!h)return 0;if(p===h)return 3;for(let w=this.map.get(h.parent);w;w=this.map.get(w.parent))if(w===p)return 1;for(let w=this.map.get(p.parent);w;w=this.map.get(w.parent))if(w===h)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=C;class v{constructor(i,s){this.testIdToInternal=i,this.publishDiff=s,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new k.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(i,s){this.addItem(i,s,null)}getTestByReference(i){return this.testItemToInternal.get(i)}collectDiff(){const i=this.diff;return this.diff=[],i}pushDiff(i){const s=this.diff[this.diff.length-1];if(s&&i[0]===1){if(s[0]===1&&s[1].extId===i[1].extId){(0,I.applyTestItemUpdate)(s[1],i[1]);return}if(s[0]===0&&s[1].item.extId===i[1].extId){(0,I.applyTestItemUpdate)(s[1],i[1]);return}}this.diff.push(i),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(i,s){var p;const h=this.testIdToInternal.object.get(i);if(!!h){if((h.expandLevels===void 0||s>h.expandLevels)&&(h.expandLevels=s),h.expand===1){const w=this.refreshChildren(h);return w.isSettled?this.expandChildren(h,s-1):w.p.then(()=>this.expandChildren(h,s-1))}else if(h.expand===3)return((p=h.initialExpand)===null||p===void 0?void 0:p.isSettled)===!1?h.initialExpand.p.then(()=>this.expandChildren(h,s-1)):this.expandChildren(h,s-1)}}dispose(){var i;for(const s of this.testItemToInternal.values())(i=s.discoverCts)===null||i===void 0||i.dispose(!0),s.actual[S.TestItemHookProperty]=void 0;this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}addItem(i,s,p){if(!(i instanceof S.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${i.id} did not`);if(this.testItemToInternal.has(i))throw new Error(`Attempted to add a single TestItem ${i.id} multiple times to the tree`);if(this.testIdToInternal.object.has(i.id))throw new Error(`Attempted to insert a duplicate test item ID ${i.id}`);const h=p?p.item.extId:null,w=i.expandable?1:0,_=p==null?void 0:p.expandLevels,c={provider:s,tree:this.testIdToInternal.object.id},l={actual:i,parent:h,item:T.TestItem.from(i),expandLevels:_&&w===1?_-1:void 0,expand:w,src:c};this.testIdToInternal.object.add(l),this.testItemToInternal.set(i,l),this.pushDiff([0,{parent:h,src:c,expand:w,item:l.item}]),i[S.TestItemHookProperty]={created:t=>this.addItem(t,s,l),delete:t=>this.removeItembyId(t),invalidate:t=>this.pushDiff([4,t]),setProp:(t,r)=>this.pushDiff([1,{extId:i.id,item:{[t]:t==="range"?T.Range.from(r):r}}])};for(const t of i.children)this.addItem(t,s,l)}expandChildren(i,s){if(!(s<0)){const p=[...i.actual.children].map(h=>this.expand(h.id,s-1)).filter(k.isThenable);if(p.length)return Promise.all(p).then(()=>{})}}refreshChildren(i){i.discoverCts&&i.discoverCts.dispose(!0),i.expand=2,i.discoverCts=new A.CancellationTokenSource,this.pushExpandStateUpdate(i);const s=new k.DeferredPromise;return i.initialExpand=s,i.actual.discoverChildren({report:p=>{p.busy?(i.expand=2,this.pushExpandStateUpdate(i)):(i.expand=3,s.isSettled||s.complete(),this.pushExpandStateUpdate(i))}},i.discoverCts.token),s}pushExpandStateUpdate(i){this.pushDiff([1,{extId:i.actual.id,expand:i.expand}])}removeItembyId(i){var s;this.pushDiff([2,i]);const p=[this.testIdToInternal.object.get(i)];for(;p.length;){const h=p.pop();if(!!h){(s=h.discoverCts)===null||s===void 0||s.dispose(!0),this.testIdToInternal.object.delete(h.item.extId),this.testItemToInternal.delete(h.actual);for(const w of h.actual.children)p.push(this.testIdToInternal.object.get(w.id))}}}flushDiff(){const i=this.collectDiff();i.length&&this.publishDiff(i)}}e.SingleUseTestCollection=v}),define(be[182],we([0,1,26,3,11]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=T;class S{constructor(R){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(E.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(E.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let C of R.activationEvents)C==="onUri"&&(C=`onUri:${E.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(R)}}keepOnly(R){const C=new Set;R.forEach(v=>C.add(E.ExtensionIdentifier.toKey(v))),this._extensionDescriptions=this._extensionDescriptions.filter(v=>C.has(E.ExtensionIdentifier.toKey(v.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,C){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const v=S._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(v.map(m=>m.identifier)),C.length>0){const m=new Set;C.forEach(i=>m.add(E.ExtensionIdentifier.toKey(i))),this._extensionDescriptions=this._extensionDescriptions.filter(i=>!m.has(E.ExtensionIdentifier.toKey(i.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(v)}static _findLoopingExtensions(R){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,h){this.addNode(p),this.addNode(h),this._arcs.has(p)?this._arcs.get(p).push(h):this._arcs.set(p,[h])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,h){const w=C.getArcs(p);for(let _=0;_<w.length;_++)if(!h.has(w[_]))return!1;return!0}getNodes(){return this._nodesArr}};let v=new Map;for(let p of R){const h=E.ExtensionIdentifier.toKey(p.identifier);if(v.set(h,p),p.extensionDependencies)for(let w of p.extensionDependencies){const _=E.ExtensionIdentifier.toKey(w);C.addArc(h,_)}}let m=new Set;C.getNodes().filter(p=>C.getArcs(p).length===0).forEach(p=>m.add(p));let i=C.getNodes().filter(p=>!m.has(p)),s;do{s=!1;for(let p=0;p<i.length;p++){const h=i[p];C.hasOnlyGoodArcs(h,m)&&(i.splice(p,1),p--,m.add(h),s=!0)}}while(s);return i.map(p=>v.get(p))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(E.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const C=this._activationMap.get(R);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const C=this._extensionsMap.get(E.ExtensionIdentifier.toKey(R));return C||void 0}}e.ExtensionDescriptionRegistry=S;var I;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(I||(I={}));function y(n,R){const C=n.isBuiltin?0:n.isUnderDevelopment?2:1,v=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(C!==v)return C-v;const m=A.posix.basename(n.extensionLocation.path),i=A.posix.basename(R.extensionLocation.path);return m<i?-1:m>i?1:0}}),define(be[183],we([0,1,24]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var k;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function T(I){const y=E.VSBuffer.alloc(1);switch(I){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=T;function S(I,y){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=S}),define(be[33],we([0,1,3,2,4,26,149]),function(ie,e,E,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class I{constructor(w){this.dependency=w}}e.MissingDependencyError=I;var y;(function(h){h[h.LocalProcess=0]="LocalProcess",h[h.LocalWebWorker=1]="LocalWebWorker",h[h.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(w,_,c,l){this.codeLoadingTime=w,this.activateCallTime=_,this.activateResolvedTime=c,this.activationReason=l}}e.ActivationTimes=n;class R{constructor(w,_){this.description=w,this.value=_}}e.ExtensionPointContribution=R,e.ExtensionHostLogFileName="exthost";var C;(function(h){h[h.Normal=0]="Normal",h[h.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function v(h){h.enableProposedApi||m(h)}e.checkProposedApiEnabled=v;function m(h){throw new Error(`[${h.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${h.identifier.value}`)}e.throwProposedApiError=m;function i(h){return{type:h.isBuiltin?0:1,isBuiltin:h.isBuiltin||h.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(h.publisher,h.name),uuid:h.uuid},manifest:h,location:h.extensionLocation}}e.toExtension=i;function s(h){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(h.identifier.id),isBuiltin:h.type===0,isUserBuiltin:h.type===1&&h.isBuiltin,isUnderDevelopment:!1,extensionLocation:h.location},h.manifest),{uuid:h.identifier.uuid})}e.toExtensionDescription=s;class p{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None}activateByEvent(w){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(w){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(w){return Promise.resolve(0)}restartExtensionHost(){}async setRemoteEnvironment(w){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(w,_){}_activateById(w,_){return Promise.resolve()}_onWillActivateExtension(w){}_onDidActivateExtension(w,_,c,l,t){}_onExtensionRuntimeError(w,_){}_onExtensionHostExit(w){}}e.NullExtensionService=p}),define(be[184],we([0,1,130,26,33,19]),function(ie,e,E,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class I{constructor(s,p,h,w){this.startup=s,this.codeLoadingTime=p,this.activateCallTime=h,this.activateResolvedTime=w}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class y{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,p){return s===-1||p===-1?-1:p-s}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class n{constructor(s,p,h,w,_,c){this.activationFailed=s,this.activationFailedError=p,this.activationTimes=h,this.module=w,this.exports=_,this.subscriptions=c}}e.ActivatedExtension=n;class R extends n{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class C extends n{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class v extends n{constructor(s){super(!0,s,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=v;let m=class{constructor(s,p,h,w,_){this._logService=_,this._registry=s,this._resolvedExtensionsSet=new Set,p.forEach(c=>this._resolvedExtensionsSet.add(k.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,h.forEach(c=>this._hostExtensionsMap.set(k.ExtensionIdentifier.toKey(c),c)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(s){const p=k.ExtensionIdentifier.toKey(s);return this._activatedExtensions.has(p)}getActivatedExtension(s){const p=k.ExtensionIdentifier.toKey(s),h=this._activatedExtensions.get(p);if(!h)throw new Error("Extension `"+s.value+"` is not known or not activated");return h}activateByEvent(s,p){if(this._alreadyActivatedEvents[s])return S;const h=this._registry.getExtensionDescriptionsForActivationEvent(s);return this._activateExtensions(h.map(w=>({id:w.identifier,reason:{startup:p,extensionId:w.identifier,activationEvent:s}}))).then(()=>{this._alreadyActivatedEvents[s]=!0})}activateById(s,p){const h=this._registry.getExtensionDescription(s);if(!h)throw new Error("Extension `"+s+"` is not known");return this._activateExtensions([{id:h.identifier,reason:p}])}_handleActivateRequest(s,p,h){if(this._hostExtensionsMap.has(k.ExtensionIdentifier.toKey(s.id))){p[k.ExtensionIdentifier.toKey(s.id)]=s;return}const w=this._registry.getExtensionDescription(s.id);if(!w){this._host.onExtensionActivationError(s.id,new A.MissingDependencyError(s.id.value));const l=new Error(`Unknown dependency '${s.id.value}'`);this._activatedExtensions.set(k.ExtensionIdentifier.toKey(s.id),new v(l));return}const _=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let c=!0;for(let l=0,t=_.length;l<t;l++){const r=_[l];if(!this._resolvedExtensionsSet.has(k.ExtensionIdentifier.toKey(r))){const u=this._activatedExtensions.get(k.ExtensionIdentifier.toKey(r));if(!(u&&!u.activationFailed)){if(u&&u.activationFailed){this._host.onExtensionActivationError(w.identifier,E.localize(0,null,w.displayName||w.identifier.value,r));const f=new Error(`Dependency ${r} failed to activate`);f.detail=u.activationFailedError,this._activatedExtensions.set(k.ExtensionIdentifier.toKey(w.identifier),new v(f));return}if(this._hostExtensionsMap.has(k.ExtensionIdentifier.toKey(r))){c=!1,p[k.ExtensionIdentifier.toKey(r)]={id:this._hostExtensionsMap.get(k.ExtensionIdentifier.toKey(r)),reason:s.reason};continue}const o=this._registry.getExtensionDescription(r);if(o){c=!1,p[k.ExtensionIdentifier.toKey(r)]={id:o.identifier,reason:s.reason};continue}this._host.onExtensionActivationError(w.identifier,new A.MissingDependencyError(r));const a=new Error(`Unknown dependency '${r}'`);this._activatedExtensions.set(k.ExtensionIdentifier.toKey(w.identifier),new v(a));return}}}c?p[k.ExtensionIdentifier.toKey(w.identifier)]=s:h.push(s)}_activateExtensions(s){if(s.length===0||(s=s.filter(_=>!this._activatedExtensions.has(k.ExtensionIdentifier.toKey(_.id))),s.length===0))return Promise.resolve(void 0);const p=Object.create(null),h=[];for(let _=0,c=s.length;_<c;_++)this._handleActivateRequest(s[_],p,h);for(let _=0,c=h.length;_<c;_++){const l=k.ExtensionIdentifier.toKey(h[_].id);p[l]&&delete p[l]}const w=Object.keys(p).map(_=>p[_]);return h.length===0?Promise.all(w.map(_=>this._activateExtension(_.id,_.reason))).then(_=>{}):this._activateExtensions(w).then(_=>this._activateExtensions(h))}_activateExtension(s,p){const h=k.ExtensionIdentifier.toKey(s);if(this._activatedExtensions.has(h))return Promise.resolve(void 0);const w=this._activatingExtensions.get(h);if(w)return w;const _=this._host.actualActivateExtension(s,p).then(void 0,c=>(this._host.onExtensionActivationError(s,E.localize(1,null,s.value,c.message)),this._logService.error(`Activating extension ${s.value} failed due to an error:`),this._logService.error(c),new v(c))).then(c=>{this._activatedExtensions.set(h,c),this._activatingExtensions.delete(h)});return this._activatingExtensions.set(h,_),_}};m=je([Ke(4,T.ILogService)],m),e.ExtensionsActivator=m}),define(be[185],we([0,1,10]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class k{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,S)=>{this._actualOk=T,this._actualErr=S,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,E.onUnexpectedError)(T))}then(T,S){return this._ensureActual().then(T,S)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=k}),define(be[97],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class E{constructor(y,n){this.isMain=y,this.sid=n,this.nid=++E.count}}e.ProxyIdentifier=E,E.count=0;const k=[];function A(I){const y=new E(!0,I);return k[y.nid]=y,y}e.createMainContextProxyIdentifier=A;function T(I){const y=new E(!1,I);return k[y.nid]=y,y}e.createExtHostContextProxyIdentifier=T;function S(I){return k[I].sid}e.getStringIdentifierForProxy=S}),define(be[5],we([0,1,2,97,57]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var S;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(S=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var n;(function(c){c[c.Markdown=1]="Markdown",c[c.Code=2]="Code"})(n=e.CellKind||(e.CellKind={}));var R;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(R=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var v;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(v=e.CandidatePortSource||(e.CandidatePortSource={}));var m;(function(c){c.name="$ident";function l(r,u){return Object.defineProperty(r,c.name,{value:u,enumerable:!0}),r}c.mixin=l;function t(r){return r[c.name]}c.of=t})(m=e.ObjectIdentifier||(e.ObjectIdentifier={}));class i{static mixin(l){return l._id=i._n++,l}}e.IdObject=i,i._n=0;var s;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n",c.label2="o"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var h;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(h=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(c){if(c&&c.edits)for(const l of c.edits)typeof l.resource=="object"?l.resource=E.URI.revive(l.resource):(l.newUri=E.URI.revive(l.newUri),l.oldUri=E.URI.revive(l.oldUri)),l.metadata&&l.metadata.iconPath&&(l.metadata=(0,A.revive)(l.metadata));return c}e.reviveWorkspaceEditDto=w;var _;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(_=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,k.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[71],we([0,1,5,3,4]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(I){this._onDidChangePassword=new k.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(E.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,y){return this._proxy.$getPassword(I,y)}store(I,y,n){return this._proxy.$setPassword(I,y,n)}delete(I,y){return this._proxy.$deletePassword(I,y)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,A.createDecorator)("IExtHostSecretState")}),define(be[72],we([0,1,4,19,5,14]),function(ie,e,E,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,E.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(y,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(A.MainContext.MainThreadTelemetry)}report(y,n,R){const C=this.getUsageKey(y,n);this._reportedUsages.has(C)||(this._reportedUsages.add(C),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:y}))}getUsageKey(y,n){return`${y}-${n.identifier.value}`}};S=je([Ke(0,T.IExtHostRpcService),Ke(1,k.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(I,y,n){}})}),define(be[186],we([0,1,3,5,7,26]),function(ie,e,E,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new E.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new E.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,n,R,C={}){const v=T.ExtensionIdentifier.toKey(y.identifier),m=this._inFlightRequests.get(v)||[],i=R.sort().join(" ");let s=m.find(p=>p.scopes===i);if(s)return s.result;{const p=this._getSession(y,v,n,R,C);s={scopes:i,result:p},m.push(s),this._inFlightRequests.set(v,m);try{await p}finally{const h=m.findIndex(w=>w.scopes===i);h>-1&&(m.splice(h),this._inFlightRequests.set(v,m))}return p}}async _getSession(y,n,R,C,v={}){await this._proxy.$ensureProvider(R);const m=y.displayName||y.name;return this._proxy.$getSession(R,C,n,m,v)}async removeSession(y,n){const R=this._authenticationProviders.get(y);return R?R.provider.removeSession(n):this._proxy.$removeSession(y,n)}registerAuthenticationProvider(y,n,R,C){var v;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:n,provider:R,options:C!=null?C:{supportsMultipleAccounts:!1}}),this._providers.find(i=>i.id===y)||this._providers.push({id:y,label:n});const m=R.onDidChangeSessions(i=>{var s,p,h;this._proxy.$sendDidChangeSessions(y,{added:(s=i.added)!==null&&s!==void 0?s:[],changed:(p=i.changed)!==null&&p!==void 0?p:[],removed:(h=i.removed)!==null&&h!==void 0?h:[]})});return this._proxy.$registerAuthenticationProvider(y,n,(v=C==null?void 0:C.supportsMultipleAccounts)!==null&&v!==void 0?v:!1),new A.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(y);const i=this._providers.findIndex(s=>s.id===y);i>-1&&this._providers.splice(i),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,n){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.createSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,n){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.removeSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,n){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.getSessions(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,n){return this._onDidChangeSessions.fire({provider:{id:y,label:n}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,n){return y.forEach(R=>{this._providers.some(C=>C.id===R.id)||this._providers.push(R)}),n.forEach(R=>{const C=this._providers.findIndex(v=>v.id===R.id);C>-1&&this._providers.splice(C)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(be[187],we([0,1,5,14,9]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(I,y){this._extHostDocumentsAndEditors=y,this._proxy=I.getProxy(E.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const y=A.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};T=je([Ke(0,k.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(be[188],we([0,1,5]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(T){const S=T.getProxy(E.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(I){return S.$writeText(I)}})}}e.ExtHostClipboard=k}),define(be[73],we([0,1,12,7,9,23,5,15,19,57,32,38,2,6,4,14]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let p=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(S.MainContext.MainThreadCommands),this._logService=r,this.converter=new h(this,u=>{const o=this._apiCommands.get(u);return(o==null?void 0:o.result)===_.Void?o:void 0},r),this._argumentProcessors=[{processArgument(u){return(0,n.revive)(u)}},{processArgument(u){return(0,T.cloneAndChange)(u,function(o){if(R.Range.isIRange(o))return A.Range.to(o);if(C.Position.isIPosition(o))return A.Position.to(o);if(R.Range.isIRange(o.range)&&v.URI.isUri(o.uri))return A.location.to(o);if(!Array.isArray(o))return o})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...u)=>{const o=t.args.map((f,b)=>{if(!f.validate(u[b]))throw new Error(`Invalid argument '${f.name}' when running '${t.id}', received: ${u[b]}`);return f.convert(u[b])}),a=await this.executeCommand(t.internalId,...o);return t.result.convert(a,u,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new k.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,u,o,a){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:u,thisArg:o,description:a}),t&&this._proxy.$registerCommand(r),new k.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,u){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const o=(0,T.cloneAndChange)(r,function(a){if(a instanceof k.Position)return A.Position.from(a);if(a instanceof k.Range)return A.Range.from(a);if(a instanceof k.Location)return A.location.from(a);if(!Array.isArray(a))return a});try{const a=await this._proxy.$executeCommand(t,o,u);return(0,n.revive)(a)}catch(a){if(a instanceof Error&&a.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw a}}}async _executeContributedCommand(t,r){const u=this._commands.get(t);if(!u)throw new Error("Unknown command");let{callback:o,thisArg:a,description:f}=u;if(f)for(let b=0;b<f.args.length;b++)try{(0,E.validateConstraint)(r[b],f.args[b].constraint)}catch(D){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${f.args[b].name}' - ${f.args[b].description}`)}try{return await o.apply(a,r)}catch(b){if(t===this.converter.delegatingCommandId){const D=this.converter.getActualCommand(...r);D&&(t=D.command)}throw this._logService.error(b,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(u=>this._argumentProcessors.reduce((o,a)=>a.processArgument(o),u)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(u=>u[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,u]of this._commands){let{description:o}=u;o&&(t[r]=o)}return Promise.resolve(t)}};p=je([Ke(0,s.IExtHostRpcService),Ke(1,y.ILogService)],p),e.ExtHostCommands=p,e.IExtHostCommands=(0,i.createDecorator)("IExtHostCommands");class h{constructor(t,r,u){this._commands=t,this._lookupApiCommand=r,this._logService=u,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!!t){const u={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return u;const o=this._lookupApiCommand(t.command);if(o)u.id=o.internalId,u.arguments=o.args.map((a,f)=>a.convert(t.arguments&&t.arguments[f]));else if((0,I.isNonEmptyArray)(t.arguments)){const a=++this._cachIdPool;this._cache.set(a,t),r.add((0,m.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),u.$ident=a,u.id=this.delegatingCommandId,u.arguments=[a],this._logService.trace("CommandsConverter#CREATE",t.command,a)}return u}}fromInternal(t){const r=S.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=h;class w{constructor(t,r,u,o){this.name=t,this.description=r,this.validate=u,this.convert=o}optional(){return new w(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new w(t!=null?t:this.name,r!=null?r:this.description,this.validate,this.convert)}}e.ApiCommandArgument=w,w.Uri=new w("uri","Uri of a text document",l=>v.URI.isUri(l),l=>l),w.Position=new w("position","A position in a text document",l=>k.Position.isPosition(l),A.Position.from),w.Range=new w("range","A range in a text document",l=>k.Range.isRange(l),A.Range.from),w.Selection=new w("selection","A selection in a text document",l=>k.Selection.isSelection(l),A.Selection.from),w.Number=new w("number","",l=>typeof l=="number",l=>l),w.String=new w("string","",l=>typeof l=="string",l=>l),w.CallHierarchyItem=new w("item","A call hierarchy item",l=>l instanceof k.CallHierarchyItem,A.CallHierarchyItem.to);class _{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=_,_.Void=new _("no result",l=>l);class c{constructor(t,r,u,o,a){this.id=t,this.internalId=r,this.description=u,this.args=o,this.result=a}}e.ApiCommand=c}),define(be[189],we([0,1,6,9,7,62,73,167,15,84]),function(ie,e,E,k,A,T,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const R=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",v(k.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(i,s)=>{if(!(0,y.isFalsyOrEmpty)(i)){class p extends A.SymbolInformation{static to(w){const _=new p(w.name,k.SymbolKind.to(w.kind),w.containerName||"",new A.Location(s[0],k.Range.to(w.range)));return _.detail=w.detail,_.range=_.location.range,_.selectionRange=k.Range.to(w.selectionRange),_.children=w.children?w.children.map(p.to):[],_}}return i.map(p.to)}})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new S.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",v(k.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",v(k.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(s=>A.Position.isPosition(s)),i=>i.map(k.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(s=>{let p;for(const h of s.reverse())p=new A.SelectionRange(k.Range.to(h),p);return p}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>{const s=[];if(Array.isArray(i))for(let p of i)s.push(...p[1].map(k.WorkspaceSymbol.to));return s})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(k.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(k.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(k.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(!!i){if(i.rejectReason)throw new Error(i.rejectReason);return k.WorkspaceEdit.to(i)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(k.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new A.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!!i){const s=(0,n.decodeSemanticTokensDto)(i);if(s.type==="full")return new A.SemanticTokens(s.data,void 0)}})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new A.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!!i){const s=(0,n.decodeSemanticTokensDto)(i);if(s.type==="full")return new A.SemanticTokens(s.data,void 0)}})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,s,p)=>{if(!i)return new A.CompletionList([]);const h=i.suggestions.map(w=>k.CompletionItem.to(w,p));return new A.CompletionList(h,i.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return k.SignatureHelp.to(i)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,s,p)=>v(h=>new A.CodeLens(k.Range.to(h.range),h.command&&p.fromInternal(h.command)))(i))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>A.Range.isRange(i),i=>A.Selection.isSelection(i)?k.Selection.from(i):k.Range.from(i)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,s,p)=>v(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(h.command)}else{const w=new A.CodeAction(h.title,h.kind?new A.CodeActionKind(h.kind):void 0);return h.edit&&(w.edit=k.WorkspaceEdit.to(h.edit)),h.command&&(w.command=p.fromInternal(h.command)),w.isPreferred=h.isPreferred,w}})(i))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(s=>new A.ColorInformation(k.Range.to(s.range),k.Color.to(s.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",i=>i instanceof A.Color,k.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:k.Range.from(i.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(k.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineHint objects",i=>i.map(k.InlineHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",v(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientMetadata:i.options.transientMetadata},filenamePattern:i.filenamePattern.map(s=>k.NotebookExclusiveDocumentPattern.to(s))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(k.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[i,void 0]:[k.ViewColumn.from(i.viewColumn),k.TextEditorOpenOptions.from(i)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[i,void 0]:[k.ViewColumn.from(i.viewColumn),k.TextEditorOpenOptions.from(i)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[k.ViewColumn.from(i.viewColumn),k.TextEditorOpenOptions.from(i)]).optional()],S.ApiCommandResult.Void)];class C{constructor(s){this._disposables=new E.DisposableStore,this._commands=s}static register(s){return R.forEach(s.registerApiCommand,s),new C(s).registerCommands()}registerCommands(){const s=p=>(...h)=>p(this._commands,...h);this._register(I.RemoveFromRecentlyOpenedAPICommand.ID,s(I.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:p=>typeof p=="string"}]}),this._register(I.OpenIssueReporter.ID,s(I.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:p=>typeof p=="string"||typeof p=="object"&&typeof p.extensionId=="string"}]})}_register(s,p,h){const w=this._commands.registerCommand(!1,s,p,this,h);this._disposables.add(w)}}e.ExtHostApiCommands=C;function v(i){return s=>{if(Array.isArray(s))return s.map(i)}}function m(i){if(!!Array.isArray(i)){const s=[];for(const p of i)T.isLocationLink(p)?s.push(k.DefinitionLink.to(p)):s.push(k.location.to(p));return s}}}),define(be[190],we([0,1,13,51,3,6,2,62,26,9,7,5]),function(ie,e,E,k,A,T,S,I,y,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class v{constructor(c,l,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=c.getProxy(C.MainContext.MainThreadComments),l.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const u=this._commentControllers.get(r.handle);return u||r}else if(r&&r.$mid===7){const u=this._commentControllers.get(r.commentControlHandle);if(!u)return r;const o=u.getCommentThread(r.commentThreadHandle);return o||r}else if(r&&r.$mid===8){const u=this._commentControllers.get(r.thread.commentControlHandle);if(!u)return r;const o=u.getCommentThread(r.thread.commentThreadHandle);return o?{thread:o,text:r.text}:r}else if(r&&r.$mid===9){const u=this._commentControllers.get(r.thread.commentControlHandle);if(!u)return r;const o=u.getCommentThread(r.thread.commentThreadHandle);if(!o)return r;let a=r.commentUniqueId,f=o.getCommentByUniqueId(a);return f||r}else if(r&&r.$mid===10){const u=this._commentControllers.get(r.thread.commentControlHandle);if(!u)return r;const o=u.getCommentThread(r.thread.commentThreadHandle);if(!o)return r;let a=r.text,f=r.commentUniqueId,b=o.getCommentByUniqueId(f);return b?(b.body=a,b):r}return r}})}createCommentController(c,l,t){const r=v.handlePool++,u=new i(c,r,this._proxy,l,t);this._commentControllers.set(u.handle,u);const o=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(c.identifier))||[];return o.push(u),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(c.identifier),o),u}$createCommentThreadTemplate(c,l,t){const r=this._commentControllers.get(c);!r||r.$createCommentThreadTemplate(l,t)}async $updateCommentThreadTemplate(c,l,t){const r=this._commentControllers.get(c);!r||r.$updateCommentThreadTemplate(l,t)}$deleteCommentThread(c,l){const t=this._commentControllers.get(c);t&&t.$deleteCommentThread(l)}$provideCommentingRanges(c,l,t){const r=this._commentControllers.get(c);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const u=this._documents.getDocument(S.URI.revive(l));return(0,E.asPromise)(()=>r.commentingRangeProvider.provideCommentingRanges(u,t)).then(o=>o?o.map(a=>n.Range.from(a)):void 0)}$toggleReaction(c,l,t,r,u){const o=this._commentControllers.get(c);return!o||!o.reactionHandler?Promise.resolve(void 0):(0,E.asPromise)(()=>{const a=o.getCommentThread(l);if(a){const f=a.getCommentByUniqueId(r.uniqueIdInThread);if(o!==void 0&&f&&o.reactionHandler)return o.reactionHandler(f,h(u))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=v,v.handlePool=0;class m{constructor(c,l,t,r,u,o,a){this._proxy=c,this._commentController=l,this._id=t,this._uri=r,this._range=u,this._comments=o,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new A.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${l.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),a),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=o}set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const c=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),l={};c("range")&&(l.range=n.Range.from(this._range)),c("label")&&(l.label=this.label),c("contextValue")&&(l.contextValue=this.contextValue),c("comments")&&(l.comments=this._comments.map(t=>s(this,this._commentController,t,this._commentsMap))),c("collapsibleState")&&(l.collapseState=w(this._collapseState)),c("canReply")&&(l.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,l)}}getCommentByUniqueId(c){for(let l of this._commentsMap){let t=l[0],r=l[1];if(c===r)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}m._handlePool=0,je([(0,k.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=m;class i{constructor(c,l,t,r,u){this._extension=c,this._handle=l,this._proxy=t,this._id=r,this._label=u,this._threads=new Map,this._proxy.$registerCommentController(this.handle,r,u)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(c,l,t,r){if(typeof c=="string"){const u=new m(this._proxy,this,c,l,t,r,this._extension.identifier);return this._threads.set(u.handle,u),u}else{const u=new m(this._proxy,this,void 0,c,l,t,this._extension.identifier);return this._threads.set(u.handle,u),u}}$createCommentThreadTemplate(c,l){const t=new m(this._proxy,this,void 0,S.URI.revive(c),n.Range.to(l),[],this._extension.identifier);return t.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(c,l){let t=this._threads.get(c);t&&(t.range=n.Range.to(l))}$deleteCommentThread(c){let l=this._threads.get(c);l&&l.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function s(_,c,l,t){let r=t.get(l);r||(r=++_.commentHandle,t.set(l,r));const u=l.author&&l.author.iconPath?l.author.iconPath.toString():void 0;return{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:r,body:n.MarkdownString.from(l.body),userName:l.author.name,userIconPath:u,label:l.label,commentReactions:l.reactions?l.reactions.map(o=>p(o)):void 0}}function p(_){return{label:_.label,iconPath:_.iconPath?n.pathOrURIToURI(_.iconPath):void 0,count:_.count,hasReacted:_.authorHasReacted}}function h(_){return{label:_.label||"",count:_.count||0,iconPath:_.iconPath?S.URI.revive(_.iconPath):"",authorHasReacted:_.hasReacted||!1}}function w(_){if(_!==void 0)switch(_){case R.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}}),define(be[98],we([0,1,2,5,7,4,14,19,15,8,11]),function(ie,e,E,k,A,T,S,I,y,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class un{constructor(m,i){this._logService=i,this._provider=new Map,this._proxy=m.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,i){const s=un._handlePool++;this._provider.set(s,{provider:m,extensionId:i}),this._proxy.$registerDecorationProvider(s,i.value);const p=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(h=>{if(!h){this._proxy.$onDidChange(s,null);return}let w=(0,y.asArray)(h);if(w.length<=un._maxEventSize){this._proxy.$onDidChange(s,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",i.value,w.length);const _=w.map(t=>({uri:t,rank:(0,n.count)(t.path,"/")})),c=(0,y.groupBy)(_,(t,r)=>t.rank-r.rank||(0,n.compare)(t.uri.path,r.uri.path));let l=[];e:for(let t of c){let r;for(let u of t){let o=(0,R.dirname)(u.uri.path);if(r!==o&&(r=o,l.push(u.uri)>=un._maxEventSize))break e}}this._proxy.$onDidChange(s,l)});return new A.Disposable(()=>{p==null||p.dispose(),this._proxy.$unregisterDecorationProvider(s),this._provider.delete(s)})}async $provideDecorations(m,i,s){if(!this._provider.has(m))return Object.create(null);const p=Object.create(null),{provider:h,extensionId:w}=this._provider.get(m);return await Promise.all(i.map(async _=>{try{const{uri:c,id:l}=_,t=await Promise.resolve(h.provideFileDecoration(E.URI.revive(c),s));if(!t)return;try{A.FileDecoration.validate(t),p[l]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${w.value}': ${r}`)}}catch(c){this._logService.error(c)}})),p}};C._handlePool=0,C._maxEventSize=250,C=je([Ke(0,S.IExtHostRpcService),Ke(1,I.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(be[191],we([0,1,129,87,2,5,7,9,3,19,22]),function(ie,e,E,k,A,T,S,I,y,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(i,s,p,h,w){this._name=i,this._owner=s,this._maxDiagnosticsPerFile=p,this._proxy=h,this._onDidChangeDiagnostics=w,this._isDisposed=!1,this._data=new R.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(i,s){if(!i){this.clear();return}this._checkDisposed();let p=[];if(A.URI.isUri(i)){if(!s){this.delete(i);return}this._data.set(i,s.slice()),p=[i]}else if(Array.isArray(i)){p=[];let w;i=[...i].sort(C._compareIndexedTuplesByUri);for(const _ of i){const[c,l]=_;if((!w||c.toString()!==w.toString())&&(w&&this._data.get(w).length===0&&this._data.delete(w),w=c,p.push(c),this._data.set(c,[])),l){const t=this._data.get(c);t&&t.push(...l)}else{const t=this._data.get(c);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(p),!!this._proxy){const h=[];for(let w of p){let _=[];const c=this._data.get(w);if(c)if(c.length>this._maxDiagnosticsPerFile){_=[];const l=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of c)if(r.severity===l[t]&&_.push(I.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;_.push({severity:k.MarkerSeverity.Info,message:(0,E.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:_[_.length-1].startLineNumber,startColumn:_[_.length-1].startColumn,endLineNumber:_[_.length-1].endLineNumber,endColumn:_[_.length-1].endColumn})}else _=c.map(l=>I.Diagnostic.from(l));h.push([w,_])}this._proxy.$changeMany(this._owner,h)}}delete(i){this._checkDisposed(),this._onDidChangeDiagnostics.fire([i]),this._data.delete(i),this._proxy&&this._proxy.$changeMany(this._owner,[[i,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(i,s){this._checkDisposed();for(let p of this._data.keys())i.apply(s,[p,this.get(p),this])}get(i){this._checkDisposed();const s=this._data.get(i);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(i){return this._checkDisposed(),Array.isArray(this._data.get(i))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(i,s){return i[0].toString()<s[0].toString()?-1:i[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=C;let v=class Wt{constructor(i,s){this._logService=s,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,Wt._debouncer,50),Wt._mapper),this._proxy=i.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(i,s){return i?i.concat(s):s}static _mapper(i){const s=[],p=new Set;for(const h of i)typeof h=="string"?p.has(h)||(p.add(h),s.push(A.URI.parse(h))):p.has(h.toString())||(p.add(h.toString()),s.push(h));return Object.freeze(s),{uris:s}}createDiagnosticCollection(i,s){const{_collections:p,_proxy:h,_onDidChangeDiagnostics:w,_logService:_}=this,c=new class{$changeMany(r,u){h.$changeMany(r,u),_.trace("[DiagnosticCollection] change many (extension, owner, uris)",i.value,r,u.length===0?"CLEARING":u)}$clear(r){h.$clear(r),_.trace("[DiagnosticCollection] remove all (extension, owner)",i.value,r)}dispose(){h.dispose()}};let l;if(!s)s="_generated_diagnostic_collection_name_#"+Wt._idPool++,l=s;else if(!p.has(s))l=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do l=s+Wt._idPool++;while(p.has(l))}return new class extends C{constructor(){super(s,l,Wt._maxDiagnosticsPerFile,c,w);p.set(l,this)}dispose(){super.dispose(),p.delete(l)}}}getDiagnostics(i){if(i)return this._getDiagnostics(i);{const s=new Map,p=[];for(const h of this._collections.values())h.forEach((w,_)=>{let c=s.get(w.toString());typeof c=="undefined"&&(c=p.length,s.set(w.toString(),c),p.push([w,[]])),p[c][1]=p[c][1].concat(..._)});return p}}_getDiagnostics(i){let s=[];for(let p of this._collections.values())p.has(i)&&(s=s.concat(p.get(i)));return s}$acceptMarkersChange(i){if(!this._mirrorCollection){const s="_generated_mirror",p=new C(s,s,Wt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(s,p),this._mirrorCollection=p}for(const[s,p]of i)this._mirrorCollection.set(A.URI.revive(s),p.map(I.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=je([Ke(1,n.ILogService)],v),e.ExtHostDiagnostics=v}),define(be[192],we([0,1,2,5]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(S){this._proxy=S.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(S){return this._proxy.$showOpenDialog(S).then(I=>I?I.map(y=>E.URI.revive(y)):void 0)}showSaveDialog(S){return this._proxy.$showSaveDialog(S).then(I=>I?E.URI.revive(I):void 0)}}e.ExtHostDialogs=A}),define(be[193],we([0,1,10,2,7,5,18,20,8]),function(ie,e,E,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(C,v,m){this._documentsAndEditors=v,this._logService=m,this._documentContentProviders=new Map,this._proxy=C.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,v){if(Object.keys(S.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const m=n._handlePool++;this._documentContentProviders.set(m,v),this._proxy.$registerTextContentProvider(m,C);let i;return typeof v.onDidChange=="function"&&(i=v.onDidChange(s=>{if(s.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(s)&&this.$provideTextDocumentContent(m,s).then(p=>{if(!(!p&&typeof p!="string")){const h=this._documentsAndEditors.getDocument(s);if(!!h){const w=(0,y.splitLines)(p);if(!h.equalLines(w))return this._proxy.$onVirtualDocumentChange(s,p)}}},E.onUnexpectedError)})),new A.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),i&&(i.dispose(),i=void 0)})}$provideTextDocumentContent(C,v){const m=this._documentContentProviders.get(C);return m?Promise.resolve(m.provideTextDocumentContent(k.URI.revive(v),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(be[194],we([0,1,3,6,2,5,94,9,12,23]),function(ie,e,E,k,A,T,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class R{constructor(v,m){this._onDidAddDocument=new E.Emitter,this._onDidRemoveDocument=new E.Emitter,this._onDidChangeDocument=new E.Emitter,this._onDidSaveDocument=new E.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new k.DisposableStore,this._documentLoader=new Map,this._proxy=v.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(i=>{for(const s of i)this._onDidRemoveDocument.fire(s.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(i=>{for(const s of i)this._onDidAddDocument.fire(s.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(v){if(!!v){const m=this._documentsAndEditors.getDocument(v);if(m)return m}}getDocument(v){const m=this.getDocumentData(v);if(!(m==null?void 0:m.document))throw new Error(`Unable to retrieve document from URI '${v}'`);return m.document}ensureDocumentData(v){const m=this._documentsAndEditors.getDocument(v);if(m)return Promise.resolve(m);let i=this._documentLoader.get(v.toString());return i||(i=this._proxy.$tryOpenDocument(v).then(s=>{this._documentLoader.delete(v.toString());const p=A.URI.revive(s);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(p))},s=>(this._documentLoader.delete(v.toString()),Promise.reject(s))),this._documentLoader.set(v.toString(),i)),i}createDocumentData(v){return this._proxy.$tryCreateDocument(v).then(m=>A.URI.revive(m))}$acceptModelModeChanged(v,m){const i=A.URI.revive(v),s=this._documentsAndEditors.getDocument(i);if(!s)throw new Error("unknown document");this._onDidRemoveDocument.fire(s.document),s._acceptLanguageId(m),this._onDidAddDocument.fire(s.document)}$acceptModelSaved(v){const m=A.URI.revive(v),i=this._documentsAndEditors.getDocument(m);if(!i)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this._onDidSaveDocument.fire(i.document)}$acceptDirtyStateChanged(v,m){const i=A.URI.revive(v),s=this._documentsAndEditors.getDocument(i);if(!s)throw new Error("unknown document");s._acceptIsDirty(m),this._onDidChangeDocument.fire({document:s.document,contentChanges:[]})}$acceptModelChanged(v,m,i){const s=A.URI.revive(v),p=this._documentsAndEditors.getDocument(s);if(!p)throw new Error("unknown document");p._acceptIsDirty(i),p.onEvents(m),this._onDidChangeDocument.fire((0,n.deepFreeze)({document:p.document,contentChanges:m.changes.map(h=>({range:I.Range.to(h.range),rangeOffset:h.rangeOffset,rangeLength:h.rangeLength,text:h.text}))}))}setWordDefinitionFor(v,m){(0,S.setWordDefinitionFor)(v,m)}}e.ExtHostDocuments=R}),define(be[39],we([0,1,42,3,6,2,4,5,94,14,96,9,19,22,18,54,106]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m,i,s,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(c,l){this._extHostRpc=c,this._logService=l,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new k.Emitter,this._onDidRemoveDocuments=new k.Emitter,this._onDidChangeVisibleTextEditors=new k.Emitter,this._onDidChangeActiveTextEditor=new k.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const l=[],t=[],r=[];if(c.removedDocuments)for(const u of c.removedDocuments){const o=T.URI.revive(u),a=this._documents.get(o);(a==null?void 0:a.unref())&&(this._documents.delete(o),l.push(a.value))}if(c.addedDocuments)for(const u of c.addedDocuments){const o=T.URI.revive(u.uri);let a=this._documents.get(o);if(a&&o.scheme!==i.Schemas.vscodeNotebookCell)throw new Error(`document '${o} already exists!'`);a||(a=new h(new y.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),o,u.lines,u.EOL,u.versionId,u.modeId,u.isDirty,u.notebook)),this._documents.set(o,a),t.push(a.value)),a.ref()}if(c.removedEditors)for(const u of c.removedEditors){const o=this._editors.get(u);this._editors.delete(u),o&&r.push(o)}if(c.addedEditors)for(const u of c.addedEditors){const o=T.URI.revive(u.documentUri);E.ok(this._documents.has(o),`document '${o}' does not exist`),E.ok(!this._editors.has(u.id),`editor '${u.id}' already exists!`);const a=this._documents.get(o).value,f=new R.ExtHostTextEditor(u.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>a.document),u.selections.map(C.Selection.to),u.options,u.visibleRanges.map(b=>C.Range.to(b)),typeof u.editorPosition=="number"?C.ViewColumn.to(u.editorPosition):void 0);this._editors.set(u.id,f)}c.newActiveEditor!==void 0&&(E.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,A.dispose)(l),(0,A.dispose)(r),c.removedDocuments&&this._onDidRemoveDocuments.fire(l),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(u=>u.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){var l;return(l=this._documents.get(c))===null||l===void 0?void 0:l.value}allDocuments(){return s.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!!this._activeEditorId){const l=this._editors.get(this._activeEditorId);return c?l:l==null?void 0:l.value}}allEditors(){return[...this._editors.values()]}};w=je([Ke(0,n.IExtHostRpcService),Ke(1,v.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[195],we([0,1,2,5,6,7,9,116,8,24]),function(ie,e,E,k,A,T,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class R{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const i=this._schemes.indexOf(m);i>=0&&(this._schemes.splice(i,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),i=[];let s,p,h=14,w=14;for(const _ of m){let c=s?(0,y.commonPrefixLength)(s,_):0;for(c===0?p=1:p=w;c<_.length;c++)c+1===_.length?(h=w,w=9):w+=1,i.push([p,_.toUpperCase().charCodeAt(c),w]),i.push([p,_.toLowerCase().charCodeAt(c),w]),p=w;s=_,w=h}i.push([9,58,10]),i.push([10,47,12]),this._stateMachine=new I.StateMachine(i)}}provideDocumentLinks(m){this._initStateMachine();const i=[],s=I.LinkComputer.computeLinks({getLineContent(p){return m.lineAt(p-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const p of s){const h=S.DocumentLink.to(p);h.target&&i.push(h)}return i}}class C{constructor(m,i){this._extHostLanguageFeatures=i,this._linkProvider=new R,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){var m;(m=this._linkProviderRegistration)===null||m===void 0||m.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,i,s,p={}){if(this._registeredSchemes.has(i))throw new Error(`a provider for the scheme '${i}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const h=this._handlePool++;this._linkProvider.add(i),this._registeredSchemes.add(i),this._fsProvider.set(h,s);let w=2;p.isCaseSensitive&&(w+=1024),p.isReadonly&&(w+=2048),typeof s.copy=="function"&&(w+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&(w+=4),this._proxy.$registerFileSystemProvider(h,i,w).catch(c=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${i}`),console.error(c)});const _=s.onDidChangeFile(c=>{const l=[];for(const t of c){let{uri:r,type:u}=t;if(r.scheme===i){let o;switch(u){case T.FileChangeType.Changed:o=0;break;case T.FileChangeType.Created:o=1;break;case T.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:r,type:o})}}this._proxy.$onFileSystemChange(h,l)});return(0,A.toDisposable)(()=>{_.dispose(),this._linkProvider.delete(i),this._registeredSchemes.delete(i),this._fsProvider.delete(h),this._proxy.$unregisterProvider(h)})}static _asIStat(m){const{type:i,ctime:s,mtime:p,size:h}=m;return{type:i,ctime:s,mtime:p,size:h}}$stat(m,i){return Promise.resolve(this._getFsProvider(m).stat(E.URI.revive(i))).then(C._asIStat)}$readdir(m,i){return Promise.resolve(this._getFsProvider(m).readDirectory(E.URI.revive(i)))}$readFile(m,i){return Promise.resolve(this._getFsProvider(m).readFile(E.URI.revive(i))).then(s=>n.VSBuffer.wrap(s))}$writeFile(m,i,s,p){return Promise.resolve(this._getFsProvider(m).writeFile(E.URI.revive(i),s.buffer,p))}$delete(m,i,s){return Promise.resolve(this._getFsProvider(m).delete(E.URI.revive(i),s))}$rename(m,i,s,p){return Promise.resolve(this._getFsProvider(m).rename(E.URI.revive(i),E.URI.revive(s),p))}$copy(m,i,s,p){const h=this._getFsProvider(m);if(!h.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(h.copy(E.URI.revive(i),E.URI.revive(s),p))}$mkdir(m,i){return Promise.resolve(this._getFsProvider(m).createDirectory(E.URI.revive(i)))}$watch(m,i,s,p){const h=this._getFsProvider(m).watch(E.URI.revive(s),p);this._watches.set(i,h)}$unwatch(m,i){const s=this._watches.get(i);s&&(s.dispose(),this._watches.delete(i))}$open(m,i,s){const p=this._getFsProvider(m);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(E.URI.revive(i),s))}$close(m,i){const s=this._getFsProvider(m);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(i))}$read(m,i,s,p){const h=this._getFsProvider(m);if(!h.read)throw new Error('FileSystemProvider does not implement "read"');const w=n.VSBuffer.alloc(p);return Promise.resolve(h.read(i,s,w.buffer,0,p)).then(_=>w.slice(0,_))}$write(m,i,s,p){const h=this._getFsProvider(m);if(!h.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(h.write(i,s,p.buffer,0,p.byteLength))}_getFsProvider(m){const i=this._fsProvider.get(m);if(!i){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return i}}e.ExtHostFileSystem=C}),define(be[74],we([0,1,5,64,7,24,4,14,48]),function(ie,e,E,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Tt{constructor(C,v){const m=C.getProxy(E.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(i){return m.$stat(i).catch(Tt._handleError)},readDirectory(i){return m.$readdir(i).catch(Tt._handleError)},createDirectory(i){return m.$mkdir(i).catch(Tt._handleError)},async readFile(i){return m.$readFile(i).then(s=>s.buffer).catch(Tt._handleError)},writeFile(i,s){return m.$writeFile(i,T.VSBuffer.wrap(s)).catch(Tt._handleError)},delete(i,s){return m.$delete(i,Object.assign({recursive:!1,useTrash:!1},s)).catch(Tt._handleError)},rename(i,s,p){return m.$rename(i,s,Object.assign({overwrite:!1},p)).catch(Tt._handleError)},copy(i,s,p){return m.$copy(i,s,Object.assign({overwrite:!1},p)).catch(Tt._handleError)},isWritableFileSystem(i){const s=v.getCapabilities(i);if(typeof s=="number")return!(s&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new A.FileSystemError(String(C));if(C.name==="ENOPRO")throw A.FileSystemError.Unavailable(C.message);switch(C.name){case k.FileSystemProviderErrorCode.FileExists:throw A.FileSystemError.FileExists(C.message);case k.FileSystemProviderErrorCode.FileNotFound:throw A.FileSystemError.FileNotFound(C.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw A.FileSystemError.FileNotADirectory(C.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw A.FileSystemError.FileIsADirectory(C.message);case k.FileSystemProviderErrorCode.NoPermissions:throw A.FileSystemError.NoPermissions(C.message);case k.FileSystemProviderErrorCode.Unavailable:throw A.FileSystemError.Unavailable(C.message);default:throw new A.FileSystemError(C.message,C.name)}}};n=je([Ke(0,I.IExtHostRpcService),Ke(1,y.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(be[196],we([0,1,6,5]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class A{constructor(S){this._handlePool=0,this._proxy=S.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,S),(0,E.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=A}),define(be[197],we([0,1,2,23,9,7,13,5,8,32,15,12,113,6,84,53,92,55,10]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m,i,s,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class _{constructor(N,G){this._documents=N,this._provider=G}provideDocumentSymbols(N,G){const te=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideDocumentSymbols(te,G)).then(ae=>{if(!(0,R.isFalsyOrEmpty)(ae))return ae[0]instanceof T.DocumentSymbol?ae.map(A.DocumentSymbol.from):_._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(N){var G;N=N.slice(0).sort((me,Se)=>{let Me=me.location.range.start.compareTo(Se.location.range.start);return Me===0&&(Me=Se.location.range.end.compareTo(me.location.range.end)),Me});const te=[],ae=[];for(const me of N){const Se={name:me.name||"!!MISSING: name!!",kind:A.SymbolKind.from(me.kind),tags:((G=me.tags)===null||G===void 0?void 0:G.map(A.SymbolTag.from))||[],detail:"",containerName:me.containerName,range:A.Range.from(me.location.range),selectionRange:A.Range.from(me.location.range),children:[]};for(;;){if(ae.length===0){ae.push(Se),te.push(Se);break}const Me=ae[ae.length-1];if(n.Range.containsRange(Me.range,Se.range)&&!n.Range.equalsRange(Me.range,Se.range)){Me.children&&Me.children.push(Se),ae.push(Se);break}ae.pop()}}return te}}class c{constructor(N,G,te){this._documents=N,this._commands=G,this._provider=te,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(N,G){const te=this._documents.getDocument(N),ae=await this._provider.provideCodeLenses(te,G);if(!(!ae||G.isCancellationRequested)){const me=this._cache.add(ae),Se=new m.DisposableStore;this._disposables.set(me,Se);const Me={cacheId:me,lenses:[]};for(let ge=0;ge<ae.length;ge++)Me.lenses.push({cacheId:[me,ge],range:A.Range.from(ae[ge].range),command:this._commands.toInternal(ae[ge].command,Se)});return Me}}async resolveCodeLens(N,G){var te;const ae=N.cacheId&&this._cache.get(...N.cacheId);if(!!ae){let me;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?me=ae:me=await this._provider.resolveCodeLens(ae,G),me||(me=ae),!G.isCancellationRequested){const Se=N.cacheId&&this._disposables.get(N.cacheId[0]);if(!!Se)return N.command=this._commands.toInternal((te=me.command)!==null&&te!==void 0?te:c._badCmd,Se),N}}}releaseCodeLenses(N){var G;(G=this._disposables.get(N))===null||G===void 0||G.dispose(),this._disposables.delete(N),this._cache.delete(N)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function l(ze){return Array.isArray(ze)?ze.map(A.DefinitionLink.from):ze?[A.DefinitionLink.from(ze)]:[]}class t{constructor(N,G){this._documents=N,this._provider=G}provideDefinition(N,G,te){const ae=this._documents.getDocument(N),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideDefinition(ae,me,te)).then(l)}}class r{constructor(N,G){this._documents=N,this._provider=G}provideDeclaration(N,G,te){const ae=this._documents.getDocument(N),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideDeclaration(ae,me,te)).then(l)}}class u{constructor(N,G){this._documents=N,this._provider=G}provideImplementation(N,G,te){const ae=this._documents.getDocument(N),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideImplementation(ae,me,te)).then(l)}}class o{constructor(N,G){this._documents=N,this._provider=G}provideTypeDefinition(N,G,te){const ae=this._documents.getDocument(N),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideTypeDefinition(ae,me,te)).then(l)}}class a{constructor(N,G){this._documents=N,this._provider=G}provideHover(N,G,te){const ae=this._documents.getDocument(N),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideHover(ae,me,te)).then(Se=>{if(!(!Se||(0,R.isFalsyOrEmpty)(Se.contents)))return Se.range||(Se.range=ae.getWordRangeAtPosition(me)),Se.range||(Se.range=new T.Range(me,me)),A.Hover.from(Se)})}}class f{constructor(N,G){this._documents=N,this._provider=G}provideEvaluatableExpression(N,G,te){const ae=this._documents.getDocument(N),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideEvaluatableExpression(ae,me,te)).then(Se=>{if(Se)return A.EvaluatableExpression.from(Se)})}}class b{constructor(N,G){this._documents=N,this._provider=G}provideInlineValues(N,G,te,ae){const me=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideInlineValues(me,A.Range.to(G),A.InlineValueContext.to(te),ae)).then(Se=>{if(Array.isArray(Se))return Se.map(Me=>A.InlineValue.from(Me))})}}class D{constructor(N,G){this._documents=N,this._provider=G}provideDocumentHighlights(N,G,te){const ae=this._documents.getDocument(N),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideDocumentHighlights(ae,me,te)).then(Se=>{if(Array.isArray(Se))return Se.map(A.DocumentHighlight.from)})}}class d{constructor(N,G){this._documents=N,this._provider=G}provideLinkedEditingRanges(N,G,te){const ae=this._documents.getDocument(N),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideLinkedEditingRanges(ae,me,te)).then(Se=>{if(Se&&Array.isArray(Se.ranges))return{ranges:(0,R.coalesce)(Se.ranges.map(A.Range.from)),wordPattern:Se.wordPattern}})}}class g{constructor(N,G){this._documents=N,this._provider=G}provideReferences(N,G,te,ae){const me=this._documents.getDocument(N),Se=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideReferences(me,Se,te,ae)).then(Me=>{if(Array.isArray(Me))return Me.map(A.location.from)})}}class P{constructor(N,G,te,ae,me,Se,Me){this._documents=N,this._commands=G,this._diagnostics=te,this._provider=ae,this._logService=me,this._extension=Se,this._apiDeprecation=Me,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(N,G,te,ae){const me=this._documents.getDocument(N),Se=v.Selection.isISelection(G)?A.Selection.to(G):A.Range.to(G),Me=[];for(const Ce of this._diagnostics.getDiagnostics(N))if(Se.intersection(Ce.range)&&Me.push(Ce)>P._maxCodeActionsPerFile)break;const ge={diagnostics:Me,only:te.only?new T.CodeActionKind(te.only):void 0,triggerKind:A.CodeActionTriggerKind.to(te.trigger)};return(0,S.asPromise)(()=>this._provider.provideCodeActions(me,Se,ge,ae)).then(Ce=>{var Pe;if(!(!(0,R.isNonEmptyArray)(Ce)||ae.isCancellationRequested)){const $e=this._cache.add(Ce),_e=new m.DisposableStore;this._disposables.set($e,_e);const qe=[];for(let V=0;V<Ce.length;V++){const X=Ce[V];!X||(P._isCommand(X)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:X.title,command:this._commands.toInternal(X,_e)})):(ge.only&&(X.kind?ge.only.contains(X.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${X.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[$e,V],title:X.title,command:X.command&&this._commands.toInternal(X.command,_e),diagnostics:X.diagnostics&&X.diagnostics.map(A.Diagnostic.from),edit:X.edit&&A.WorkspaceEdit.from(X.edit),kind:X.kind&&X.kind.value,isPreferred:X.isPreferred,disabled:(Pe=X.disabled)===null||Pe===void 0?void 0:Pe.reason})))}return{cacheId:$e,actions:qe}}})}async resolveCodeAction(N,G){var te;const[ae,me]=N,Se=this._cache.get(ae,me);if(!(!Se||P._isCommand(Se))&&!!this._provider.resolveCodeAction){const Me=(te=await this._provider.resolveCodeAction(Se,G))!==null&&te!==void 0?te:Se;return(Me==null?void 0:Me.edit)?A.WorkspaceEdit.from(Me.edit):void 0}}releaseCodeActions(N){var G;(G=this._disposables.get(N))===null||G===void 0||G.dispose(),this._disposables.delete(N),this._cache.delete(N)}static _isCommand(N){return typeof N.command=="string"&&typeof N.title=="string"}}P._maxCodeActionsPerFile=1e3;class F{constructor(N,G){this._documents=N,this._provider=G}provideDocumentFormattingEdits(N,G,te){const ae=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ae,G,te)).then(me=>{if(Array.isArray(me))return me.map(A.TextEdit.from)})}}class z{constructor(N,G){this._documents=N,this._provider=G}provideDocumentRangeFormattingEdits(N,G,te,ae){const me=this._documents.getDocument(N),Se=A.Range.to(G);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(me,Se,te,ae)).then(Me=>{if(Array.isArray(Me))return Me.map(A.TextEdit.from)})}}class de{constructor(N,G){this._documents=N,this._provider=G,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(N,G,te,ae,me){const Se=this._documents.getDocument(N),Me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Se,Me,te,ae,me)).then(ge=>{if(Array.isArray(ge))return ge.map(A.TextEdit.from)})}}class W{constructor(N,G){this._provider=N,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(N,G){const te=I.IdObject.mixin({symbols:[]});return(0,S.asPromise)(()=>this._provider.provideWorkspaceSymbols(N,G)).then(ae=>{if((0,R.isNonEmptyArray)(ae)){for(const me of ae)if(!!me){if(!me.name){this._logService.warn("INVALID SymbolInformation, lacks name",me);continue}const Se=I.IdObject.mixin(A.WorkspaceSymbol.from(me));this._symbolCache.set(Se._id,me),te.symbols.push(Se)}}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol(N,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return N;const te=this._symbolCache.get(N._id);if(te){const ae=await(0,S.asPromise)(()=>this._provider.resolveWorkspaceSymbol(te,G));return ae&&(0,k.mixin)(N,A.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(N){const G=this._resultCache.get(N);if(G){for(let[te,ae]=G;te<=ae;te++)this._symbolCache.delete(te);this._resultCache.delete(N)}}}class B{constructor(N,G,te){this._documents=N,this._provider=G,this._logService=te}static supportsResolving(N){return typeof N.prepareRename=="function"}provideRenameEdits(N,G,te,ae){const me=this._documents.getDocument(N),Se=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideRenameEdits(me,Se,te,ae)).then(Me=>{if(!!Me)return A.WorkspaceEdit.from(Me)},Me=>{const ge=B._asMessage(Me);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Me)})}resolveRenameLocation(N,G,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(N),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.prepareRename(ae,me,te)).then(Se=>{let Me,ge;if(T.Range.isRange(Se)?(Me=Se,ge=ae.getText(Se)):(0,C.isObject)(Se)&&(Me=Se.range,ge=Se.placeholder),!!Me){if(Me.start.line>me.line||Me.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:A.Range.from(Me),text:ge}}},Se=>{const Me=B._asMessage(Se);return Me?{rejectReason:Me,range:void 0,text:void 0}:Promise.reject(Se)})}static _asMessage(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class K{constructor(N,G){this.resultId=N,this.tokens=G}}class L{constructor(N,G){this._documents=N,this._provider=G,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(N,G,te){const ae=this._documents.getDocument(N),me=G!==0?this._previousResults.get(G):null;return(0,S.asPromise)(()=>me&&typeof me.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,me.resultId,te):this._provider.provideDocumentSemanticTokens(ae,te)).then(Se=>(me&&this._previousResults.delete(G),Se?(Se=L._fixProvidedSemanticTokens(Se),this._send(L._convertToEdits(me,Se),Se)):null))}async releaseDocumentSemanticColoring(N){this._previousResults.delete(N)}static _fixProvidedSemanticTokens(N){return L._isSemanticTokens(N)?L._isCorrectSemanticTokens(N)?N:new T.SemanticTokens(new Uint32Array(N.data),N.resultId):L._isSemanticTokensEdits(N)?L._isCorrectSemanticTokensEdits(N)?N:new T.SemanticTokensEdits(N.edits.map(G=>new T.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),N.resultId):N}static _isSemanticTokens(N){return N&&!!N.data}static _isCorrectSemanticTokens(N){return N.data instanceof Uint32Array}static _isSemanticTokensEdits(N){return N&&Array.isArray(N.edits)}static _isCorrectSemanticTokensEdits(N){for(const G of N.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(N,G){if(!L._isSemanticTokens(G)||!N||!N.tokens)return G;const te=N.tokens,ae=te.length,me=G.data,Se=me.length;let Me=0;const ge=Math.min(ae,Se);for(;Me<ge&&te[Me]===me[Me];)Me++;if(Me===ae&&Me===Se)return new T.SemanticTokensEdits([],G.resultId);let Ce=0;const Pe=ge-Me;for(;Ce<Pe&&te[ae-Ce-1]===me[Se-Ce-1];)Ce++;return new T.SemanticTokensEdits([{start:Me,deleteCount:ae-Me-Ce,data:me.subarray(Me,Se-Ce)}],G.resultId)}_send(N,G){if(L._isSemanticTokens(N)){const te=this._nextResultId++;return this._previousResults.set(te,new K(N.resultId,N.data)),(0,i.encodeSemanticTokensDto)({id:te,type:"full",data:N.data})}if(L._isSemanticTokensEdits(N)){const te=this._nextResultId++;return L._isSemanticTokens(G)?this._previousResults.set(te,new K(G.resultId,G.data)):this._previousResults.set(te,new K(N.resultId)),(0,i.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(N.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=L;class U{constructor(N,G){this._documents=N,this._provider=G}provideDocumentRangeSemanticTokens(N,G,te){const ae=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ae,A.Range.to(G),te)).then(me=>me?this._send(me):null)}_send(N){return(0,i.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}e.DocumentRangeSemanticTokensAdapter=U;class x{constructor(N,G,te,ae,me){this._documents=N,this._commands=G,this._provider=te,this._apiDeprecation=ae,this._extension=me,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}async provideCompletionItems(N,G,te,ae){const me=this._documents.getDocument(N),Se=A.Position.to(G),Me=me.getWordRangeAtPosition(Se)||new T.Range(Se,Se),ge=Me.with({end:Se}),Ce=new h.StopWatch(!0),Pe=await(0,S.asPromise)(()=>this._provider.provideCompletionItems(me,Se,ae,A.CompletionContext.to(te)));if(!!Pe&&!ae.isCancellationRequested){const $e=Array.isArray(Pe)?new T.CompletionList(Pe):Pe,_e=x.supportsResolving(this._provider)?this._cache.add($e.items):this._cache.add([]),qe=new m.DisposableStore;this._disposables.set(_e,qe);const V=[],X={x:_e,b:V,a:{replace:A.Range.from(Me),insert:A.Range.from(ge)},c:$e.isIncomplete||void 0,d:Ce.elapsed()};for(let ve=0;ve<$e.items.length;ve++){const Le=$e.items[ve],He=this._convertCompletionItem(Le,[_e,ve],ge,Me);V.push(He)}return X}}async resolveCompletionItem(N,G){if(typeof this._provider.resolveCompletionItem=="function"){const te=this._cache.get(...N);if(!!te){const ae=await(0,S.asPromise)(()=>this._provider.resolveCompletionItem(te,G));if(!!ae)return this._convertCompletionItem(ae,N)}}}releaseCompletionItems(N){var G;(G=this._disposables.get(N))===null||G===void 0||G.dispose(),this._disposables.delete(N),this._cache.delete(N)}_convertCompletionItem(N,G,te,ae){var me;const Se=this._disposables.get(G[0]);if(!Se)throw Error("DisposableStore is missing...");const Me={x:G,a:(me=N.label)!==null&&me!==void 0?me:"",o:N.label2,b:N.kind!==void 0?A.CompletionItemKind.from(N.kind):void 0,n:N.tags&&N.tags.map(A.CompletionItemTag.from),c:N.detail,d:typeof N.documentation=="undefined"?void 0:A.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters,l:N.additionalTextEdits&&N.additionalTextEdits.map(A.TextEdit.from),m:this._commands.toInternal(N.command,Se)};N.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Me.h=N.textEdit.newText):typeof N.insertText=="string"?Me.h=N.insertText:N.insertText instanceof T.SnippetString&&(Me.h=N.insertText.value,Me.i|=4);let ge;return N.textEdit?ge=N.textEdit.range:N.range&&(ge=N.range),T.Range.isRange(ge)?Me.j=A.Range.from(ge):ge&&(!(te==null?void 0:te.isEqual(ge.inserting))||!(ae==null?void 0:ae.isEqual(ge.replacing)))&&(Me.j={insert:A.Range.from(ge.inserting),replace:A.Range.from(ge.replacing)}),Me}}class Q{constructor(N,G){this._documents=N,this._provider=G,this._cache=new p.Cache("SignatureHelp")}provideSignatureHelp(N,G,te,ae){const me=this._documents.getDocument(N),Se=A.Position.to(G),Me=this.reviveContext(te);return(0,S.asPromise)(()=>this._provider.provideSignatureHelp(me,Se,ae,Me)).then(ge=>{if(ge){const Ce=this._cache.add([ge]);return Object.assign(Object.assign({},A.SignatureHelp.from(ge)),{id:Ce})}})}reviveContext(N){let G;if(N.activeSignatureHelp){const te=A.SignatureHelp.to(N.activeSignatureHelp),ae=this._cache.get(N.activeSignatureHelp.id,0);ae?(G=ae,G.activeSignature=te.activeSignature,G.activeParameter=te.activeParameter):G=te}return Object.assign(Object.assign({},N),{activeSignatureHelp:G})}releaseSignatureHelp(N){this._cache.delete(N)}}class ${constructor(N,G){this._documents=N,this._provider=G}provideInlineHints(N,G,te){const ae=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideInlineHints(ae,A.Range.to(G),te)).then(me=>me?{hints:me.map(A.InlineHint.from)}:void 0)}}class ee{constructor(N,G){this._documents=N,this._provider=G,this._cache=new p.Cache("DocumentLink")}provideLinks(N,G){const te=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideDocumentLinks(te,G)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(A.DocumentLink.from)};{const me=this._cache.add(ae),Se={links:[],id:me};for(let Me=0;Me<ae.length;Me++){const ge=A.DocumentLink.from(ae[Me]);ge.cacheId=[me,Me],Se.links.push(ge)}return Se}}})}resolveLink(N,G){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const te=this._cache.get(...N);return te?(0,S.asPromise)(()=>this._provider.resolveDocumentLink(te,G)).then(ae=>ae&&A.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(N){this._cache.delete(N)}}class re{constructor(N,G){this._documents=N,this._provider=G}provideColors(N,G){const te=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideDocumentColors(te,G)).then(ae=>Array.isArray(ae)?ae.map(Se=>({color:A.Color.from(Se.color),range:A.Range.from(Se.range)})):[])}provideColorPresentations(N,G,te){const ae=this._documents.getDocument(N),me=A.Range.to(G.range),Se=A.Color.to(G.color);return(0,S.asPromise)(()=>this._provider.provideColorPresentations(Se,{document:ae,range:me},te)).then(Me=>{if(!!Array.isArray(Me))return Me.map(A.ColorPresentation.from)})}}class se{constructor(N,G){this._documents=N,this._provider=G}provideFoldingRanges(N,G,te){const ae=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideFoldingRanges(ae,G,te)).then(me=>{if(!!Array.isArray(me))return me.map(A.FoldingRange.from)})}}class ye{constructor(N,G,te){this._documents=N,this._provider=G,this._logService=te}provideSelectionRanges(N,G,te){const ae=this._documents.getDocument(N),me=G.map(A.Position.to);return(0,S.asPromise)(()=>this._provider.provideSelectionRanges(ae,me,te)).then(Se=>{if(!(0,R.isNonEmptyArray)(Se))return[];if(Se.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Me=[];for(let ge=0;ge<me.length;ge++){const Ce=[];Me.push(Ce);let Pe=me[ge],$e=Se[ge];for(;;){if(!$e.range.contains(Pe))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(A.SelectionRange.from($e)),!$e.parent)break;Pe=$e.range,$e=$e.parent}}return Me})}}class Ie{constructor(N,G){this._documents=N,this._provider=G,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(N,G,te){const ae=this._documents.getDocument(N),me=A.Position.to(G),Se=await this._provider.prepareCallHierarchy(ae,me,te);if(!!Se){const Me=this._idPool.nextId();return this._cache.set(Me,new Map),Array.isArray(Se)?Se.map(ge=>this._cacheAndConvertItem(Me,ge)):[this._cacheAndConvertItem(Me,Se)]}}async provideCallsTo(N,G,te){const ae=this._itemFromCache(N,G);if(!ae)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(ae,te);if(!!me)return me.map(Se=>({from:this._cacheAndConvertItem(N,Se.from),fromRanges:Se.fromRanges.map(Me=>A.Range.from(Me))}))}async provideCallsFrom(N,G,te){const ae=this._itemFromCache(N,G);if(!ae)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(ae,te);if(!!me)return me.map(Se=>({to:this._cacheAndConvertItem(N,Se.to),fromRanges:Se.fromRanges.map(Me=>A.Range.from(Me))}))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,G){var te;const ae=this._cache.get(N),me={_sessionId:N,_itemId:ae.size.toString(36),name:G.name,detail:G.detail,kind:A.SymbolKind.from(G.kind),uri:G.uri,range:A.Range.from(G.range),selectionRange:A.Range.from(G.selectionRange),tags:(te=G.tags)===null||te===void 0?void 0:te.map(A.SymbolTag.from)};return ae.set(me._itemId,G),me}_itemFromCache(N,G){const te=this._cache.get(N);return te==null?void 0:te.get(G)}}class xe{constructor(N,G){this.adapter=N,this.extension=G}}class Fe{constructor(N,G,te,ae,me,Se,Me){this._adapter=new Map,this._uriTransformer=G,this._proxy=N.getProxy(I.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ae,this._diagnostics=me,this._logService=Se,this._apiDeprecation=Me}_transformDocumentSelector(N){return(0,R.coalesce)((0,R.asArray)(N).map(G=>this._doTransformDocumentSelector(G)))}_doTransformDocumentSelector(N){if(typeof N=="string")return{$serialized:!0,language:N};if(N)return{$serialized:!0,language:N.language,scheme:this._transformScheme(N.scheme),pattern:typeof N.pattern=="undefined"?void 0:A.GlobPattern.from(N.pattern),exclusive:N.exclusive}}_transformScheme(N){return this._uriTransformer&&typeof N=="string"?this._uriTransformer.transformOutgoingScheme(N):N}_createDisposable(N){return new T.Disposable(()=>{this._adapter.delete(N),this._proxy.$unregister(N)})}_nextHandle(){return Fe._handlePool++}_withAdapter(N,G,te,ae,me=!1){const Se=this._adapter.get(N);if(!Se)return Promise.resolve(ae);if(Se.adapter instanceof G){let Me;Se.extension&&(Me=Date.now(),this._logService.trace(`[${Se.extension.identifier.value}] INVOKE provider '${G.name}'`));const ge=te(Se.adapter,Se.extension),Ce=Se.extension;return Ce&&Promise.resolve(ge).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Me}ms`),Pe=>{me&&Pe instanceof w.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Pe))}),ge}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(N,G){const te=this._nextHandle();return this._adapter.set(te,new xe(N,G)),te}static _extLabel(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,G,te,ae){const me=this._addNewAdapter(new _(this._documents,te),N),Se=ae&&ae.label||Fe._extLabel(N);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector(G),Se),this._createDisposable(me)}$provideDocumentSymbols(N,G,te){return this._withAdapter(N,_,ae=>ae.provideDocumentSymbols(E.URI.revive(G),te),void 0)}registerCodeLensProvider(N,G,te){const ae=this._nextHandle(),me=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new xe(new c(this._documents,this._commands.converter,te),N)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(G),me);let Se=this._createDisposable(ae);if(me!==void 0){const Me=te.onDidChangeCodeLenses(ge=>this._proxy.$emitCodeLensEvent(me));Se=T.Disposable.from(Se,Me)}return Se}$provideCodeLenses(N,G,te){return this._withAdapter(N,c,ae=>ae.provideCodeLenses(E.URI.revive(G),te),void 0)}$resolveCodeLens(N,G,te){return this._withAdapter(N,c,ae=>ae.resolveCodeLens(G,te),void 0)}$releaseCodeLenses(N,G){this._withAdapter(N,c,te=>Promise.resolve(te.releaseCodeLenses(G)),void 0)}registerDefinitionProvider(N,G,te){const ae=this._addNewAdapter(new t(this._documents,te),N);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDefinition(N,G,te,ae){return this._withAdapter(N,t,me=>me.provideDefinition(E.URI.revive(G),te,ae),[])}registerDeclarationProvider(N,G,te){const ae=this._addNewAdapter(new r(this._documents,te),N);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDeclaration(N,G,te,ae){return this._withAdapter(N,r,me=>me.provideDeclaration(E.URI.revive(G),te,ae),[])}registerImplementationProvider(N,G,te){const ae=this._addNewAdapter(new u(this._documents,te),N);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideImplementation(N,G,te,ae){return this._withAdapter(N,u,me=>me.provideImplementation(E.URI.revive(G),te,ae),[])}registerTypeDefinitionProvider(N,G,te){const ae=this._addNewAdapter(new o(this._documents,te),N);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideTypeDefinition(N,G,te,ae){return this._withAdapter(N,o,me=>me.provideTypeDefinition(E.URI.revive(G),te,ae),[])}registerHoverProvider(N,G,te,ae){const me=this._addNewAdapter(new a(this._documents,te),N);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector(G)),this._createDisposable(me)}$provideHover(N,G,te,ae){return this._withAdapter(N,a,me=>me.provideHover(E.URI.revive(G),te,ae),void 0)}registerEvaluatableExpressionProvider(N,G,te,ae){const me=this._addNewAdapter(new f(this._documents,te),N);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector(G)),this._createDisposable(me)}$provideEvaluatableExpression(N,G,te,ae){return this._withAdapter(N,f,me=>me.provideEvaluatableExpression(E.URI.revive(G),te,ae),void 0)}registerInlineValuesProvider(N,G,te,ae){const me=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Se=this._addNewAdapter(new b(this._documents,te),N);this._proxy.$registerInlineValuesProvider(Se,this._transformDocumentSelector(G),me);let Me=this._createDisposable(Se);if(me!==void 0){const ge=te.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(me));Me=T.Disposable.from(Me,ge)}return Me}$provideInlineValues(N,G,te,ae,me){return this._withAdapter(N,b,Se=>Se.provideInlineValues(E.URI.revive(G),te,ae,me),void 0)}registerDocumentHighlightProvider(N,G,te){const ae=this._addNewAdapter(new D(this._documents,te),N);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDocumentHighlights(N,G,te,ae){return this._withAdapter(N,D,me=>me.provideDocumentHighlights(E.URI.revive(G),te,ae),void 0)}registerLinkedEditingRangeProvider(N,G,te){const ae=this._addNewAdapter(new d(this._documents,te),N);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideLinkedEditingRanges(N,G,te,ae){return this._withAdapter(N,d,async me=>{const Se=await me.provideLinkedEditingRanges(E.URI.revive(G),te,ae);if(Se)return{ranges:Se.ranges,wordPattern:Se.wordPattern?Fe._serializeRegExp(Se.wordPattern):void 0}},void 0)}registerReferenceProvider(N,G,te){const ae=this._addNewAdapter(new g(this._documents,te),N);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideReferences(N,G,te,ae,me){return this._withAdapter(N,g,Se=>Se.provideReferences(E.URI.revive(G),te,ae,me),void 0)}registerCodeActionProvider(N,G,te,ae){var me,Se;const Me=new m.DisposableStore,ge=this._addNewAdapter(new P(this._documents,this._commands.converter,this._diagnostics,te,this._logService,N,this._apiDeprecation),N);return this._proxy.$registerQuickFixSupport(ge,this._transformDocumentSelector(G),{providedKinds:(me=ae==null?void 0:ae.providedCodeActionKinds)===null||me===void 0?void 0:me.map(Ce=>Ce.value),documentation:(Se=ae==null?void 0:ae.documentation)===null||Se===void 0?void 0:Se.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Me)}))},Fe._extLabel(N),Boolean(te.resolveCodeAction)),Me.add(this._createDisposable(ge)),Me}$provideCodeActions(N,G,te,ae,me){return this._withAdapter(N,P,Se=>Se.provideCodeActions(E.URI.revive(G),te,ae,me),void 0)}$resolveCodeAction(N,G,te){return this._withAdapter(N,P,ae=>ae.resolveCodeAction(G,te),void 0)}$releaseCodeActions(N,G){this._withAdapter(N,P,te=>Promise.resolve(te.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider(N,G,te){const ae=this._addNewAdapter(new F(this._documents,te),N);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(G),N.identifier,N.displayName||N.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(N,G,te,ae){return this._withAdapter(N,F,me=>me.provideDocumentFormattingEdits(E.URI.revive(G),te,ae),void 0)}registerDocumentRangeFormattingEditProvider(N,G,te){const ae=this._addNewAdapter(new z(this._documents,te),N);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(G),N.identifier,N.displayName||N.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(N,G,te,ae,me){return this._withAdapter(N,z,Se=>Se.provideDocumentRangeFormattingEdits(E.URI.revive(G),te,ae,me),void 0)}registerOnTypeFormattingEditProvider(N,G,te,ae){const me=this._addNewAdapter(new de(this._documents,te),N);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector(G),ae,N.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits(N,G,te,ae,me,Se){return this._withAdapter(N,de,Me=>Me.provideOnTypeFormattingEdits(E.URI.revive(G),te,ae,me,Se),void 0)}registerWorkspaceSymbolProvider(N,G){const te=this._addNewAdapter(new W(G,this._logService),N);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(N,G,te){return this._withAdapter(N,W,ae=>ae.provideWorkspaceSymbols(G,te),{symbols:[]})}$resolveWorkspaceSymbol(N,G,te){return this._withAdapter(N,W,ae=>ae.resolveWorkspaceSymbol(G,te),void 0)}$releaseWorkspaceSymbols(N,G){this._withAdapter(N,W,te=>te.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider(N,G,te){const ae=this._addNewAdapter(new B(this._documents,te,this._logService),N);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(G),B.supportsResolving(te)),this._createDisposable(ae)}$provideRenameEdits(N,G,te,ae,me){return this._withAdapter(N,B,Se=>Se.provideRenameEdits(E.URI.revive(G),te,ae,me),void 0)}$resolveRenameLocation(N,G,te,ae){return this._withAdapter(N,B,me=>me.resolveRenameLocation(E.URI.revive(G),te,ae),void 0)}registerDocumentSemanticTokensProvider(N,G,te,ae){const me=this._nextHandle(),Se=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(me,new xe(new L(this._documents,te),N)),this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector(G),ae,Se);let Me=this._createDisposable(me);if(Se){const ge=te.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(Se));Me=T.Disposable.from(Me,ge)}return Me}$provideDocumentSemanticTokens(N,G,te,ae){return this._withAdapter(N,L,me=>me.provideDocumentSemanticTokens(E.URI.revive(G),te,ae),null,!0)}$releaseDocumentSemanticTokens(N,G){this._withAdapter(N,L,te=>te.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider(N,G,te,ae){const me=this._addNewAdapter(new U(this._documents,te),N);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector(G),ae),this._createDisposable(me)}$provideDocumentRangeSemanticTokens(N,G,te,ae){return this._withAdapter(N,U,me=>me.provideDocumentRangeSemanticTokens(E.URI.revive(G),te,ae),null,!0)}registerCompletionItemProvider(N,G,te,ae){const me=this._addNewAdapter(new x(this._documents,this._commands.converter,te,this._apiDeprecation,N),N);return this._proxy.$registerSuggestSupport(me,this._transformDocumentSelector(G),ae,x.supportsResolving(te),`${N.identifier.value}(${ae.join("")})`),this._createDisposable(me)}$provideCompletionItems(N,G,te,ae,me){return this._withAdapter(N,x,Se=>Se.provideCompletionItems(E.URI.revive(G),te,ae,me),void 0)}$resolveCompletionItem(N,G,te){return this._withAdapter(N,x,ae=>ae.resolveCompletionItem(G,te),void 0)}$releaseCompletionItems(N,G){this._withAdapter(N,x,te=>te.releaseCompletionItems(G),void 0)}registerSignatureHelpProvider(N,G,te,ae){const me=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,Se=this._addNewAdapter(new Q(this._documents,te),N);return this._proxy.$registerSignatureHelpProvider(Se,this._transformDocumentSelector(G),me),this._createDisposable(Se)}$provideSignatureHelp(N,G,te,ae,me){return this._withAdapter(N,Q,Se=>Se.provideSignatureHelp(E.URI.revive(G),te,ae,me),void 0)}$releaseSignatureHelp(N,G){this._withAdapter(N,Q,te=>te.releaseSignatureHelp(G),void 0)}registerInlineHintsProvider(N,G,te){const ae=typeof te.onDidChangeInlineHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new $(this._documents,te),N);this._proxy.$registerInlineHintsProvider(me,this._transformDocumentSelector(G),ae);let Se=this._createDisposable(me);if(ae!==void 0){const Me=te.onDidChangeInlineHints(ge=>this._proxy.$emitInlineHintsEvent(ae));Se=T.Disposable.from(Se,Me)}return Se}$provideInlineHints(N,G,te,ae){return this._withAdapter(N,$,me=>me.provideInlineHints(E.URI.revive(G),te,ae),void 0)}registerDocumentLinkProvider(N,G,te){const ae=this._addNewAdapter(new ee(this._documents,te),N);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(G),typeof te.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(N,G,te){return this._withAdapter(N,ee,ae=>ae.provideLinks(E.URI.revive(G),te),void 0)}$resolveDocumentLink(N,G,te){return this._withAdapter(N,ee,ae=>ae.resolveLink(G,te),void 0)}$releaseDocumentLinks(N,G){this._withAdapter(N,ee,te=>te.releaseLinks(G),void 0)}registerColorProvider(N,G,te){const ae=this._addNewAdapter(new re(this._documents,te),N);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDocumentColors(N,G,te){return this._withAdapter(N,re,ae=>ae.provideColors(E.URI.revive(G),te),[])}$provideColorPresentations(N,G,te,ae){return this._withAdapter(N,re,me=>me.provideColorPresentations(E.URI.revive(G),te,ae),void 0)}registerFoldingRangeProvider(N,G,te){const ae=this._nextHandle(),me=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new xe(new se(this._documents,te),N)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(G),me);let Se=this._createDisposable(ae);if(me!==void 0){const Me=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));Se=T.Disposable.from(Se,Me)}return Se}$provideFoldingRanges(N,G,te,ae){return this._withAdapter(N,se,me=>me.provideFoldingRanges(E.URI.revive(G),te,ae),void 0)}registerSelectionRangeProvider(N,G,te){const ae=this._addNewAdapter(new ye(this._documents,te,this._logService),N);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideSelectionRanges(N,G,te,ae){return this._withAdapter(N,ye,me=>me.provideSelectionRanges(E.URI.revive(G),te,ae),[])}registerCallHierarchyProvider(N,G,te){const ae=this._addNewAdapter(new Ie(this._documents,te),N);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$prepareCallHierarchy(N,G,te,ae){return this._withAdapter(N,Ie,me=>Promise.resolve(me.prepareSession(E.URI.revive(G),te,ae)),void 0)}$provideCallHierarchyIncomingCalls(N,G,te,ae){return this._withAdapter(N,Ie,me=>me.provideCallsTo(G,te,ae),void 0)}$provideCallHierarchyOutgoingCalls(N,G,te,ae){return this._withAdapter(N,Ie,me=>me.provideCallsFrom(G,te,ae),void 0)}$releaseCallHierarchy(N,G){this._withAdapter(N,Ie,te=>Promise.resolve(te.releaseSession(G)),void 0)}static _serializeRegExp(N){return{pattern:N.source,flags:(0,y.regExpFlags)(N)}}static _serializeIndentationRule(N){return{decreaseIndentPattern:Fe._serializeRegExp(N.decreaseIndentPattern),increaseIndentPattern:Fe._serializeRegExp(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?Fe._serializeRegExp(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?Fe._serializeRegExp(N.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(N){return{beforeText:Fe._serializeRegExp(N.beforeText),afterText:N.afterText?Fe._serializeRegExp(N.afterText):void 0,previousLineText:N.previousLineText?Fe._serializeRegExp(N.previousLineText):void 0,action:N.action}}static _serializeOnEnterRules(N){return N.map(Fe._serializeOnEnterRule)}setLanguageConfiguration(N,G,te){let{wordPattern:ae}=te;if(ae&&(0,y.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(G,ae):this._documents.setWordDefinitionFor(G,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const me=this._nextHandle(),Se={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Fe._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Fe._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Fe._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,G,Se),this._createDisposable(me)}$setWordDefinitions(N){for(const G of N)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=Fe,Fe._handlePool=0}),define(be[198],we([0,1,5,9,7]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(I,y){this._proxy=I.getProxy(E.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(I,y){await this._proxy.$changeLanguage(I,y);const n=this._documents.getDocumentData(I);if(!n)throw new Error(`document '${I.toString}' NOT found`);return n.document}async tokenAtPosition(I,y){var n;const R=I.version,C=k.Position.from(y),v=await this._proxy.$tokensAtPosition(I.uri,C),m={type:A.StandardTokenType.Other,range:(n=I.getWordRangeAtPosition(y))!==null&&n!==void 0?n:new A.Range(y.line,y.character,y.line,y.character)};if(!v)return m;const i={range:k.Range.to(v.range),type:k.TokenType.to(v.type)};return!i.range.contains(y)||R!==I.version?m:i}}e.ExtHostLanguages=T}),define(be[199],we([0,1,5,19,33]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(I){return I&&I.title}let S=class{constructor(y,n){this._logService=n,this._proxy=y.getProxy(E.MainContext.MainThreadMessageService)}showMessage(y,n,R,C,v){const m={extension:y};let i;typeof C=="string"||T(C)?i=[C,...v]:(m.modal=C&&C.modal,m.useCustom=C&&C.useCustom,i=v),m.useCustom&&(0,A.checkProposedApiEnabled)(y);const s=[];for(let p=0;p<i.length;p++){const h=i[p];if(typeof h=="string")s.push({title:h,handle:p,isCloseAffordance:!1});else if(typeof h=="object"){let{title:w,isCloseAffordance:_}=h;s.push({title:w,isCloseAffordance:!!_,handle:p})}else this._logService.warn("Invalid message item:",h)}return this._proxy.$showMessage(n,R,m,s).then(p=>{if(typeof p=="number")return i[p]})}};S=je([Ke(1,k.ILogService)],S),e.ExtHostMessageService=S}),define(be[200],we([0,1,20,3,6,2,29,5,9,7,69,70,22,177,178,53,12,24,56]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m,i,s,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class _ extends A.Disposable{constructor(b,D,d,g,P){super();this._editorId=b,this.uri=D,this._proxy=d,this._webviewInitData=g,this.document=P,this._onDidReceiveDocumentMessage=new k.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:F=>this._proxy.$postMessage(this._editorId,void 0,F),asWebviewUri:F=>this._asWebviewUri(F)}}onDidReceiveMessage(b,D){var d;this._onDidReceiveDocumentMessage.fire(D),b!==void 0&&((d=this._rendererIdToEmitters.get(b))===null||d===void 0||d.fire(D))}getRendererComm(b){const D=new k.Emitter;return this._rendererIdToEmitters.set(b,D),{editorId:this._editorId,onDidReceiveMessage:D.event,postMessage:d=>this._proxy.$postMessage(this._editorId,b,d),asWebviewUri:d=>this._asWebviewUri(d)}}_asWebviewUri(b){return(0,R.asWebviewUri)(this._webviewInitData,this._editorId,b)}}class c extends A.Disposable{constructor(b,D,d,g){super();this._proxy=b,this._handle=D,this._extension=d,this._provider=g,this._kernelToFriendlyId=new v.ResourceMap,this._friendlyIdToKernel=new v.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(P=>{const F=P==null?void 0:P.uri;this._proxy.$onNotebookKernelChange(this._handle,F)}))}async provideKernels(b,D){const d=await this._provider.provideKernels(b.notebookDocument,D)||[],g=new Map;let P=0;const F=new Set,z=this._kernelToFriendlyId.get(b.uri),de=d.map(B=>{let K=z==null?void 0:z.get(B);return K===void 0&&(B.id&&F.has(B.id)?K=`${this._extension.identifier.value}_${B.id}_${P++}`:K=`${this._extension.identifier.value}_${B.id||S.generateUuid()}`),g.set(B,K),{id:B.id,friendlyId:K,label:B.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:B.description,detail:B.detail,isPreferred:B.isPreferred,preloads:B.preloads,supportedLanguages:B.supportedLanguages,implementsInterrupt:!!B.interrupt}});this._kernelToFriendlyId.set(b.uri,g);const W=new Map;return g.forEach((B,K)=>{W.set(B,K)}),this._friendlyIdToKernel.set(b.uri,W),de}getKernelByFriendlyId(b,D){var d;return(d=this._friendlyIdToKernel.get(b))===null||d===void 0?void 0:d.get(D)}async resolveNotebook(b,D,d,g){var P;const F=(P=this._friendlyIdToKernel.get(D.uri))===null||P===void 0?void 0:P.get(b);if(F&&this._provider.resolveKernel)return this._provider.resolveKernel(F,D.notebookDocument,d,g)}async executeNotebook(b,D,d){var g;const P=(g=this._friendlyIdToKernel.get(D.uri))===null||g===void 0?void 0:g.get(b);if(!!P){const F=d.map(z=>y.NotebookCellRange.to(z));return P.executeCellsRequest(D.notebookDocument,F)}}async interruptNotebookExecution(b,D){var d;const g=(d=this._friendlyIdToKernel.get(D.uri))===null||d===void 0?void 0:d.get(b);if(!(!g||!g.interrupt))return g.interrupt(D.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=c;class l{constructor(b,D){const d=l._Keys.nextId();b.$registerNotebookEditorDecorationType(d,y.NotebookDecorationRenderOptions.from(D)),this.value={key:d,dispose(){b.$removeNotebookEditorDecorationType(d)}}}}e.NotebookEditorDecorationType=l,l._Keys=new s.IdGenerator("NotebookEditorDecorationType");class t{constructor(b,D,d,g,P,F,z){this._textDocumentsAndEditors=d,this._textDocuments=g,this._webviewInitData=P,this.logService=F,this._extensionStoragePaths=z,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new v.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new k.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new k.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new k.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new k.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new k.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new k.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new k.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new k.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new k.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new k.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new k.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new k.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new k.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new v.ResourceMap,this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=b.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=b.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=b.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=D.converter,D.registerArgumentProcessor({processArgument:de=>{var W;if(de&&de.$mid===12){const B=(W=de.notebookEditor)===null||W===void 0?void 0:W.notebookUri,K=de.cell.handle,L=this._documents.get(B),U=L==null?void 0:L.getCell(K);if(U)return U.cell}return de}})}get activeNotebookEditor(){var b;return(b=this._activeNotebookEditor)===null||b===void 0?void 0:b.editor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(b=>b.editor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(b){return this._documents.get(b)}_getNotebookDocument(b){const D=this._documents.get(b);if(!D)throw new Error(`NO notebook document for '${b}'`);return D}_getProviderData(b){const D=this._notebookContentProviders.get(b);if(!D)throw new Error(`NO provider for '${b}'`);return D}registerNotebookContentProvider(b,D,d,g){var P,F,z;if(this._notebookContentProviders.has(D))throw new Error(`Notebook provider for '${D}' already registered`);this._notebookContentProviders.set(D,{extension:b,provider:d});let de;d.onDidChangeNotebookContentOptions&&(de=d.onDidChangeNotebookContentOptions(()=>{const K=y.NotebookDocumentContentOptions.from(d.options);this._notebookProxy.$updateNotebookProviderOptions(D,K)}));const W=(P=g==null?void 0:g.viewOptions)===null||P===void 0?void 0:P.filenamePattern.map(K=>y.NotebookExclusiveDocumentPattern.from(K)).filter(K=>K!==void 0);((F=g==null?void 0:g.viewOptions)===null||F===void 0?void 0:F.filenamePattern)&&!W&&console.warn(`Notebook content provider view options file name pattern is invalid ${(z=g==null?void 0:g.viewOptions)===null||z===void 0?void 0:z.filenamePattern}`);const B=y.NotebookDocumentContentOptions.from(g);return this._notebookProxy.$registerNotebookProvider({id:b.identifier,location:b.extensionLocation,description:b.description},D,{transientOutputs:B.transientOutputs,transientMetadata:B.transientMetadata,viewOptions:(g==null?void 0:g.viewOptions)&&W?{displayName:g.viewOptions.displayName,filenamePattern:W,exclusive:g.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{de==null||de.dispose(),this._notebookContentProviders.delete(D),this._notebookProxy.$unregisterNotebookProvider(D)})}registerNotebookKernelProvider(b,D,d){const g=t._notebookKernelProviderHandlePool++,P=new c(this._notebookProxy,g,b,d);return this._notebookKernelProviders.set(g,P),this._notebookProxy.$registerNotebookKernelProvider({id:b.identifier,location:b.extensionLocation,description:b.description},g,{viewType:D.viewType,filenamePattern:D.filenamePattern?y.NotebookExclusiveDocumentPattern.from(D.filenamePattern):void 0}),new n.Disposable(()=>{P.dispose(),this._notebookKernelProviders.delete(g),this._notebookProxy.$unregisterNotebookKernelProvider(g)})}createNotebookEditorDecorationType(b){return new l(this._notebookEditorsProxy,b).value}async openNotebookDocument(b){const D=this._documents.get(b);if(D)return D.notebookDocument;const d=await this._notebookDocumentsProxy.$tryOpenDocument(b),g=this._documents.get(T.URI.revive(d));return(0,p.assertIsDefined)(g==null?void 0:g.notebookDocument)}_withAdapter(b,D,d){const g=this._documents.get(T.URI.revive(D));if(!g)return[];const P=this._notebookKernelProviders.get(b);return P?d(P,g):[]}async showNotebookDocument(b,D){var d;T.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let g;typeof D=="object"?g={position:y.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:D.selection&&y.NotebookCellRange.from(D.selection),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:g={preserveFocus:!1};const P=await this._notebookEditorsProxy.$tryShowNotebookDocument(b.uri,b.viewType,g),F=P&&((d=this._editors.get(P))===null||d===void 0?void 0:d.editor);if(F)return F.editor;throw P?new Error(`Could NOT open editor for "${b.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.toString()}".`)}async $provideNotebookKernels(b,D,d){return this._withAdapter(b,D,(g,P)=>g.provideKernels(P,d))}async $resolveNotebookKernel(b,D,d,g,P){await this._withAdapter(b,d,async(F,z)=>{const de=this._webviewComm.get(D);de&&await F.resolveNotebook(g,z,de.contentProviderComm,P)})}async $resolveNotebookEditor(b,D,d){const g=this._notebookContentProviders.get(b),P=T.URI.revive(D),F=this._documents.get(P);if(!(!F||!g)){let z=this._webviewComm.get(d);z||(z=new _(d,P,this._notebookProxy,this._webviewInitData,F),this._webviewComm.set(d,z))}}async $executeNotebookKernelFromProvider(b,D,d,g){await this._withAdapter(b,D,async(P,F)=>P.executeNotebook(d,F,g))}registerNotebookSerializer(b,D,d,g){const P=this._handlePool++;this._notebookSerializer.set(P,d);const F=y.NotebookDocumentContentOptions.from(g);return this._notebookProxy.$registerNotebookSerializer(P,{id:b.identifier,location:b.extensionLocation,description:b.description},D,F),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(P)})}async $dataToNotebook(b,D){const d=this._notebookSerializer.get(b);if(!d)throw new Error("NO serializer found");const g=await d.dataToNotebook(D.buffer);return{metadata:y.NotebookDocumentMetadata.from(g.metadata),cells:g.cells.map(y.NotebookCellData.from)}}async $notebookToData(b,D){const d=this._notebookSerializer.get(b);if(!d)throw new Error("NO serializer found");const g=await d.notebookToData({metadata:y.NotebookDocumentMetadata.to(D.metadata),cells:D.cells.map(y.NotebookCellData.to)});return h.VSBuffer.wrap(g)}async $cancelNotebookCellExecution(b,D,d,g){await this._withAdapter(b,D,async(F,z)=>F.interruptNotebookExecution(d,z));const P=this._documents.get(T.URI.revive(D));if(!!P)for(let F of g)for(let z=F.start;z<F.end;z++){const de=P.getCellFromIndex(z);de&&this.cancelOneNotebookCellExecution(de)}}cancelOneNotebookCellExecution(b){const D=this._activeExecutions.get(b.uri);D==null||D.cancel()}async $openNotebook(b,D,d,g,P){const{provider:F}=this._getProviderData(b),z=await F.openNotebook(T.URI.revive(D),{backupId:d,untitledDocumentData:g==null?void 0:g.buffer},P);return{metadata:y.NotebookDocumentMetadata.from(z.metadata),cells:z.cells.map(y.NotebookCellData.from)}}async $saveNotebook(b,D,d){const g=this._getNotebookDocument(T.URI.revive(D)),{provider:P}=this._getProviderData(b);return await P.saveNotebook(g.notebookDocument,d),!0}async $saveNotebookAs(b,D,d,g){const P=this._getNotebookDocument(T.URI.revive(D)),{provider:F}=this._getProviderData(b);return await F.saveNotebookAs(T.URI.revive(d),P.notebookDocument,g),!0}async $backupNotebook(b,D,d){var g;const P=this._getNotebookDocument(T.URI.revive(D)),F=this._getProviderData(b),z=(g=this._extensionStoragePaths.workspaceValue(F.extension))!==null&&g!==void 0?g:this._extensionStoragePaths.globalValue(F.extension),de=String((0,w.hash)([P.uri.toString(),this._backupIdPool++])),W=T.URI.joinPath(z,de),B=await F.provider.backupNotebook(P.notebookDocument,{destination:W},d);return P.updateBackup(B),B.id}$acceptNotebookActiveKernelChange(b){b.providerHandle!==void 0&&this._withAdapter(b.providerHandle,b.uri,async(D,d)=>{const g=b.kernelFriendlyId?D.getKernelByFriendlyId(T.URI.revive(b.uri),b.kernelFriendlyId):void 0;this._editors.forEach(P=>{P.editor.notebookData===d&&P.editor._acceptKernel(g)}),this._onDidChangeActiveNotebookKernel.fire({document:d.notebookDocument,kernel:g})})}$onDidReceiveMessage(b,D,d){var g;(g=this._webviewComm.get(b))===null||g===void 0||g.onDidReceiveMessage(D,d)}$acceptModelChanged(b,D,d){this._getNotebookDocument(T.URI.revive(b)).acceptModelChanged(D,d)}$acceptDirtyStateChanged(b,D){const d=this._getNotebookDocument(T.URI.revive(b));d.acceptModelChanged({rawEvents:[],versionId:d.notebookDocument.version},D)}$acceptModelSaved(b){const D=this._getNotebookDocument(T.URI.revive(b));this._onDidSaveNotebookDocument.fire(D.notebookDocument)}$acceptEditorPropertiesChanged(b,D){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,D);const d=this._editors.get(b);if(!d)throw new Error(`unknown text editor: ${b}. known editors: ${[...this._editors.keys()]} `);D.visibleRanges&&d.editor._acceptVisibleRanges(D.visibleRanges.ranges.map(y.NotebookCellRange.to)),D.selections&&d.editor._acceptSelections(D.selections.selections.map(y.NotebookCellRange.to)),D.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:d.editor.editor,visibleRanges:d.editor.editor.visibleRanges}),D.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:d.editor.editor,selections:d.editor.editor.selections}))}$acceptEditorViewColumns(b){for(const D in b){const d=this._editors.get(D);if(!d)throw new Error(`unknown text editor: ${D}. known editors: ${[...this._editors.keys()]} `);d.editor._acceptViewColumn(y.ViewColumn.to(b[D]))}}$acceptDocumentPropertiesChanged(b,D){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",b.path,D);const d=this._getNotebookDocument(T.URI.revive(b));d.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:d.notebookDocument})}_createExtHostEditor(b,D,d){var g;const P=b.uri;let F=this._webviewComm.get(D);F||(F=new _(D,P,this._notebookProxy,this._webviewInitData,b),this._webviewComm.set(D,F));const z=new i.ExtHostNotebookEditor(D,this._notebookEditorsProxy,b,d.visibleRanges.map(y.NotebookCellRange.to),d.selections.map(y.NotebookCellRange.to),typeof d.viewColumn=="number"?y.ViewColumn.to(d.viewColumn):void 0);(g=this._editors.get(D))===null||g===void 0||g.editor.dispose(),this._editors.set(D,{editor:z})}$acceptDocumentAndEditorsDelta(b){var D,d,g,P;let F=!1;if(b.removedDocuments)for(const de of b.removedDocuments){const W=T.URI.revive(de),B=this._documents.get(W);B&&(B.dispose(),this._documents.delete(W),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:B.notebookDocument.getCells().map(K=>K.document.uri)}),this._onDidCloseNotebookDocument.fire(B.notebookDocument));for(const K of this._editors.values())K.editor.notebookData.uri.toString()===W.toString()&&(K.editor.dispose(),this._editors.delete(K.editor.id),F=!0)}if(b.addedDocuments){const de=[];for(const W of b.addedDocuments){const B=T.URI.revive(W.uri),K=W.viewType;if(this._documents.has(B))throw new Error(`adding EXISTING notebook ${B} `);const L=this,U=new m.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(x){L._onDidChangeNotebookCells.fire(x)},emitCellOutputsChange(x){L._onDidChangeCellOutputs.fire(x)},emitCellMetadataChange(x){L._onDidChangeCellMetadata.fire(x)},emitCellExecutionStateChange(x){L._onDidChangeCellExecutionState.fire(x)}},K,W.metadata?y.NotebookDocumentMetadata.to(W.metadata):new n.NotebookDocumentMetadata,B);U.acceptModelChanged({versionId:W.versionId,rawEvents:[{kind:C.NotebookCellsChangeType.Initialize,changes:[[0,0,W.cells]]}]},!1),de.push(...W.cells.map(x=>m.ExtHostCell.asModelAddData(U.notebookDocument,x))),(D=this._documents.get(B))===null||D===void 0||D.dispose(),this._documents.set(B,U),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:de}),this._onDidOpenNotebookDocument.fire(U.notebookDocument)}}if(b.addedEditors)for(const de of b.addedEditors){if(this._editors.has(de.id))return;const W=T.URI.revive(de.documentUri),B=this._documents.get(W);B&&(this._createExtHostEditor(B,de.id,de),F=!0)}const z=[];if(b.removedEditors)for(const de of b.removedEditors){const W=this._editors.get(de);W&&(F=!0,this._editors.delete(de),((d=this._activeNotebookEditor)===null||d===void 0?void 0:d.id)===W.editor.id&&(this._activeNotebookEditor=void 0),z.push(W))}if(F&&z.forEach(de=>{de.editor.dispose()}),b.visibleEditors){this._visibleNotebookEditors=b.visibleEditors.map(W=>this._editors.get(W).editor).filter(W=>!!W);const de=new Set;this._visibleNotebookEditors.forEach(W=>de.add(W.id));for(const W of this._editors.values()){const B=de.has(W.editor.id);W.editor._acceptVisibility(B)}this._visibleNotebookEditors=[...this._editors.values()].map(W=>W.editor).filter(W=>W.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}b.newActiveEditor===null?this._activeNotebookEditor=void 0:b.newActiveEditor&&(this._activeNotebookEditor=(g=this._editors.get(b.newActiveEditor))===null||g===void 0?void 0:g.editor),b.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((P=this._activeNotebookEditor)===null||P===void 0?void 0:P.editor)}createNotebookCellStatusBarItemInternal(b,D,d){const g=new r(this._notebookProxy,this._commandsConverter,b,D,d),P=C.CellUri.parse(b.document.uri);if(P){const F=this._documents.get(P.notebook);if(F){const z=F.getCell(P.handle);z&&k.Event.once(z.onDidDispose)(()=>g.dispose())}}return g}createNotebookCellExecution(b,D,d){const g=this.lookupNotebookDocument(b);if(!g)throw new Error(`Invalid cell uri / index: ${b}, ${D} `);const P=g.getCellFromIndex(D);if(!P)throw new Error(`Invalid cell uri / index: ${b}, ${D} `);if(!this._activeExecutions.has(P.uri)){const F=new a(b,g,P,this._notebookDocumentsProxy);this._activeExecutions.set(P.uri,F);const z=F.onDidChangeState(()=>{F.state===o.Resolved&&(F.dispose(),z.dispose(),this._activeExecutions.delete(P.uri))});return F.asApiObject()}}}e.ExtHostNotebookController=t,t._notebookKernelProviderHandlePool=0;class r extends A.Disposable{constructor(b,D,d,g,P){super();this._proxy=b,this._commands=D,this._cell=d,this._priority=P,this._id=r.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new A.DisposableStore),this._alignment=g!=null?g:n.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=u(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(b){this._alignment=b,this.update()}get priority(){return this._priority}set priority(b){this._priority=b,this.update()}get text(){return this._text}set text(b){this._text=b,this.update()}get tooltip(){return this._tooltip}set tooltip(b){this._tooltip=b,this.update()}get command(){var b;return(b=this._command)===null||b===void 0?void 0:b.fromApi}set command(b){var D;((D=this._command)===null||D===void 0?void 0:D.fromApi)!==b&&(this._internalCommandRegistration.clear(),typeof b=="string"?this._command={fromApi:b,internal:this._commands.toInternal({title:"",command:b},this._internalCommandRegistration)}:b?this._command={fromApi:b,internal:this._commands.toInternal(b,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(b){this._accessibilityInformation=b,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var b;if(!this._isDisposed){const D={alignment:this.alignment===n.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.document.uri,command:(b=this._command)===null||b===void 0?void 0:b.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,D)}}}e.NotebookCellStatusBarItemInternal=r,r.NEXT_ID=0;function u(f){return Object.freeze({cell:f.cell,get alignment(){return f.alignment},set alignment(b){f.alignment=b},get priority(){return f.priority},set priority(b){f.priority=b},get text(){return f.text},set text(b){f.text=b},get tooltip(){return f.tooltip},set tooltip(b){f.tooltip=b},get command(){return f.command},set command(b){f.command=b},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(b){f.accessibilityInformation=b},show(){f.show()},hide(){f.hide()},dispose(){f.dispose()}})}var o;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(o||(o={}));class a extends A.Disposable{constructor(b,D,d,g){super();this._uri=b,this._document=D,this._cell=d,this._proxy=g,this._onDidChangeState=new k.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._executionOrder=d.internalMetadata.executionOrder,this.mixinMetadata({runState:C.NotebookCellExecutionState.Pending,lastRunDuration:null,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(b){return this._proxy.$applyEdits(this._uri,b,!1)}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(b){const D=[{editType:11,handle:this._cell.handle,metadata:b}];this.applyEdits(D)}cellIndexToHandle(b){const D=typeof b=="number"?this._document.getCellFromIndex(b):this._cell;if(!!D)return D.handle}asApiObject(){const b=this;return Object.freeze({get document(){return b._document.notebookDocument},get cell(){return b._cell.cell},get executionOrder(){return b._executionOrder},set executionOrder(D){b._executionOrder=D,b.mixinMetadata({executionOrder:D})},start(D){if(b._state===o.Resolved||b._state===o.Started)throw new Error("Cannot call start again");b._state=o.Started,b._onDidChangeState.fire(),b.mixinMetadata({runState:C.NotebookCellExecutionState.Executing,runStartTime:D==null?void 0:D.startTime})},end(D){var d,g;if(b._state===o.Resolved)throw new Error("Cannot call resolve twice");b._state=o.Resolved,b._onDidChangeState.fire(),b.mixinMetadata({runState:C.NotebookCellExecutionState.Idle,lastRunSuccess:(d=D==null?void 0:D.success)!==null&&d!==void 0?d:null,lastRunDuration:(g=D==null?void 0:D.duration)!==null&&g!==void 0?g:null})},clearOutput(D){return b.verifyStateForOutput(),this.replaceOutput([],D)},async appendOutput(D,d){b.verifyStateForOutput();const g=b.cellIndexToHandle(d);if(typeof g=="number")return D=Array.isArray(D)?D:[D],b.applyEdits([{editType:2,handle:g,append:!0,outputs:D.map(y.NotebookCellOutput.from)}])},async replaceOutput(D,d){b.verifyStateForOutput();const g=b.cellIndexToHandle(d);if(typeof g=="number")return D=Array.isArray(D)?D:[D],b.applyEdits([{editType:2,handle:g,outputs:D.map(y.NotebookCellOutput.from)}])},async appendOutputItems(D,d){return b.verifyStateForOutput(),D=Array.isArray(D)?D:[D],b.applyEdits([{editType:10,append:!0,items:D.map(y.NotebookCellOutputItem.from),outputId:d}])},async replaceOutputItems(D,d){return b.verifyStateForOutput(),D=Array.isArray(D)?D:[D],b.applyEdits([{editType:10,items:D.map(y.NotebookCellOutputItem.from),outputId:d}])},token:b._tokenSource.token})}}}),define(be[99],we([0,1,5,3,6,24,4,14]),function(ie,e,E,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends A.Disposable{constructor(i,s,p,h){super();this._onDidAppend=this._register(new k.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=i,this._proxy=h,this._id=h.$register(this.name,s,p),this._disposed=!1,this._offset=0}get name(){return this._name}append(i){this.validate(),this._offset+=i?T.VSBuffer.fromString(i).byteLength:0}update(){this._id.then(i=>this._proxy.$update(i))}appendLine(i){this.validate(),this.append(i+`
`)}clear(){this.validate();const i=this._offset;this._id.then(s=>this._proxy.$clear(s,i))}show(i,s){this.validate(),this._id.then(p=>this._proxy.$reveal(p,!!(typeof i=="boolean"?i:s)))}hide(){this.validate(),this._id.then(i=>this._proxy.$close(i))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(i=>this._proxy.$dispose(i)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class n extends y{constructor(i,s){super(i,!1,void 0,s)}append(i){super.append(i),this._id.then(s=>this._proxy.$append(s,i)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class R extends y{constructor(i,s,p){super(i,!0,s,p)}append(i){throw new Error("Not supported")}}class C{constructor(i,s){this.name=i,this._channel=s}append(i){this._channel.then(s=>s.append(i))}appendLine(i){this._channel.then(s=>s.appendLine(i))}clear(){this._channel.then(i=>i.clear())}show(i,s){this._channel.then(p=>p.show(i,s))}hide(){this._channel.then(i=>i.hide())}dispose(){this._channel.then(i=>i.dispose())}}e.LazyOutputChannel=C;let v=class{constructor(i){this._proxy=i.getProxy(E.MainContext.MainThreadOutputService)}$setVisibleChannel(i){}createOutputChannel(i){if(i=i.trim(),!i)throw new Error("illegal argument `name`. must not be falsy");return new n(i,this._proxy)}createOutputChannelFromLogFile(i,s){if(i=i.trim(),!i)throw new Error("illegal argument `name`. must not be falsy");if(!s)throw new Error("illegal argument `file`. must not be falsy");return new R(i,s,this._proxy)}};v=je([Ke(0,I.IExtHostRpcService)],v),e.ExtHostOutputService=v,e.IExtHostOutputService=(0,S.createDecorator)("IExtHostOutputService")}),define(be[201],we([0,1,13,20,3,6,5,2,7,10,15,46]),function(ie,e,E,k,A,T,S,I,y,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function v(m,i,s){const p=m.getProxy(S.MainContext.MainThreadQuickOpen);class h{constructor(o,a){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=a}showQuickPick(o,a,f,b=k.CancellationToken.None){this._onDidSelectItem=void 0;const D=Promise.resolve(o),d=++this._instances,g=p.$show(d,{title:f==null?void 0:f.title,placeHolder:f==null?void 0:f.placeHolder,matchOnDescription:f==null?void 0:f.matchOnDescription,matchOnDetail:f==null?void 0:f.matchOnDetail,ignoreFocusLost:f==null?void 0:f.ignoreFocusOut,canPickMany:f==null?void 0:f.canPickMany},b),P={},F=g.then(()=>P);return Promise.race([F,D]).then(z=>{if(z!==P)return D.then(de=>{const W=[];for(let B=0;B<de.length;B++){const K=de[B];let L,U,x,Q,$;typeof K=="string"?L=K:(L=K.label,U=K.description,x=K.detail,Q=K.picked,$=K.alwaysShow),W.push({label:L,description:U,handle:B,detail:x,picked:Q,alwaysShow:$})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{f.onDidSelectItem(de[B])}),p.$setItems(d,W),g.then(B=>{if(typeof B=="number")return de[B];if(Array.isArray(B))return B.map(K=>de[K])})})}).then(void 0,z=>{if(!(0,n.isPromiseCanceledError)(z))return p.$setError(d,z),Promise.reject(z)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,a=k.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,p.$input(o,typeof this._validateInput=="function",a).then(void 0,f=>{if(!(0,n.isPromiseCanceledError)(f))return Promise.reject(f)})}$validateInput(o){return this._validateInput?(0,E.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,a=k.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!!f){const b=await this._workspace.getWorkspaceFolders2();if(!!b)return b.find(D=>D.uri.toString()===f.uri.toString())}}createQuickPick(o,a){const f=new t(o,a,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(o){const a=new r(o,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(o,a){const f=this._sessions.get(o);f&&f._fireDidChangeValue(a)}$onDidAccept(o){const a=this._sessions.get(o);a&&a._fireDidAccept()}$onDidChangeActive(o,a){const f=this._sessions.get(o);f instanceof t&&f._fireDidChangeActive(a)}$onDidChangeSelection(o,a){const f=this._sessions.get(o);f instanceof t&&f._fireDidChangeSelection(a)}$onDidTriggerButton(o,a){const f=this._sessions.get(o);f&&f._fireDidTriggerButton(a)}$onDidHide(o){const a=this._sessions.get(o);a&&a._fireDidHide()}}class w{constructor(o,a){this._extensionId=o,this._onDidDispose=a,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new A.Emitter,this._onDidChangeValueEmitter=new A.Emitter,this._onDidTriggerButtonEmitter=new A.Emitter,this._onDidHideEmitter=new A.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((a,f)=>{const b=a===y.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(b,a)}),this.update({buttons:o.map((a,f)=>({iconPath:_(a.iconPath),tooltip:a.tooltip,handle:a===y.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const a=this._handlesToButtons.get(o);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(o){if(!this._disposed){for(const a of Object.keys(o)){const f=o[a];this._pendingUpdate[a]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}w._nextId=1;function _(u){if(u instanceof y.ThemeIcon)return{id:u.id};const o=l(u),a=c(u);return{dark:typeof o=="string"?I.URI.file(o):o,light:typeof a=="string"?I.URI.file(a):a}}function c(u){return typeof u=="object"&&"light"in u?u.light:u}function l(u){return typeof u=="object"&&"dark"in u?u.dark:u}class t extends w{constructor(o,a,f){super(o,f);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new A.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new A.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((a,f)=>{this._handlesToItems.set(f,a),this._itemsToHandles.set(a,f)}),this.update({items:o.map((a,f)=>({label:a.label,description:a.description,handle:f,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(o){const a=(0,R.coalesce)(o.map(f=>this._handlesToItems.get(f)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(o){const a=(0,R.coalesce)(o.map(f=>this._handlesToItems.get(f)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}}class r extends w{constructor(o,a){super(o,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?C.default.Error:C.default.Ignore})}}return new h(i,s)}e.createExtHostQuickOpen=v}),define(be[202],we([0,1,2,3,51,6,13,5,15,110,19,26,33]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(o){if(o)return typeof o.iconPath=="string"?E.URI.file(o.iconPath):o.iconPath}function i(o,a){if(!o.iconPath&&!a.iconPath)return 0;if(o.iconPath){if(!a.iconPath)return 1}else return-1;const f=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath,b=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath;return(0,n.comparePaths)(f,b)}function s(o,a){let f=0;if(o.strikeThrough!==a.strikeThrough)return o.strikeThrough?1:-1;if(o.faded!==a.faded)return o.faded?1:-1;if(o.tooltip!==a.tooltip)return(o.tooltip||"").localeCompare(a.tooltip||"");if(f=i(o,a),f!==0)return f;if(o.light&&a.light)f=i(o.light,a.light);else{if(o.light)return 1;if(a.light)return-1}if(f!==0)return f;if(o.dark&&a.dark)f=i(o.dark,a.dark);else{if(o.dark)return 1;if(a.dark)return-1}return f}function p(o,a){if(o.command!==a.command)return o.command<a.command?-1:1;if(o.title!==a.title)return o.title<a.title?-1:1;if(o.tooltip!==a.tooltip){if(o.tooltip!==void 0&&a.tooltip!==void 0)return o.tooltip<a.tooltip?-1:1;if(o.tooltip!==void 0)return 1;if(a.tooltip!==void 0)return-1}if(o.arguments===a.arguments)return 0;if(o.arguments)if(a.arguments){if(o.arguments.length!==a.arguments.length)return o.arguments.length-a.arguments.length}else return 1;else return-1;for(let f=0;f<o.arguments.length;f++){const b=o.arguments[f],D=a.arguments[f];if(b!==D)return b<D?-1:1}return 0}function h(o,a){let f=(0,n.comparePaths)(o.resourceUri.fsPath,a.resourceUri.fsPath,!0);if(f!==0)return f;if(o.command&&a.command)f=p(o.command,a.command);else{if(o.command)return 1;if(a.command)return-1}if(f!==0)return f;if(o.decorations&&a.decorations)f=s(o.decorations,a.decorations);else{if(o.decorations)return 1;if(a.decorations)return-1}return f}function w(o,a){for(let f=0;f<o.length;f++)if(o[f]!==a[f])return!1;return!0}function _(o,a){return o.command===a.command&&o.title===a.title&&o.tooltip===a.tooltip&&(o.arguments&&a.arguments?w(o.arguments,a.arguments):o.arguments===a.arguments)}function c(o,a){return(0,y.equals)(o,a,_)}class l{constructor(a,f,b){this._extension=a,this._proxy=f,this._sourceControlHandle=b,this._value="",this._onDidChange=new k.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(a){this._proxy.$setInputBoxValue(this._sourceControlHandle,a),this.updateValue(a)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(a){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,a),this._placeholder=a}get validateInput(){return(0,v.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(a){if((0,v.checkProposedApiEnabled)(this._extension),a&&typeof a!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=a,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!a)}get visible(){return this._visible}set visible(a){a=!!a,this._visible!==a&&(this._visible=a,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,a))}focus(){this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(a,f){this._proxy.$showValidationMessage(this._sourceControlHandle,a,f)}$onInputBoxValueChange(a){this.updateValue(a)}updateValue(a){this._value=a,this._onDidChange.fire(a)}}e.ExtHostSCMInputBox=l;class t{constructor(a,f,b,D,d){this._proxy=a,this._commands=f,this._sourceControlHandle=b,this._id=D,this._label=d,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new k.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(a){this._label=a,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,a)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(a){this._hideWhenEmpty=a,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(a){this._resourceStates=[...a],this._onDidUpdateResourceStates.fire()}getResourceState(a){return this._resourceStatesMap.get(a)}$executeResourceCommand(a,f){const b=this._resourceStatesCommandsMap.get(a);return b?(0,S.asPromise)(()=>this._commands.executeCommand(b.command,...b.arguments||[],f)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var a;const f=[...this._resourceStates].sort(h),D=(0,y.sortedDiff)(this._resourceSnapshot,f,h).map(P=>{const F=P.toInsert.map(z=>{const de=this._resourceHandlePool++;this._resourceStatesMap.set(de,z);const W=z.resourceUri,B=m(z.decorations),K=z.decorations&&m(z.decorations.light)||B,L=z.decorations&&m(z.decorations.dark)||B,U=[];let x;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const ye=new T.DisposableStore;x=this._commands.converter.toInternal(z.command,ye),this._resourceStatesDisposablesMap.set(de,ye)}else this._resourceStatesCommandsMap.set(de,z.command);K&&U.push(K),L&&L.toString()!==(K==null?void 0:K.toString())&&U.push(L);const Q=z.decorations&&z.decorations.tooltip||"",$=z.decorations&&!!z.decorations.strikeThrough,ee=z.decorations&&!!z.decorations.faded,re=z.contextValue||"";return{rawResource:[de,W,U,Q,$,ee,re,x],handle:de}});return{start:P.start,deleteCount:P.deleteCount,toInsert:F}}),d=D.map(({start:P,deleteCount:F,toInsert:z})=>[P,F,z.map(de=>de.rawResource)]),g=D.reverse();for(const{start:P,deleteCount:F,toInsert:z}of g){const de=z.map(B=>B.handle),W=this._handlesSnapshot.splice(P,F,...de);for(const B of W)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),(a=this._resourceStatesDisposablesMap.get(B))===null||a===void 0||a.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=f,d}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class r{constructor(a,f,b,D,d,g){this._proxy=f,this._commands=b,this._id=D,this._label=d,this._rootUri=g,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new k.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new l(a,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,D,d,g)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(a){this._count!==a&&(this._count=a,this._proxy.$updateSourceControl(this.handle,{count:a}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(a){this._quickDiffProvider=a,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!a})}get commitTemplate(){return this._commitTemplate}set commitTemplate(a){a!==this._commitTemplate&&(this._commitTemplate=a,this._proxy.$updateSourceControl(this.handle,{commitTemplate:a}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(a){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=a;const f=this._commands.converter.toInternal(a,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:f})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(a){if(!(this._statusBarCommands&&a&&c(this._statusBarCommands,a))){this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=a;const f=(a||[]).map(b=>this._commands.converter.toInternal(b,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:f})}}get selected(){return this._selected}createResourceGroup(a,f){const b=new t(this._proxy,this._commands,this.handle,a,f),D=k.Event.once(b.onDidDispose)(()=>this.createdResourceGroups.delete(b));return this.createdResourceGroups.set(b,D),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const a=[],f=[];for(const[b,D]of this.createdResourceGroups){D.dispose();const d=b.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(b),this.eventuallyUpdateResourceStates()});k.Event.once(b.onDidDispose)(()=>{this.updatedResourceGroups.delete(b),d.dispose(),this._groups.delete(b.handle),this._proxy.$unregisterGroup(this.handle,b.handle)}),a.push([b.handle,b.id,b.label,b.features]);const g=b._takeResourceStateSnapshot();g.length>0&&f.push([b.handle,g]),this._groups.set(b.handle,b)}this._proxy.$registerGroups(this.handle,a,f),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const a=[];this.updatedResourceGroups.forEach(f=>{const b=f._takeResourceStateSnapshot();b.length!==0&&a.push([f.handle,b])}),a.length>0&&this._proxy.$spliceResourceStates(this.handle,a),this.updatedResourceGroups.clear()}getResourceGroup(a){return this._groups.get(a)}setSelectionState(a){this._selected=a,this._onDidChangeSelection.fire(a)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(a=>a.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,je([(0,A.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),je([(0,A.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let u=class kn{constructor(a,f,b){this._commands=f,this.logService=b,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new k.Emitter,this._proxy=a.getProxy(I.MainContext.MainThreadSCM),this._telemetry=a.getProxy(I.MainContext.MainThreadTelemetry),f.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===3){const d=this._sourceControls.get(D.sourceControlHandle);if(!d)return D;const g=d.getResourceGroup(D.groupHandle);return g?g.getResourceState(D.handle):D}else if(D&&D.$mid===4){const d=this._sourceControls.get(D.sourceControlHandle);return d?d.getResourceGroup(D.groupHandle):D}else if(D&&D.$mid===5){const d=this._sourceControls.get(D.handle);return d||D}return D}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(a,f,b,D){this.logService.trace("ExtHostSCM#createSourceControl",a.identifier.value,f,b,D),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:a.identifier.value});const d=kn._handlePool++,g=new r(a,this._proxy,this._commands,f,b,D);this._sourceControls.set(d,g);const P=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(a.identifier))||[];return P.push(g),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(a.identifier),P),g}getLastInputBox(a){this.logService.trace("ExtHostSCM#getLastInputBox",a.identifier.value);const f=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(a.identifier)),b=f&&f[f.length-1];return b&&b.inputBox}$provideOriginalResource(a,f,b){const D=E.URI.revive(f);this.logService.trace("ExtHostSCM#$provideOriginalResource",a,D.toString());const d=this._sourceControls.get(a);return!d||!d.quickDiffProvider||!d.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>d.quickDiffProvider.provideOriginalResource(D,b)).then(g=>g||null)}$onInputBoxValueChange(a,f){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",a);const b=this._sourceControls.get(a);return b&&b.inputBox.$onInputBoxValueChange(f),Promise.resolve(void 0)}$executeResourceCommand(a,f,b,D){this.logService.trace("ExtHostSCM#$executeResourceCommand",a,f,b);const d=this._sourceControls.get(a);if(!d)return Promise.resolve(void 0);const g=d.getResourceGroup(f);return g?g.$executeResourceCommand(b,D):Promise.resolve(void 0)}$validateInput(a,f,b){this.logService.trace("ExtHostSCM#$validateInput",a);const D=this._sourceControls.get(a);return!D||!D.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>D.inputBox.validateInput(f,b)).then(d=>d?Promise.resolve([d.message,d.type]):Promise.resolve(void 0))}$setSelectedSourceControl(a){var f,b;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",a),a!==void 0&&((f=this._sourceControls.get(a))===null||f===void 0||f.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((b=this._sourceControls.get(this._selectedSourceControlHandle))===null||b===void 0||b.setSelectionState(!1)),this._selectedSourceControlHandle=a,Promise.resolve(void 0)}};u._handlePool=0,u=je([Ke(2,R.ILogService)],u),e.ExtHostSCM=u});var tt=this&&this.__classPrivateFieldSet||function(ie,e,E,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(ie,E):A?A.value=E:e.set(ie,E),E},Ue=this&&this.__classPrivateFieldGet||function(ie,e,E,k){if(E==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?k:E==="a"?k.call(ie):k?k.value:e.get(ie)};define(be[203],we([0,1,7,5,133,6]),function(ie,e,E,k,A,T){"use strict";var S,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(v,m,i,s,p=E.StatusBarAlignment.Left,h,w){S.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,tt(this,S,v,"f"),tt(this,I,m,"f"),this._id=y.ID_GEN++,this._statusId=i,this._statusName=s,this._alignment=p,this._priority=h,this._accessibilityInformation=w}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var v;return(v=this._command)===null||v===void 0?void 0:v.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(v){this._text=v,this.update()}set tooltip(v){this._tooltip=v,this.update()}set color(v){this._color=v,this.update()}set backgroundColor(v){v&&!y.ALLOWED_BACKGROUND_COLORS.has(v.id)&&(v=void 0),this._backgroundColor=v,this.update()}set command(v){var m;((m=this._command)===null||m===void 0?void 0:m.fromApi)!==v&&(this._internalCommandRegistration.clear(),typeof v=="string"?this._command={fromApi:v,internal:Ue(this,I,"f").toInternal({title:"",command:v},this._internalCommandRegistration)}:v?this._command={fromApi:v,internal:Ue(this,I,"f").toInternal(v,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(v){this._accessibilityInformation=v,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,S,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var v;this._timeoutHandle=void 0;let m=this._color;this._backgroundColor&&(m=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Ue(this,S,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(v=this._command)===null||v===void 0?void 0:v.internal,m,this._backgroundColor,this._alignment===E.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,S=new WeakMap,I=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new E.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(v){this._messages=[],this._item=v.createStatusBarEntry("status.extensionMessage",(0,A.localize)(0,null),E.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(v){const m={message:v};return this._messages.unshift(m),this._update(),new E.Disposable(()=>{const i=this._messages.indexOf(m);i>=0&&(this._messages.splice(i,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class R{constructor(v,m){this._proxy=v.getProxy(k.MainContext.MainThreadStatusBar),this._commands=m,this._statusMessage=new n(this)}createStatusBarEntry(v,m,i,s,p){return new y(this._proxy,this._commands,v,m,i,s,p)}setStatusBarMessage(v,m){const i=this._statusMessage.setMessage(v);let s;return typeof m=="number"?s=setTimeout(()=>i.dispose(),m):typeof m!="undefined"&&m.then(()=>i.dispose(),()=>i.dispose()),new E.Disposable(()=>{i.dispose(),clearTimeout(s)})}}e.ExtHostStatusBar=R}),define(be[75],we([0,1,5,3,4]),function(ie,e,E,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(I){this._onDidChangeStorage=new k.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(E.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,y){this._proxy.$registerExtensionStorageKeysToSync(I,y)}getValue(I,y,n){return this._proxy.$getValue(I,y).then(R=>R||n)}setValue(I,y,n){return this._proxy.$setValue(I,y,n)}$acceptValue(I,y,n){this._onDidChangeStorage.fire({shared:I,key:y,value:n})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,A.createDecorator)("IExtHostStorage")}),define(be[76],we([0,1,4,27,19,74,2]),function(ie,e,E,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,E.createDecorator)("IExtensionStoragePaths");let I=class{constructor(n,R,C){var v;this._logService=R,this._extHostFileSystem=C,this._workspace=(v=n.workspace)!==null&&v!==void 0?v:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const R=this._workspace.id,C=S.URI.joinPath(this._environment.workspaceStorageHome,R);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch(v){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(S.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=S.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),C}catch(v){this._logService.error("[ExtHostStorage]",v);return}}workspaceValue(n){if(this._value)return S.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return S.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};I=je([Ke(0,k.IExtHostInitDataService),Ke(1,A.ILogService),Ke(2,T.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(be[40],we([0,1,3,5,4,2,14,6,7,134,10,171,20,29,154]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,A.createDecorator)("IExtHostTerminalService");class s{constructor(t,r,u,o){this._proxy=t,this._id=r,this._creationOptions=u,this._name=o,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(f=>this._pidPromiseComplete=f);const a=this;this.value={get name(){return a._name||""},get processId(){return a._pidPromise},get creationOptions(){return a._creationOptions},get exitStatus(){return a._exitStatus},sendText(f,b=!0){a._checkDisposed(),a._proxy.$sendText(a._id,f,b)},show(f){a._checkDisposed(),a._proxy.$show(a._id,f)},hide(){a._checkDisposed(),a._proxy.$hide(a._id)},dispose(){a._disposed||(a._disposed=!0,a._proxy.$dispose(a._id))},get dimensions(){if(!(a._cols===void 0||a._rows===void 0))return{columns:a._cols,rows:a._rows}}}}async create(t,r,u,o,a,f,b,D,d,g,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:r,cwd:u,env:o,icon:a,initialText:f,waitOnExit:b,strictEnv:D,hideFromUser:d,isFeatureTerminal:g,isExtensionOwnedTerminal:P})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,r){return t===this._cols&&r===this._rows||t===0||r===0?!1:(this._cols=t,this._rows=r,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=s;class p{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new E.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new E.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new E.Emitter,this._onProcessTitleChanged=new E.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new E.Emitter,this._onProcessShellTypeChanged=new E.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,r){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:r})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose&&this._pty.onDidClose((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r&&{cols:r.columns,rows:r.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=p;let h=1,w=class extends I.Disposable{constructor(t,r){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new E.Emitter,this._onDidOpenTerminal=new E.Emitter,this._onDidChangeActiveTerminal=new E.Emitter,this._onDidChangeTerminalDimensions=new E.Emitter,this._proxy=r.getProxy(k.MainContext.MainThreadTerminalService),this._bufferer=new i.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new E.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[u,o]of this._terminalProcesses)o.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const r=new s(this._proxy,(0,m.generateUuid)(),t,t.name),u=new p(t.pty);return r.createExtensionTerminal().then(o=>{const a=this._setupExtHostProcessListeners(o,u);this._terminalProcessDisposables[o]=a}),this._terminals.push(r),r.value}attachPtyToTerminal(t,r){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const o=new p(r),a=this._setupExtHostProcessListeners(t,o);this._terminalProcessDisposables[t]=a}async $acceptActiveTerminalChanged(t){const r=this._activeTerminal;if(t===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const u=this._getTerminalById(t);u&&(this._activeTerminal=u,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,r){const u=this._getTerminalById(t);u&&this._onDidWriteTerminalData.fire({terminal:u.value,data:r})}async $acceptTerminalDimensions(t,r,u){const o=this._getTerminalById(t);o&&o.setDimensions(r,u)&&this._onDidChangeTerminalDimensions.fire({terminal:o.value,dimensions:o.value.dimensions})}async $acceptTerminalMaximumDimensions(t,r,u){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.resize(r,u)}async $acceptTerminalTitleChange(t,r){const u=this._getTerminalById(t);u&&(u.name=r)}async $acceptTerminalClosed(t,r){const u=this._getTerminalObjectIndexById(this._terminals,t);if(u!==null){const o=this._terminals.splice(u,1)[0];o.setExitCode(r),this._onDidCloseTerminal.fire(o.value)}}$acceptTerminalOpened(t,r,u,o){if(r){const b=this._getTerminalObjectIndexById(this._terminals,r);if(b!==null){this._terminals[b]._id=t,this._onDidOpenTerminal.fire(this.terminals[b]),this._terminals[b].isOpen=!0;return}}const a={name:o.name,shellPath:o.executable,shellArgs:o.args,cwd:typeof o.cwd=="string"?o.cwd:T.URI.revive(o.cwd),env:o.env,hideFromUser:o.hideFromUser},f=new s(this._proxy,t,a,u);this._terminals.push(f),this._onDidOpenTerminal.fire(f.value),f.isOpen=!0}async $acceptTerminalProcessId(t,r){const u=this._getTerminalById(t);u&&u._setProcessId(r)}async $startExtensionTerminal(t,r){const u=this._getTerminalById(t);if(!u)return{message:(0,n.localize)(0,null,t)};u.isOpen||await new Promise(a=>{const f=this.onDidOpenTerminal(async b=>{b===u.value&&(f.dispose(),a())})});const o=this._terminalProcesses.get(t);o?o.startSendingEvents(r):this._extensionTerminalAwaitingStart[t]={initialDimensions:r}}_setupExtHostProcessListeners(t,r){const u=new I.DisposableStore;u.add(r.onProcessReady(a=>this._proxy.$sendProcessReady(t,a.pid,a.cwd))),u.add(r.onProcessTitleChanged(a=>this._proxy.$sendProcessTitle(t,a))),this._bufferer.startBuffering(t,r.onProcessData),u.add(r.onProcessExit(a=>this._onProcessExit(t,a))),r.onProcessOverrideDimensions&&u.add(r.onProcessOverrideDimensions(a=>this._proxy.$sendOverrideDimensions(t,a))),this._terminalProcesses.set(t,r);const o=this._extensionTerminalAwaitingStart[t];return o&&r instanceof p&&(r.startSendingEvents(o.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),u}$acceptProcessAckDataEvent(t,r){var u;(u=this._terminalProcesses.get(t))===null||u===void 0||u.acknowledgeDataEvent(r)}$acceptProcessInput(t,r){var u;(u=this._terminalProcesses.get(t))===null||u===void 0||u.input(r)}$acceptProcessResize(t,r,u){var o;try{(o=this._terminalProcesses.get(t))===null||o===void 0||o.resize(r,u)}catch(a){if(a.code!=="EPIPE"&&a.code!=="ERR_IPC_CHANNEL_CLOSED")throw a}}$acceptProcessShutdown(t,r){var u;(u=this._terminalProcesses.get(t))===null||u===void 0||u.shutdown(r)}$acceptProcessRequestInitialCwd(t){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.getInitialCwd().then(u=>this._proxy.$sendProcessInitialCwd(t,u))}$acceptProcessRequestCwd(t){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.getCwd().then(u=>this._proxy.$sendProcessCwd(t,u))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,r){const u=this._getTerminalById(t);if(!u)return[];this._terminalLinkCache.delete(t);const o=this._terminalLinkCancellationSource.get(t);o&&o.dispose(!0);const a=new v.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,a);const f=[],b={terminal:u.value,line:r},D=[];for(const P of this._linkProviders)D.push(new Promise(async F=>{a.token.onCancellationRequested(()=>F({provider:P,links:[]}));const z=await P.provideTerminalLinks(b,a.token)||[];a.token.isCancellationRequested||F({provider:P,links:z})}));const d=await Promise.all(D);if(a.token.isCancellationRequested)return[];const g=new Map;for(const P of d)P&&P.links.length>0&&f.push(...P.links.map(F=>{const z={id:h++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return g.set(z.id,{provider:P.provider,link:F}),z}));return this._terminalLinkCache.set(t,g),f}$activateLink(t,r){var u;const o=(u=this._terminalLinkCache.get(t))===null||u===void 0?void 0:u.get(r);!o||o.provider.handleTerminalLink(o.link)}_onProcessExit(t,r){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const u=this._terminalProcessDisposables[t];u&&(u.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,r)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,r){const u=this._getTerminalObjectIndexById(t,r);return u!==null?t[u]:null}_getTerminalObjectIndexById(t,r){let u=null;return t.some((o,a)=>o._id===r?(u=a,!0):!1),u}getEnvironmentVariableCollection(t){let r=this._environmentVariableCollections.get(t.identifier.value);return r||(r=new _,this._setEnvironmentVariableCollection(t.identifier.value,r)),r}_syncEnvironmentVariableCollection(t,r){const u=(0,C.serializeEnvironmentVariableCollection)(r.map);this._proxy.$setEnvironmentVariableCollection(t,r.persistent,u.length===0?void 0:u)}$initEnvironmentVariableCollections(t){t.forEach(r=>{const u=r[0],o=new _(r[1]);this._setEnvironmentVariableCollection(u,o)})}_setEnvironmentVariableCollection(t,r){this._environmentVariableCollections.set(t,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,r)})}};w=je([Ke(1,S.IExtHostRpcService)],w),e.BaseExtHostTerminalService=w;class _{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new E.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,r){this._setIfDiffers(t,{value:r,type:y.EnvironmentVariableMutatorType.Replace})}append(t,r){this._setIfDiffers(t,{value:r,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,r){this._setIfDiffers(t,{value:r,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,r){const u=this.map.get(t);(!u||u.value!==r.value||u.type!==r.type)&&(this.map.set(t,r),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,r){this.map.forEach((u,o)=>t.call(r,o,u,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=_;let c=class extends w{constructor(t){super(!1,t)}createTerminal(t,r,u){throw new R.NotSupportedError}createTerminalFromOptions(t){throw new R.NotSupportedError}getDefaultShell(t,r){throw new R.NotSupportedError}getDefaultShellArgs(t,r){throw new R.NotSupportedError}$getAvailableProfiles(t){throw new R.NotSupportedError}async $getDefaultShellAndArgs(t){throw new R.NotSupportedError}$acceptWorkspacePermissionsChanged(t){throw new R.NotSupportedError}};c=je([Ke(0,S.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c}),define(be[204],we([0,1,3,15,5,96,9,7]),function(ie,e,E,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(R,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new E.Emitter,this._onDidChangeTextEditorOptions=new E.Emitter,this._onDidChangeTextEditorVisibleRanges=new E.Emitter,this._onDidChangeTextEditorViewColumn=new E.Emitter,this._onDidChangeActiveTextEditor=new E.Emitter,this._onDidChangeVisibleTextEditors=new E.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(A.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(v=>this._onDidChangeVisibleTextEditors.fire(v)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(v=>this._onDidChangeActiveTextEditor.fire(v))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const C=this._extHostDocumentsAndEditors.allEditors();return R?C:C.map(v=>v.value)}async showTextDocument(R,C,v){let m;typeof C=="number"?m={position:S.ViewColumn.from(C),preserveFocus:v}:typeof C=="object"?m={position:S.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?S.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:m={preserveFocus:!1};const i=await this._proxy.$tryShowTextDocument(R.uri,m),s=i&&this._extHostDocumentsAndEditors.getEditor(i);if(s)return s.value;throw i?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R){return new T.TextEditorDecorationType(this._proxy,R).value}$acceptEditorPropertiesChanged(R,C){const v=this._extHostDocumentsAndEditors.getEditor(R);if(!v)throw new Error("unknown text editor");if(C.options&&v._acceptOptions(C.options),C.selections){const m=C.selections.selections.map(S.Selection.to);v._acceptSelections(m)}if(C.visibleRanges){const m=k.coalesce(C.visibleRanges.map(S.Range.to));v._acceptVisibleRanges(m)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:v.value,options:Object.assign(Object.assign({},C.options),{lineNumbers:S.TextEditorLineNumbersStyle.to(C.options.lineNumbers)})}),C.selections){const m=I.TextEditorSelectionChangeKind.fromValue(C.selections.source),i=C.selections.selections.map(S.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:v.value,selections:i,kind:m})}if(C.visibleRanges){const m=k.coalesce(C.visibleRanges.map(S.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:v.value,visibleRanges:m})}}$acceptEditorPositionData(R){for(const C in R){const v=this._extHostDocumentsAndEditors.getEditor(C);if(!v)throw new Error("Unknown text editor");const m=S.ViewColumn.to(R[C]);v.value.viewColumn!==m&&(v._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:v.value,viewColumn:m}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=y});var cn=this&&this.__rest||function(ie,e){var E={};for(var k in ie)Object.prototype.hasOwnProperty.call(ie,k)&&e.indexOf(k)<0&&(E[k]=ie[k]);if(ie!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,k=Object.getOwnPropertySymbols(ie);A<k.length;A++)e.indexOf(k[A])<0&&Object.prototype.propertyIsEnumerable.call(ie,k[A])&&(E[k[A]]=ie[k[A]]);return E};define(be[205],we([0,1,2,4,5,6,7]),function(ie,e,E,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class I{constructor(R,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(A.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:v=>{var m,i;if(v&&v.$mid===11){const s=v.uri===void 0?void 0:E.URI.revive(v.uri);return(i=(m=this._itemsBySourceAndUriMap.get(v.source))===null||m===void 0?void 0:m.get(y(s)))===null||i===void 0?void 0:i.get(v.handle)}return v}})}async $getTimeline(R,C,v,m,i){const s=this._providers.get(R);return s==null?void 0:s.provideTimeline(E.URI.revive(C),v,m,i)}registerTimelineProvider(R,C,v,m){const i=new T.DisposableStore,s=this.convertTimelineItem(C.id,m,i).bind(this);let p;C.onDidChange&&(p=C.onDidChange(w=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},w),{id:C.id})),this));const h=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},C),{scheme:R,onDidChange:void 0,async provideTimeline(w,_,c,l){var t;(l==null?void 0:l.resetCache)&&(i.clear(),(t=h.get(C.id))===null||t===void 0||t.clear());const r=await C.provideTimeline(w,_,c);if(r!=null){const u=s(w,l);return Object.assign(Object.assign({},r),{source:C.id,items:r.items.map(u)})}},dispose(){var w;for(const _ of h.values())(w=_.get(C.id))===null||w===void 0||w.clear();p==null||p.dispose(),i.dispose()}}))}convertTimelineItem(R,C,v){return(m,i)=>{let s;if(i==null?void 0:i.cacheResults){let p=this._itemsBySourceAndUriMap.get(R);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(R,p));const h=y(m);s=p.get(h),s===void 0&&(s=new Map,p.set(h,s))}return p=>{var h,w;const{iconPath:_}=p,c=cn(p,["iconPath"]),l=`${R}|${(h=p.id)!==null&&h!==void 0?h:p.timestamp}`;s==null||s.set(l,p);let t,r,u;return p.iconPath&&(_ instanceof S.ThemeIcon?u={id:_.id}:E.URI.isUri(_)?(t=_,r=_):{light:t,dark:r}=_),Object.assign(Object.assign({},c),{id:(w=c.id)!==null&&w!==void 0?w:void 0,handle:l,source:R,command:p.command?C.toInternal(p.command,v):void 0,icon:t,iconDark:r,themeIcon:u,accessibilityInformation:p.accessibilityInformation})}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,T.toDisposable)(()=>{var v;for(const m of this._itemsBySourceAndUriMap.values())(v=m.get(R.id))===null||v===void 0||v.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=I;function y(n){return n==null?void 0:n.toString()}}),define(be[206],we([0,1,6,18,2,5]),function(ie,e,E,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(y){this._openers=new Map,this._proxy=y.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,n,R,C){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const v=C.schemes.find(m=>!S.supportedSchemes.has(m));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,R),this._proxy.$registerUriOpener(n,C.schemes,y,C.label),(0,E.toDisposable)(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(y,n,R){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener with id: ${y}`);const v=A.URI.revive(n);return C.canOpenExternalUri(v,R)}async $openUri(y,n,R){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener id: '${y}'`);return C.openExternalUri(A.URI.revive(n.resolvedUri),{sourceUri:A.URI.revive(n.sourceUri)},R)}}e.ExtHostUriOpeners=S,S.supportedSchemes=new Set([k.Schemas.http,k.Schemas.https])}),define(be[207],we([0,1,5,2,6,10,26]),function(ie,e,E,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(E.MainContext.MainThreadUrls)}registerUriHandler(n,R){if(this.handles.has(S.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const C=I.HandlePool++;return this.handles.add(S.ExtensionIdentifier.toKey(n)),this.handlers.set(C,R),this._proxy.$registerUriHandler(C,n),(0,A.toDisposable)(()=>{this.handles.delete(S.ExtensionIdentifier.toKey(n)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(n,R){const C=this.handlers.get(n);if(!C)return Promise.resolve(void 0);try{C.handleUri(k.URI.revive(R))}catch(v){(0,T.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(n){return k.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=I,I.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(ie,e,E,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(ie,E):A?A.value=E:e.set(ie,E),E},Ue=this&&this.__classPrivateFieldGet||function(ie,e,E,k){if(E==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?k:E==="a"?k.call(ie):k?k.value:e.get(ie)};define(be[49],we([0,1,24,3,2,143,164,69,5]),function(ie,e,E,k,A,T,S,I,y){"use strict";var n,R,C,v,m,i,s,p,h,w,_,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class l{constructor(d,g,P,F,z,de,W){n.set(this,void 0),R.set(this,void 0),C.set(this,void 0),v.set(this,void 0),m.set(this,void 0),i.set(this,void 0),s.set(this,""),p.set(this,void 0),h.set(this,!1),w.set(this,!1),_.set(this,!1),this._onMessageEmitter=new k.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new k.Emitter),this._onDidDispose=Ue(this,c,"f").event,tt(this,n,d,"f"),tt(this,R,g,"f"),tt(this,p,P,"f"),tt(this,v,F,"f"),tt(this,m,z,"f"),tt(this,i,de,"f"),tt(this,_,t(de),"f"),tt(this,C,W,"f")}dispose(){tt(this,h,!0,"f"),Ue(this,c,"f").fire(),Ue(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return tt(this,w,!0,"f"),(0,I.asWebviewUri)(Ue(this,v,"f"),Ue(this,n,"f"),d)}get cspSource(){return Ue(this,v,"f").webviewCspSource.replace("{{uuid}}",Ue(this,n,"f"))}get html(){return this.assertNotDisposed(),Ue(this,s,"f")}set html(d){this.assertNotDisposed(),Ue(this,s,"f")!==d&&(tt(this,s,d,"f"),!Ue(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(tt(this,w,!0,"f"),Ue(this,C,"f").report("Webview vscode-resource: uris",Ue(this,i,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,R,"f").$setHtml(Ue(this,n,"f"),d))}get options(){return this.assertNotDisposed(),Ue(this,p,"f")}set options(d){this.assertNotDisposed(),Ue(this,R,"f").$setOptions(Ue(this,n,"f"),a(Ue(this,i,"f"),Ue(this,m,"f"),d)),tt(this,p,d,"f")}async postMessage(d){if(Ue(this,h,"f"))return!1;const g=r(d,{serializeBuffersForPostMessage:Ue(this,_,"f")});return Ue(this,R,"f").$postMessage(Ue(this,n,"f"),g.message,...g.buffers)}assertNotDisposed(){if(Ue(this,h,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=l,n=new WeakMap,R=new WeakMap,C=new WeakMap,v=new WeakMap,m=new WeakMap,i=new WeakMap,s=new WeakMap,p=new WeakMap,h=new WeakMap,w=new WeakMap,_=new WeakMap,c=new WeakMap;function t(D){if(!D.enableProposedApi)return!1;try{const d=(0,T.normalizeVersion)((0,T.parseVersion)(D.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=56}catch(d){return!1}}e.shouldSerializeBuffersForPostMessage=t;function r(D,d){if(d.serializeBuffersForPostMessage){const g=[],P=(z,de)=>{if(de&&de instanceof ArrayBuffer){let W=g.findIndex(B=>B.original===de);if(W===-1){const B=new Uint8Array(de),K=E.VSBuffer.wrap(B);W=g.length,g.push({original:de,vsBuffer:K})}return{$$vscode_array_buffer_reference$$:!0,index:W}}return de};return{message:JSON.stringify(D,P),buffers:g.map(z=>z.vsBuffer)}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeMessage=r;class u{constructor(d,g,P,F,z){this.initData=g,this.workspace=P,this._logService=F,this._deprecationService=z,this._webviews=new Map,this._webviewProxy=d.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(d,g,...P){const F=this.getWebview(d);if(F){const{message:z}=(0,S.deserializeWebviewMessage)(g,P);F._onMessageEmitter.fire(z)}}$onMissingCsp(d,g){this._logService.warn(`${g} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,g,P){const F=new l(d,this._webviewProxy,f(g),this.initData,this.workspace,P,this._deprecationService);return this._webviews.set(d,F),F._onDidDispose(()=>{this._webviews.delete(d)}),F}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=u;function o(D){return{id:D.identifier,location:D.extensionLocation}}e.toExtensionData=o;function a(D,d,g){return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,portMapping:g.portMapping,localResourceRoots:g.localResourceRoots||b(D,d)}}e.serializeWebviewOptions=a;function f(D){var d;return{enableCommandUris:D.enableCommandUris,enableScripts:D.enableScripts,portMapping:D.portMapping,localResourceRoots:(d=D.localResourceRoots)===null||d===void 0?void 0:d.map(g=>A.URI.from(g))}}e.reviveOptions=f;function b(D,d){return[...((d==null?void 0:d.getWorkspaceFolders())||[]).map(g=>g.uri),D.extensionLocation]}}),define(be[208],we([0,1,20,56,6,18,25,2,9,49,92,5,7]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,S.joinPath)(this._storagePath,t)}updateBackup(t){var r;(r=this._backup)===null||r===void 0||r.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class i{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,u){const o=this.key(t,r.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const a=new m(r,u);return this._documents.set(o,a),a}delete(t,r){const u=this.key(t,r.uri);this._documents.delete(u)}key(t,r){return`${t}@@@${r}`}}var s;(function(l){l[l.Text=0]="Text",l[l.Custom=1]="Custom"})(s||(s={}));class p{constructor(){this._providers=new Map}addTextProvider(t,r,u){return this.add(0,t,r,u)}addCustomProvider(t,r,u){return this.add(1,t,r,u)}get(t){return this._providers.get(t)}add(t,r,u,o){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:u,provider:o}),new v.Disposable(()=>this._providers.delete(r))}}class h{constructor(t,r,u,o,a){this._extHostDocuments=r,this._extensionStoragePaths=u,this._extHostWebview=o,this._extHostWebviewPanels=a,this._editorProviders=new p,this._documents=new i,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,u,o){const a=new A.DisposableStore;return w(u)?(a.add(this._editorProviders.addTextProvider(r,t,u)),this._proxy.$registerTextEditorProvider((0,n.toExtensionData)(t),r,o.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,n.shouldSerializeBuffersForPostMessage)(t))):(a.add(this._editorProviders.addCustomProvider(r,t,u)),this.supportEditing(u)&&a.add(u.onDidChangeCustomDocument(f=>{const b=this.getCustomDocumentEntry(r,f.document.uri);if(_(f)){const D=b.addEdit(f);this._proxy.$onDidEdit(f.document.uri,r,D,f.label)}else this._proxy.$onContentChange(f.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,n.toExtensionData)(t),r,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,n.shouldSerializeBuffersForPostMessage)(t))),v.Disposable.from(a,new v.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,u,o,a){var f;const b=this._editorProviders.get(r);if(!b)throw new Error(`No provider found for '${r}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${r}'`);const D=I.URI.revive(t),d=await b.provider.openCustomDocument(D,{backupId:u,untitledDocumentData:o==null?void 0:o.buffer},a);let g;return this.supportEditing(b.provider)&&this._extensionStoragePaths&&(g=(f=this._extensionStoragePaths.workspaceValue(b.extension))!==null&&f!==void 0?f:this._extensionStoragePaths.globalValue(b.extension)),this._documents.add(r,d,g),{editable:this.supportEditing(b.provider)}}async $disposeCustomDocument(t,r){const u=this._editorProviders.get(r);if(!u)throw new Error(`No provider found for '${r}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${r}'`);const o=I.URI.revive(t),{document:a}=this.getCustomDocumentEntry(r,o);this._documents.delete(r,a),a.dispose()}async $resolveWebviewEditor(t,r,u,o,a,f){const b=this._editorProviders.get(u);if(!b)throw new Error(`No provider found for '${u}'`);const D=y.ViewColumn.to(a),d=this._extHostWebview.createNewWebview(r,o.webviewOptions,b.extension),g=this._extHostWebviewPanels.createNewWebviewPanel(r,u,o.title,D,o.panelOptions,d),P=I.URI.revive(t);switch(b.type){case 1:{const{document:F}=this.getCustomDocumentEntry(u,P);return b.provider.resolveCustomEditor(F,g,f)}case 0:{const F=this._extHostDocuments.getDocument(P);return b.provider.resolveCustomTextEditor(F,g,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,u){this.getCustomDocumentEntry(r,t).disposeEdits(u)}async $onMoveCustomEditor(t,r,u){const o=this._editorProviders.get(u);if(!o)throw new Error(`No provider found for '${u}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const a=this._extHostWebviewPanels.getWebviewPanel(t);if(!a)throw new Error("No webview found");const f=I.URI.revive(r),b=this._extHostDocuments.getDocument(f);await o.provider.moveCustomTextEditor(b,a,E.CancellationToken.None)}async $undo(t,r,u,o){return this.getCustomDocumentEntry(r,t).undo(u,o)}async $redo(t,r,u,o){return this.getCustomDocumentEntry(r,t).redo(u,o)}async $revert(t,r,u){const o=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(o.document,u),o.disposeBackup()}async $onSave(t,r,u){const o=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(o.document,u),o.disposeBackup()}async $onSaveAs(t,r,u,o){const a=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(a.document,I.URI.revive(u),o)}async $backup(t,r,u){const o=this.getCustomDocumentEntry(r,t),f=await this.getCustomEditorProvider(r).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},u);return o.updateBackup(f),f.id}getCustomDocumentEntry(t,r){const u=this._documents.get(t,I.URI.revive(r));if(!u)throw new Error("No custom document found");return u}getCustomEditorProvider(t){const r=this._editorProviders.get(t),u=r==null?void 0:r.provider;if(!u||!this.supportEditing(u))throw new Error("Custom document is not editable");return u}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=h;function w(l){return typeof l.resolveCustomTextEditor=="function"}function _(l){return typeof l.undo=="function"&&typeof l.redo=="function"}function c(l){const t=l.scheme===T.Schemas.file||l.scheme===T.Schemas.untitled?l.fsPath:l.toString();return(0,k.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(ie,e,E,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(ie,E):A?A.value=E:e.set(ie,E),E},Ue=this&&this.__classPrivateFieldGet||function(ie,e,E,k){if(E==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?k:E==="a"?k.call(ie):k?k.value:e.get(ie)};define(be[209],we([0,1,3,6,2,29,9,49,5,7]),function(ie,e,E,k,A,T,S,I,y,n){"use strict";var R,C,v,m,i,s,p,h,w,_,c,l,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends k.Disposable{constructor(f,b,D,d,g,P,F){super();R.set(this,void 0),C.set(this,void 0),v.set(this,void 0),m.set(this,void 0),i.set(this,void 0),s.set(this,void 0),p.set(this,void 0),h.set(this,void 0),w.set(this,!0),_.set(this,!0),c.set(this,!1),l.set(this,this._register(new E.Emitter)),this.onDidDispose=Ue(this,l,"f").event,t.set(this,this._register(new E.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,tt(this,R,f,"f"),tt(this,C,b,"f"),tt(this,v,D,"f"),tt(this,i,P,"f"),tt(this,h,g,"f"),tt(this,s,d,"f"),tt(this,m,F,"f")}dispose(){Ue(this,c,"f")||(tt(this,c,!0,"f"),Ue(this,l,"f").fire(),Ue(this,C,"f").$disposeWebview(Ue(this,R,"f")),Ue(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,m,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,v,"f")}get title(){return this.assertNotDisposed(),Ue(this,s,"f")}set title(f){this.assertNotDisposed(),Ue(this,s,"f")!==f&&(tt(this,s,f,"f"),Ue(this,C,"f").$setTitle(Ue(this,R,"f"),f))}get iconPath(){return this.assertNotDisposed(),Ue(this,p,"f")}set iconPath(f){this.assertNotDisposed(),Ue(this,p,"f")!==f&&(tt(this,p,f,"f"),Ue(this,C,"f").$setIconPath(Ue(this,R,"f"),A.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Ue(this,i,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,h,"f")=="number"&&Ue(this,h,"f")<0))return Ue(this,h,"f")}get active(){return this.assertNotDisposed(),Ue(this,_,"f")}get visible(){return this.assertNotDisposed(),Ue(this,w,"f")}_updateViewState(f){Ue(this,c,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(tt(this,_,f.active,"f"),tt(this,w,f.visible,"f"),tt(this,h,f.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(f,b){this.assertNotDisposed(),Ue(this,C,"f").$reveal(Ue(this,R,"f"),{viewColumn:f?S.ViewColumn.from(f):void 0,preserveFocus:!!b})}assertNotDisposed(){if(Ue(this,c,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,C=new WeakMap,v=new WeakMap,m=new WeakMap,i=new WeakMap,s=new WeakMap,p=new WeakMap,h=new WeakMap,w=new WeakMap,_=new WeakMap,c=new WeakMap,l=new WeakMap,t=new WeakMap;class u{constructor(f,b,D){this.webviews=b,this.workspace=D,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(f,b,D,d,g={}){const P=typeof d=="object"?d.viewColumn:d,F={viewColumn:S.ViewColumn.from(P),preserveFocus:typeof d=="object"&&!!d.preserveFocus},z=(0,I.shouldSerializeBuffersForPostMessage)(f),de=u.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(f),de,b,{title:D,panelOptions:o(g),webviewOptions:(0,I.serializeWebviewOptions)(f,this.workspace,g),serializeBuffersForPostMessage:z},F);const W=this.webviews.createNewWebview(de,g,f);return this.createNewWebviewPanel(de,b,D,P,g,W)}$onDidChangeWebviewPanelViewStates(f){const b=Object.keys(f);b.sort((D,d)=>{const g=f[D],P=f[d];return g.active?1:P.active?-1:+g.visible-+P.visible});for(const D of b){const d=this.getWebviewPanel(D);if(!!d){const g=f[D];d._updateViewState({active:g.active,visible:g.visible,viewColumn:S.ViewColumn.to(g.position)})}}}async $onDidDisposeWebviewPanel(f){const b=this.getWebviewPanel(f);b==null||b.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,b,D){if(this._serializers.has(b))throw new Error(`Serializer for '${b}' already registered`);return this._serializers.set(b,{serializer:D,extension:f}),this._proxy.$registerSerializer(b,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(f)}),new n.Disposable(()=>{this._serializers.delete(b),this._proxy.$unregisterSerializer(b)})}async $deserializeWebviewPanel(f,b,D,d){const g=this._serializers.get(b);if(!g)throw new Error(`No serializer found for '${b}'`);const{serializer:P,extension:F}=g,z=this.webviews.createNewWebview(f,D.webviewOptions,F),de=this.createNewWebviewPanel(f,b,D.title,d,D.panelOptions,z);await P.deserializeWebviewPanel(de,D.state)}createNewWebviewPanel(f,b,D,d,g,P){const F=new r(f,this._proxy,b,D,d,g,P);return this._webviewPanels.set(f,F),F}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=u;function o(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(ie,e,E,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(ie,E):A?A.value=E:e.set(ie,E),E},Ue=this&&this.__classPrivateFieldGet||function(ie,e,E,k){if(E==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?k:E==="a"?k.call(ie):k?k.value:e.get(ie)};define(be[210],we([0,1,3,6,49,5,7]),function(ie,e,E,k,A,T,S){"use strict";var I,y,n,R,C,v,m,i,s,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class h extends k.Disposable{constructor(c,l,t,r,u,o){super();I.set(this,void 0),y.set(this,void 0),n.set(this,void 0),R.set(this,void 0),C.set(this,!1),v.set(this,void 0),m.set(this,void 0),i.set(this,void 0),s.set(this,this._register(new E.Emitter)),this.onDidChangeVisibility=Ue(this,s,"f").event,p.set(this,this._register(new E.Emitter)),this.onDidDispose=Ue(this,p,"f").event,tt(this,n,t,"f"),tt(this,m,r,"f"),tt(this,I,c,"f"),tt(this,y,l,"f"),tt(this,R,u,"f"),tt(this,v,o,"f")}dispose(){Ue(this,C,"f")||(tt(this,C,!0,"f"),Ue(this,p,"f").fire(),Ue(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,m,"f")}set title(c){this.assertNotDisposed(),Ue(this,m,"f")!==c&&(tt(this,m,c,"f"),Ue(this,y,"f").$setWebviewViewTitle(Ue(this,I,"f"),c))}get description(){return this.assertNotDisposed(),Ue(this,i,"f")}set description(c){this.assertNotDisposed(),Ue(this,i,"f")!==c&&(tt(this,i,c,"f"),Ue(this,y,"f").$setWebviewViewDescription(Ue(this,I,"f"),c))}get visible(){return Ue(this,v,"f")}get webview(){return Ue(this,R,"f")}get viewType(){return Ue(this,n,"f")}_setVisible(c){c===Ue(this,v,"f")||Ue(this,C,"f")||(tt(this,v,c,"f"),Ue(this,s,"f").fire())}show(c){this.assertNotDisposed(),Ue(this,y,"f").$show(Ue(this,I,"f"),!!c)}assertNotDisposed(){if(Ue(this,C,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,y=new WeakMap,n=new WeakMap,R=new WeakMap,C=new WeakMap,v=new WeakMap,m=new WeakMap,i=new WeakMap,s=new WeakMap,p=new WeakMap;class w{constructor(c,l){this._extHostWebview=l,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,l,t,r){if(this._viewProviders.has(l))throw new Error(`View provider for '${l}' already registered`);return this._viewProviders.set(l,{provider:t,extension:c}),this._proxy.$registerWebviewViewProvider((0,A.toExtensionData)(c),l,{retainContextWhenHidden:r==null?void 0:r.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new S.Disposable(()=>{this._viewProviders.delete(l),this._proxy.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(c,l,t,r,u){const o=this._viewProviders.get(l);if(!o)throw new Error(`No view provider found for '${l}'`);const{provider:a,extension:f}=o,b=this._extHostWebview.createNewWebview(c,{},f),D=new h(c,this._proxy,l,t,b,!0);this._webviewViews.set(c,D),await a.resolveWebviewView(D,{state:r},u)}async $onDidChangeWebviewViewVisibility(c,l){this.getWebviewView(c)._setVisible(l)}async $disposeWebviewView(c){const l=this.getWebviewView(c);this._webviewViews.delete(c),l.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const l=this._webviewViews.get(c);if(!l)throw new Error("No webview found");return l}}e.ExtHostWebviewViews=w}),define(be[100],we([0,1,3,5,2,18,8,4,14]),function(ie,e,E,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class In{constructor(C){this._onDidChangeWindowState=new E.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=In.InitialState,this._proxy=C.getProxy(k.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(v=>this.$onDidChangeWindowFocus(v))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:C}),this._onDidChangeWindowState.fire(this._state))}openUri(C,v){let m;if(typeof C=="string"){m=C;try{C=A.URI.parse(C)}catch(i){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,S.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,m,v)}async asExternalUri(C,v){if((0,S.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([T.Schemas.http,T.Schemas.https]).has(C.scheme))return Promise.reject(`Invalid scheme '${C.scheme}'`);const m=await this._proxy.$asExternalUri(C,v);return A.URI.from(m)}};n.InitialState={focused:!0},n=je([Ke(0,y.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(be[211],we([0,1,19,5,27,14]),function(ie,e,E,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let S=class extends E.AbstractLogger{constructor(y,n){super();this._proxy=y.getProxy(k.MainContext.MainThreadLog),this._logFile=n.logFile.toJSON(),this.setLevel(n.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...n){this.getLevel()<=E.LogLevel.Trace&&this._proxy.$log(this._logFile,E.LogLevel.Trace,Array.from(arguments))}debug(y,...n){this.getLevel()<=E.LogLevel.Debug&&this._proxy.$log(this._logFile,E.LogLevel.Debug,Array.from(arguments))}info(y,...n){this.getLevel()<=E.LogLevel.Info&&this._proxy.$log(this._logFile,E.LogLevel.Info,Array.from(arguments))}warn(y,...n){this.getLevel()<=E.LogLevel.Warning&&this._proxy.$log(this._logFile,E.LogLevel.Warning,Array.from(arguments))}error(y,...n){this.getLevel()<=E.LogLevel.Error&&this._proxy.$log(this._logFile,E.LogLevel.Error,Array.from(arguments))}critical(y,...n){this.getLevel()<=E.LogLevel.Critical&&this._proxy.$log(this._logFile,E.LogLevel.Critical,Array.from(arguments))}flush(){}};S=je([Ke(0,T.IExtHostRpcService),Ke(1,A.IExtHostInitDataService)],S),e.ExtHostLogService=S}),define(be[212],we([0,1,13,20,10,3,6,111,185,97,24]),function(ie,e,E,k,A,T,S,I,y,n,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function v(o,a){try{return JSON.stringify(o,a)}catch(f){return"null"}}function m(o,a){return JSON.stringify(o,a)}function i(o){return o?(a,f)=>f&&f.$mid===1?o.transformOutgoing(f):f:null}var s;(function(o){o[o.LocalSide=0]="LocalSide",o[o.OtherSide=1]="OtherSide"})(s=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(o){o[o.Responsive=0]="Responsive",o[o.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const h=()=>{},w=Symbol.for("rpcProtocol"),_=Symbol.for("rpcProxy");class c extends S.Disposable{constructor(a,f=null,b=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=a,this._logger=f,this._uriTransformer=b,this._uriReplacer=i(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let D=0,d=n.ProxyIdentifier.count;D<d;D++)this._locals[D]=null,this._proxies[D]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new E.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(D=>this._receiveOneMessage(D))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(a=>{this._pendingRPCReplies[a].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(a){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(a){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(a){this._responsiveState!==a&&(this._responsiveState=a,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(a){return this._uriTransformer?(0,I.transformIncomingURIs)(a,this._uriTransformer):a}getProxy(a){const{nid:f,sid:b}=a;return this._proxies[f]||(this._proxies[f]=this._createProxy(f,b)),this._proxies[f]}_createProxy(a,f){let b={get:(D,d)=>(typeof d=="string"&&!D[d]&&d.charCodeAt(0)===36&&(D[d]=(...g)=>this._remoteCall(a,d,g)),d===_?f:D[d])};return new Proxy(Object.create(null),b)}set(a,f){return this._locals[a.nid]=f,f}assertRegistered(a){for(let f=0,b=a.length;f<b;f++){const D=a[f];if(!this._locals[D.nid])throw new Error(`Missing actor ${D.sid} (isMain: ${D.isMain})`)}}_receiveOneMessage(a){if(!this._isDisposed){const f=a.byteLength,b=l.read(a,0),D=b.readUInt8(),d=b.readUInt32();switch(D){case 1:case 2:{let{rpcId:g,method:P,args:F}=t.deserializeRequestJSONArgs(b);this._uriTransformer&&(F=(0,I.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(f,d,g,P,F,D===2);break}case 3:case 4:{let{rpcId:g,method:P,args:F}=t.deserializeRequestMixedArgs(b);this._uriTransformer&&(F=(0,I.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(f,d,g,P,F,D===4);break}case 5:{this._logger&&this._logger.logIncoming(f,d,0,"ack"),this._onDidReceiveAcknowledge(d);break}case 6:{this._receiveCancel(f,d);break}case 7:{this._receiveReply(f,d,void 0);break}case 9:{let g=t.deserializeReplyOKJSON(b);this._uriTransformer&&(g=(0,I.transformIncomingURIs)(g,this._uriTransformer)),this._receiveReply(f,d,g);break}case 8:{let g=t.deserializeReplyOKVSBuffer(b);this._receiveReply(f,d,g);break}case 10:{let g=t.deserializeReplyErrError(b);this._uriTransformer&&(g=(0,I.transformIncomingURIs)(g,this._uriTransformer)),this._receiveReplyErr(f,d,g);break}case 11:{this._receiveReplyErr(f,d,void 0);break}default:console.error("received unexpected message"),console.error(a)}}}_receiveRequest(a,f,b,D,d,g){this._logger&&this._logger.logIncoming(a,f,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(b)}.${D}(`,d);const P=String(f);let F,z;if(g){const W=new k.CancellationTokenSource;d.push(W.token),F=this._invokeHandler(b,D,d),z=()=>W.cancel()}else F=this._invokeHandler(b,D,d),z=h;this._cancelInvokedHandlers[P]=z;const de=t.serializeAcknowledged(f);this._logger&&this._logger.logOutgoing(de.byteLength,f,1,"ack"),this._protocol.send(de),F.then(W=>{delete this._cancelInvokedHandlers[P];const B=t.serializeReplyOK(f,W,this._uriReplacer);this._logger&&this._logger.logOutgoing(B.byteLength,f,1,"reply:",W),this._protocol.send(B)},W=>{delete this._cancelInvokedHandlers[P];const B=t.serializeReplyErr(f,W);this._logger&&this._logger.logOutgoing(B.byteLength,f,1,"replyErr:",W),this._protocol.send(B)})}_receiveCancel(a,f){this._logger&&this._logger.logIncoming(a,f,1,"receiveCancel");const b=String(f);this._cancelInvokedHandlers[b]&&this._cancelInvokedHandlers[b]()}_receiveReply(a,f,b){this._logger&&this._logger.logIncoming(a,f,0,"receiveReply:",b);const D=String(f);if(!!this._pendingRPCReplies.hasOwnProperty(D)){const d=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],d.resolveOk(b)}}_receiveReplyErr(a,f,b){this._logger&&this._logger.logIncoming(a,f,0,"receiveReplyErr:",b);const D=String(f);if(!!this._pendingRPCReplies.hasOwnProperty(D)){const d=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D];let g;b&&(b.$isError?(g=new Error,g.name=b.name,g.message=b.message,g.stack=b.stack):g=b),d.resolveErr(g)}}_invokeHandler(a,f,b){try{return Promise.resolve(this._doInvokeHandler(a,f,b))}catch(D){return Promise.reject(D)}}_doInvokeHandler(a,f,b){const D=this._locals[a];if(!D)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(a));let d=D[f];if(typeof d!="function")throw new Error("Unknown method "+f+" on actor "+(0,n.getStringIdentifierForProxy)(a));return d.apply(D,b)}_remoteCall(a,f,b){if(this._isDisposed)return Promise.reject(A.canceled());let D=null;if(b.length>0&&k.CancellationToken.isCancellationToken(b[b.length-1])&&(D=b.pop()),D&&D.isCancellationRequested)return Promise.reject(A.canceled());const d=t.serializeRequestArguments(b,this._uriReplacer),g=++this._lastMessageId,P=String(g),F=new y.LazyPromise;D&&D.onCancellationRequested(()=>{const de=t.serializeCancel(g);this._logger&&this._logger.logOutgoing(de.byteLength,g,0,"cancel"),this._protocol.send(t.serializeCancel(g))}),this._pendingRPCReplies[P]=F,this._onWillSendRequest(g);const z=t.serializeRequest(g,a,f,d,!!D);return this._logger&&this._logger.logOutgoing(z.byteLength,g,0,`request: ${(0,n.getStringIdentifierForProxy)(a)}.${f}(`,b),this._protocol.send(z),F}}e.RPCProtocol=c,C=w,c.UNRESPONSIVE_TIME=3*1e3;class l{constructor(a,f){this._buff=a,this._offset=f}static alloc(a,f,b){let D=new l(R.VSBuffer.alloc(b+1+4),0);return D.writeUInt8(a),D.writeUInt32(f),D}static read(a,f){return new l(a,f)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(a){this._buff.writeUInt8(a,this._offset),this._offset+=1}readUInt8(){const a=this._buff.readUInt8(this._offset);return this._offset+=1,a}writeUInt32(a){this._buff.writeUInt32BE(a,this._offset),this._offset+=4}readUInt32(){const a=this._buff.readUInt32BE(this._offset);return this._offset+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this._buff.writeUInt8(a.byteLength,this._offset),this._offset+=1,this._buff.set(a,this._offset),this._offset+=a.byteLength}readShortString(){const a=this._buff.readUInt8(this._offset);this._offset+=1;const b=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,b}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readLongString(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const b=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,b}writeBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readVSBuffer(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+a);return this._offset+=a,f}static sizeMixedArray(a,f){let b=0;b+=1;for(let D=0,d=a.length;D<d;D++){const g=a[D],P=f[D];switch(b+=1,P){case 1:b+=this.sizeLongString(g);break;case 2:b+=this.sizeVSBuffer(g);break;case 3:break}}return b}writeMixedArray(a,f){this._buff.writeUInt8(a.length,this._offset),this._offset+=1;for(let b=0,D=a.length;b<D;b++){const d=a[b];switch(f[b]){case 1:this.writeUInt8(1),this.writeLongString(d);break;case 2:this.writeUInt8(2),this.writeVSBuffer(d);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const a=this._buff.readUInt8(this._offset);this._offset+=1;let f=new Array(a);for(let b=0;b<a;b++)switch(this.readUInt8()){case 1:f[b]=this.readLongString();break;case 2:f[b]=this.readVSBuffer();break;case 3:f[b]=void 0;break}return f}}class t{static _arrayContainsBufferOrUndefined(a){for(let f=0,b=a.length;f<b;f++)if(a[f]instanceof R.VSBuffer||typeof a[f]=="undefined")return!0;return!1}static serializeRequestArguments(a,f){if(this._arrayContainsBufferOrUndefined(a)){let b=[],D=[];for(let d=0,g=a.length;d<g;d++){const P=a[d];P instanceof R.VSBuffer?(b[d]=P,D[d]=2):typeof P=="undefined"?(b[d]=R.VSBuffer.alloc(0),D[d]=3):(b[d]=R.VSBuffer.fromString(m(P,f)),D[d]=1)}return{type:"mixed",args:b,argsType:D}}return{type:"simple",args:m(a,f)}}static serializeRequest(a,f,b,D,d){return D.type==="mixed"?this._requestMixedArgs(a,f,b,D.args,D.argsType,d):this._requestJSONArgs(a,f,b,D.args,d)}static _requestJSONArgs(a,f,b,D,d){const g=R.VSBuffer.fromString(b),P=R.VSBuffer.fromString(D);let F=0;F+=l.sizeUInt8(),F+=l.sizeShortString(g),F+=l.sizeLongString(P);let z=l.alloc(d?2:1,a,F);return z.writeUInt8(f),z.writeShortString(g),z.writeLongString(P),z.buffer}static deserializeRequestJSONArgs(a){const f=a.readUInt8(),b=a.readShortString(),D=a.readLongString();return{rpcId:f,method:b,args:JSON.parse(D)}}static _requestMixedArgs(a,f,b,D,d,g){const P=R.VSBuffer.fromString(b);let F=0;F+=l.sizeUInt8(),F+=l.sizeShortString(P),F+=l.sizeMixedArray(D,d);let z=l.alloc(g?4:3,a,F);return z.writeUInt8(f),z.writeShortString(P),z.writeMixedArray(D,d),z.buffer}static deserializeRequestMixedArgs(a){const f=a.readUInt8(),b=a.readShortString(),D=a.readMixedArray(),d=new Array(D.length);for(let g=0,P=D.length;g<P;g++){const F=D[g];typeof F=="string"?d[g]=JSON.parse(F):d[g]=F}return{rpcId:f,method:b,args:d}}static serializeAcknowledged(a){return l.alloc(5,a,0).buffer}static serializeCancel(a){return l.alloc(6,a,0).buffer}static serializeReplyOK(a,f,b){return typeof f=="undefined"?this._serializeReplyOKEmpty(a):f instanceof R.VSBuffer?this._serializeReplyOKVSBuffer(a,f):this._serializeReplyOKJSON(a,v(f,b))}static _serializeReplyOKEmpty(a){return l.alloc(7,a,0).buffer}static _serializeReplyOKVSBuffer(a,f){let b=0;b+=l.sizeVSBuffer(f);let D=l.alloc(8,a,b);return D.writeVSBuffer(f),D.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static _serializeReplyOKJSON(a,f){const b=R.VSBuffer.fromString(f);let D=0;D+=l.sizeLongString(b);let d=l.alloc(9,a,D);return d.writeLongString(b),d.buffer}static deserializeReplyOKJSON(a){const f=a.readLongString();return JSON.parse(f)}static serializeReplyErr(a,f){return f?this._serializeReplyErrEror(a,f):this._serializeReplyErrEmpty(a)}static _serializeReplyErrEror(a,f){const b=R.VSBuffer.fromString(v(A.transformErrorForSerialization(f),null));let D=0;D+=l.sizeLongString(b);let d=l.alloc(10,a,D);return d.writeLongString(b),d.buffer}static deserializeReplyErrError(a){const f=a.readLongString();return JSON.parse(f)}static _serializeReplyErrEmpty(a){return l.alloc(11,a,0).buffer}}var r;(function(o){o[o.RequestJSONArgs=1]="RequestJSONArgs",o[o.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",o[o.RequestMixedArgs=3]="RequestMixedArgs",o[o.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",o[o.Acknowledged=5]="Acknowledged",o[o.Cancel=6]="Cancel",o[o.ReplyOKEmpty=7]="ReplyOKEmpty",o[o.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",o[o.ReplyOKJSON=9]="ReplyOKJSON",o[o.ReplyErrError=10]="ReplyErrError",o[o.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var u;(function(o){o[o.String=1]="String",o[o.VSBuffer=2]="VSBuffer",o[o.Undefined=3]="Undefined"})(u||(u={}))}),define(be[213],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const E=function(T){const S=I=>{self.removeEventListener("message",S);const y=I.data;Object.defineProperties(self,{postMessage:{value(n,R){y.postMessage(n,R)}},onmessage:{get(){return y.onmessage},set(n){y.onmessage=n}}}),y.addEventListener("message",n=>{self.dispatchEvent(new MessageEvent("message",{data:n.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",S)}.toString();class k extends EventTarget{constructor(T,S,I){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${E})('${S}'))`,n=new Blob([y],{type:"application/javascript"}),R=URL.createObjectURL(n),C=new MessageChannel,v=R,m={type:"_newWorker",id:v,port:C.port2,url:R,options:I};T(m,[C.port2]),this.postMessage=C.port1.postMessage.bind(C.port1),this.terminate=()=>{const i={type:"_terminateWorker",id:v};C.port1.postMessage(i),URL.revokeObjectURL(R),C.port1.close(),C.port2.close()},Object.defineProperties(this,{onmessage:{get(){return C.port1.onmessage},set(i){C.port1.onmessage=i}},onmessageerror:{get(){return C.port1.onmessageerror},set(i){C.port1.onmessageerror=i}}}),C.port1.addEventListener("messageerror",i=>{const s=new MessageEvent("messageerror",{data:i.data});this.dispatchEvent(s)}),C.port1.addEventListener("message",i=>{const s=new MessageEvent("message",{data:i.data});this.dispatchEvent(s)}),C.port1.start()}}e.NestedWorker=k}),define(be[214],we([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,E.createDecorator)("remoteAgentService")}),define(be[215],we([0,1,18,11,21,2,4,214]),function(ie,e,E,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let y=class{constructor(R,C){this.localUserHome=R,this.remoteAgentService=C,this.resolveOS=(async()=>{const v=await this.remoteAgentService.getEnvironment();return(v==null?void 0:v.os)||A.OS})(),this.resolveUserHome=(async()=>{const v=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(v==null?void 0:v.userHome)||R})()}async userHome(R){return(R==null?void 0:R.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(R=>R===1?k.win32:k.posix)}async fileURI(R){let C="";if(await this.resolveOS===1&&(R=R.replace(/\\/g,"/")),R[0]==="/"&&R[1]==="/"){const m=R.indexOf("/",2);m===-1?(C=R.substring(2),R="/"):(C=R.substring(2,m),R=R.substring(m)||"/")}return T.URI.from({scheme:E.Schemas.file,authority:C,path:R,query:"",fragment:""})}};y=je([Ke(1,I.IRemoteAgentService)],y),e.AbstractPathService=y}),define(be[41],we([0,1,15,28,23,37,8,4,11,10]),function(ie,e,E,k,A,T,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const R="\u27EA ",C=" characters skipped \u27EB",v=(R.length+C.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var m;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(m=e.SearchProviderType||(e.SearchProviderType={}));var i;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(i=e.QueryType||(e.QueryType={}));function s(L){return!!L.preview}e.resultIsMatch=s;function p(L){return!!L.resource}e.isFileMatch=p;function h(L){return!!L.message}e.isProgressMessage=h;var w;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(w=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class _{constructor(U){this.resource=U,this.results=[]}}e.FileMatch=_;class c{constructor(U,x,Q){this.ranges=x;const $=Array.isArray(x)?x:[x];if(Q&&Q.matchLines===1&&l($)){U=(0,S.getNLines)(U,Q.matchLines);let ee="",re=0,se=0;const ye=Math.floor(Q.charsPerLine/5),Ie=[];for(const xe of $){const Fe=Math.max(xe.startColumn-ye,0),ze=xe.startColumn+Q.charsPerLine;if(Fe>se+ye+v){const N=R+(Fe-se)+C;ee+=N+U.slice(Fe,ze),re+=Fe-(se+N.length)}else ee+=U.slice(se,ze);Ie.push(new r(0,xe.startColumn-re,xe.endColumn-re)),se=ze}this.preview={text:ee,matches:Array.isArray(this.ranges)?Ie:Ie[0]}}else{const ee=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:U,matches:(0,E.mapArrayOrNot)(x,re=>new t(re.startLineNumber-ee,re.startColumn,re.endLineNumber-ee,re.endColumn))}}}}e.TextSearchMatch=c;function l(L){const U=L[0].startLineNumber;for(const x of L)if(x.startLineNumber!==U||x.endLineNumber!==U)return!1;return!0}class t{constructor(U,x,Q,$){this.startLineNumber=U,this.startColumn=x,this.endLineNumber=Q,this.endColumn=$}}e.SearchRange=t;class r extends t{constructor(U,x,Q){super(U,x,U,Q)}}e.OneLineRange=r;var u;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function o(L,U=!0){const x=L&&L.files&&L.files.exclude,Q=U&&L&&L.search&&L.search.exclude;if(!(!x&&!Q)){if(!x||!Q)return x||Q;let $=Object.create(null);return $=A.mixin($,A.deepClone(x)),$=A.mixin($,A.deepClone(Q),!0),$}}e.getExcludes=o;function a(L,U){return L.excludePattern&&k.match(L.excludePattern,U)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&k.match(L.includePattern,U)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(x=>{const Q=x.folder.fsPath;if(T.isEqualOrParent(U,Q)){const $=y.relative(Q,U);return!x.includePattern||!!k.match(x.includePattern,$)}else return!1}):!1:!0}e.pathIncludedInQuery=a;var f;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class b extends Error{constructor(U,x){super(U);this.code=x}}e.SearchError=b;function D(L){const U=L.message;if((0,n.isPromiseCanceledError)(L))return new b(U,f.canceled);try{const x=JSON.parse(U);return new b(x.message,x.code)}catch(x){return new b(U,f.other)}}e.deserializeSearchError=D;function d(L){const U={message:L.message,code:L.code};return new Error(JSON.stringify(U))}e.serializeSearchError=d;function g(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=g;function P(L){return L.type==="success"}e.isSerializedSearchSuccess=P;function F(L){return!!L.path}e.isSerializedFileMatch=F;function z(L,U){const x=L.searchPath?L.searchPath:L.relativePath;return(0,S.fuzzyContains)(x,U)}e.isFilePatternMatch=z;class de{constructor(U){this.path=U,this.results=[]}addMatch(U){this.results.push(U)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=de;function W(L,U){const x=Object.assign(Object.assign({},L||{}),U||{});return Object.keys(x).filter(Q=>{const $=x[Q];return typeof $=="boolean"&&$})}e.resolvePatternsForProvider=W;class B{constructor(U,x){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},U.excludePattern||{}),x.excludePattern||{}),this._parsedExcludeExpression=k.parse(this._excludeExpression);let Q=U.includePattern;x.includePattern&&(Q?Q=Object.assign(Object.assign({},Q),x.includePattern):Q=x.includePattern),Q&&(this._parsedIncludeExpression=k.parse(Q))}includedInQuerySync(U,x,Q){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(U,x,Q)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(U,x,Q))}includedInQuery(U,x,Q){return Promise.resolve(this._parsedExcludeExpression(U,x,Q)).then(ee=>!!ee).then(ee=>ee?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(U,x,Q)).then(re=>!!re):Promise.resolve(!0)).then(ee=>ee)}hasSiblingExcludeClauses(){return K(this._excludeExpression)}}e.QueryGlobTester=B;function K(L){for(const U in L)if(typeof L[U]!="boolean")return!0;return!1}}),define(be[31],we([0,1,15,13,20,3,22,18,78,25,8,12,2,136,4,19,151,47,48,27,14,7,41,5]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m,i,s,p,h,w,_,c,l,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(P,F,z){return new n.ExtUri(de=>b(de,z)).isEqual(P,F)}function o(P,F,z){return u(P.uri,F.uri,z)?0:(0,R.compare)(P.uri.toString(),F.uri.toString())}function a(P,F,z){return P.index!==F.index?P.index<F.index?-1:1:u(P.uri,F.uri,z)?(0,R.compare)(P.name,F.name):(0,R.compare)(P.uri.toString(),F.uri.toString())}function f(P,F,z,de){const W=P.slice(0).sort((K,L)=>z(K,L,de)),B=F.slice(0).sort((K,L)=>z(K,L,de));return(0,E.delta)(W,B,(K,L)=>z(K,L,de))}function b(P,F){const z=F.getCapabilities(P.scheme);return!(z&&z&1024)}class D extends h.Workspace{constructor(F,z,de,W,B,K){super(F,de.map(L=>new h.WorkspaceFolder(L)),W,K);this._name=z,this._isUntitled=B,this._workspaceFolders=[],this._structure=S.TernarySearchTree.forUris(K),de.forEach(L=>{this._workspaceFolders.push(L),this._structure.set(L.uri,L)})}static toExtHostWorkspace(F,z,de,W){if(!F)return{workspace:null,added:[],removed:[]};const{id:B,name:K,folders:L,configuration:U,isUntitled:x}=F,Q=[],$=z;z?L.forEach((ye,Ie)=>{const xe=v.URI.revive(ye.uri),Fe=D._findFolder(de||z,xe,W);Fe?(Fe.name=ye.name,Fe.index=ye.index,Q.push(Fe)):Q.push({uri:xe,name:ye.name,index:Ie})}):Q.push(...L.map(({uri:ye,name:Ie,index:xe})=>({uri:v.URI.revive(ye),name:Ie,index:xe}))),Q.sort((ye,Ie)=>ye.index<Ie.index?-1:1);const ee=new D(B,K,Q,U?v.URI.revive(U):null,!!x,ye=>b(ye,W)),{added:re,removed:se}=f($?$.workspaceFolders:[],ee.workspaceFolders,o,W);return{workspace:ee,added:re,removed:se}}static _findFolder(F,z,de){for(let W=0;W<F.folders.length;W++){const B=F.workspaceFolders[W];if(u(B.uri,z,de))return B}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,z){return z&&this._structure.get(F)&&(F=(0,n.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let d=class{constructor(F,z,de,W){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidChangeWorkspaceTrustState=new T.Emitter,this.onDidChangeWorkspaceTrustState=this._onDidChangeWorkspaceTrustState.event,this._activeSearchCallbacks=[],this._workspaceTrustState=l.WorkspaceTrustState.Unspecified,this._logService=W,this._extHostFileSystemInfo=de,this._requestIdProvider=new y.Counter,this._barrier=new k.Barrier,this._proxy=F.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(r.MainContext.MainThreadMessageService);const B=z.workspace;this._confirmedWorkspace=B?new D(B.id,B.name,[],B.configuration?v.URI.revive(B.configuration):null,!!B.isUntitled,K=>b(K,de)):void 0}$initializeWorkspace(F,z){this._workspaceTrustState=z,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?v.URI.from({scheme:I.Schemas.untitled,path:(0,n.basename)((0,n.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,z,de,...W){const B=[];if(Array.isArray(W)&&W.forEach(Q=>{v.URI.isUri(Q.uri)&&!B.some($=>u($.uri,Q.uri,this._extHostFileSystemInfo))&&B.push({uri:Q.uri,name:Q.name||(0,n.basenameOrAuthority)(Q.uri)})}),this._unconfirmedWorkspace||[z,de].some(Q=>typeof Q!="number"||Q<0)||de===0&&B.length===0)return!1;const K=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(z+de>K.length)return!1;const L=K.slice(0);L.splice(z,de,...B.map(Q=>({uri:Q.uri,name:Q.name||(0,n.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<L.length;Q++){const $=L[Q];if(L.some((ee,re)=>re!==Q&&u($.uri,ee.uri,this._extHostFileSystemInfo)))return!1}L.forEach((Q,$)=>Q.index=$);const{added:U,removed:x}=f(K,L,a,this._extHostFileSystemInfo);if(U.length===0&&x.length===0)return!1;if(this._proxy){const Q=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(Q,z,de,B).then(void 0,$=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,m.localize)(0,null,Q,$.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(L),!0}getWorkspaceFolder(F,z){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,z)}async getWorkspaceFolder2(F,z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,z)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!!this._actualWorkspace){const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}}getRelativePath(F,z){let de,W="";if(typeof F=="string"?(de=v.URI.file(F),W=F):typeof F!="undefined"&&(de=F,W=F.fsPath),!de)return W;const B=this.getWorkspaceFolder(de,!0);if(!B)return W;typeof z=="undefined"&&this._actualWorkspace&&(z=this._actualWorkspace.folders.length>1);let K=(0,n.relativePath)(B.uri,de);return z&&B.name&&(K=`${B.name}/${K}`),K}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=D.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:z,added:de,removed:W}=D.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=z||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:de,removed:W}))}findFiles(F,z,de,W,B=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${W.value}, entryPoint: findFiles`);let K;if(z===null?K=!1:z&&(typeof z=="string"?K=z:K=z.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:L,folder:U}=g(F);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(L),(0,C.withUndefinedAsNull)(U),(0,C.withUndefinedAsNull)(K),(0,C.withUndefinedAsNull)(de),B).then(x=>Array.isArray(x)?x.map(Q=>v.URI.revive(Q)):[])}async findTextInFiles(F,z,de,W,B=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${W.value}, entryPoint: findTextInFiles`);const K=this._requestIdProvider.getNext(),L=typeof z.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:U,folder:x}=g(z.include),Q=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,$={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:L,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:U,excludePattern:Q},ee=!1;if(this._activeSearchCallbacks[K]=re=>{if(!ee){const se=v.URI.revive(re.resource);re.results.forEach(ye=>{(0,t.resultIsMatch)(ye)?de({uri:se,preview:{text:ye.preview.text,matches:(0,E.mapArrayOrNot)(ye.preview.matches,Ie=>new l.Range(Ie.startLineNumber,Ie.startColumn,Ie.endLineNumber,Ie.endColumn))},ranges:(0,E.mapArrayOrNot)(ye.ranges,Ie=>new l.Range(Ie.startLineNumber,Ie.startColumn,Ie.endLineNumber,Ie.endColumn))}):de({uri:se,text:ye.text,lineNumber:ye.lineNumber})})}},B.isCancellationRequested)return{};try{const re=await this._proxy.$startTextSearch(F,(0,C.withUndefinedAsNull)(x),$,K,B);return delete this._activeSearchCallbacks[K],re||{}}catch(re){throw delete this._activeSearchCallbacks[K],re}}$handleTextSearchResult(F,z){this._activeSearchCallbacks[z]&&this._activeSearchCallbacks[z](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trustState(){return this._workspaceTrustState}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidChangeWorkspaceTrustState(F){this._workspaceTrustState=F.currentTrustState,this._onDidChangeWorkspaceTrustState.fire(Object.freeze({newTrustState:F.currentTrustState}))}};d=je([Ke(0,c.IExtHostRpcService),Ke(1,_.IExtHostInitDataService),Ke(2,w.IExtHostFileSystemInfo),Ke(3,s.ILogService)],d),e.ExtHostWorkspace=d,e.IExtHostWorkspace=(0,i.createDecorator)("IExtHostWorkspace");function g(P){let F,z;return P&&(typeof P=="string"?F=P:(F=P.pattern,z=P.baseFolder||v.URI.file(P.base))),{includePattern:F,folder:z}}}),define(be[34],we([0,1,23,3,31,5,7,153,66,12,13,4,14,19,2]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function s(r,u){if(u){const o=u.split(".");let a=r;for(let f=0;a&&f<o.length;f++)a=a[o[f]];return a}}function p(r){return r instanceof i.URI}function h(r){return r&&r.uri instanceof i.URI&&r.languageId&&typeof r.languageId=="string"}function w(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function _(r){return r&&r.uri instanceof i.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function c(r){if(p(r))return{resource:r};if(h(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(w(r))return{overrideIdentifier:r.languageId};if(_(r))return{resource:r.uri};if(r===null)return{resource:null}}let l=class{constructor(u,o,a){this._proxy=u.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=a,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(u=>this._actual)}$initializeConfiguration(u){this._actual=new t(this._proxy,this._extHostWorkspace,u,this._logService),this._barrier.open()}$acceptConfigurationChanged(u,o){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(u,o))}};l=je([Ke(0,v.IExtHostRpcService),Ke(1,A.IExtHostWorkspace),Ke(2,m.ILogService)],l),e.ExtHostConfiguration=l;class t{constructor(u,o,a,f){this._onDidChangeConfiguration=new k.Emitter,this._proxy=u,this._logService=f,this._extHostWorkspace=o,this._configuration=I.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(u,o){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,a))}getConfiguration(u,o,a){const f=c(o)||{},b=this._toReadonlyValue(u?s(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),u):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));u&&this._validateConfigurationAccess(u,f,a==null?void 0:a.identifier);function D(g){if(g==null)return null;if(typeof g=="boolean")return g?1:4;switch(g){case S.ConfigurationTarget.Global:return 1;case S.ConfigurationTarget.Workspace:return 4;case S.ConfigurationTarget.WorkspaceFolder:return 5}}const d={has(g){return typeof s(b,g)!="undefined"},get:(g,P)=>{this._validateConfigurationAccess(u?`${u}.${g}`:g,f,a==null?void 0:a.identifier);let F=s(b,g);if(typeof F=="undefined")F=P;else{let z;const de=(W,B)=>{let K;const L=()=>{z=z||(0,E.deepClone)(b),K=K||s(z,B)};return(0,n.isObject)(W)?new Proxy(W,{get:(U,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return L(),()=>K;if(z)return K=K||s(z,B),K[x];const Q=U[x];return typeof x=="string"?de(Q,`${B}.${x}`):Q},set:(U,x,Q)=>(L(),K&&(K[x]=Q),!0),deleteProperty:(U,x)=>(L(),K&&delete K[x],!0),defineProperty:(U,x,Q)=>(L(),K&&Object.defineProperty(K,x,Q),!0)}):W};F=de(F,g)}return F},update:(g,P,F,z)=>{g=u?`${u}.${g}`:g;const de=D(F);return P!==void 0?this._proxy.$updateConfigurationOption(de,g,P,f,z):this._proxy.$removeConfigurationOption(de,g,f,z)},inspect:g=>{var P,F,z,de,W,B,K,L;g=u?`${u}.${g}`:g;const U=(0,E.deepClone)(this._configuration.inspect(g,f,this._extHostWorkspace.workspace));if(U)return{key:g,defaultValue:(P=U.default)===null||P===void 0?void 0:P.value,globalValue:(F=U.user)===null||F===void 0?void 0:F.value,workspaceValue:(z=U.workspace)===null||z===void 0?void 0:z.value,workspaceFolderValue:(de=U.workspaceFolder)===null||de===void 0?void 0:de.value,defaultLanguageValue:(W=U.default)===null||W===void 0?void 0:W.override,globalLanguageValue:(B=U.user)===null||B===void 0?void 0:B.override,workspaceLanguageValue:(K=U.workspace)===null||K===void 0?void 0:K.override,workspaceFolderLanguageValue:(L=U.workspaceFolder)===null||L===void 0?void 0:L.override,languageIds:U.overrideIdentifiers}}};return typeof b=="object"&&(0,E.mixin)(d,b,!1),Object.freeze(d)}_toReadonlyValue(u){const o=a=>(0,n.isObject)(a)?new Proxy(a,{get:(f,b)=>o(f[b]),set:(f,b,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(f,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(f,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return o(u)}_validateConfigurationAccess(u,o,a){const f=y.OVERRIDE_PROPERTY_PATTERN.test(u)?4:this._configurationScopes.get(u),b=a?`[${a.value}] `:"";if(f===4){typeof(o==null?void 0:o.resource)=="undefined"&&this._logService.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){(o==null?void 0:o.resource)&&this._logService.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(u,o){const a=new I.ConfigurationChangeEvent(u,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,b)=>a.affectsConfiguration(f,c(b))})}_toMap(u){return u.reduce((o,a)=>(o.set(a[0],a[1]),o),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(ie,e,E,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(ie,E):A?A.value=E:e.set(ie,E),E},Ue=this&&this.__classPrivateFieldGet||function(ie,e,E,k){if(E==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?k:E==="a"?k.call(ie):k?k.value:e.get(ie)};define(be[101],we([0,1,2,13,3,5,7,31,39,34,20,40,14,27,4,18,21,19,72,170,10]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m,i,s,p,h,w,_,c){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(W){function B(L){if(L!=null)return L}W.from=B;function K(L){if(L!=null)return L}W.to=K})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(W){function B(L){if(L!=null)return L}W.from=B;function K(L){if(L!=null)return L}W.to=K})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var u;(function(W){function B(L){if(L!=null)return L}W.from=B;function K(L){if(L!=null)return L}W.to=K})(u=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var o;(function(W){function B(U){if(U){const x=U;return x&&!!x.process}else return!1}W.is=B;function K(U){if(U!=null){const x={process:U.process,args:U.args};return U.options&&(x.options=u.from(U.options)),x}}W.from=K;function L(U){if(U!=null)return new S.ProcessExecution(U.process,U.args,U.options)}W.to=L})(o=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var a;(function(W){function B(L){if(L!=null)return L}W.from=B;function K(L){if(L!=null)return L}W.to=K})(a=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(W){function B(U){if(U){const x=U;return x&&(!!x.commandLine||!!x.command)}else return!1}W.is=B;function K(U){if(U!=null){const x={};return U.commandLine!==void 0?x.commandLine=U.commandLine:(x.command=U.command,x.args=U.args),U.options&&(x.options=a.from(U.options)),x}}W.from=K;function L(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new S.ShellExecution(U.commandLine,U.options):new S.ShellExecution(U.command,U.args?U.args:[],U.options)}W.to=L})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var b;(function(W){function B(U){if(U){let x=U;return x&&x.customExecution==="customExecution"}else return!1}W.is=B;function K(U){return{customExecution:"customExecution"}}W.from=K;function L(U,x){return x.get(U)}W.to=L})(b=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var D;(function(W){function B(K,L){let U;return K.scope!==void 0&&typeof K.scope!="number"?U=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===S.TaskScope.Workspace&&L&&L.workspaceFile?U=L.workspaceFile:U=_.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:U}}W.from=B})(D=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(W){function B(U,x){if(U==null)return[];const Q=[];for(let $ of U){const ee=K($,x);ee&&Q.push(ee)}return Q}W.fromMany=B;function K(U,x){if(U!=null){let Q;U.execution instanceof S.ProcessExecution?Q=o.from(U.execution):U.execution instanceof S.ShellExecution?Q=f.from(U.execution):U.execution&&U.execution instanceof S.CustomExecution&&(Q=b.from(U.execution));const $=t.from(U.definition);let ee;if(U.scope?typeof U.scope=="number"?ee=U.scope:ee=U.scope.uri:ee=S.TaskScope.Workspace,!(!$||!ee)){const re=U.group?U.group.id:void 0;return{_id:U._id,definition:$,name:U.name,source:{extensionId:x.identifier.value,label:U.source,scope:ee},execution:Q,isBackground:U.isBackground,group:re,presentationOptions:r.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}}}W.from=K;async function L(U,x,Q){if(U!=null){let $;o.is(U.execution)?$=o.to(U.execution):f.is(U.execution)?$=f.to(U.execution):b.is(U.execution)&&($=b.to(U._id,Q));const ee=t.to(U.definition);let re;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?re=U.source.scope:re=await x.resolveWorkspaceFolder(E.URI.revive(U.source.scope)):re=S.TaskScope.Workspace),!(!ee||!re)){const se=new S.Task(ee,re,U.name,U.source.label,$,U.problemMatchers);return U.isBackground!==void 0&&(se.isBackground=U.isBackground),U.group!==void 0&&(se.group=S.TaskGroup.from(U.group)),U.presentationOptions&&(se.presentationOptions=r.to(U.presentationOptions)),U._id&&(se._id=U._id),U.detail&&(se.detail=U.detail),se}}}W.to=L})(d=e.TaskDTO||(e.TaskDTO={}));var g;(function(W){function B(L){return L}W.from=B;function K(L){if(!!L)return Object.assign(Object.create(null),L)}W.to=K})(g=e.TaskFilterDTO||(e.TaskFilterDTO={}));class P{constructor(B,K,L){this._id=K,this._task=L,l.set(this,void 0),tt(this,l,B,"f")}get task(){return this._task}terminate(){Ue(this,l,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}l=new WeakMap;var F;(function(W){function B(K){return{id:K._id,task:void 0}}W.from=B})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let z=class{constructor(B,K,L,U,x,Q,$,ee){this._onDidExecuteTask=new A.Emitter,this._onDidTerminateTask=new A.Emitter,this._onDidTaskProcessStarted=new A.Emitter,this._onDidTaskProcessEnded=new A.Emitter,this._proxy=B.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=L,this._editorService=U,this._configurationService=x,this._terminalService=Q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=$,this._deprecationService=ee,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,K,L){if(!L)return new S.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:K,provider:L,extension:B}),this._proxy.$registerTaskProvider(U,K),new S.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(B,K){this._proxy.$registerTaskSystem(B,K)}fetchTasks(B){return this._proxy.$fetchTasks(g.from(B)).then(async K=>{const L=[];for(let U of K){const x=await d.to(U,this._workspaceProvider,this._providedCustomExecutions2);x&&L.push(x)}return L})}get taskExecutions(){const B=[];return this._taskExecutions.forEach(K=>B.push(K)),B}terminateTask(B){if(!(B instanceof P))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,K,L){const U=this._providedCustomExecutions2.get(B.id);if(U){if(this._activeCustomExecutions2.get(B.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(B.id,U),this._terminalService.attachPtyToTerminal(K,await U.callback(L))}this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const K=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const K=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:K,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const K=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:B.exitCode})}$provideTasks(B,K){const L=this._handlers.get(B);if(!L)return Promise.reject(new Error("no handler found"));const U=[],x=(0,k.asPromise)(()=>L.provider.provideTasks(R.CancellationToken.None)).then(Q=>this.provideTasksInternal(K,U,L,Q));return new Promise(Q=>{x.then($=>{Promise.all(U).then(()=>{Q($)})})})}async $resolveTask(B,K){const L=this._handlers.get(B);if(!L)return Promise.reject(new Error("no handler found"));if(K.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${L.type}].`);const U=await d.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const x=await L.provider.resolveTask(U,R.CancellationToken.None);if(!!x){this.checkDeprecation(x,L);const Q=d.from(x,L.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(Q.execution)&&await this.addCustomExecution(Q,x,!0),await this.resolveTaskInternal(Q)}}nextHandle(){return this._handleCounter++}async addCustomExecution(B,K,L){const U=await this._proxy.$createTaskId(B);!L&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,K.execution)}async getTaskExecution(B,K){if(typeof B=="string"){const x=this._taskExecutionPromises.get(B);if(!x)throw new Error("Unexpected: The specified task is missing an execution");return x}let L=this._taskExecutionPromises.get(B.id);if(L)return L;const U=new Promise(async(x,Q)=>{const $=K||await d.to(B.task,this._workspaceProvider,this._providedCustomExecutions2);$?x(new P(this,B.id,$)):Q("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(B.id,U),U.then(x=>(this._taskExecutions.set(B.id,x),x),x=>Promise.reject(x))}checkDeprecation(B,K){B._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));let L=this._notProvidedCustomExecutions.values(),U=L.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=L.next()}};z=je([Ke(0,v.IExtHostRpcService),Ke(1,m.IExtHostInitDataService),Ke(2,I.IExtHostWorkspace),Ke(3,y.IExtHostDocumentsAndEditors),Ke(4,n.IExtHostConfiguration),Ke(5,C.IExtHostTerminalService),Ke(6,h.ILogService),Ke(7,w.IExtHostApiDeprecationService)],z),e.ExtHostTaskBase=z;let de=class extends z{constructor(B,K,L,U,x,Q,$,ee){super(B,K,L,U,x,Q,$,ee);this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(B,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const L=d.from(K,B);if(L===void 0)throw new Error("Task is not valid");if(b.is(L.execution))await this.addCustomExecution(L,K,!1);else throw new c.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(L),K);return this._proxy.$executeTask(L).catch(x=>{throw new Error(x)}),U}provideTasksInternal(B,K,L,U){const x=[];if(U)for(let Q of U){this.checkDeprecation(Q,L),(!Q.definition||!B[Q.definition.type])&&this._logService.warn(`The task [${Q.source}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`);const $=d.from(Q,L.extension);$&&b.is($.execution)?(x.push($),K.push(this.addCustomExecution($,Q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:L.extension}}async resolveTaskInternal(B){if(b.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,K){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(B,K,L){}};de=je([Ke(0,v.IExtHostRpcService),Ke(1,m.IExtHostInitDataService),Ke(2,I.IExtHostWorkspace),Ke(3,y.IExtHostDocumentsAndEditors),Ke(4,n.IExtHostConfiguration),Ke(5,C.IExtHostTerminalService),Ke(6,h.ILogService),Ke(7,w.IExtHostApiDeprecationService)],de),e.WorkerExtHostTask=de,e.IExtHostTask=(0,i.createDecorator)("IExtHostTask")});var cn=this&&this.__rest||function(ie,e){var E={};for(var k in ie)Object.prototype.hasOwnProperty.call(ie,k)&&e.indexOf(k)<0&&(E[k]=ie[k]);if(ie!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,k=Object.getOwnPropertySymbols(ie);A<k.length;A++)e.indexOf(k[A])<0&&Object.prototype.propertyIsEnumerable.call(ie,k[A])&&(E[k[A]]=ie[k[A]]);return E};define(be[216],we([0,1,15,13,20,3,52,6,23,12,2,29,5,39,14,9,7,31,181,95]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m,i,s,p,h,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const c=(D,d)=>`${D}:${d.toString()}`;let l=class{constructor(d,g,P){this.documents=g,this.workspace=P,this.resultsChangedEmitter=new T.Emitter,this.providers=new Map,this.ownedTests=new w.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=d.getProxy(v.MainContext.MainThreadTesting),this.workspaceObservers=new f(this.proxy),this.textDocumentObservers=new b(this.proxy,g)}registerTestProvider(d){const g=(0,C.generateUuid)();this.providers.set(g,d),this.proxy.$registerTestProvider(g);const P=[...this.testSubscriptions.keys()];return setTimeout(()=>{var F;for(const z of P)(F=this.testSubscriptions.get(z))===null||F===void 0||F.subscribeFn(g,d)},0),new p.Disposable(()=>{this.providers.delete(g),this.proxy.$unregisterTestProvider(g)})}createTextDocumentTestObserver(d){return this.textDocumentObservers.checkout(d.uri)}createWorkspaceTestObserver(d){return this.workspaceObservers.checkout(d.uri)}async runTests(d,g=A.CancellationToken.None){const P=F=>F.map(this.getInternalTestForReference,this).filter(n.isDefined).map(z=>({src:z.src,testId:z.item.extId}));await this.proxy.$runTests({exclude:d.exclude?P(d.exclude).map(F=>F.testId):void 0,tests:P(d.tests),debug:d.debug},g)}publishExtensionProvidedResults(d,g){this.proxy.$publishExtensionProvidedResults(s.TestResults.from((0,C.generateUuid)(),d),g)}$publishTestResults(d){this.results=Object.freeze(d.map(g=>(0,y.deepFreeze)(s.TestResults.to(g))).concat(this.results).sort((g,P)=>P.completedAt-g.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(d,g){const P=R.URI.revive(g),F=c(d,P);if(!this.testSubscriptions.has(F)){const z=new A.CancellationTokenSource;let de;if(d===1){let L=this.documents.getDocument(P);if(!L){const U=new I.DisposableStore;L=await new Promise(x=>{U.add((0,k.disposableTimeout)(()=>x(void 0),5e3)),U.add(this.documents.onDidAddDocuments(Q=>{const $=Q.find(ee=>ee.document.uri.toString()===P.toString());$&&x($)}))}).finally(()=>U.dispose())}if(L){const U=await this.workspace.getWorkspaceFolder2(P,!1);de=x=>x.provideDocumentTestRoot?x.provideDocumentTestRoot(L.document,z.token):(0,e.createDefaultDocumentTestRoot)(x,L.document,U,z.token)}}else{const L=await this.workspace.getWorkspaceFolder2(P,!1);L&&(de=U=>U.provideWorkspaceTestRoot(L,z.token))}if(!!de){const W=async(L,U)=>{try{const x=await de(U);x&&K.addRoot(x,L)}catch(x){console.error(x)}},B=new I.DisposableStore,K=B.add(this.ownedTests.createForHierarchy(L=>this.proxy.$publishDiff(d,g,L)));B.add((0,I.toDisposable)(()=>z.dispose(!0)));for(const[L,U]of this.providers)W(L,U);K.pushDiff([3,-1]),this.testSubscriptions.set(F,{store:B,collection:K,subscribeFn:W})}}}async $expandTest(d,g){const P=(0,E.mapFind)(this.testSubscriptions.values(),F=>F.collection.treeId===d.src.tree?F:void 0);await(P==null?void 0:P.collection.expand(d.testId,g<0?Infinity:g)),this.flushCollectionDiffs()}$unsubscribeFromTests(d,g){var P;const F=R.URI.revive(g),z=c(d,F);(P=this.testSubscriptions.get(z))===null||P===void 0||P.store.dispose(),this.testSubscriptions.delete(z)}$acceptDiff(d,g,P){d===1?this.textDocumentObservers.acceptDiff(R.URI.revive(g),P):this.workspaceObservers.acceptDiff(R.URI.revive(g),P)}async $runTestsForProvider(d,g){const P=this.providers.get(d.tests[0].src.provider);if(!!P){const F=d.tests.map(({testId:W,src:B})=>this.ownedTests.getTestById(W,B.tree)).filter(n.isDefined).map(([W,B])=>B),z=d.excludeExtIds.map(W=>this.ownedTests.getTestById(W)).filter(n.isDefined).filter(([W,B])=>F.some(K=>W.comparePositions(K,B)===1));if(!!F.length){const de=W=>{for(const[B,K]of z){const L=B.comparePositions(K,W.id);if(L===1||L===3)return!0}return!1};try{await P.runTests({appendOutput(){},appendMessage:(W,B)=>{de(W)||(this.flushCollectionDiffs(),this.proxy.$appendTestMessageInRun(d.runId,W.id,s.TestMessage.from(B)))},setState:(W,B,K)=>{de(W)||(this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(d.runId,W.id,B,K))},tests:F.map(W=>r.unwrap(W.actual)),exclude:z.map(([,W])=>r.unwrap(W.actual)),debug:d.debug},g);for(const{collection:W}of this.testSubscriptions.values())W.flushDiff();return}catch(W){throw console.error(W),W}}}}$lookupTest(d){const g=this.ownedTests.getTestById(d.testId);if(!g)return Promise.resolve(void 0);const P=g[1],{actual:F,discoverCts:z,expandLevels:de}=P,W=cn(P,["actual","discoverCts","expandLevels"]);return Promise.resolve(W)}flushCollectionDiffs(){for(const{collection:d}of this.testSubscriptions.values())d.flushDiff()}getInternalTestForReference(d){var g,P;return(P=(g=this.workspaceObservers.getMirroredTestDataByReference(d))!==null&&g!==void 0?g:(0,E.mapFind)(this.testSubscriptions.values(),F=>F.collection.getTestByReference(d)))!==null&&P!==void 0?P:this.textDocumentObservers.getMirroredTestDataByReference(d)}};l=je([Ke(0,i.IExtHostRpcService),Ke(1,m.IExtHostDocumentsAndEditors),Ke(2,h.IExtHostWorkspace)],l),e.ExtHostTesting=l;const t=async(D,d,g,P)=>{if(!!g){const F=await D.provideWorkspaceTestRoot(g,P);if(!!F)return P.onCancellationRequested(()=>{r.removeFilter(d)}),r.getWrapperForTestItem(F,d)}};e.createDefaultDocumentTestRoot=t;class r extends p.TestItem{constructor(d,g,P){super(d.id,d.label,d.uri,d.expandable);if(this.actual=d,this.filterDocument=g,this.parent=P,!(d instanceof p.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${d.id} did not`);d[p.TestItemHookProperty]={setProp:(F,z)=>this[F]=z,created:F=>r.getWrapperForTestItem(F,this.filterDocument,this).refreshMatch(),invalidate:()=>this.invalidate(),delete:F=>this.children.delete(F)}}static removeFilter(d){this.wrapperMap.delete(d)}static getWrapperForTestItem(d,g,P){let F=this.wrapperMap.get(g);if(F==null?void 0:F.has(d))return F.get(d);F||(F=new WeakMap,this.wrapperMap.set(g,F));const z=new r(d,g,P);return F.set(d,z),z}static unwrap(d){return d instanceof r?d.actual:d}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var d;const g=this._cachedMatchesFilter;for(const F of this.actual.children){const z=r.getWrapperForTestItem(F,this.filterDocument,this);z.hasNodeMatchingFilter?this.children.add(z):this.children.delete(z)}const P=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=P,P!==g&&((d=this.parent)===null||d===void 0||d.refreshMatch()),this._cachedMatchesFilter}}e.TestItemFilteredWrapper=r,r.wrapperMap=new WeakMap;class u extends _.IncrementalChangeCollector{constructor(d){super();this.emitter=d,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(d){this.added.add(d)}update(d){Object.assign(d.revived,s.TestItem.toPlain(d.item)),this.added.has(d)||this.updated.add(d)}remove(d){if(this.added.has(d)){this.added.delete(d);return}if(this.updated.delete(d),d.parent&&this.alreadyRemoved.has(d.parent)){this.alreadyRemoved.add(d.item.extId);return}this.removed.add(d)}getChangeEvent(){const{added:d,updated:g,removed:P}=this;return{get added(){return[...d].map(F=>F.revived)},get updated(){return[...g].map(F=>F.revived)},get removed(){return[...P].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class o extends _.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(d){let g=[];for(const P of d){const F=this.items.get(P);F&&g.push(F.revived)}return g}getMirroredTestDataById(d){return this.items.get(d)}getMirroredTestDataByReference(d){return this.items.get(d.id)}createItem(d,g){return Object.assign(Object.assign({},d),{revived:s.TestItem.toPlain(d.item),depth:g?g.depth+1:0,children:new Set})}createChangeCollector(){return new u(this.changeEmitter)}}e.MirroredTestCollection=o;class a{constructor(){this.resources=new Map}checkout(d){var g,P;const F=d.toString(),z=(g=this.resources.get(F))!==null&&g!==void 0?g:this.createObserverData(d);return(P=z.pendingDeletion)===null||P===void 0||P.dispose(),z.observers++,{onDidChangeTest:z.tests.onDidChangeTests,onDidDiscoverInitialTests:new T.Emitter().event,get tests(){return z.tests.rootTestItems},dispose:(0,S.once)(()=>{--z.observers||(z.pendingDeletion=this.eventuallyDispose(d))})}}getMirroredTestDataByReference(d){for(const{tests:g}of this.resources.values()){const P=g.getMirroredTestDataByReference(d);if(P)return P}}eventuallyDispose(d){return(0,k.disposableTimeout)(()=>this.unlisten(d),10*1e3)}createObserverData(d){const g=new o,P=this.listen(d,z=>g.apply(z)),F={observers:0,tests:g,listener:P};return this.resources.set(d.toString(),F),F}unlisten(d){var g;const P=d.toString(),F=this.resources.get(P);F&&(F.observers=-1,(g=F.pendingDeletion)===null||g===void 0||g.dispose(),F.listener.dispose(),this.resources.delete(P))}}class f extends a{constructor(d){super();this.proxy=d,this.diffListeners=new Map}acceptDiff(d,g){var P;(P=this.diffListeners.get(d.toString()))===null||P===void 0||P(g)}listen(d,g){this.proxy.$subscribeToDiffs(0,d);const P=d.toString();return this.diffListeners.set(P,g),new p.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,d),this.diffListeners.delete(P)})}}class b extends a{constructor(d,g){super();this.proxy=d,this.documents=g,this.diffListeners=new Map}acceptDiff(d,g){var P;(P=this.diffListeners.get(d.toString()))===null||P===void 0||P(g)}listen(d,g){if(!this.documents.getDocument(d))return new p.Disposable(()=>{});const F=d.toString();return this.diffListeners.set(F,g),this.proxy.$subscribeToDiffs(1,d),new p.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,d),this.diffListeners.delete(F)})}}}),define(be[217],we([0,1,15,50,28,58,22,18,11,25,8,12,2,114,139,89,47,173,215,41]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m,i,s,p,h,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let c=class{constructor(D,d,g,P){this.configurationService=D,this.workspaceContextService=d,this.editorGroupsService=g,this.pathService=P}text(D,d,g={}){D=this.getContentPattern(D,g);const P=this.configurationService.getValue(),F=d&&d.some(de=>!this.configurationService.getValue({resource:de}).search.useRipgrep),z=this.commonQuery(d==null?void 0:d.map(p.toWorkspaceFolder),g);return Object.assign(Object.assign({},z),{type:2,contentPattern:D,previewOptions:g.previewOptions,maxFileSize:g.maxFileSize,usePCRE2:P.search.usePCRE2||F||!1,beforeContext:g.beforeContext,afterContext:g.afterContext,userDisabledExcludesAndIgnoreFiles:g.disregardExcludeSettings&&g.disregardIgnoreFiles})}getContentPattern(D,d){const g=this.configurationService.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const P=Object.assign(Object.assign({},D),{wordSeparators:g.editor.wordSeparators});return this.isCaseSensitive(D,d)&&(P.isCaseSensitive=!0),this.isMultiline(D)&&(P.isMultiline=!0),P}file(D,d={}){const g=this.commonQuery(D,d);return Object.assign(Object.assign({},g),{type:1,filePattern:d.filePattern?d.filePattern.trim():d.filePattern,exists:d.exists,sortByScore:d.sortByScore,cacheKey:d.cacheKey})}handleIncludeExclude(D,d){return D?(D=Array.isArray(D)?D.map(o):o(D),d?this.parseSearchPaths(D):{pattern:t(...Array.isArray(D)?D:[D])}):{}}commonQuery(D=[],d={}){const g=this.handleIncludeExclude(d.includePattern,d.expandPatterns),P=this.handleIncludeExclude(d.excludePattern,d.expandPatterns),F=D.length>1,z=(g.searchPaths&&g.searchPaths.length?g.searchPaths.map(B=>this.getFolderQueryForSearchPath(B,d,P)):D.map(B=>this.getFolderQueryForRoot(B,d,P,F))).filter(B=>!!B),de={_reason:d._reason,folderQueries:z,usingSearchPaths:!!(g.searchPaths&&g.searchPaths.length),extraFileResources:d.extraFileResources,excludePattern:P.pattern,includePattern:g.pattern,onlyOpenEditors:d.onlyOpenEditors,maxResults:d.maxResults};if(d.onlyOpenEditors){const K=E.coalesce(E.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(x=>x.resource)))).filter(U=>(0,_.pathIncludedInQuery)(de,U.fsPath)),L=this.commonQueryFromFileList(K);return Object.assign(Object.assign({},de),L)}const W=d.extraFileResources&&d.extraFileResources.filter(B=>(0,_.pathIncludedInQuery)(de,B.fsPath));return de.extraFileResources=W&&W.length?W:void 0,de}commonQueryFromFileList(D){const d=[],g=new S.ResourceMap,P={};let F=!1;return D.forEach(z=>{var de,W;if(z.scheme!==I.Schemas.walkThrough)if((0,n.isAbsolutePath)(z)){const K=(W=(de=this.workspaceContextService.getWorkspaceFolder(z))===null||de===void 0?void 0:de.uri)!==null&&W!==void 0?W:z.with({path:y.dirname(z.fsPath)});let L=g.get(K);L||(F=!0,L={folder:K,includePattern:{}},d.push(L),g.set(K,L));const U=y.relative(K.fsPath,z.fsPath);(0,C.assertIsDefined)(L.includePattern)[U.replace(/\\/g,"/")]=!0}else z.fsPath&&(F=!0,P[z.fsPath]=!0)}),{folderQueries:d,includePattern:P,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(D,d){if(d.isSmartCase){if(D.isRegExp){if(R.containsUppercaseCharacter(D.pattern,!0))return!0}else if(R.containsUppercaseCharacter(D.pattern))return!0}return!!D.isCaseSensitive}isMultiline(D){return D.isMultiline||D.isRegExp&&(0,m.isMultilineRegexSource)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const d=L=>y.isAbsolute(L)||/^\.\.?([\/\\]|$)/.test(L),P=(Array.isArray(D)?D:r(D)).map(L=>{const U=this.pathService.resolvedUserHome;return U?(0,T.untildify)(L,U.scheme===I.Schemas.file?U.fsPath:U.path):L}),F=k.groupBy(P,L=>d(L)?"searchPaths":"exprSegments"),z=(F.exprSegments||[]).map(L=>R.rtrim(L,"/")).map(L=>R.rtrim(L,"\\")).map(L=>(L[0]==="."&&(L="*"+L),u(L))),de={},W=this.expandSearchPathPatterns(F.searchPaths||[]);W&&W.length&&(de.searchPaths=W);const B=E.flatten(z),K=t(...B);return K&&(de.pattern=K),de}getExcludesForFolder(D,d){return d.disregardExcludeSettings?void 0:(0,_.getExcludes)(D,!d.disregardSearchExcludeSettings)}expandSearchPathPatterns(D){if(!D||!D.length)return[];const d=E.flatten(D.map(P=>{let{pathPortion:F,globPortion:z}=l(P);z&&(z=a(z));const de=this.expandOneSearchPath(F);return E.flatten(de.map(W=>this.resolveOneSearchPathPattern(W,z)))})),g=new Map;return d.forEach(P=>{const F=P.searchPath.toString(),z=g.get(F);z?P.pattern&&(z.pattern=z.pattern||{},z.pattern[P.pattern]=!0):g.set(F,{searchPath:P.searchPath,pattern:P.pattern?t(P.pattern):void 0})}),Array.from(g.values())}expandOneSearchPath(D){if(y.isAbsolute(D)){const d=this.workspaceContextService.getWorkspace().folders;return d[0]&&d[0].uri.scheme!==I.Schemas.file?[{searchPath:d[0].uri.with({path:D})}]:[{searchPath:v.URI.file(y.normalize(D))}]}if(this.workspaceContextService.getWorkbenchState()===2){const d=this.workspaceContextService.getWorkspace().folders[0].uri;if(D=o(D),D.startsWith("../")||D===".."){const P=y.posix.resolve(d.path,D);return[{searchPath:d.with({path:P})}]}const g=a(D);return[{searchPath:d,pattern:g}]}else{if(D==="./"||D===".\\")return[];{const d=D.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(d){const g=d[1],P=this.workspaceContextService.getWorkspace().folders.filter(F=>F.name===g);if(P.length)return P.map(F=>{const z=d[2];return{searchPath:F.uri,pattern:z&&a(z)}});{const F=i.localize(0,null,g);throw new Error(F)}}}}return[]}resolveOneSearchPathPattern(D,d){const g=D.pattern&&d?`${D.pattern}/${d}`:D.pattern||d,P=[{searchPath:D.searchPath,pattern:g}];return g&&!g.endsWith("**")&&P.push({searchPath:D.searchPath,pattern:g+"/**"}),P}getFolderQueryForSearchPath(D,d,g){const P=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(D.searchPath),d,g,!1);return P?Object.assign(Object.assign({},P),{includePattern:D.pattern}):null}getFolderQueryForRoot(D,d,g,P){let F;const z=v.URI.isUri(D)?D:D.uri;if(g.searchPaths){const L=g.searchPaths.filter(U=>(0,n.isEqual)(U.searchPath,z))[0];if(L&&!L.pattern)return null;L&&(F=L.pattern)}const de=this.configurationService.getValue({resource:z}),W=this.getExcludesForFolder(de,d),B=Object.assign(Object.assign({},W||{}),F||{}),K=v.URI.isUri(D)?(0,n.basename)(D):D.name;return{folder:z,folderName:P?K:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:de.files&&de.files.encoding,disregardIgnoreFiles:typeof d.disregardIgnoreFiles=="boolean"?d.disregardIgnoreFiles:!de.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof d.disregardGlobalIgnoreFiles=="boolean"?d.disregardGlobalIgnoreFiles:!de.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof d.ignoreSymlinks=="boolean"?d.ignoreSymlinks:!de.search.followSymlinks}}};c=je([Ke(0,s.IConfigurationService),Ke(1,p.IWorkspaceContextService),Ke(2,h.IEditorGroupsService),Ke(3,w.IPathService)],c),e.QueryBuilder=c;function l(b){const D=b.match(/[\*\{\}\(\)\[\]\?]/);if(D){const d=D.index,g=b.substr(0,d).match(/[/|\\][^/\\]*$/);if(g){let P=b.substr(0,g.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:b.substr((g.index||0)+1)}}}return{pathPortion:b}}function t(...b){return b.length?b.reduce((D,d)=>(D[d]=!0,D),Object.create(null)):void 0}function r(b){return A.splitGlobAware(b,",").map(D=>D.trim()).filter(D=>!!D.length)}function u(b){return[`**/${b}/**`,`**/${b}`].map(d=>d.replace(/\*\*\/\*\*/g,"**"))}function o(b){return b.replace(/\\/g,"/")}function a(b){return o(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(b,D){b=E.distinct(b,P=>P.toString());const d=[],g=D.getWorkspace();return b&&b.forEach(P=>{let F;if(D.getWorkbenchState()===2)F=(0,n.relativePath)(g.folders[0].uri,P),F&&F!=="."&&(F="./"+F);else{const z=D.getWorkspaceFolder(P);if(z){const de=z.name;if(g.folders.filter(B=>B.name===de).length===1){const B=(0,n.relativePath)(z.uri,P);B===""?F=`./${z.name}`:F=`./${z.name}/${B}`}else F=P.fsPath}}F&&d.push(F)}),d}e.resolveResourcesForSearchIncludes=f}),define(be[218],we([0,1,25,2,20,10,4,217,41,47]),function(ie,e,E,k,A,T,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function C(s,p){const h=p.activationEvents;if(!h)return Promise.resolve(void 0);const w=[],_=[];for(const o of h)if(/^workspaceContains:/.test(o)){const a=o.substr("workspaceContains:".length);a.indexOf("*")>=0||a.indexOf("?")>=0||s.forceUsingSearch?_.push(a):w.push(a)}if(w.length===0&&_.length===0)return Promise.resolve(void 0);let c;const l=new Promise((o,a)=>{c=o}),t=o=>c({activationEvent:o}),r=Promise.all(w.map(o=>v(s,o,t))).then(()=>{}),u=m(s,p.identifier,_,t);return Promise.all([r,u]).then(()=>{c(void 0)}),l}e.checkActivateWorkspaceContainsExtension=C;async function v(s,p,h){for(const w of s.folders)if(await s.exists(E.joinPath(k.URI.revive(w),p))){h(`workspaceContains:${p}`);return}}async function m(s,p,h,w){if(h.length===0)return Promise.resolve(void 0);const _=new A.CancellationTokenSource,c=s.checkExists(s.folders,h,_.token),l=setTimeout(async()=>{_.cancel(),w(`workspaceContainsTimeout:${h.join(",")}`)},R);let t=!1;try{t=await c}catch(r){T.isPromiseCanceledError(r)||T.onUnexpectedError(r)}_.dispose(),clearTimeout(l),t&&w(`workspaceContains:${h.join(",")}`)}function i(s,p,h,w){const _=s.get(S.IInstantiationService),c=s.get(y.ISearchService),t=_.createInstance(I.QueryBuilder).file(p.map(r=>(0,n.toWorkspaceFolder)(k.URI.revive(r))),{_reason:"checkExists",includePattern:h,exists:!0});return c.fileSearch(t,w).then(r=>!!r.limitHit,r=>T.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=i});var tt=this&&this.__classPrivateFieldSet||function(ie,e,E,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(ie,E):A?A.value=E:e.set(ie,E),E},Ue=this&&this.__classPrivateFieldGet||function(ie,e,E,k){if(E==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?k:E==="a"?k.call(ie):k?k.value:e.get(ie)};define(be[35],we([0,1,131,11,77,25,13,6,22,2,19,5,34,184,75,31,33,182,10,26,18,24,160,7,90,4,27,76,14,65,67,40,3,218,71,161]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m,i,s,p,h,w,_,c,l,t,r,u,o,a,f,b,D,d,g,P,F,z,de){"use strict";var W,B,K;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let L=class Pn extends I.Disposable{constructor($,ee,re,se,ye,Ie,xe,Fe,ze,N){super();this._onDidChangeRemoteConnectionData=this._register(new P.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ee,this._extHostContext=re,this._initData=xe,this._extHostWorkspace=se,this._extHostConfiguration=ye,this._logService=Ie,this._extHostTunnelService=ze,this._extHostTerminalService=N,this._disposables=new I.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new S.Barrier,this._readyToStartExtensionHost=new S.Barrier,this._readyToRunExtensions=new S.Barrier,this._eagerExtensionsActivated=new S.Barrier,this._registry=new h.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new i.ExtHostStorage(this._extHostContext),this._secretState=new z.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=$.createChild(new D.ServiceCollection([i.IExtHostStorage,this._storage],[z.IExtHostSecretState,this._secretState]));const G=new Set;this._initData.hostExtensions.forEach(te=>G.add(_.ExtensionIdentifier.toKey(te))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(te,ae)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(te,ae)},actualActivateExtension:async(te,ae)=>{if(G.has(_.ExtensionIdentifier.toKey(te)))return await this._mainThreadExtensionsProxy.$activateExtension(te,ae),new m.HostExtension;const me=this._registry.getExtensionDescription(te);return this._activateExtension(me,ae)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),A.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch($){w.onUnexpectedError($)}}async deactivateAll(){let $=[];try{$=this._registry.getAllExtensionDescriptions().map(ye=>ye.identifier).filter(ye=>this.isActivated(ye)).map(ye=>this._deactivate(ye))}catch(ee){}await Promise.all($)}isActivated($){return this._readyToRunExtensions.isOpen()?this._activator.isActivated($):!1}_activateByEvent($,ee){return this._activator.activateByEvent($,ee)}_activateById($,ee){return this._activator.activateById($,ee)}activateByIdWithErrors($,ee){return this._activateById($,ee).then(()=>{const re=this._activator.getActivatedExtension($);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then($=>this._registry)}getExtensionExports($){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension($).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const $=y.TernarySearchTree.forPaths(),ee=this._registry.getAllExtensionDescriptions().map(re=>{if(!!this._getEntryPoint(re))return this._hostUtils.realpath(re.extensionLocation.fsPath).then(se=>$.set(n.URI.file(se).fsPath,re))});this._extensionPathIndex=Promise.all(ee).then(()=>$)}return this._extensionPathIndex}_deactivate($){let ee=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated($))return ee;const re=this._activator.getActivatedExtension($);if(!re)return ee;try{typeof re.module.deactivate=="function"&&(ee=Promise.resolve(re.module.deactivate()).then(void 0,se=>Promise.resolve(void 0)))}catch(se){}try{(0,I.dispose)(re.subscriptions)}catch(se){}return ee}async _activateExtension($,ee){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension($.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension($.identifier),this._doActivateExtension($,ee).then(re=>{const se=re.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension($.identifier,se.codeLoadingTime,se.activateCallTime,se.activateResolvedTime,ee),this._logExtensionActivationTimes($,ee,"success",se),re},re=>{throw this._logExtensionActivationTimes($,ee,"failure"),re})}_logExtensionActivationTimes($,ee,re,se){const ye=U($,ee);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},ye),se||{}),{outcome:re}))}_doActivateExtension($,ee){const re=U($,ee);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",re);const se=this._getEntryPoint($);if(!se)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${$.identifier.value} ${JSON.stringify(ee)}`),this._logService.flush();const ye=new m.ExtensionActivationTimesBuilder(ee.startup);return Promise.all([this._loadCommonJSModule($.identifier,(0,T.joinPath)($.extensionLocation,se),ye),this._loadExtensionContext($)]).then(Ie=>(A.mark(`code/extHost/willActivateExtension/${$.identifier.value}`),Pn._callActivate(this._logService,$.identifier,Ie[0],Ie[1],ye))).then(Ie=>(A.mark(`code/extHost/didActivateExtension/${$.identifier.value}`),Ie))}_loadExtensionContext($){const ee=new t.ExtensionGlobalMemento($,this._storage),re=new t.ExtensionMemento($.identifier.value,!1,this._storage),se=new de.ExtensionSecrets($,this._secretState),ye=$.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Ie=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${$.identifier.value}`),Promise.all([ee.whenReady,re.whenReady,this._storagePath.whenReady]).then(()=>{const xe=this;let Fe;return Object.freeze({globalState:ee,workspaceState:re,secrets:se,subscriptions:[],get extensionUri(){return $.extensionLocation},get extensionPath(){return $.extensionLocation.fsPath},asAbsolutePath(ze){return k.join($.extensionLocation.fsPath,ze)},get storagePath(){var ze;return(ze=xe._storagePath.workspaceValue($))===null||ze===void 0?void 0:ze.fsPath},get globalStoragePath(){return xe._storagePath.globalValue($).fsPath},get logPath(){return k.join(xe._initData.logsLocation.fsPath,$.identifier.value)},get logUri(){return n.URI.joinPath(xe._initData.logsLocation,$.identifier.value)},get storageUri(){return xe._storagePath.workspaceValue($)},get globalStorageUri(){return xe._storagePath.globalValue($)},get extensionMode(){return ye},get extension(){return Fe===void 0&&(Fe=new x(xe,$.identifier,$,Ie)),Fe},get extensionRuntime(){return(0,p.checkProposedApiEnabled)($),xe.extensionRuntime},get environmentVariableCollection(){return xe._extHostTerminalService.getEnvironmentVariableCollection($)}})})}static _callActivate($,ee,re,se,ye){return re=re||{activate:void 0,deactivate:void 0},this._callActivateOptional($,ee,re,se,ye).then(Ie=>new m.ActivatedExtension(!1,null,ye.build(),re,Ie,se.subscriptions))}static _callActivateOptional($,ee,re,se,ye){if(typeof re.activate=="function")try{ye.activateCallStart(),$.trace(`ExtensionService#_callActivateOptional ${ee.value}`);const Ie=typeof global=="object"?global:self,xe=re.activate.apply(Ie,[se]);return ye.activateCallStop(),ye.activateResolveStart(),Promise.resolve(xe).then(Fe=>(ye.activateResolveStop(),Fe))}catch(Ie){return Promise.reject(Ie)}else return Promise.resolve(re)}_activateOneStartupFinished($,ee){this._activateById($.identifier,{startup:!1,extensionId:$.identifier,activationEvent:ee}).then(void 0,re=>{this._logService.error(re)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(A.getMarks());for(const $ of this._registry.getAllExtensionDescriptions())if($.activationEvents)for(const ee of $.activationEvents)ee==="onStartupFinished"&&this._activateOneStartupFinished($,ee)}_handleEagerExtensions(){const $=this._activateByEvent("*",!0).then(void 0,ye=>{this._logService.error(ye)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ye=>this._handleWorkspaceContainsEagerExtensions(ye.added)));const ee=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],re=this._handleWorkspaceContainsEagerExtensions(ee),se=Promise.all([$,re]).then(()=>{});return Promise.race([se,(0,S.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),se}_handleWorkspaceContainsEagerExtensions($){return $.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ee=>this._handleWorkspaceContainsEagerExtension($,ee))).then(()=>{})}async _handleWorkspaceContainsEagerExtension($,ee){if(!this.isActivated(ee.identifier)){const re=!this._initData.remote.isRemote&&!!this._initData.remote.authority,se={folders:$.map(Ie=>Ie.uri),forceUsingSearch:re,exists:Ie=>this._hostUtils.exists(Ie.fsPath),checkExists:(Ie,xe,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(Ie,xe,Fe)},ye=await(0,F.checkActivateWorkspaceContainsExtension)(se,ee);if(!!ye)return this._activateById(ee.identifier,{startup:!0,extensionId:ee.identifier,activationEvent:ye.activationEvent}).then(void 0,Ie=>this._logService.error(Ie))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch($){throw console.error($),$}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:$,extensionTestsLocationURI:ee}=this._initData.environment;if(!$||!ee||ee.scheme!==c.Schemas.file)throw new Error(E.localize(0,null));const re=(0,T.originalFSPath)(ee),se=await this._loadCommonJSModule(null,ee,new m.ExtensionActivationTimesBuilder(!1));if(!se||typeof se.run!="function")throw new Error(E.localize(1,null,re));return new Promise((ye,Ie)=>{const xe=(ze,N)=>{ze?Ie(ze):ye(typeof N=="number"&&N>0?1:0)},Fe=se.run(re,xe);Fe&&Fe.then&&Fe.then(()=>{ye(0)}).catch(ze=>{Ie(ze.toString())})})}async $extensionTestsExit($){this._logService.info(`extension host terminating: test runner requested exit with code ${$}`),this._logService.info(`exiting with code ${$}`),this._logService.flush(),this._hostUtils.exit($)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver($,ee){return this._resolvers[$]=ee,(0,I.toDisposable)(()=>{delete this._resolvers[$]})}async $resolveAuthority($,ee){const re=$.indexOf("+");if(re===-1)throw new Error("Not an authority that can be resolved!");const se=$.substr(0,re);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${se}`,!1);const ye=this._resolvers[se];if(!ye)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${se}.`,detail:void 0}};try{A.mark(`code/extHost/willResolveAuthority/${se}`);const Ie=await ye.resolve($,{resolveAttempt:ee});A.mark(`code/extHost/didResolveAuthorityOK/${se}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(ye));const xe={authority:$,host:Ie.host,port:Ie.port,connectionToken:Ie.connectionToken},Fe={extensionHostEnv:Ie.extensionHostEnv};return{type:"ok",value:{authority:xe,options:Fe,tunnelInformation:{environmentTunnels:Ie.environmentTunnels}}}}catch(Ie){if(A.mark(`code/extHost/didResolveAuthorityError/${se}`),Ie instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:Ie._code,message:Ie._message,detail:Ie._detail}};throw Ie}}$startExtensionHost($){return this._registry.keepOnly($),this._startExtensionHost()}$activateByEvent($,ee){return ee===1?this._activateByEvent($,!1):this._readyToRunExtensions.wait().then(re=>this._activateByEvent($,!1))}async $activate($,ee){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription($)?(await this._activateById($,ee),!0):!1}async $deltaExtensions($,ee){$.forEach(se=>se.extensionLocation=n.URI.revive(se.extensionLocation));const re=await this.getExtensionPathIndex();return await Promise.all(ee.map(async se=>{const ye=this._registry.getExtensionDescription(se);if(!!ye){const Ie=await this._hostUtils.realpath(ye.extensionLocation.fsPath);re.delete(n.URI.file(Ie).fsPath)}})),await Promise.all($.map(async se=>{const ye=await this._hostUtils.realpath(se.extensionLocation.fsPath);re.set(n.URI.file(ye).fsPath,se)})),this._registry.deltaExtensions($,ee),Promise.resolve(void 0)}async $test_latency($){return $}async $test_up($){return $.byteLength}async $test_down($){let ee=l.VSBuffer.alloc($),re=Math.random()%256;for(let se=0;se<$;se++)ee.writeUInt8(re,se);return ee}async $updateRemoteConnectionData($){this._remoteConnectionData=$,this._onDidChangeRemoteConnectionData.fire()}};L=je([Ke(0,o.IInstantiationService),Ke(1,e.IHostUtils),Ke(2,b.IExtHostRpcService),Ke(3,s.IExtHostWorkspace),Ke(4,v.IExtHostConfiguration),Ke(5,R.ILogService),Ke(6,a.IExtHostInitDataService),Ke(7,f.IExtensionStoragePaths),Ke(8,d.IExtHostTunnelService),Ke(9,g.IExtHostTerminalService)],L),e.AbstractExtHostExtensionService=L;function U(Q,$){return{id:Q.identifier.value,name:Q.name,extensionVersion:Q.version,publisherDisplayName:Q.publisher,activationEvents:Q.activationEvents?Q.activationEvents.join(","):null,isBuiltin:Q.isBuiltin,reason:$.activationEvent,reasonId:$.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class x{constructor($,ee,re,se){W.set(this,void 0),B.set(this,void 0),K.set(this,void 0),tt(this,W,$,"f"),tt(this,B,ee,"f"),tt(this,K,re.identifier,"f"),this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=k.normalize((0,T.originalFSPath)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=se}get isActive(){return Ue(this,W,"f").isActivated(Ue(this,K,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,W,"f").getExtensionExports(Ue(this,K,"f"))}activate(){return Ue(this,W,"f").activateByIdWithErrors(Ue(this,K,"f"),{startup:!1,extensionId:Ue(this,B,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=x,W=new WeakMap,B=new WeakMap,K=new WeakMap}),define(be[102],we([0,1,11,2,3,13,5,7,168,31,35,39,172,34,169,14,4,12,45]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m,i,s,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let _=class{constructor(f,b,D,d,g){this._workspaceService=b,this._extensionService=D,this._editorsService=d,this._configurationService=g,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new A.Emitter,this._onDidTerminateDebugSession=new A.Emitter,this._onDidChangeActiveDebugSession=new A.Emitter,this._onDidReceiveDebugSessionCustomEvent=new A.Emitter,this._debugServiceProxy=f.getProxy(S.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new A.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new l(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(P=>{P.onDidChange(F=>{this.registerAllDebugTypes(P)}),this.registerAllDebugTypes(P)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(f,b){const D=f;if(typeof D.sourceReference=="number"&&D.sourceReference>0){let d=`debug:${encodeURIComponent(D.path||"")}`,g="?";return b&&(d+=`${g}session=${encodeURIComponent(b.id)}`,g="&"),d+=`${g}ref=${D.sourceReference}`,k.URI.parse(d)}else{if(D.path)return k.URI.file(D.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(f){const b=[];for(const D of f.getAllExtensionDescriptions())if(D.contributes){const d=D.contributes.debuggers;if(d&&d.length>0)for(const g of d)(0,i.isDebuggerMainContribution)(g)&&b.push(g.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const f=[];return this._breakpoints.forEach(b=>f.push(b)),f}addBreakpoints(f){this.startBreakpoints();const b=f.filter(g=>{const P=g.id;return this._breakpoints.has(P)?!1:(this._breakpoints.set(P,g),!0)});this.fireBreakpointChanges(b,[],[]);const D=[],d=new Map;for(const g of b)if(g instanceof I.SourceBreakpoint){let P=d.get(g.location.uri.toString());P||(P={type:"sourceMulti",uri:g.location.uri,lines:[]},d.set(g.location.uri.toString(),P),D.push(P)),P.lines.push({id:g.id,enabled:g.enabled,condition:g.condition,hitCondition:g.hitCondition,logMessage:g.logMessage,line:g.location.range.start.line,character:g.location.range.start.character})}else g instanceof I.FunctionBreakpoint&&D.push({type:"function",id:g.id,enabled:g.enabled,hitCondition:g.hitCondition,logMessage:g.logMessage,condition:g.condition,functionName:g.functionName});return this._debugServiceProxy.$registerBreakpoints(D)}removeBreakpoints(f){this.startBreakpoints();const b=f.filter(P=>this._breakpoints.delete(P.id));this.fireBreakpointChanges([],b,[]);const D=b.filter(P=>P instanceof I.SourceBreakpoint).map(P=>P.id),d=b.filter(P=>P instanceof I.FunctionBreakpoint).map(P=>P.id),g=b.filter(P=>P instanceof I.DataBreakpoint).map(P=>P.id);return this._debugServiceProxy.$unregisterBreakpoints(D,d,g)}startDebugging(f,b,D){return this._debugServiceProxy.$startDebugging(f?f.uri:void 0,b,{parentSessionID:D.parentSession?D.parentSession.id:void 0,repl:D.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:D.noDebug,compact:D.compact})}stopDebugging(f){return this._debugServiceProxy.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,b,D){if(!b)return new I.Disposable(()=>{});const d=this._configProviderHandleCounter++;return this._configProviders.push({type:f,handle:d,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(f,D,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,d),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(g=>g.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(d)})}registerDebugAdapterDescriptorFactory(f,b,D){if(!D)return new I.Disposable(()=>{});if(!this.definesDebugType(f,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const d=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:d,factory:D}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,d),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(g=>g.factory!==D),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(d)})}registerDebugAdapterTrackerFactory(f,b){if(!b)return new I.Disposable(()=>{});const D=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:f,handle:D,factory:b}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(d=>d.factory!==b)})}async $runInTerminal(f,b){return Promise.resolve(void 0)}async $substituteVariables(f,b){if(!this._variableResolver){const[g,P]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(g||[],this._editorsService,P)}let D;const d=await this.getFolder(f);return d&&(D={uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(D,b)}createDebugAdapter(f,b){if(f.type==="implementation")return new u(f.implementation)}createSignService(){}async $startDASession(f,b){const D=this,d=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(d.type),d).then(g=>{if(!g)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}' (extension might have failed to activate)`);const P=this.convertToDto(g),F=this.createDebugAdapter(P,d);if(!F)throw new Error(`Couldn't create a debug adapter for type '${d.type}'.`);const z=F;return this._debugAdapters.set(f,z),this.getDebugAdapterTrackers(d).then(de=>(de&&this._debugAdaptersTrackers.set(f,de),z.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const B=W,K={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(B.arguments.value);K.body={signature:L},z.sendResponse(K)}else throw new Error("no signer")}catch(L){K.success=!1,K.message=L.message,z.sendResponse(K)}}else de&&de.onDidSendMessage&&de.onDidSendMessage(W),W=(0,i.convertToVSCPaths)(W,!0),D._debugServiceProxy.$acceptDAMessage(f,W)}),z.onError(W=>{de&&de.onError&&de.onError(W),this._debugServiceProxy.$acceptDAError(f,W.name,W.message,W.stack)}),z.onExit(W=>{de&&de.onExit&&de.onExit((0,h.withNullAsUndefined)(W),void 0),this._debugServiceProxy.$acceptDAExit(f,(0,h.withNullAsUndefined)(W),void 0)}),de&&de.onWillStartSession&&de.onWillStartSession(),z.startSession()))})}$sendDAMessage(f,b){b=(0,i.convertToDAPaths)(b,!1);const D=this._debugAdaptersTrackers.get(f);D&&D.onWillReceiveMessage&&D.onWillReceiveMessage(b);const d=this._debugAdapters.get(f);d&&d.sendMessage(b)}$stopDASession(f){const b=this._debugAdaptersTrackers.get(f);this._debugAdaptersTrackers.delete(f),b&&b.onWillStopSession&&b.onWillStopSession();const D=this._debugAdapters.get(f);return this._debugAdapters.delete(f),D?D.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const b=[],D=[],d=[];if(f.added)for(const g of f.added){const P=g.id;if(P&&!this._breakpoints.has(P)){let F;if(g.type==="function")F=new I.FunctionBreakpoint(g.functionName,g.enabled,g.condition,g.hitCondition,g.logMessage);else if(g.type==="data")F=new I.DataBreakpoint(g.label,g.dataId,g.canPersist,g.enabled,g.hitCondition,g.condition,g.logMessage);else{const z=k.URI.revive(g.uri);F=new I.SourceBreakpoint(new I.Location(z,new I.Position(g.line,g.character)),g.enabled,g.condition,g.hitCondition,g.logMessage)}F._id=P,this._breakpoints.set(P,F),b.push(F)}}if(f.removed)for(const g of f.removed){const P=this._breakpoints.get(g);P&&(this._breakpoints.delete(g),D.push(P))}if(f.changed){for(const g of f.changed)if(g.id){const P=this._breakpoints.get(g.id);if(P){if(P instanceof I.FunctionBreakpoint&&g.type==="function"){const F=P;F.enabled=g.enabled,F.condition=g.condition,F.hitCondition=g.hitCondition,F.logMessage=g.logMessage,F.functionName=g.functionName}else if(P instanceof I.SourceBreakpoint&&g.type==="source"){const F=P;F.enabled=g.enabled,F.condition=g.condition,F.hitCondition=g.hitCondition,F.logMessage=g.logMessage,F.location=new I.Location(k.URI.revive(g.uri),new I.Position(g.line,g.character))}d.push(P)}}}this.fireBreakpointChanges(b,D,d)}$provideDebugConfigurations(f,b,D){return(0,T.asPromise)(async()=>{const d=this.getConfigProviderByHandle(f);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const g=await this.getFolder(b);return d.provideDebugConfigurations(g,D)}).then(d=>{if(!d)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return d})}$resolveDebugConfiguration(f,b,D,d){return(0,T.asPromise)(async()=>{const g=this.getConfigProviderByHandle(f);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.getFolder(b);return g.resolveDebugConfiguration(P,D,d)})}$resolveDebugConfigurationWithSubstitutedVariables(f,b,D,d){return(0,T.asPromise)(async()=>{const g=this.getConfigProviderByHandle(f);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.getFolder(b);return g.resolveDebugConfigurationWithSubstitutedVariables(P,D,d)})}async $provideDebugAdapter(f,b){const D=this.getAdapterDescriptorFactoryByHandle(f);if(!D)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const d=await this.getSession(b);return this.getAdapterDescriptor(D,d).then(g=>{if(!g)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}'`);return this.convertToDto(g)})}async $acceptDebugSessionStarted(f){const b=await this.getSession(f);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(f){const b=await this.getSession(f);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(f){this._activeDebugSession=f?await this.getSession(f):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(f,b){const D=await this.getSession(f);D&&D._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(f,b){const d={session:await this.getSession(f),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(d)}convertToDto(f){if(f instanceof I.DebugAdapterExecutable)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof I.DebugAdapterServer)return{type:"server",port:f.port,host:f.host};if(f instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:f.path};if(f instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(f){const b=this._adapterFactories.filter(D=>D.type===f);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(f){const b=this._adapterFactories.filter(D=>D.handle===f);if(b.length>0)return b[0].factory}getConfigProviderByHandle(f){const b=this._configProviders.filter(D=>D.handle===f);if(b.length>0)return b[0].provider}definesDebugType(f,b){if(f.contributes){const D=f.contributes.debuggers;if(D&&D.length>0){for(const d of D)if(d.label&&d.type&&d.type===b)return!0}}return!1}getDebugAdapterTrackers(f){const D=f.configuration.type,d=this._trackerFactories.filter(g=>g.type===D||g.type==="*").map(g=>(0,T.asPromise)(()=>g.factory.createDebugAdapterTracker(f)).then(P=>P,P=>null));return Promise.race([Promise.all(d).then(g=>{const P=g.filter(F=>!!F);if(P.length>0)return new r(P)}),new Promise((g,P)=>{const F=setTimeout(()=>{clearTimeout(F),P(new Error("timeout"))},1e3)})]).catch(g=>{})}async getAdapterDescriptor(f,b){const D=b.configuration.debugServer;if(typeof D=="number")return Promise.resolve(new I.DebugAdapterServer(D));if(f){const g=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>f.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,g))).then(P=>{if(P)return P})}const d=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,d))}daExecutableFromPackage(f,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(f,b,D){(f.length>0||b.length>0||D.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:f,removed:b,changed:D}))}async getSession(f){if(f)if(typeof f=="string"){const b=this._debugSessions.get(f);if(b)return b}else{let b=this._debugSessions.get(f.id);if(!b){const D=await this.getFolder(f.folderUri);b=new c(this._debugServiceProxy,f.id,f.type,f.name,D,f.configuration),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(f){if(f){const b=k.URI.revive(f);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};_=je([Ke(0,s.IExtHostRpcService),Ke(1,n.IExtHostWorkspace),Ke(2,R.IExtHostExtensionService),Ke(3,C.IExtHostDocumentsAndEditors),Ke(4,m.IExtHostConfiguration)],_),e.ExtHostDebugServiceBase=_;class c{constructor(f,b,D,d,g,P){this._debugServiceProxy=f,this._id=b,this._type=D,this._name=d,this._workspaceFolder=g,this._configuration=P}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(f){this._name=f,this._debugServiceProxy.$setDebugSessionName(this._id,f)}_acceptNameChanged(f){this._name=f}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(f,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,f,b)}getDebugProtocolBreakpoint(f){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,f.id)}}e.ExtHostDebugSession=c;class l{constructor(f){this.value=Object.freeze({append(b){f.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=l;class t extends v.AbstractVariableResolverService{constructor(f,b,D,d){super({getFolderUri:g=>{const P=f.filter(F=>F.name===g);if(P&&P.length>0)return P[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(g,P)=>D.getConfiguration(void 0,g).get(P),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(b){const g=b.activeEditor();if(g)return E.normalize(g.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(b&&d){const g=b.activeEditor();if(g){const P=d.getWorkspaceFolder(g.document.uri);if(P)return E.normalize(P.uri.fsPath)}}},getSelectedText:()=>{if(b){const g=b.activeEditor();if(g&&!g.selection.isEmpty)return g.document.getText(g.selection)}},getLineNumber:()=>{if(b){const g=b.activeEditor();if(g)return String(g.selection.end.line+1)}}},void 0,w.env)}}e.ExtHostVariableResolverService=t;class r{constructor(f){this.trackers=f}onWillStartSession(){this.trackers.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(f):void 0)}onWillStopSession(){this.trackers.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.trackers.forEach(b=>b.onError?b.onError(f):void 0)}onExit(f,b){this.trackers.forEach(D=>D.onExit?D.onExit(f,b):void 0)}}class u extends y.AbstractDebugAdapter{constructor(f){super();this.implementation=f,f.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.implementation.handleMessage(f)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends _{constructor(f,b,D,d,g){super(f,b,D,d,g)}createVariableResolver(f,b,D){return new t(f,b,D)}};o=je([Ke(0,s.IExtHostRpcService),Ke(1,n.IExtHostWorkspace),Ke(2,R.IExtHostExtensionService),Ke(3,C.IExtHostDocumentsAndEditors),Ke(4,m.IExtHostConfiguration)],o),e.WorkerExtHostDebugService=o}),define(be[219],we([0,1,77,2,5,34,33,26,14,27,4,35,45,19]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let i=class{constructor(_,c,l,t,r,u,o){this._apiFactory=_,this._extensionRegistry=c,this._instaService=l,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=u,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),E.mark("code/extHost/willWaitForConfig");const _=await this._extHostConfiguration.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new s(this._apiFactory,c,this._extensionRegistry,_,this._logService)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(h,c,this._initData.environment.appUriScheme))}register(_){if(Array.isArray(_.nodeModuleName))for(let c of _.nodeModuleName)this._factories.set(c,_);else this._factories.set(_.nodeModuleName,_);typeof _.alternativeModuleName=="function"&&this._alternatives.push(c=>_.alternativeModuleName(c))}};i=je([Ke(2,R.IInstantiationService),Ke(3,T.IExtHostConfiguration),Ke(4,C.IExtHostExtensionService),Ke(5,n.IExtHostInitDataService),Ke(6,m.ILogService)],i),e.RequireInterceptor=i;class s{constructor(_,c,l,t,r){this._apiFactory=_,this._extensionPaths=c,this._extensionRegistry=l,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(_,c){const l=this._extensionPaths.findSubstr(c.fsPath);if(l){let t=this._extApiImpl.get(I.ExtensionIdentifier.toKey(l.identifier));return t||(t=this._apiFactory(l,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(l.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,u)=>t+=`	${u} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(S.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(_,c){this.nodeModuleName="keytar";const{environment:l}=c,t=_.getProxy(A.MainContext.MainThreadKeytar);if(l.appRoot){let r=l.appRoot.fsPath;v.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,u)=>t.$getPassword(r,u),setPassword:(r,u,o)=>t.$setPassword(r,u,o),deletePassword:(r,u)=>t.$deletePassword(r,u),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(_,c){return this._impl}alternativeModuleName(_){const c=_.length;if(!(c<=7||!this.alternativeNames)){const l=c-7;if((_.charAt(l)==="/"||_.charAt(l)==="\\")&&_.endsWith("keytar")&&(_=_.replace(/\\/g,"/"),this.alternativeNames.has(_)))return"keytar"}}};p=je([Ke(0,y.IExtHostRpcService),Ke(1,n.IExtHostInitDataService)],p);let h=class{constructor(_,c,l){this._extensionPaths=_,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=l.getProxy(A.MainContext.MainThreadTelemetry);const t=l.getProxy(A.MainContext.MainThreadWindow);this._impl=(r,u)=>{const o=k.URI.parse(r);return u?this.callOriginal(r,u):o.scheme==="http"||o.scheme==="https"?t.$openUri(o,r,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?t.$openUri(o,r,{}):this.callOriginal(r,u)}}load(_,c,l){const t=this._extensionPaths.findSubstr(c.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=l(_),this._impl}callOriginal(_,c){return this.sendNoForwardTelemetry(),this._original(_,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};h=je([Ke(2,y.IExtHostRpcService)],h)}),define(be[220],we([0,1,13,10,77,6,2,5,212,19,61,65,27,150,14,68,35,40]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m,i,s,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(c,l,t,r){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const u=new y.RPCProtocol(c,null,r);l=w._transform(l,u);const o=new C.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());o.set(v.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},l)),o.set(i.IExtHostRpcService,new i.ExtHostRpcService(u)),o.set(s.IURITransformerService,new s.URITransformerService(r)),o.set(p.IHostUtils,t);const a=new m.InstantiationService(o,!0),f=a.invokeFunction(g=>g.get(h.IExtHostTerminalService));this._disposables.add(f),this._logService=a.invokeFunction(g=>g.get(n.ILogService)),A.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",l),this._extensionService=a.invokeFunction(g=>g.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const b=new WeakMap;this._extensionService.getExtensionPathIndex().then(g=>{Error.prepareStackTrace=(P,F)=>{let z="",de,W;for(const B of F)z+=`
	at ${B.toString()}`,W=B.getFileName(),!de&&W&&(de=g.findSubstr(W));return b.set(P,de),`${P.name||"Error"}: ${P.message||""}${z}`}});const D=u.getProxy(I.MainContext.MainThreadExtensionService),d=u.getProxy(I.MainContext.MainThreadErrors);k.setUnexpectedErrorHandler(g=>{const P=k.transformErrorForSerialization(g),F=b.get(g);F?D.$onExtensionRuntimeError(F.identifier,P):d.$onUnexpectedError(P)})}terminate(c){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),k.setUnexpectedErrorHandler(t=>{});const l=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,E.timeout)(4e3),l]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(c,l){c.extensions.forEach(r=>r.extensionLocation=S.URI.revive(l.transformIncomingURIs(r.extensionLocation))),c.environment.appRoot=S.URI.revive(l.transformIncomingURIs(c.environment.appRoot));const t=c.environment.extensionDevelopmentLocationURI;return t&&(c.environment.extensionDevelopmentLocationURI=t.map(r=>S.URI.revive(l.transformIncomingURIs(r)))),c.environment.extensionTestsLocationURI=S.URI.revive(l.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=S.URI.revive(l.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=S.URI.revive(l.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=S.URI.revive(l.transformIncomingURIs(c.logsLocation)),c.logFile=S.URI.revive(l.transformIncomingURIs(c.logFile)),c.workspace=l.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=w}),define(be[221],we([0,1,11,20,60,28,25,55,41]),function(ie,e,E,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class n{constructor(v,m,i){this.config=v,this.provider=m,this.sessionToken=i,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=v.filePattern,this.includePattern=v.includePattern&&T.parse(v.includePattern),this.maxResults=v.maxResults||void 0,this.exists=v.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=v.excludePattern&&T.parse(v.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(v=>v.cancel()),this.activeCancellationTokens=new Set}search(v){const m=this.config.folderQueries||[];return new Promise((i,s)=>{const p=h=>{this.resultCount++,v(h)};if(this.isCanceled)return i({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(h=>{const w=h.toString(),_=E.basename(w);this.globalExcludePattern&&this.globalExcludePattern(w,_)||this.matchFile(p,{base:h,basename:_})}),Promise.all(m.map(h=>this.searchInFolder(h,p))).then(h=>{i({limitHit:this.isLimitHit,stats:h[0]||void 0})},h=>{s(new Error((0,A.toErrorMessage)(h)))})})}async searchInFolder(v,m){const i=new k.CancellationTokenSource,s=this.getSearchOptionsForFolder(v),p=this.initDirectoryTree(),h=new y.QueryGlobTester(this.config,v),w=!h.hasSiblingExcludeClauses();let _;try{this.activeCancellationTokens.add(i),_=I.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},s,i.token),l=_.elapsed(),t=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(r=>{const u=E.posix.relative(v.folder.path,r.path);if(w){const o=E.basename(r.path);this.matchFile(m,{base:v.folder,relativePath:u,basename:o});return}this.addDirectoryEntries(p,v.folder,u,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,h,m),{providerTime:l,postProcessTime:t.elapsed()})}finally{i.dispose(),this.activeCancellationTokens.delete(i)}}getSearchOptionsForFolder(v){const m=(0,y.resolvePatternsForProvider)(this.config.includePattern,v.includePattern),i=(0,y.resolvePatternsForProvider)(this.config.excludePattern,v.excludePattern);return{folder:v.folder,excludes:i,includes:m,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}addDirectoryEntries({pathToEntries:v},m,i,s){if(i===this.filePattern){const h=E.basename(this.filePattern);this.matchFile(s,{base:m,relativePath:this.filePattern,basename:h})}function p(h){const w=E.basename(h),_=E.dirname(h);let c=v[_];c||(c=v[_]=[],p(_)),c.push({base:m,relativePath:h,basename:w})}p(i)}matchDirectoryTree({rootEntries:v,pathToEntries:m},i,s){const p=this,h=this.filePattern;function w(_){const c=T.hasSiblingFn(()=>_.map(l=>l.basename));for(let l=0,t=_.length;l<t;l++){const r=_[l],{relativePath:u,basename:o}=r;if(!!i.includedInQuerySync(u,o,h!==o?c:void 0)){const a=m[u];if(a)w(a);else{if(u===h)continue;p.matchFile(s,r)}if(p.isLimitHit)break}}}w(v)}matchFile(v,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||v(m))}}class R{constructor(){this.sessions=new Map}fileSearch(v,m,i,s){const p=this.getSessionTokenSource(v.cacheKey),h=new n(v,m,p&&p.token);let w=0;const _=c=>{w+=c.length,i(c.map(l=>this.rawMatchToSearchItem(l)))};return this.doSearch(h,R.BATCH_SIZE,_,s).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:c.stats}}))}clearCache(v){const m=this.getSessionTokenSource(v);m&&m.cancel()}getSessionTokenSource(v){if(!!v)return this.sessions.has(v)||this.sessions.set(v,new k.CancellationTokenSource),this.sessions.get(v)}rawMatchToSearchItem(v){return v.relativePath?{resource:S.joinPath(v.base,v.relativePath)}:{resource:v.base}}doSearch(v,m,i,s){s.onCancellationRequested(()=>{v.cancel()});const p=w=>{w&&(h.push(w),m>0&&h.length>=m&&(i(h),h=[]))};let h=[];return v.search(p).then(w=>(h.length&&i(h),w),w=>(h.length&&i(h),Promise.reject(w)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(be[222],we([0,1,11,15,20,60,25,28,2,41,18]),function(ie,e,E,k,A,T,S,I,y,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class C{constructor(w,_,c){this.query=w,this.provider=_,this.fileUtils=c,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(w,_){const c=this.query.folderQueries||[],l=new A.CancellationTokenSource;return _.onCancellationRequested(()=>l.cancel()),new Promise((t,r)=>{this.collector=new m(w);let u=!1;const o=(a,f)=>{if(!u&&!this.isLimitHit){const b=this.resultSize(a);s(a)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,u=!0,l.cancel(),a=this.trimResultToSize(a,this.query.maxResults-this.resultCount));const D=this.resultSize(a);this.resultCount+=D,(D>0||!s(a))&&this.collector.add(a,f)}};Promise.all(c.map((a,f)=>this.searchInFolder(a,b=>o(b,f),l.token))).then(a=>{l.dispose(),this.collector.flush();const f=a.some(b=>!!b&&!!b.limitHit);t({limitHit:this.isLimitHit||f,stats:{type:"textSearchProvider"}})},a=>{l.dispose();const f=(0,T.toErrorMessage)(a);r(new Error(f))})})}resultSize(w){return s(w)?Array.isArray(w.ranges)?w.ranges.length:1:0}trimResultToSize(w,_){const c=Array.isArray(w.ranges)?w.ranges:[w.ranges],l=Array.isArray(w.preview.matches)?w.preview.matches:[w.preview.matches];return{ranges:c.slice(0,_),preview:{matches:l.slice(0,_),text:w.preview.text},uri:w.uri}}async searchInFolder(w,_,c){const l=new n.QueryGlobTester(this.query,w),t=[],r={report:a=>{if(!!this.validateProviderResult(a)){const f=w.folder.scheme===R.Schemas.file?I.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(a.uri))):void 0,b=S.relativePath(w.folder,a.uri);b&&t.push(l.includedInQuery(b,E.basename(b),f).then(D=>{D&&_(a)}))}}},u=this.getSearchOptionsForFolder(w),o=await this.provider.provideTextSearchResults(v(this.query.contentPattern),u,r,c);return await Promise.all(t),o}validateProviderResult(w){if(s(w)){if(Array.isArray(w.ranges)){if(!Array.isArray(w.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(w.preview.matches.length!==w.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(w.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(w){const _=(0,n.resolvePatternsForProvider)(this.query.includePattern,w.includePattern),c=(0,n.resolvePatternsForProvider)(this.query.excludePattern,w.excludePattern),l={folder:y.URI.from(w.folder),excludes:c,includes:_,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,followSymlinks:!w.ignoreSymlinks,encoding:w.fileEncoding&&this.fileUtils.toCanonicalName(w.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return l.usePCRE2=this.query.usePCRE2,l}}e.TextSearchManager=C;function v(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class m{constructor(w){this._onResult=w,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new p(512,_=>this.sendItems(_))}add(w,_){this._currentFileMatch&&(this._currentFolderIdx!==_||!S.isEqual(this._currentUri,w.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=_,this._currentFileMatch={resource:w.uri,results:[]}),this._currentFileMatch.results.push(i(w))}pushToCollector(){const w=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,w)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(w){this._onResult(w)}}e.TextSearchResultsCollector=m;function i(h){return s(h)?{preview:{matches:(0,k.mapArrayOrNot)(h.preview.matches,w=>({startLineNumber:w.start.line,startColumn:w.start.character,endLineNumber:w.end.line,endColumn:w.end.character})),text:h.preview.text},ranges:(0,k.mapArrayOrNot)(h.ranges,w=>({startLineNumber:w.start.line,startColumn:w.start.character,endLineNumber:w.end.line,endColumn:w.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function s(h){return!!h.preview}e.extensionResultIsMatch=s;class p{constructor(w,_){this.maxBatchSize=w,this.cb=_,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(w,_){!w||this.addItemToBatch(w,_)}addItems(w,_){!w||this.addItemsToBatch(w,_)}addItemToBatch(w,_){this.batch.push(w),this.batchSize+=_,this.onUpdate()}addItemsToBatch(w,_){this.batch=this.batch.concat(w),this.batchSize+=_,this.onUpdate()}onUpdate(){this.totalNumberCompleted<p.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},p.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=p,p.TIMEOUT=4e3,p.START_BATCH_AFTER_COUNT=50}),define(be[103],we([0,1,6,5,4,221,14,68,19,2,222]),function(ie,e,E,k,A,T,S,I,y,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,A.createDecorator)("IExtHostSearch");let C=class{constructor(s,p,h){this.extHostRpc=s,this._uriTransformer=p,this._logService=h,this._proxy=this.extHostRpc.getProxy(k.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(s){return this._uriTransformer.transformOutgoingScheme(s)}registerTextSearchProvider(s,p){if(this._textSearchUsedSchemes.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this._textSearchUsedSchemes.add(s);const h=this._handlePool++;return this._textSearchProvider.set(h,p),this._proxy.$registerTextSearchProvider(h,this._transformScheme(s)),(0,E.toDisposable)(()=>{this._textSearchUsedSchemes.delete(s),this._textSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}registerFileSearchProvider(s,p){if(this._fileSearchUsedSchemes.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this._fileSearchUsedSchemes.add(s);const h=this._handlePool++;return this._fileSearchProvider.set(h,p),this._proxy.$registerFileSearchProvider(h,this._transformScheme(s)),(0,E.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(s),this._fileSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}$provideFileSearchResults(s,p,h,w){const _=v(h),c=this._fileSearchProvider.get(s);if(c)return this._fileSearchManager.fileSearch(_,c,l=>{this._proxy.$handleFileMatch(s,p,l.map(t=>t.resource))},w);throw new Error("unknown provider: "+s)}$clearCache(s){return this._fileSearchManager.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,p,h,w){const _=this._textSearchProvider.get(s);if(!_||!_.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const c=v(h);return this.createTextSearchManager(c,_).search(t=>this._proxy.$handleTextMatch(s,p,t),w)}createTextSearchManager(s,p){return new R.TextSearchManager(s,p,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h})}};C=je([Ke(0,S.IExtHostRpcService),Ke(1,I.IURITransformerService),Ke(2,y.ILogService)],C),e.ExtHostSearch=C;function v(i){return Object.assign(Object.assign({},i),{folderQueries:i.folderQueries&&i.folderQueries.map(m),extraFileResources:i.extraFileResources&&i.extraFileResources.map(s=>n.URI.revive(s))})}e.reviveQuery=v;function m(i){return Object.assign(Object.assign({},i),{folder:n.URI.revive(i.folder)})}}),define(be[223],we([0,1,128,20,10,3,46,2,121,82,115,59,64,5,189,188,73,190,34,191,192,193,175,194,39,35,195,176,197,198,199,99,179,201,202,203,75,40,204,180,9,7,207,49,100,31,33,50,165,196,91,98,101,102,103,19,68,14,27,200,163,67,72,186,205,162,76,74,210,208,209,187,48,216,206,71,159,93]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m,i,s,p,h,w,_,c,l,t,r,u,o,a,f,b,D,d,g,P,F,z,de,W,B,K,L,U,x,Q,$,ee,re,se,ye,Ie,xe,Fe,ze,N,G,te,ae,me,Se,Me,ge,Ce,Pe,$e,_e,qe,V,X,ve,Le,He,Oe,et,H,ne,he,q,J,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function fe(pe){const We=pe.get(Me.IExtHostInitDataService),Ne=pe.get(H.IExtHostFileSystemInfo),Ve=pe.get(ve.IExtHostConsumerFileSystem),Xe=pe.get(o.IExtHostExtensionService),Ze=pe.get(re.IExtHostWorkspace),ct=pe.get(oe.IExtHostTelemetry),ot=pe.get(w.IExtHostConfiguration),nt=pe.get(me.IURITransformerService),ue=pe.get(Se.IExtHostRpcService),De=pe.get(W.IExtHostStorage),le=pe.get(X.IExtensionStoragePaths),j=pe.get(ae.ILogService),Ae=pe.get(Pe.IExtHostTunnelService),Te=pe.get($e.IExtHostApiDeprecationService),Ye=pe.get(ee.IExtHostWindow),Ge=pe.get(q.IExtHostSecretState);ue.set(m.ExtHostContext.ExtHostFileSystemInfo,Ne),ue.set(m.ExtHostContext.ExtHostLogService,j),ue.set(m.ExtHostContext.ExtHostWorkspace,Ze),ue.set(m.ExtHostContext.ExtHostConfiguration,ot),ue.set(m.ExtHostContext.ExtHostExtensionService,Xe),ue.set(m.ExtHostContext.ExtHostStorage,De),ue.set(m.ExtHostContext.ExtHostTunnelService,Ae),ue.set(m.ExtHostContext.ExtHostWindow,Ye),ue.set(m.ExtHostContext.ExtHostSecretState,Ge),ue.set(m.ExtHostContext.ExtHostTelemetry,ct);const rt=ue.set(m.ExtHostContext.ExtHostDecorations,pe.get(ze.IExtHostDecorations)),at=ue.set(m.ExtHostContext.ExtHostDocumentsAndEditors,pe.get(u.IExtHostDocumentsAndEditors)),Qe=ue.set(m.ExtHostContext.ExtHostCommands,pe.get(p.IExtHostCommands)),ut=ue.set(m.ExtHostContext.ExtHostTerminalService,pe.get(B.IExtHostTerminalService)),st=ue.set(m.ExtHostContext.ExtHostDebugService,pe.get(G.IExtHostDebugService)),gt=ue.set(m.ExtHostContext.ExtHostSearch,pe.get(te.IExtHostSearch)),wt=ue.set(m.ExtHostContext.ExtHostTask,pe.get(N.IExtHostTask)),St=ue.set(m.ExtHostContext.ExtHostOutputService,pe.get(g.IExtHostOutputService)),vt=ue.set(m.ExtHostContext.ExtHostEditorTabs,new J.ExtHostEditorTabs),Et=ue.set(m.ExtHostContext.ExtHostUrls,new Q.ExtHostUrls(ue)),pt=ue.set(m.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(ue,at)),Rt=ue.set(m.ExtHostContext.ExtHostDocumentContentProviders,new l.ExtHostDocumentContentProvider(ue,at,j)),Ft=ue.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(j,pt,ue.getProxy(m.MainContext.MainThreadBulkEdits))),ft=ue.set(m.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(ue,Qe,at,pt,We.environment,j,le)),yt=ue.set(m.ExtHostContext.ExtHostEditors,new K.ExtHostEditors(ue,at)),Bt=ue.set(m.ExtHostContext.ExtHostTreeViews,new L.ExtHostTreeViews(ue.getProxy(m.MainContext.MainThreadTreeViews),Qe,j)),qt=ue.set(m.ExtHostContext.ExtHostEditorInsets,new Ie.ExtHostEditorInsets(ue.getProxy(m.MainContext.MainThreadEditorInsets),yt,We.environment)),Lt=ue.set(m.ExtHostContext.ExtHostDiagnostics,new _.ExtHostDiagnostics(ue,j)),ht=ue.set(m.ExtHostContext.ExtHostLanguageFeatures,new b.ExtHostLanguageFeatures(ue,nt,pt,Qe,Lt,j,Te)),Kt=ue.set(m.ExtHostContext.ExtHostFileSystem,new a.ExtHostFileSystem(ue,ht)),Ct=ue.set(m.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(ue,j,at)),Ot=ue.set(m.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(ue,Ze,Qe)),Ht=ue.set(m.ExtHostContext.ExtHostSCM,new z.ExtHostSCM(ue,Qe,j)),Gt=ue.set(m.ExtHostContext.ExtHostComments,new h.ExtHostComments(ue,Qe,pt)),en=ue.set(m.ExtHostContext.ExtHostProgress,new P.ExtHostProgress(ue.getProxy(m.MainContext.MainThreadProgress))),dn=ue.set(m.ExtHostContext.ExtHosLabelService,new xe.ExtHostLabelService(ue)),tn=ue.set(m.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(ue)),Mt=ue.set(m.ExtHostContext.ExtHostAuthentication,new _e.ExtHostAuthentication(ue)),hn=ue.set(m.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(ue,Qe)),Nt=ue.set(m.ExtHostContext.ExtHostWebviews,new $.ExtHostWebviews(ue,We.environment,Ze,j,Te)),Ut=ue.set(m.ExtHostContext.ExtHostWebviewPanels,new Oe.ExtHostWebviewPanels(ue,Nt,Ze)),fn=ue.set(m.ExtHostContext.ExtHostCustomEditors,new He.ExtHostCustomEditors(ue,pt,le,Nt,Ut)),mn=ue.set(m.ExtHostContext.ExtHostWebviewViews,new Le.ExtHostWebviewViews(ue,Nt)),Pt=ue.set(m.ExtHostContext.ExtHostTesting,new ne.ExtHostTesting(ue,at,Ze)),gn=ue.set(m.ExtHostContext.ExtHostUriOpeners,new he.ExtHostUriOpeners(ue)),zt=(0,ye.values)(m.ExtHostContext);ue.assertRegistered(zt);const pn=new et.ExtHostBulkEdits(ue,at),vn=new s.ExtHostClipboard(ue),xt=new d.ExtHostMessageService(ue,j),nn=new c.ExtHostDialogs(ue),Vt=new de.ExtHostStatusBar(ue,Qe.converter),$t=new D.ExtHostLanguages(ue,pt);return i.ExtHostApiCommands.register(Qe),function(Re,Qt,Jt){const mt=function(){let Y=!Re.isUnderDevelopment;function ce(ke){Y||(j.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function ke(lt){if(Array.isArray(lt))lt.forEach(ke);else if(typeof lt=="string")ce(lt);else{const _t=lt;typeof _t.scheme=="undefined"&&ce(lt),!Re.enableProposedApi&&typeof _t.exclusive=="boolean"&&(0,se.throwProposedApiError)(Re)}return lt}}(),_n={getSession(Y,ce,ke){return Mt.getSession(Re,Y,ce,ke)},get onDidChangeSessions(){return Mt.onDidChangeSessions},registerAuthenticationProvider(Y,ce,ke,lt){return Mt.registerAuthenticationProvider(Y,ce,ke,lt)},get onDidChangeAuthenticationProviders(){return(0,se.checkProposedApiEnabled)(Re),Mt.onDidChangeAuthenticationProviders},get providers(){return(0,se.checkProposedApiEnabled)(Re),Mt.providers},logout(Y,ce){return(0,se.checkProposedApiEnabled)(Re),Mt.removeSession(Y,ce)}},bn={registerCommand(Y,ce,ke){return Qe.registerCommand(!0,Y,ce,ke)},registerTextEditorCommand(Y,ce,ke){return Qe.registerCommand(!0,Y,(...lt)=>{const _t=yt.getActiveTextEditor();if(!_t){j.warn("Cannot execute "+Y+" because there is no active text editor.");return}return _t.edit(O=>{ce.apply(ke,[_t,O,...lt])}).then(O=>{O||j.warn("Edits from command "+Y+" were not applied.")},O=>{j.warn("An error occurred while running command "+Y,O)})})},registerDiffInformationCommand:(Y,ce,ke)=>((0,se.checkProposedApiEnabled)(Re),Qe.registerCommand(!0,Y,async(...lt)=>{const _t=at.activeEditor(!0);if(!_t){j.warn("Cannot execute "+Y+" because there is no active text editor.");return}const O=await yt.getDiffInformation(_t.id);ce.apply(ke,[O,...lt])})),executeCommand(Y,...ce){return Qe.executeCommand(Y,...ce)},getCommands(Y=!1){return Qe.getCommands(Y)}},rn={get machineId(){return We.telemetryInfo.machineId},get sessionId(){return We.telemetryInfo.sessionId},get language(){return We.environment.appLanguage},get appName(){return We.environment.appName},get appRoot(){var Y,ce;return(ce=(Y=We.environment.appRoot)===null||Y===void 0?void 0:Y.fsPath)!==null&&ce!==void 0?ce:""},get uriScheme(){return We.environment.appUriScheme},get clipboard(){return vn.value},get shell(){return ut.getDefaultShell(!1,Jt)},get isTelemetryEnabled(){return ct.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ct.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(We.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,ce){return Ye.openUri(Y,{allowTunneling:!!We.remote.authority,allowContributedOpeners:ce==null?void 0:ce.allowContributedOpeners})},asExternalUri(Y){return Y.scheme===We.environment.appUriScheme?Et.createAppUri(Y):Ye.asExternalUri(Y,{allowTunneling:!!We.remote.authority})},get remoteName(){return(0,Fe.getRemoteName)(We.remote.authority)},get uiKind(){return We.uiKind}};We.environment.extensionTestsLocationURI||Object.freeze(rn);const sn=We.remote.isRemote?x.ExtensionKind.Workspace:x.ExtensionKind.UI,wn={registerTestProvider(Y){return(0,se.checkProposedApiEnabled)(Re),Pt.registerTestProvider(Y)},createDocumentTestObserver(Y){return(0,se.checkProposedApiEnabled)(Re),Pt.createTextDocumentTestObserver(Y)},createWorkspaceTestObserver(Y){return(0,se.checkProposedApiEnabled)(Re),Pt.createWorkspaceTestObserver(Y)},runTests(Y){return(0,se.checkProposedApiEnabled)(Re),Pt.runTests(Y)},publishTestResult(Y,ce=!0){return(0,se.checkProposedApiEnabled)(Re),Pt.publishExtensionProvidedResults(Y,ce)},get onDidChangeTestResults(){return(0,se.checkProposedApiEnabled)(Re),Pt.onResultsChanged},get testResults(){return(0,se.checkProposedApiEnabled)(Re),Pt.results}},Yt={getExtension(Y){const ce=Qt.getExtensionDescription(Y);if(ce)return new o.Extension(Xe,Re.identifier,ce,sn)},get all(){return Qt.getAllExtensionDescriptions().map(Y=>new o.Extension(Xe,Re.identifier,Y,sn))},get onDidChange(){return Qt.onDidChange}},En={createDiagnosticCollection(Y){return Lt.createDiagnosticCollection(Re.identifier,Y)},get onDidChangeDiagnostics(){return Lt.onDidChangeDiagnostics},getDiagnostics:Y=>Lt.getDiagnostics(Y),getLanguages(){return $t.getLanguages()},setTextDocumentLanguage(Y,ce){return $t.changeLanguage(Y.uri,ce)},match(Y,ce){return(0,C.score)(U.LanguageSelector.from(Y),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(Y,ce,ke){return ht.registerCodeActionProvider(Re,mt(Y),ce,ke)},registerCodeLensProvider(Y,ce){return ht.registerCodeLensProvider(Re,mt(Y),ce)},registerDefinitionProvider(Y,ce){return ht.registerDefinitionProvider(Re,mt(Y),ce)},registerDeclarationProvider(Y,ce){return ht.registerDeclarationProvider(Re,mt(Y),ce)},registerImplementationProvider(Y,ce){return ht.registerImplementationProvider(Re,mt(Y),ce)},registerTypeDefinitionProvider(Y,ce){return ht.registerTypeDefinitionProvider(Re,mt(Y),ce)},registerHoverProvider(Y,ce){return ht.registerHoverProvider(Re,mt(Y),ce,Re.identifier)},registerEvaluatableExpressionProvider(Y,ce){return ht.registerEvaluatableExpressionProvider(Re,mt(Y),ce,Re.identifier)},registerInlineValuesProvider(Y,ce){return ht.registerInlineValuesProvider(Re,mt(Y),ce,Re.identifier)},registerDocumentHighlightProvider(Y,ce){return ht.registerDocumentHighlightProvider(Re,mt(Y),ce)},registerLinkedEditingRangeProvider(Y,ce){return ht.registerLinkedEditingRangeProvider(Re,mt(Y),ce)},registerReferenceProvider(Y,ce){return ht.registerReferenceProvider(Re,mt(Y),ce)},registerRenameProvider(Y,ce){return ht.registerRenameProvider(Re,mt(Y),ce)},registerDocumentSymbolProvider(Y,ce,ke){return ht.registerDocumentSymbolProvider(Re,mt(Y),ce,ke)},registerWorkspaceSymbolProvider(Y){return ht.registerWorkspaceSymbolProvider(Re,Y)},registerDocumentFormattingEditProvider(Y,ce){return ht.registerDocumentFormattingEditProvider(Re,mt(Y),ce)},registerDocumentRangeFormattingEditProvider(Y,ce){return ht.registerDocumentRangeFormattingEditProvider(Re,mt(Y),ce)},registerOnTypeFormattingEditProvider(Y,ce,ke,...lt){return ht.registerOnTypeFormattingEditProvider(Re,mt(Y),ce,[ke].concat(lt))},registerDocumentSemanticTokensProvider(Y,ce,ke){return ht.registerDocumentSemanticTokensProvider(Re,mt(Y),ce,ke)},registerDocumentRangeSemanticTokensProvider(Y,ce,ke){return ht.registerDocumentRangeSemanticTokensProvider(Re,mt(Y),ce,ke)},registerSignatureHelpProvider(Y,ce,ke,...lt){return typeof ke=="object"?ht.registerSignatureHelpProvider(Re,mt(Y),ce,ke):ht.registerSignatureHelpProvider(Re,mt(Y),ce,typeof ke=="undefined"?[]:[ke,...lt])},registerCompletionItemProvider(Y,ce,...ke){return ht.registerCompletionItemProvider(Re,mt(Y),ce,ke)},registerDocumentLinkProvider(Y,ce){return ht.registerDocumentLinkProvider(Re,mt(Y),ce)},registerColorProvider(Y,ce){return ht.registerColorProvider(Re,mt(Y),ce)},registerFoldingRangeProvider(Y,ce){return ht.registerFoldingRangeProvider(Re,mt(Y),ce)},registerSelectionRangeProvider(Y,ce){return ht.registerSelectionRangeProvider(Re,Y,ce)},registerCallHierarchyProvider(Y,ce){return ht.registerCallHierarchyProvider(Re,Y,ce)},setLanguageConfiguration:(Y,ce)=>ht.setLanguageConfiguration(Re,Y,ce),getTokenInformationAtPosition(Y,ce){return(0,se.checkProposedApiEnabled)(Re),$t.tokenAtPosition(Y,ce)},registerInlineHintsProvider(Y,ce){return(0,se.checkProposedApiEnabled)(Re),ht.registerInlineHintsProvider(Re,Y,ce)}},yn={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return ut.activeTerminal},get terminals(){return ut.terminals},async showTextDocument(Y,ce,ke){const lt=await(I.URI.isUri(Y)?Promise.resolve(on.openTextDocument(Y)):Promise.resolve(Y));return yt.showTextDocument(lt,ce,ke)},createTextEditorDecorationType(Y){return yt.createTextEditorDecorationType(Y)},onDidChangeActiveTextEditor(Y,ce,ke){return yt.onDidChangeActiveTextEditor(Y,ce,ke)},onDidChangeVisibleTextEditors(Y,ce,ke){return yt.onDidChangeVisibleTextEditors(Y,ce,ke)},onDidChangeTextEditorSelection(Y,ce,ke){return yt.onDidChangeTextEditorSelection(Y,ce,ke)},onDidChangeTextEditorOptions(Y,ce,ke){return yt.onDidChangeTextEditorOptions(Y,ce,ke)},onDidChangeTextEditorVisibleRanges(Y,ce,ke){return yt.onDidChangeTextEditorVisibleRanges(Y,ce,ke)},onDidChangeTextEditorViewColumn(Y,ce,ke){return yt.onDidChangeTextEditorViewColumn(Y,ce,ke)},onDidCloseTerminal(Y,ce,ke){return ut.onDidCloseTerminal(Y,ce,ke)},onDidOpenTerminal(Y,ce,ke){return ut.onDidOpenTerminal(Y,ce,ke)},onDidChangeActiveTerminal(Y,ce,ke){return ut.onDidChangeActiveTerminal(Y,ce,ke)},onDidChangeTerminalDimensions(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ut.onDidChangeTerminalDimensions(Y,ce,ke)},onDidWriteTerminalData(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ut.onDidWriteTerminalData(Y,ce,ke)},get state(){return Ye.state},onDidChangeWindowState(Y,ce,ke){return Ye.onDidChangeWindowState(Y,ce,ke)},showInformationMessage(Y,...ce){return xt.showMessage(Re,S.default.Info,Y,ce[0],ce.slice(1))},showWarningMessage(Y,...ce){return xt.showMessage(Re,S.default.Warning,Y,ce[0],ce.slice(1))},showErrorMessage(Y,...ce){return xt.showMessage(Re,S.default.Error,Y,ce[0],ce.slice(1))},showQuickPick(Y,ce,ke){return Ot.showQuickPick(Y,!!Re.enableProposedApi,ce,ke)},showWorkspaceFolderPick(Y){return Ot.showWorkspaceFolderPick(Y)},showInputBox(Y,ce){return Ot.showInput(Y,ce)},showOpenDialog(Y){return nn.showOpenDialog(Y)},showSaveDialog(Y){return nn.showSaveDialog(Y)},createStatusBarItem(Y,ce){let ke,lt,_t,O;return Y&&typeof Y!="number"?(ke=Y.id,lt=Y.name,_t=Y.alignment,ce=Y.priority,O=Y.accessibilityInformation):(ke=Re.identifier.value,lt=E.localize(0,null,Re.displayName||Re.name),_t=Y),Vt.createStatusBarEntry(ke,lt,_t,ce,O)},setStatusBarMessage(Y,ce){return Vt.setStatusBarMessage(Y,ce)},withScmProgress(Y){return Te.report("window.withScmProgress",Re,"Use 'withProgress' instead."),en.withProgress(Re,{location:x.ProgressLocation.SourceControl},(ce,ke)=>Y({report(lt){}}))},withProgress(Y,ce){return en.withProgress(Re,Y,ce)},createOutputChannel(Y){return St.createOutputChannel(Y)},createWebviewPanel(Y,ce,ke,lt){return Ut.createWebviewPanel(Re,Y,ce,ke,lt)},createWebviewTextEditorInset(Y,ce,ke,lt){return(0,se.checkProposedApiEnabled)(Re),qt.createWebviewEditorInset(Y,ce,ke,lt,Re)},createTerminal(Y,ce,ke){return typeof Y=="object"?"pty"in Y?ut.createExtensionTerminal(Y):(Y.message&&(0,se.checkProposedApiEnabled)(Re),Y.icon&&(0,se.checkProposedApiEnabled)(Re),ut.createTerminalFromOptions(Y)):ut.createTerminal(Y,ce,ke)},registerTerminalLinkProvider(Y){return ut.registerLinkProvider(Y)},registerTreeDataProvider(Y,ce){return Bt.registerTreeDataProvider(Y,ce,Re)},createTreeView(Y,ce){return Bt.createTreeView(Y,ce,Re)},registerWebviewPanelSerializer:(Y,ce)=>Ut.registerWebviewPanelSerializer(Re,Y,ce),registerCustomEditorProvider:(Y,ce,ke={})=>fn.registerCustomEditorProvider(Re,Y,ce,ke),registerFileDecorationProvider(Y){return rt.registerFileDecorationProvider(Y,Re.identifier)},registerUriHandler(Y){return Et.registerUriHandler(Re.identifier,Y)},createQuickPick(){return Ot.createQuickPick(Re.identifier,!!Re.enableProposedApi)},createInputBox(){return Ot.createInputBox(Re.identifier)},get activeColorTheme(){return tn.activeColorTheme},onDidChangeActiveColorTheme(Y,ce,ke){return tn.onDidChangeActiveColorTheme(Y,ce,ke)},registerWebviewViewProvider(Y,ce,ke){return mn.registerWebviewViewProvider(Re,Y,ce,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return(0,se.checkProposedApiEnabled)(Re),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeActiveNotebookEditor(Y,ce,ke)},get visibleNotebookEditors(){return(0,se.checkProposedApiEnabled)(Re),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookEditorSelection(Y,ce,ke)},onDidChangeNotebookEditorVisibleRanges(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookEditorVisibleRanges(Y,ce,ke)},showNotebookDocument(Y,ce){return(0,se.checkProposedApiEnabled)(Re),ft.showNotebookDocument(Y,ce)},registerExternalUriOpener(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),gn.registerExternalUriOpener(Re.identifier,Y,ce,ke)},get openEditors(){return(0,se.checkProposedApiEnabled)(Re),vt.tabs},get onDidChangeOpenEditors(){return(0,se.checkProposedApiEnabled)(Re),vt.onDidChangeTabs}},on={get rootPath(){return Te.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(Y){throw A.readonly()},getWorkspaceFolder(Y){return Ze.getWorkspaceFolder(Y)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(Y){throw A.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(Y){throw A.readonly()},updateWorkspaceFolders:(Y,ce,...ke)=>Ze.updateWorkspaceFolders(Re,Y,ce||0,...ke),onDidChangeWorkspaceFolders:function(Y,ce,ke){return Ze.onDidChangeWorkspace(Y,ce,ke)},asRelativePath:(Y,ce)=>Ze.getRelativePath(Y,ce),findFiles:(Y,ce,ke,lt)=>Ze.findFiles(U.GlobPattern.from(Y),U.GlobPattern.from(ce),ke,Re.identifier,lt),findTextInFiles:(Y,ce,ke,lt)=>{let _t,O;return typeof ce=="object"?(_t=ce,O=ke):(_t={},O=ce,lt=ke),Ze.findTextInFiles(Y,_t||{},O,Re.identifier,lt)},saveAll:Y=>Ze.saveAll(Y),applyEdit(Y){return pn.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,ce,ke,lt)=>Ct.createFileSystemWatcher(U.GlobPattern.from(Y),ce,ke,lt),get textDocuments(){return pt.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw A.readonly()},openTextDocument(Y){let ce;const ke=Y;if(typeof Y=="string")ce=Promise.resolve(I.URI.file(Y));else if(I.URI.isUri(Y))ce=Promise.resolve(Y);else if(!ke||typeof ke=="object")ce=pt.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(lt=>pt.ensureDocumentData(lt).then(_t=>_t.document))},onDidOpenTextDocument:(Y,ce,ke)=>pt.onDidAddDocument(Y,ce,ke),onDidCloseTextDocument:(Y,ce,ke)=>pt.onDidRemoveDocument(Y,ce,ke),onDidChangeTextDocument:(Y,ce,ke)=>pt.onDidChangeDocument(Y,ce,ke),onDidSaveTextDocument:(Y,ce,ke)=>pt.onDidSaveDocument(Y,ce,ke),onWillSaveTextDocument:(Y,ce,ke)=>Ft.getOnWillSaveTextDocumentEvent(Re)(Y,ce,ke),onDidChangeConfiguration:(Y,ce,ke)=>Jt.onDidChangeConfiguration(Y,ce,ke),getConfiguration(Y,ce){return ce=arguments.length===1?void 0:ce,Jt.getConfiguration(Y,ce,Re)},registerTextDocumentContentProvider(Y,ce){return Rt.registerTextDocumentContentProvider(Y,ce)},registerTaskProvider:(Y,ce)=>(Te.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),wt.registerTaskProvider(Re,Y,ce)),registerFileSystemProvider(Y,ce,ke){return Kt.registerFileSystemProvider(Re.identifier,Y,ce,ke)},get fs(){return Ve.value},registerFileSearchProvider:(Y,ce)=>((0,se.checkProposedApiEnabled)(Re),gt.registerFileSearchProvider(Y,ce)),registerTextSearchProvider:(Y,ce)=>((0,se.checkProposedApiEnabled)(Re),gt.registerTextSearchProvider(Y,ce)),registerRemoteAuthorityResolver:(Y,ce)=>((0,se.checkProposedApiEnabled)(Re),Xe.registerRemoteAuthorityResolver(Y,ce)),registerResourceLabelFormatter:Y=>((0,se.checkProposedApiEnabled)(Re),dn.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,ce,ke)=>Ct.onDidCreateFile(Y,ce,ke),onDidDeleteFiles:(Y,ce,ke)=>Ct.onDidDeleteFile(Y,ce,ke),onDidRenameFiles:(Y,ce,ke)=>Ct.onDidRenameFile(Y,ce,ke),onWillCreateFiles:(Y,ce,ke)=>Ct.getOnWillCreateFileEvent(Re)(Y,ce,ke),onWillDeleteFiles:(Y,ce,ke)=>Ct.getOnWillDeleteFileEvent(Re)(Y,ce,ke),onWillRenameFiles:(Y,ce,ke)=>Ct.getOnWillRenameFileEvent(Re)(Y,ce,ke),openTunnel:Y=>((0,se.checkProposedApiEnabled)(Re),Ae.openTunnel(Re,Y).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,se.checkProposedApiEnabled)(Re),Ae.getTunnels()},onDidChangeTunnels:(Y,ce,ke)=>((0,se.checkProposedApiEnabled)(Re),Ae.onDidChangeTunnels(Y,ce,ke)),registerPortAttributesProvider:(Y,ce)=>((0,se.checkProposedApiEnabled)(Re),Ae.registerPortsAttributesProvider(Y,ce)),registerTimelineProvider:(Y,ce)=>((0,se.checkProposedApiEnabled)(Re),hn.registerTimelineProvider(Y,ce,Re.identifier,Qe.converter)),get trustState(){return(0,se.checkProposedApiEnabled)(Re),Ze.trustState},requestWorkspaceTrust:Y=>((0,se.checkProposedApiEnabled)(Re),Ze.requestWorkspaceTrust(Y)),onDidChangeWorkspaceTrustState:(Y,ce,ke)=>Ze.onDidChangeWorkspaceTrustState(Y,ce,ke)},Sn={get inputBox(){return Te.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),Ht.getLastInputBox(Re)},createSourceControl(Y,ce,ke){return Ht.createSourceControl(Re,Y,ce,ke)}},Dn={createCommentController(Y,ce){return Gt.createCommentController(Re,Y,ce)}},an={get activeDebugSession(){return st.activeDebugSession},get activeDebugConsole(){return st.activeDebugConsole},get breakpoints(){return st.breakpoints},onDidStartDebugSession(Y,ce,ke){return st.onDidStartDebugSession(Y,ce,ke)},onDidTerminateDebugSession(Y,ce,ke){return st.onDidTerminateDebugSession(Y,ce,ke)},onDidChangeActiveDebugSession(Y,ce,ke){return st.onDidChangeActiveDebugSession(Y,ce,ke)},onDidReceiveDebugSessionCustomEvent(Y,ce,ke){return st.onDidReceiveDebugSessionCustomEvent(Y,ce,ke)},onDidChangeBreakpoints(Y,ce,ke){return st.onDidChangeBreakpoints(Y,ce,ke)},registerDebugConfigurationProvider(Y,ce,ke){return st.registerDebugConfigurationProvider(Y,ce,ke||x.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,ce){return st.registerDebugAdapterDescriptorFactory(Re,Y,ce)},registerDebugAdapterTrackerFactory(Y,ce){return st.registerDebugAdapterTrackerFactory(Y,ce)},startDebugging(Y,ce,ke){return!ke||typeof ke=="object"&&"configuration"in ke?st.startDebugging(Y,ce,{parentSession:ke}):st.startDebugging(Y,ce,ke||{})},stopDebugging(Y){return st.stopDebugging(Y)},addBreakpoints(Y){return st.addBreakpoints(Y)},removeBreakpoints(Y){return st.removeBreakpoints(Y)},asDebugSourceUri(Y,ce){return st.asDebugSourceUri(Y,ce)}},jt={registerTaskProvider:(Y,ce)=>wt.registerTaskProvider(Re,Y,ce),fetchTasks:Y=>wt.fetchTasks(Y),executeTask:Y=>wt.executeTask(Re,Y),get taskExecutions(){return wt.taskExecutions},onDidStartTask:(Y,ce,ke)=>wt.onDidStartTask(Y,ce,ke),onDidEndTask:(Y,ce,ke)=>wt.onDidEndTask(Y,ce,ke),onDidStartTaskProcess:(Y,ce,ke)=>wt.onDidStartTaskProcess(Y,ce,ke),onDidEndTaskProcess:(Y,ce,ke)=>wt.onDidEndTaskProcess(Y,ce,ke)},ln={openNotebookDocument:Y=>((0,se.checkProposedApiEnabled)(Re),ft.openNotebookDocument(Y)),get onDidOpenNotebookDocument(){return(0,se.checkProposedApiEnabled)(Re),ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,se.checkProposedApiEnabled)(Re),ft.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,se.checkProposedApiEnabled)(Re),ft.onDidSaveNotebookDocument},get notebookDocuments(){return(0,se.checkProposedApiEnabled)(Re),ft.notebookDocuments.map(Y=>Y.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeActiveNotebookKernel},registerNotebookSerializer(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.registerNotebookSerializer(Re,Y,ce,ke)},registerNotebookContentProvider:(Y,ce,ke)=>((0,se.checkProposedApiEnabled)(Re),ft.registerNotebookContentProvider(Re,Y,ce,ke)),registerNotebookKernelProvider:(Y,ce)=>((0,se.checkProposedApiEnabled)(Re),ft.registerNotebookKernelProvider(Re,Y,ce)),createNotebookEditorDecorationType(Y){return(0,se.checkProposedApiEnabled)(Re),ft.createNotebookEditorDecorationType(Y)},onDidChangeNotebookDocumentMetadata(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookDocumentMetadata(Y,ce,ke)},onDidChangeNotebookCells(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookCells(Y,ce,ke)},onDidChangeCellExecutionState(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookCellExecutionState(Y,ce,ke)},onDidChangeCellOutputs(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeCellOutputs(Y,ce,ke)},onDidChangeCellMetadata(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeCellMetadata(Y,ce,ke)},createConcatTextDocument(Y,ce){return(0,se.checkProposedApiEnabled)(Re),new V.ExtHostNotebookConcatDocument(ft,pt,Y,ce)},createCellStatusBarItem(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.createNotebookCellStatusBarItemInternal(Y,ce,ke)},createNotebookCellExecutionTask(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.createNotebookCellExecution(Y,ce,ke)}};return{version:We.version,authentication:_n,commands:bn,comments:Dn,debug:an,env:rn,extensions:Yt,languages:En,notebook:ln,scm:Sn,tasks:jt,test:wn,window:yn,workspace:on,Breakpoint:x.Breakpoint,CallHierarchyIncomingCall:x.CallHierarchyIncomingCall,CallHierarchyItem:x.CallHierarchyItem,CallHierarchyOutgoingCall:x.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:k.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:x.CodeAction,CodeActionKind:x.CodeActionKind,CodeActionTriggerKind:x.CodeActionTriggerKind,CodeLens:x.CodeLens,Color:x.Color,ColorInformation:x.ColorInformation,ColorPresentation:x.ColorPresentation,ColorThemeKind:x.ColorThemeKind,CommentMode:x.CommentMode,CommentThreadCollapsibleState:x.CommentThreadCollapsibleState,CompletionItem:x.CompletionItem,CompletionItemKind:x.CompletionItemKind,CompletionItemTag:x.CompletionItemTag,CompletionList:x.CompletionList,CompletionTriggerKind:x.CompletionTriggerKind,ConfigurationTarget:x.ConfigurationTarget,CustomExecution:x.CustomExecution,DebugAdapterExecutable:x.DebugAdapterExecutable,DebugAdapterInlineImplementation:x.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:x.DebugAdapterNamedPipeServer,DebugAdapterServer:x.DebugAdapterServer,DebugConfigurationProviderTriggerKind:x.DebugConfigurationProviderTriggerKind,DebugConsoleMode:x.DebugConsoleMode,DecorationRangeBehavior:x.DecorationRangeBehavior,Diagnostic:x.Diagnostic,DiagnosticRelatedInformation:x.DiagnosticRelatedInformation,DiagnosticSeverity:x.DiagnosticSeverity,DiagnosticTag:x.DiagnosticTag,Disposable:x.Disposable,DocumentHighlight:x.DocumentHighlight,DocumentHighlightKind:x.DocumentHighlightKind,DocumentLink:x.DocumentLink,DocumentSymbol:x.DocumentSymbol,EndOfLine:x.EndOfLine,EnvironmentVariableMutatorType:x.EnvironmentVariableMutatorType,EvaluatableExpression:x.EvaluatableExpression,InlineValueText:x.InlineValueText,InlineValueVariableLookup:x.InlineValueVariableLookup,InlineValueEvaluatableExpression:x.InlineValueEvaluatableExpression,EventEmitter:T.Emitter,ExtensionKind:x.ExtensionKind,ExtensionMode:x.ExtensionMode,ExternalUriOpenerPriority:x.ExternalUriOpenerPriority,FileChangeType:x.FileChangeType,FileDecoration:x.FileDecoration,FileSystemError:x.FileSystemError,FileType:v.FileType,FoldingRange:x.FoldingRange,FoldingRangeKind:x.FoldingRangeKind,FunctionBreakpoint:x.FunctionBreakpoint,Hover:x.Hover,IndentAction:R.IndentAction,Location:x.Location,MarkdownString:x.MarkdownString,OverviewRulerLane:n.OverviewRulerLane,ParameterInformation:x.ParameterInformation,PortAutoForwardAction:x.PortAutoForwardAction,Position:x.Position,ProcessExecution:x.ProcessExecution,ProgressLocation:x.ProgressLocation,QuickInputButtons:x.QuickInputButtons,Range:x.Range,RelativePattern:x.RelativePattern,Selection:x.Selection,SelectionRange:x.SelectionRange,SemanticTokens:x.SemanticTokens,SemanticTokensBuilder:x.SemanticTokensBuilder,SemanticTokensEdit:x.SemanticTokensEdit,SemanticTokensEdits:x.SemanticTokensEdits,SemanticTokensLegend:x.SemanticTokensLegend,ShellExecution:x.ShellExecution,ShellQuoting:x.ShellQuoting,SignatureHelp:x.SignatureHelp,SignatureHelpTriggerKind:x.SignatureHelpTriggerKind,SignatureInformation:x.SignatureInformation,SnippetString:x.SnippetString,SourceBreakpoint:x.SourceBreakpoint,StandardTokenType:x.StandardTokenType,StatusBarAlignment:x.StatusBarAlignment,SymbolInformation:x.SymbolInformation,SymbolKind:x.SymbolKind,SymbolTag:x.SymbolTag,Task:x.Task,TaskGroup:x.TaskGroup,TaskPanelKind:x.TaskPanelKind,TaskRevealKind:x.TaskRevealKind,TaskScope:x.TaskScope,TextDocumentSaveReason:x.TextDocumentSaveReason,TextEdit:x.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:x.TextEditorLineNumbersStyle,TextEditorRevealType:x.TextEditorRevealType,TextEditorSelectionChangeKind:x.TextEditorSelectionChangeKind,ThemeColor:x.ThemeColor,ThemeIcon:x.ThemeIcon,TreeItem:x.TreeItem,TreeItemCollapsibleState:x.TreeItemCollapsibleState,UIKind:m.UIKind,Uri:I.URI,ViewColumn:x.ViewColumn,WorkspaceEdit:x.WorkspaceEdit,InlineHint:x.InlineHint,InlineHintKind:x.InlineHintKind,RemoteAuthorityResolverError:x.RemoteAuthorityResolverError,ResolvedAuthority:x.ResolvedAuthority,SourceControlInputBoxValidationType:x.SourceControlInputBoxValidationType,ExtensionRuntime:x.ExtensionRuntime,TimelineItem:x.TimelineItem,NotebookCellRange:x.NotebookCellRange,NotebookCellKind:x.NotebookCellKind,NotebookCellExecutionState:x.NotebookCellExecutionState,NotebookDocumentMetadata:x.NotebookDocumentMetadata,NotebookCellMetadata:x.NotebookCellMetadata,NotebookCellData:x.NotebookCellData,NotebookData:x.NotebookData,NotebookCellStatusBarAlignment:x.NotebookCellStatusBarAlignment,NotebookEditorRevealType:x.NotebookEditorRevealType,NotebookCellOutput:x.NotebookCellOutput,NotebookCellOutputItem:x.NotebookCellOutputItem,LinkedEditingRanges:x.LinkedEditingRanges,TestItem:x.TestItem,TestResultState:x.TestResultState,TestMessage:x.TestMessage,TestMessageSeverity:x.TestMessageSeverity,WorkspaceTrustState:x.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=fe}),define(be[224],we([0,1,61,99,31,98,34,73,39,40,101,102,103,76,75,67,72,100,74,48,71,93]),function(ie,e,E,k,A,T,S,I,y,n,R,C,v,m,i,s,p,h,w,_,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.registerSingleton)(m.IExtensionStoragePaths,m.ExtensionStoragePaths),(0,E.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,E.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,E.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration),(0,E.registerSingleton)(w.IExtHostConsumerFileSystem,w.ExtHostConsumerFileSystem),(0,E.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,E.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,E.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,E.registerSingleton)(_.IExtHostFileSystemInfo,_.ExtHostFileSystemInfo),(0,E.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService),(0,E.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch),(0,E.registerSingleton)(i.IExtHostStorage,i.ExtHostStorage),(0,E.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,E.registerSingleton)(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),(0,E.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,E.registerSingleton)(h.IExtHostWindow,h.ExtHostWindow),(0,E.registerSingleton)(A.IExtHostWorkspace,A.ExtHostWorkspace),(0,E.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,E.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry)}),define(be[225],we([0,1,223,35,219,7,13,5]),function(ie,e,E,k,A,T,S,I){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var n;(function(i){var s;const p=(s=self.trustedTypes)===null||s===void 0?void 0:s.createPolicy("TrustedFunctionWorkaround",{createScript:(w,..._)=>{_.forEach(r=>{var u;if(!((u=self.trustedTypes)===null||u===void 0?void 0:u.isScript(r)))throw new Error("TrustedScripts only, please")});const c=_.slice(0,-1).join(","),l=_.pop().toString();return`(function anonymous(${c}) {
${l}
})`}});function h(...w){return p?self.eval(p.createScript("",...w)):new Function(...w)}i.create=h})(n||(n={}));class R extends A.RequireInterceptor{_installInterceptor(){}getModule(s,p){for(let h of this._alternatives){let w=h(s);if(w){s=w;break}}if(this._factories.has(s))return this._factories.get(s).load(s,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class C extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const s=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);m(s,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(E.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(R,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(s){return s.browser}async _loadCommonJSModule(s,p,h){var w,_,c,l,t,r,u,o;p=p.with({path:v(p.path,".js")}),s&&performance.mark(`code/extHost/willFetchExtensionCode/${s.value}`);const a=await fetch(p.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s.value}`),a.status!==200)throw new Error(a.statusText);const f=await a.text(),b=`${p.toString(!0)}#vscode-extension`,D=`${f}
//# sourceURL=${b}`;let d;try{d=n.create((_=(w=C._ttpExtensionScripts)===null||w===void 0?void 0:w.createScript("module"))!==null&&_!==void 0?_:"module",(l=(c=C._ttpExtensionScripts)===null||c===void 0?void 0:c.createScript("exports"))!==null&&l!==void 0?l:"exports",(r=(t=C._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&r!==void 0?r:"require",(o=(u=C._ttpExtensionScripts)===null||u===void 0?void 0:u.createScript(D))!==null&&o!==void 0?o:D)}catch(z){throw s?console.error(`Loading code for extension ${s.value} failed: ${z.message}`):console.error(`Loading code failed: ${z.message}`),console.error(`${p.toString(!0)}${typeof z.line=="number"?` line ${z.line}`:""}${typeof z.column=="number"?` column ${z.column}`:""}`),console.error(z),z}const g={},P={exports:g},F=z=>{const de=this._fakeModules.getModule(z,p);if(de===void 0)throw new Error(`Cannot load module '${z}'`);return de};try{return h.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s.value}`),d(P,g,F),P.exports!==g?P.exports:g}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s.value}`),h.codeLoadingStop()}}async $setRemoteEnvironment(s){throw new Error("Not supported")}async _waitForDebuggerAttachment(s=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const p=Date.now()+s;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,S.timeout)(10)}}}e.ExtHostExtensionService=C,C._ttpExtensionScripts=(y=self.trustedTypes)===null||y===void 0?void 0:y.createPolicy("ExtensionScripts",{createScript:i=>i});function v(i,s){return i.endsWith(s)?i:i+s}function m(i,s){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(_,c){const l=console[_];console[_]=function(){i.$logExtensionHostMessage({type:"__$console",severity:c,arguments:w(arguments)}),s&&l.apply(console,arguments)}}const h=1e5;function w(_){const c=[],l=[];if(_.length)for(let t=0;t<_.length;t++){if(typeof _[t]=="undefined")_[t]="undefined";else if(_[t]instanceof Error){const r=_[t];r.stack?_[t]=r.stack:_[t]=r.toString()}l.push(_[t])}try{const t=JSON.stringify(l,function(r,u){if(u&&typeof u=="object"){if(c.indexOf(u)!==-1)return"[Circular]";c.push(u)}return u});return t.length>h?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(be[226],we([0,1,61,19,35,225,211]),function(ie,e,E,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.registerSingleton)(A.IExtHostExtensionService,T.ExtHostExtensionService),(0,E.registerSingleton)(k.ILogService,S.ExtHostLogService)}),define(be[228],we([0,1,24,3,183,220,213,11,77,224,226]),function(ie,e,E,k,A,T,S,I,y){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0});const R=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const C=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const p=(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("extensionHostWorker",{createScriptURL:w=>w}),h=self.Worker;Worker=function(w,_){const c=`importScripts('${w}');`;_=_||{},_.name=_.name||I.basename(w.toString());const l=new Blob([c],{type:"application/javascript"}),t=URL.createObjectURL(l);return new h(p?p.createScriptURL(t):t,_)}}else self.Worker=class extends S.NestedWorker{constructor(p,h){super(C,p,Object.assign({name:I.basename(p.toString())},h))}};const v=new class{exit(p){R()}async exists(p){return!0}async realpath(p){return p}};class m{constructor(){const h=new MessageChannel,w=new k.Emitter;let _=!1;C(h.port2,[h.port2]),h.port1.onmessage=c=>{const{data:l}=c;if(!(l instanceof ArrayBuffer)){console.warn("UNKNOWN data received",l);return}const t=E.VSBuffer.wrap(new Uint8Array(l,0,l.byteLength));if((0,A.isMessageOfType)(t,2)){_=!0,s("received terminate message from renderer");return}w.fire(t)},this.protocol={onMessage:w.event,send:c=>{if(!_){const l=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);h.port1.postMessage(l,[l])}}}}}function i(p){return new Promise(h=>{const w=p.onMessage(_=>{w.dispose();const c=JSON.parse(_.toString());p.send((0,A.createMessageOfType)(0)),h({protocol:p,initData:c})});p.send((0,A.createMessageOfType)(1))})}let s=p=>R();(function(){const h=new m;y.mark("code/extHost/willConnectToRenderer"),i(h.protocol).then(w=>{y.mark("code/extHost/didWaitForInitData");const _=new T.ExtensionHostMain(w.protocol,w.initData,v,null);s=c=>_.terminate(c)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/37dee411c81abf7d8ecb28ffe218475c328578b8/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
